/*$T AItypes.c GC! 1.076 03/08/00 18:25:38 */

/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */

#include "Precomp.h"
#include "AIinterp/Sources/AIengine.h"
#include "AIinterp/Sources/AIstruct.h" 
#include "MATHs/MATH.h"
#include "AIinterp/Sources/AIstack.h"
#include "AIinterp/Sources/AImsg.h"
#include "BASe/CLIbrary/CLIstr.h"
#include "ENGine/Sources/TEXT/TEXTstruct.h"
#include "ENGine/Sources/ENGvars.h"

#if defined(PSX2_TARGET) && defined(__cplusplus)
extern "C"
{
#endif

extern int AI_EvalFunc_OBJ_HasBeenKilled_C(OBJ_tdst_GameObject *);

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetGAO(void *_pv_Src, void *_pv_Dest)
{
	*(void **) _pv_Dest = *(void **) _pv_Src;

#ifdef ACTIVE_EDITORS
	if(!AI_gb_InterpForVar)
#endif
	{
		switch(*(int *) _pv_Dest)
		{
		case AI_C_MainActor0:
			*(void **) _pv_Dest = AI_gpst_MainActors[0];
			break;
		case AI_C_MainActor1:
			*(void **) _pv_Dest = AI_gpst_MainActors[1];
			break;
		}
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetPointerRef(void *_pv_Src, void *_pv_Dest)
{
	*(void **) _pv_Dest = *(void **) _pv_Src;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetMessage(void *_pv_Src, void *_pv_Dest)
{
	L_memcpy(_pv_Dest, _pv_Src, sizeof(AI_tdst_Message));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetMessageId(void *_pv_Src, void *_pv_Dest)
{
	L_memcpy(_pv_Dest, _pv_Src, sizeof(AI_tdst_GlobalMessageId));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetTrigger(void *_pv_Src, void *_pv_Dest)
{
	L_memcpy(_pv_Dest, _pv_Src, sizeof(SCR_tt_Trigger));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetInt(void *_pv_Src, void *_pv_Dest)
{
	*(int *) _pv_Dest = *(int *) _pv_Src;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetBool(void *_pv_Src, void *_pv_Dest)
{
	*(BOOL *) _pv_Dest = *(BOOL *) _pv_Src;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetVector(void *_pv_Src, void *_pv_Dest)
{
	MATH_CopyVector((MATH_tdst_Vector *) _pv_Dest, (MATH_tdst_Vector *) _pv_Src);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetString(void *_pv_Src, void *_pv_Dest)
{
	*(char **) _pv_Dest = *(char **) _pv_Src;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetText(void *_pv_Src, void *_pv_Dest)
{
	L_memcpy((TEXT_tdst_Eval *) _pv_Dest, (TEXT_tdst_Eval *) _pv_Src, sizeof(TEXT_tdst_Eval));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetKey(void *_pv_Src, void *_pv_Dest)
{
	*(BIG_KEY *) _pv_Dest = *(BIG_KEY *) _pv_Src;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void AI_EvalType_GetColor(void *_pv_Src, void *_pv_Dest)
{
	*(ULONG *) _pv_Dest = *(ULONG *) _pv_Src;
}

#if defined(PSX2_TARGET) && defined(__cplusplus)
}
#endif
