/*$T CLIxxx.c GC! 1.097 02/01/01 14:37:05 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#ifdef PSX2_TARGET

/*$4
 ***********************************************************************************************************************
    headers
 ***********************************************************************************************************************
 */

#include <libscf.h>
#include "CLIbrary/CLIxxx.h"

/*$4
 ***********************************************************************************************************************
    private variables
 ***********************************************************************************************************************
 */

static L_time_t		sst_LastRTCRead;
static L_struct_tm	sst_LastLocalTime;

/*$4
 ***********************************************************************************************************************
    private functions
 ***********************************************************************************************************************
 */

/*
 =======================================================================================================================
 =======================================================================================================================
 */
inline int BCD_To_Dec(int _val)
{
	return((_val & 0x0F) + ((_val & 0xF0) >> 4) * 10);
}

/*$4
 ***********************************************************************************************************************
    public functions
 ***********************************************************************************************************************
 */

/*
 =======================================================================================================================
 =======================================================================================================================
 */
L_time_t L_time(L_time_t *timer)
{
	if(sceCdReadClock(&sst_LastRTCRead))
		*timer = sst_LastRTCRead;
	else
		*timer = (L_time_t)
	{
		0
	};

	return *timer;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
L_struct_tm *L_localtime(L_time_t *timer)
{
	sceScfGetLocalTimefromRTC(timer);

	sst_LastLocalTime.tm_hour = BCD_To_Dec(timer->hour);
	sst_LastLocalTime.tm_min = BCD_To_Dec(timer->minute);
	sst_LastLocalTime.tm_sec = BCD_To_Dec(timer->second);
	sst_LastLocalTime.tm_mday = BCD_To_Dec(timer->day);
	sst_LastLocalTime.tm_mon = BCD_To_Dec(timer->month) - 1;
	sst_LastLocalTime.tm_year = BCD_To_Dec(timer->year) + 100;

	if(sceScfGetSummerTime() == SCE_SUMMERTIME_ON)
		sst_LastLocalTime.tm_isdst = 1;
	else
		sst_LastLocalTime.tm_isdst = 0;

	/* can't evaluate it or don't used */
	sst_LastLocalTime.tm_yday = -1;
	sst_LastLocalTime.tm_wday = -1;

	return &sst_LastLocalTime;
}

#endif /* PSX2_TARGET */ 
 