/*$T iopDebug.c GC! 1.097 04/25/02 14:23:40 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#ifdef PSX2_IOP

/*$4
 ***********************************************************************************************************************
    headers
 ***********************************************************************************************************************
 */

#include <stdio.h>
#include "iop/iopDebug.h"
#ifdef __iopDbg_Err__

/*$4
 ***********************************************************************************************************************
    macros
 ***********************************************************************************************************************
 */


/*$4
 ***********************************************************************************************************************
    variables
 ***********************************************************************************************************************
 */

int		iopDBG_gi_LastErrorCode = 0;
int		iopDBG_gi_ErrorNumber = 0;
int		iopDBG_gi_LastMapErrorCode = 0;
int		iopDBG_gi_MapErrorNumber = 0;
char	dbg_buffer[4096];

int iopDBG_AlphaToInt(char _c);

/*$4
 ***********************************************************************************************************************
    functions
 ***********************************************************************************************************************
 */

int iopDBG_AlphaToInt(char _c)
{
    int i;
    
    i=0;
    if(('a' <= _c) && (_c <= 'f'))
    {
        i = _c - 'a' + 0xA;
    }
    else if(('A' <= _c) && (_c <= 'F'))
    {
        i = _c - 'A' + 0xA;
    }
    else if(('0' <= _c) && (_c <= '9'))
    {
        i = _c - '0';
    }
    
    return i;
}
/*
 =======================================================================================================================
 =======================================================================================================================
 */
void iopDBG_Err(const char *pz)
{
	iopDBG_gi_LastErrorCode = (iopDBG_AlphaToInt(pz[9]) << 12) +
		(iopDBG_AlphaToInt(pz[10]) << 8) +
		(iopDBG_AlphaToInt(pz[11]) << 4) +
		iopDBG_AlphaToInt(pz[12]);
	iopDBG_gi_ErrorNumber++;

	iopDBG_gi_LastMapErrorCode = iopDBG_gi_LastErrorCode;
	iopDBG_gi_MapErrorNumber++;

	printf("%s\n", pz);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void iopDBG_MapResetError(int iID)
{
	if((iID & 0xFF800000) == 0xFF800000)
	{
		iopDBG_gi_LastMapErrorCode = 0;
		iopDBG_gi_MapErrorNumber = 0;
	}
}

/*$4EOF
 ***********************************************************************************************************************
 ***********************************************************************************************************************
 */

#endif
#endif /* PSX2_IOP */
