// ************************************************
// Simplified Thread Event Manager
//
// Used for King Kong Xenon Multi-Core Optimization
// By Alexandre David (February 2005)
// ************************************************

// ***********************************************************************************************************************
//    Headers
// ***********************************************************************************************************************

#include "Precomp.h"

#include "EventThread.h"

// ***********************************************************************************************************************

namespace EventThread
{

// ***********************************************************************************************************************
//    Functions - Exposed
// ***********************************************************************************************************************

void* Memory_Allocate(int Param_iSize)
{
	if (Param_iSize <= 0)
	{
		return NULL;
	}

	return MEM_p_Alloc(Param_iSize);
}

// ***********************************************************************************************************************

void Memory_Free(void* Param_pHeapBlock)
{
	if (Param_pHeapBlock != NULL)
	{
		MEM_Free(Param_pHeapBlock);
	}
}

// ***********************************************************************************************************************

void Memory_Fill(void* Param_pMemory, int Param_iSize, char Param_byValue)
{
	if ((Param_iSize <= 0) || (Param_pMemory == NULL))
	{
		return;
	}

	L_memset(Param_pMemory, Param_byValue, Param_iSize);
}

// ***********************************************************************************************************************

} // Namespace

// ***********************************************************************************************************************
