/*$T SNDdebug.c GC 1.138 07/29/05 17:07:41 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#include "Precomp.h"

/*$4
 ***********************************************************************************************************************
    headers
 ***********************************************************************************************************************
 */

#include "SouND/Sources/SNDdebug.h"
#ifdef SND_DEBUG
#include "BASe/CLIbrary/CLIstr.h"
#include "LINks/LINKmsg.h"
#include "SouND/Sources/SND.h"

/*$4
 ***********************************************************************************************************************
    macros
 ***********************************************************************************************************************
 */

/*$1- editor ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifdef ACTIVE_EDITORS
#define SND_Print(_a_)	LINK_PrintStatusMsg(_a_)

/*$1- PS2 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#elif defined(PSX2_TARGET)
#define SND_Print(_a_) \
	do \
	{ \
		printf(_a_); \
		printf("\n"); \
	} while(0);

/*$1- gamecube ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#elif defined(_GAMECUBE)
#define SND_Print(_a_)	OSReport("%s\n", _a_)
/*$1- Xenon ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#elif defined(_XENON)
#define SND_Print(_a_) OutputDebugStringA (_a_);
#else

/*$1- else ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#define SND_Print(_a_)
#endif

/*$4
 ***********************************************************************************************************************
    variables
 ***********************************************************************************************************************
 */

SND_tdst_Debug	SND_gst_Debug;
extern BOOL		LOA_gb_SpeedMode;
void			SND_TraceInstance(int index);

/*$4
 ***********************************************************************************************************************
    functions
 ***********************************************************************************************************************
 */

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_DebugInitModule(void)
{
	L_memset(&SND_gst_Debug, 0, sizeof(SND_tdst_Debug));
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_DebugCloseModule(void)
{
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_DebugRegisterBadkey(unsigned int ul)
{
	/*~~~~~~~~~~~~*/
	char	str[64];
	/*~~~~~~~~~~~~*/

	if(!SND_gst_Params.l_Available) return;
	SND_gst_Debug.ul_BadFileCounter++;
	SND_gst_Debug.ul_LastBadFileKey = ul;
	if(LOA_gb_SpeedMode)
	{
		sprintf(str, "ERROR try to laod bad sound file key %x", ul);
		SND_Print(str);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_DebugSpy(unsigned int _ul_key, char *_asz_File, int _i_Line, char *_asz_Function)
{
	/*~~~~~~~~~~~~~~~~~~~~*/
	char		str[1024];
	static int	si_line = 0;
	/*~~~~~~~~~~~~~~~~~~~~*/

	if(_ul_key != SND_gst_Debug.ul_SpyKey) return;
	if(!SND_gst_Debug.b_EnableDebugLog) return;

	sprintf(str, "[SND-SPY](0x%08X):%s(%d) : %s", SND_gst_Debug.ul_SpyKey, _asz_File, _i_Line, _asz_Function);
	SND_Print(str);

	if(si_line == _i_Line)
	{
		sprintf(str, "[SND-SPY] special case here !");
		SND_Print(str);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_TraceSound(int index)
{
	/*~~~~~~~~~~~~~~*/
	char	str[1024];
	/*~~~~~~~~~~~~~~*/

	if((index < 0) || (index >= SND_gst_Params.l_SoundNumber))
	{
		sprintf(str, "[SND] bad sound index ");
	}
	else
	{
		sprintf(str, "[SND] sound %x ", SND_gst_Params.dst_Sound[index].ul_FileKey);
	}

	SND_Print(str);
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_TraceInstance(int index)
{
	if((index < 0) || (index >= SND_gst_Params.l_InstanceNumber))
	{
		/*~~~~~~~~~~~~~~*/
		char	str[1024];
		/*~~~~~~~~~~~~~~*/

		sprintf(str, "[SND] bad instance index ");
		SND_Print(str);
	}
	else
	{
		SND_TraceSound(SND_gst_Params.dst_Instance[index].l_Sound);
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SND_TraceStr(char *log)
{
	SND_Print(log);
}
#endif /* SND_DEBUG */

/*$4
 ***********************************************************************************************************************
    EOF
 ***********************************************************************************************************************
 */
