/*$T SNDdebug.h GC 1.138 07/29/05 17:08:16 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#ifndef __SNDdebug_h__
#define __SNDdebug_h__

#if defined (__cplusplus) && !defined(JADEFUSION)
extern "C"
{
#endif

/*$4
 ***********************************************************************************************************************
    activation
 ***********************************************************************************************************************
 */

/*$1- enable debug by default ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#define SND_DEBUG

/*$1- no debug in final version ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#if defined(_FINAL_) || defined(PSX2_USE_iopCDV)
#undef SND_DEBUG
#endif

/*$1- no debug in win32 engine release version ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#if !defined(PSX2_TARGET) && !defined(_GAMECUBE) && !defined(ACTIVE_EDITORS) && !defined(_XENON)
#undef SND_DEBUG
#endif

/*$1-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifdef SND_DEBUG

/*$4
 ***********************************************************************************************************************
    DEBUGGING
 ***********************************************************************************************************************
 */

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    macros
 -----------------------------------------------------------------------------------------------------------------------
 */

#define _SND_DebugSpy(_key, _function)	SND_DebugSpy(_key, __FILE__, __LINE__, #_function)

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    types
 -----------------------------------------------------------------------------------------------------------------------
 */

typedef struct	SND_tdst_Debug_
{
	unsigned int	b_EnableDebugLog;
	unsigned int	ul_BadFileCounter;
	unsigned int	ul_LastBadFileKey;
	unsigned int	b_TraceLastStreamPlayRq;

	unsigned int	ul_SpyKey;
} SND_tdst_Debug;

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    variable
 -----------------------------------------------------------------------------------------------------------------------
 */

extern SND_tdst_Debug	SND_gst_Debug;

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    prototypes
 -----------------------------------------------------------------------------------------------------------------------
 */

void	SND_DebugInitModule(void);
void	SND_DebugCloseModule(void);
void	SND_DebugRegisterBadkey(unsigned int ul);
void	SND_DebugSpy(unsigned int _ul_entry, char *, int _i_Line, char *);
void	SND_TraceSound(int index);
void	SND_TraceStr(char *log);

#else

/*$4
 ***********************************************************************************************************************
    NO DEBUGGING
 ***********************************************************************************************************************
 */

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    macros
 -----------------------------------------------------------------------------------------------------------------------
 */

#define _SND_DebugSpy(_key, _function)

/*$2
 -----------------------------------------------------------------------------------------------------------------------
    surround functions
 -----------------------------------------------------------------------------------------------------------------------
 */

#define SND_TraceSound(ff)
#define SND_DebugInitModule()
#define SND_DebugCloseModule()
#define SND_DebugRegisterBadkey(ul)
#define SND_TraceStr(log)

/*$4
 ***********************************************************************************************************************
    EOF
 ***********************************************************************************************************************
 */

#endif
#if defined (__cplusplus) && !defined(JADEFUSION)
}
#endif
#endif /* __SNDdebug_h__ */
