/*$T gcSND_AudioFrame.c GC! 1.097 01/09/02 12:24:31 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#ifdef _GAMECUBE
#ifdef __cplusplus
extern "C"
{
#endif

/*$4
 ***********************************************************************************************************************
    headers
 ***********************************************************************************************************************
 */
#include <dolphin/mix.h>
#include "SouND/Sources/gc/gcSND_AudioFrame.h"
#include "SouND/Sources/gc/gcSND_Stream.h"

/*$4
 ***********************************************************************************************************************
    functions
 ***********************************************************************************************************************
 */

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void gcSND_AudioFrameCallBack(void)
{
	/*~~~~*/
	BOOL old;
#ifdef _DEBUG	
	static double sf_Last=0.0;
	static double sf_tot = 0.0;
	static double sf_nb = 0.0;
	double avg;
	double avg1;
	/*~~~~*/

	if(!sf_Last)
	{
		sf_Last = (double)OSTicksToMicroseconds(OSGetTime()) ;
	}
	else
	{
		sf_Last = (double)OSTicksToMicroseconds(OSGetTime())  - sf_Last;
	
		sf_nb++;
		sf_tot += sf_Last;

		avg1 = sf_tot / sf_nb;
		if(avg1)
		{
			avg = 100.0 * ( sf_Last) / avg1;

			if((avg < 5.0) || (avg > 1500.0))
			{
				OSReport("*** Fluctation de la trame son %.3f / %.3f !! ***\n", sf_Last, avg1);
			}
		}
		sf_Last = (double)OSTicksToMicroseconds(OSGetTime());
	}
#endif	
	old = OSEnableInterrupts();
	MIXUpdateSettings();
	OSRestoreInterrupts(old);
}

/*$4
 ***********************************************************************************************************************
    EOF
 ***********************************************************************************************************************
 */

#ifdef __cplusplus
}
#endif
#endif /* GC */
