/*$T CWaveFile.h GC 1.138 05/14/04 13:17:03 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#pragma once
#pragma pack(push, 1)

#define SND_Cte_WAVE_FORMAT_UNKNOWN		0x0000
#define SND_Cte_WAVE_FORMAT_PCM			0x0001
#define SND_Cte_WAVE_FORMAT_MS_ADPCM	0x0002
#define SND_Cte_WAVE_FORMAT_MSADPCM		0x0002
#define SND_Cte_WAVE_FORMAT_XBOX_ADPCM	0x0069
#define SND_Cte_WAVE_FORMAT_GAMECUBE	0xFFFE
#define SND_Cte_WAVE_FORMAT_EXTENSIBLE	0xFFFE
#define SND_Cte_WAVE_FORMAT_PS2			0xFFFF
#define SND_Cte_WAVE_FORMAT_DEVELOPMENT 0xFFFF

#if 1	/* little endian (intel) */
#define SND_M_MARKER(a, b, c, d)	((a) | ((b) << 8) | ((c) << 16) | ((d) << 24))
#else /* big endian (motorola) */
#define SND_M_MARKER(a, b, c, d)	(((a) << 24) | ((b) << 16) | ((c) << 8) | (d))
#endif
/**/
#define SND_Cte_Marker_RIFF (SND_M_MARKER('R', 'I', 'F', 'F'))
#define SND_Cte_Marker_WAVE (SND_M_MARKER('W', 'A', 'V', 'E'))
#define SND_Cte_Marker_fmt	(SND_M_MARKER('f', 'm', 't', ' '))
#define SND_Cte_Marker_fact (SND_M_MARKER('f', 'a', 'c', 't'))
#define SND_Cte_Marker_data (SND_M_MARKER('d', 'a', 't', 'a'))
#define SND_Cte_Marker_cue	(SND_M_MARKER('c', 'u', 'e', ' '))
#define SND_Cte_Marker_plst (SND_M_MARKER('p', 'l', 's', 't'))
#define SND_Cte_Marker_labl (SND_M_MARKER('l', 'a', 'b', 'l'))
#define SND_Cte_Marker_slnt (SND_M_MARKER('s', 'l', 'n', 't'))
#define SND_Cte_Marker_note (SND_M_MARKER('n', 'o', 't', 'e'))
#define SND_Cte_Marker_smpl (SND_M_MARKER('s', 'm', 'p', 'l'))
#define SND_Cte_Marker_bext (SND_M_MARKER('b', 'e', 'x', 't'))
#define SND_Cte_Marker_MEXT (SND_M_MARKER('M', 'E', 'X', 'T'))
#define SND_Cte_Marker_DISP (SND_M_MARKER('D', 'I', 'S', 'P'))
#define SND_Cte_Marker_PAD	(SND_M_MARKER('P', 'A', 'D', ' '))
#define SND_Cte_Marker_JUNK (SND_M_MARKER('J', 'U', 'N', 'K'))
#define SND_Cte_Marker_ltxt (SND_M_MARKER('l', 't', 'x', 't'))
#define SND_Cte_Marker_file (SND_M_MARKER('f', 'i', 'l', 'e'))
/**/
#define SND_Cte_Marker_LIST (SND_M_MARKER('L', 'I', 'S', 'T'))
#define SND_Cte_Marker_adtl (SND_M_MARKER('a', 'd', 't', 'l'))
#define SND_Cte_Marker_INFO (SND_M_MARKER('I', 'N', 'F', 'O'))
#define SND_Cte_Marker_wavl (SND_M_MARKER('w', 'a', 'v', 'l'))
#define SND_Cte_Marker_inst (SND_M_MARKER('i', 'n', 's', 't'))
/**/
/*$4
 ***********************************************************************************************************************
    RIFF form
 ***********************************************************************************************************************
 */

class	CForm
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	UI32	m_dwFormType;
	UI32	m_dwCkId;
	UI32	m_dwCkSize;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CForm(UI32 dwFormType = 0, UI32 dwCkId = 0, UI32 dwCkSize = 0)
	{
		m_dwFormType = dwFormType;
		m_dwCkId = dwCkId;
		m_dwCkSize = dwCkSize;		
	}
    bool bIsValid(void) { return m_dwCkSize ? true : false; }
};

/*$4
 ***********************************************************************************************************************
    RIFF chunk
 ***********************************************************************************************************************
 */

class	CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	UI32	m_dwCkId;
	UI32	m_dwCkSize;	

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CChunk(UI32 dwCkId = 0, UI32 dwCkSize = 0);
    bool bIsValid(void) { return m_dwCkSize ? true : false; }
	void	InitCk(UI32 dwCkId, UI32 dwCkSize);
};

/*$4
 ***********************************************************************************************************************
    fmt
 ***********************************************************************************************************************
 */

class CFormatChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct __CFormatChunk
	{
		struct __common
		{
			UI16	wFormatTag;
			UI16	wChannels;
			UI32	dwSamplesPerSec;
			UI32	dwAvgBytesPerSec;
			UI16	wBlockAlign;
		} st_PartCommon;

		union __facultative
		{
			struct __pcm
			{
				UI16	wBitsPerSample;
			} st_PCM;

			struct __extended
			{
				UI16	wBitsPerSample;
				UI16	cbSize;
			} st_Extended;

			struct __xbox
			{
				UI16	wBitsPerSample;
				UI16	cbSize;
				UI16	wSamplesPerBlock;
			} st_Xbox;

			struct __ms_adpcm
			{
				UI16	wBitsPerSample;
				UI16	cbSize;
				UI16	wSamplesPerBlock;
				UI16	wNumCoef;
				UI32	*aCoeff;
			} st_MS_ADPCM;
		} un_PartFacultative;
	} m_Format;
	char	*m_pExtra;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CFormatChunk(HMMIO hFile = NULL);
	~CFormatChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	int Save(HMMIO hFile = NULL);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
private:
	void	InitCommon(UI16 wFormatTag, UI16 wChannels, UI32 dwSamplesPerSec, UI32 dwAvgBytesPerSec, UI16 wBlockAlign);
	void	InitPCM
			(
				UI16	wFormatTag,
				UI16	wChannels,
				UI32	dwSamplesPerSec,
				UI32	dwAvgBytesPerSec,
				UI16	wBlockAlign,
				UI16	wBitsPerSample
			);
	void	InitEX
			(
				UI16	wFormatTag,
				UI16	wChannels,
				UI32	dwSamplesPerSec,
				UI32	dwAvgBytesPerSec,
				UI16	wBlockAlign,
				UI16	wBitsPerSample,
				UI16	cbSize
			);
	void	InitIMA
			(
				UI16	wFormatTag,
				UI16	wChannels,
				UI32	dwSamplesPerSec,
				UI32	dwAvgBytesPerSec,
				UI16	wBlockAlign,
				UI16	wBitsPerSample,
				UI16	cbSize,
				UI16	wSamplesPerBlock
			);
	void	InitADPCM
			(
				UI16	wFormatTag,
				UI16	wChannels,
				UI32	dwSamplesPerSec,
				UI32	dwAvgBytesPerSec,
				UI16	wBlockAlign,
				UI16	wBitsPerSample,
				UI16	cbSize,
				UI16	wSamplesPerBlock,
				UI16	wNumCoef,
				int		*aCoeff
			);
};

/*$4
 ***********************************************************************************************************************
    fact
 ***********************************************************************************************************************
 */

class CFactChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	UI32	m_dwFileSize;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CFactChunk(HMMIO hFile);

	int Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    cue
 ***********************************************************************************************************************
 */

typedef struct	__CCuePoint
{
	UI32	dwName;
	UI32	dwPosition;
	char	fccChunk[4];
	UI32	dwChunkStart;
	UI32	dwBlockStart;
	UI32	dwSampleOffset;
} CCuePoint;

class CCuePointChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32		dwCuePoints;
		CCuePoint	*dstCuePointTable;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CCuePointChunk(HMMIO hFile = NULL);
	~CCuePointChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI32 dwCuePoints = 0, CCuePoint *aTable = NULL);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    play list
 ***********************************************************************************************************************
 */

typedef struct	__CPlaySegment
{
	UI32	dwName;
	UI32	dwLength;
	UI32	dwLoops;
} CPlaySegment;

class CPlayListChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32			dwSegments;
		CPlaySegment	*dstSegment;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CPlayListChunk(HMMIO hFile = NULL);
	~CPlayListChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI32 dwSegments = 0, CPlaySegment *dstSegment = NULL);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    label chunk
 ***********************************************************************************************************************
 */

class CLabelChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32	dwName;
		char	*data;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CLabelChunk(HMMIO hFile = NULL);
	~CLabelChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI32 dwName = 0, char *data = NULL);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    note chunk
 ***********************************************************************************************************************
 */

class CNoteChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32	dwName;
		char	*data;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CNoteChunk(HMMIO hFile = NULL);
	~CNoteChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI32 dwName = 0, char *data = NULL);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    textl chunk
 ***********************************************************************************************************************
 */

class CTextlChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct __CTextlChunk
	{
		UI32	dwName;
		UI32	dwSampleLength;
		char	dwPurpose[4];
		UI16	wCountry;
		UI16	wLanguage;
		UI16	wDialect;
		UI16	wCodePage;
		char	*data;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CTextlChunk(HMMIO hFile = NULL);
	~CTextlChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init
			(
				UI32	dwName = 0,
				UI32	dwSampleLength = 0,
				char	dwPurpose[4] = "",
				UI16	wCountry = 0,
				UI16	wLanguage = 0,
				UI16	wDialect = 0,
				UI16	wCodePage = 0,
				char	*data = NULL
			);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    file chunk
 ***********************************************************************************************************************
 */

class CFileChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32	dwName;
		UI32	dwMedType;
		UI8		*fileData;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CFileChunk(HMMIO hFile = NULL);
	~CFileChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI32 dwName = 0, UI32 dwMedType = 0, UI8 *fileData = NULL);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    associated data chunk
 ***********************************************************************************************************************
 */

class CAssociatedDataList :
	public CForm
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CList<CLabelChunk *, CLabelChunk *> m_LabelList;
	CList<CNoteChunk *, CNoteChunk *>	m_NoteList;
	CList<CTextlChunk *, CTextlChunk *> m_TextlList;
	CList<CFileChunk *, CFileChunk *>	m_FileList;

	CLabelChunk							*m_poLabelCk;
	CNoteChunk							*m_poNoteCk;
	CTextlChunk							*m_poTextCk;
	CFileChunk							*m_poFileCk;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CAssociatedDataList(HMMIO hFile = NULL);
	~CAssociatedDataList(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(void);
	int		Save(HMMIO hFile = NULL);
};

/*$4
 ***********************************************************************************************************************
    instrument chunk
 ***********************************************************************************************************************
 */

class CInstrumentChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI8 bUnshiftedNote;
		UI8 chFineTune;
		UI8 chGain;
		UI8 bLowNote;
		UI8 bHighNote;
		UI8 bLowVelocity;
		UI8 bHighVelocity;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CInstrumentChunk
	(
		UI8 bUnshiftedNote = 0,
		UI8 chFineTune = 0,
		UI8 chGain = 0,
		UI8 bLowNote = 0,
		UI8 bHighNote = 0,
		UI8 bLowVelocity = 0,
		UI8 bHighVelocity = 0
	);
};

/*$4
 ***********************************************************************************************************************
    sample chunk
 ***********************************************************************************************************************
 */

class	CSampleLoop
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	UI32	dwIdentifier;
	UI32	dwType;
	UI32	dwStart;
	UI32	dwEnd;
	UI32	dwFraction;
	UI32	dwPlayCount;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CSampleLoop
	(
		UI32	_dwIdentifier = 0,
		UI32	_dwType = 0,
		UI32	_dwStart = 0,
		UI32	_dwEnd = 0,
		UI32	_dwFraction = 0,
		UI32	_dwPlayCount = 0
	)
	{
		dwIdentifier = _dwIdentifier;
		dwType = _dwType;
		dwStart = _dwStart;
		dwEnd = _dwEnd;
		dwFraction = _dwFraction;
		dwPlayCount = _dwPlayCount;
	}
};

class CSampleChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32		dwManufacturer;
		UI32		dwProduct;
		UI32		dwSamplePeriod;
		UI32		dwMIDIUnityNote;
		UI32		dwMIDIPitchFraction;
		UI32		dwSMPTEFormat;
		UI32		dwSMPTEOffset;
		UI32		cSampleLoops;
		UI32		cbSamplerData;
		CSampleLoop *dstSampleLoop;
		UI8			*dstSamplerSpecificData;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CSampleChunk
	(
		UI32		dwManufacturer,
		UI32		dwProduct,
		UI32		dwSamplePeriod,
		UI32		dwMIDIUnityNote,
		UI32		dwMIDIPitchFraction,
		UI32		dwSMPTEFormat,
		UI32		dwSMPTEOffset,
		UI32		cSampleLoops,
		UI32		cbSamplerData,
		CSampleLoop *dstSampleLoop,
		UI8			*dstSamplerSpecificData
	);
	~CSampleChunk(void);
};

/*$4
 ***********************************************************************************************************************
    data chunk
 ***********************************************************************************************************************
 */

class CDataChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	UI8 *m_pData;
    UI32 m_dwPadding;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CDataChunk(HMMIO hFile = NULL);
	~CDataChunk(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Init(UI8 *data = NULL);
	int		Save(HMMIO hFile = NULL);
    void    Padding(UI32);
};

/*$4
 ***********************************************************************************************************************
    silence chunk
 ***********************************************************************************************************************
 */

class CSilenceChunk :
	public CChunk
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct
	{
		UI32	dwSamples;
	} m_Data;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CSilenceChunk(UI32 dwSamples = 0);
};

/*$4
 ***********************************************************************************************************************
    data list
 ***********************************************************************************************************************
 */

class CDataList :
	public CForm
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	struct __CDataList
	{
		CDataChunk		o_DataCk;
		CSilenceChunk	o_SilenceCk;
	}
	*m_pData;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CDataList(UI32 size = 0);
	~CDataList(void);
};

/*$4
 ***********************************************************************************************************************
    RIFF file
 ***********************************************************************************************************************
 */

class CRIFFForm :
	public CForm
{
/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
private:
	HMMIO		m_hmmio;
	bool		m_bReadMode;
	MMCKINFO	m_ckRiff;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CFormatChunk		*m_pFormatCk;
	CFactChunk			*m_pFactCk;
	CCuePointChunk		*m_pCueCk;
	CPlayListChunk		*m_pPlayListCk;
	CAssociatedDataList *m_pAssDataLst;
	CDataChunk			*m_pDataCk;
	CDataList			*m_pDataList;

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	CRIFFForm(void);
	~CRIFFForm(void);

/*
 -----------------------------------------------------------------------------------------------------------------------
 -----------------------------------------------------------------------------------------------------------------------
 */
public:
	void	Reset(void);
	int		Load(void);
	int		Open(char *strFileName, bool b_readmode = true);
	void	Close(void);
	int		Save(void);
    int     AlignMarkers(UI32 dwAlign);
};

#pragma pack(pop, 1)
/*$4
 ***********************************************************************************************************************
    EOF
 ***********************************************************************************************************************
 */
