/*$T MDFmodifier_GEO.c GC! 1.081 06/09/00 09:00:51 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */

#if defined(PSX2_TARGET) && defined(__cplusplus)
extern "C"
{
#endif
 

#include "Precomp.h"
#include "BASe/BAStypes.h"

#include "BASe/CLIbrary/CLIstr.h"
#include "BASe/MEMory/MEM.h"
#include "MATHs/MATH.h"
#include "ENGine/Sources/WORld/WORaccess.h"
#include "ENGine/Sources/Grid/GRI_Struct.h"
#include "ENGine/Sources/GRId/GRI_display.h"

#include "ENGine/Sources/ANImation/ANIstruct.h"

#include "ENGine/Sources/OBJects/OBJorient.h"
#include "ENGine/Sources/OBJects/OBJslowaccess.h"
#include "ENGine/Sources/OBJects/OBJload.h"
#include "ENGine/Sources/COLlision/COLray.h"
#include "GDInterface/GDInterface.h"
#include "GDInterface/GDIrasters.h"
#include "GDInterface/GDIrequest.h"

#include "MoDiFier/MDFstruct.h"
#include "MoDiFier/MDFmodifier_SPG2.h"
#include "GEOmetric/GEOobject.h"
#include "GEOmetric/GEOstaticLOD.h"
#include "GEOmetric/GEOload.h"
#include "SOFT/SOFTstruct.h"
#include "SOFT/SOFTzlist.h"
#ifndef PSX2_TARGET
#include "MATHs/MATHvector_aligned.h"
#endif

#ifdef JADEFUSION
#include "GraphicDK/Sources/GFX/GFX.h"
#endif
#if defined(_XENON_RENDER)
#include "XenonGraphics/XeMesh.h"
#include "XenonGraphics/XeRenderer.h"
#include "XenonGraphics/XeContextManager.h"
#endif

#ifdef ACTIVE_EDITORS
#include "BIGfiles/SAVing/SAVdefs.h"
#endif
#include "BIGfiles/LOAding/LOAdefs.h"
#include "BIGfiles/LOAding/LOAread.h"
#include "BIGfiles/BIGfat.h"

#include "BASe/BENch/BENch.h"
#ifndef JADEFUSION
#undef __FILE__
#define __FILE__ "PG2"
#endif

#ifdef JADEFUSION
#include "Xenon/HackManager/HackManager.h"
extern float TIM_gf_realdt;
int g_iCurrentFireContext = 0;

#else


#define SPG2_RELATIVE_COMPUTING

#define MAX_RND 4096
typedef struct FakeStr_
{
	MATH_tdst_Vector         FakeXYZ;
	ULONG					AlphhaT;
} FakeStr ONLY_PSX2_ALIGNED(16);
#endif

UINT SPG2_gb_Recompute = FALSE;
static float					WindWaves[256];
static ULONG					WindWavesBase = 0xffffffff;

#ifdef JADEFUSION
FakeStr					Fake[MAX_RND + 1] = 
#else
static FakeStr					Fake[MAX_RND + 1] = 
#endif
{
{  { 0.453568f, 0.032258f, 0.514174f},  158}  ,{  { 0.509286f, 0.324536f, 0.166178f},  125}  ,{  { 0.750733f, 0.076246f, 0.173021f},   77}  ,{  { 0.369501f, 0.476051f, 0.154448f},  143}  ,{  { 0.147605f, 0.636364f, 0.216031f},  195}  ,{  { 0.116325f, 0.467253f, 0.416422f},  173}  ,{  { 0.188661f, 0.377322f, 0.434018f},  203}  ,{  { 0.114370f, 0.058651f, 0.826979f},  245}  ,{  { 0.739003f, 0.084066f, 0.176931f},  101}  ,{  { 0.072336f, 0.467253f, 0.460411f},  166}  ,{  { 0.403715f, 0.565982f, 0.030303f},  188}  ,{  { 0.116325f, 0.865103f, 0.018573f},   12}  ,{  { 0.469208f, 0.123167f, 0.407625f},   59}  ,{  { 0.088954f, 0.183773f, 0.727273f},   15}  ,{  { 0.149560f, 0.237537f, 0.612903f},   99}  ,{  { 0.448680f, 0.523949f, 0.027370f},   69}  ,{  { 0.250244f, 0.676442f, 0.073314f},  215}  ,{  { 0.646139f, 0.288368f, 0.065494f},   66}  ,{  { 0.696970f, 0.194526f, 0.108504f},  191}  ,{  { 0.305963f, 0.137830f, 0.556207f},  137}  ,{  { 0.413490f, 0.336266f, 0.250244f},  148}  ,{  { 0.264907f, 0.482893f, 0.252199f},   11}  ,{  { 0.035191f, 0.284457f, 0.680352f},    5}  ,{  { 0.164223f, 0.138807f, 0.696970f},   77}  ,{  { 0.181818f, 0.345064f, 0.473118f},  127}  ,{  { 0.154448f, 0.378299f, 0.467253f},   47}  ,{  { 0.371457f, 0.497556f, 0.130987f},   79}  ,{  { 0.661779f, 0.251222f, 0.086999f},   20}  ,{  { 0.363636f, 0.083089f, 0.553275f},   37}  ,{  { 0.110459f, 0.713587f, 0.175953f},  184}  ,{  { 0.143695f, 0.406647f, 0.449658f},  189}  ,{  { 0.827957f, 0.053763f, 0.118280f},   87}  ,
{  { 0.177908f, 0.547410f, 0.274682f},  150}  ,{  { 0.708700f, 0.078201f, 0.213099f},  247}  ,{  { 0.894428f, 0.086999f, 0.018573f},  115}  ,{  { 0.724340f, 0.270772f, 0.004888f},   81}  ,{  { 0.127077f, 0.326491f, 0.546432f},  246}  ,{  { 0.249267f, 0.209189f, 0.541544f},   12}  ,{  { 0.219941f, 0.775171f, 0.004888f},  135}  ,{  { 0.207234f, 0.778104f, 0.014663f},  210}  ,{  { 0.164223f, 0.680352f, 0.155425f},  128}  ,{  { 0.498534f, 0.487781f, 0.013685f},  200}  ,{  { 0.151515f, 0.291300f, 0.557185f},  162}  ,{  { 0.132942f, 0.701857f, 0.165200f},  135}  ,{  { 0.268817f, 0.080156f, 0.651026f},    4}  ,{  { 0.277615f, 0.634409f, 0.087977f},   35}  ,{  { 0.230694f, 0.601173f, 0.168133f},  162}  ,{  { 0.302053f, 0.263930f, 0.434018f},   38}  ,{  { 0.141740f, 0.130010f, 0.728250f},   65}  ,{  { 0.433040f, 0.557185f, 0.009775f},   64}  ,{  { 0.656891f, 0.179863f, 0.163245f},  206}  ,{  { 0.088954f, 0.778104f, 0.132942f},   23}  ,{  { 0.456501f, 0.505376f, 0.038123f},  250}  ,{  { 0.643206f, 0.334311f, 0.022483f},  212}  ,{  { 0.137830f, 0.461388f, 0.400782f},   63}  ,{  { 0.087977f, 0.652004f, 0.260020f},   65}  ,{  { 0.772238f, 0.161290f, 0.066471f},   80}  ,{  { 0.069404f, 0.797654f, 0.132942f},  115}  ,{  { 0.093842f, 0.753666f, 0.152493f},  103}  ,{  { 0.168133f, 0.021505f, 0.810362f},    9}  ,{  { 0.808407f, 0.180841f, 0.010753f},  198}  ,{  { 0.066471f, 0.116325f, 0.817204f},   14}  ,{  { 0.299120f, 0.183773f, 0.517107f},   60}  ,{  { 0.133920f, 0.346041f, 0.520039f},  253}  ,
{  { 0.320626f, 0.321603f, 0.357771f},   49}  ,{  { 0.065494f, 0.804497f, 0.130010f},   75}  ,{  { 0.064516f, 0.340176f, 0.595308f},   64}  ,{  { 0.281525f, 0.430108f, 0.288368f},   24}  ,{  { 0.841642f, 0.085044f, 0.073314f},   57}  ,{  { 0.090909f, 0.227761f, 0.681329f},  111}  ,{  { 0.665689f, 0.067449f, 0.266862f},   26}  ,{  { 0.518084f, 0.261975f, 0.219941f},  207}  ,{  { 0.699902f, 0.038123f, 0.261975f},  168}  ,{  { 0.105572f, 0.100684f, 0.793744f},  117}  ,{  { 0.013685f, 0.542522f, 0.443793f},  254}  ,{  { 0.762463f, 0.198436f, 0.039101f},    1}  ,{  { 0.283480f, 0.573803f, 0.142717f},    4}  ,{  { 0.244379f, 0.260020f, 0.495601f},   36}  ,{  { 0.409580f, 0.116325f, 0.474096f},  172}  ,{  { 0.266862f, 0.732160f, 0.000978f},  124}  ,{  { 0.100684f, 0.169110f, 0.730205f},   45}  ,{  { 0.213099f, 0.776149f, 0.010753f},  140}  ,{  { 0.308895f, 0.490714f, 0.200391f},  193}  ,{  { 0.093842f, 0.621701f, 0.284457f},   83}  ,{  { 0.607038f, 0.040078f, 0.352884f},  191}  ,{  { 0.179863f, 0.178886f, 0.641251f},  115}  ,{  { 0.499511f, 0.053763f, 0.446725f},  133}  ,{  { 0.130987f, 0.105572f, 0.763441f},  232}  ,{  { 0.423265f, 0.049853f, 0.526882f},   71}  ,{  { 0.217009f, 0.763441f, 0.019550f},   40}  ,{  { 0.324536f, 0.533724f, 0.141740f},  108}  ,{  { 0.127077f, 0.755621f, 0.117302f},  199}  ,{  { 0.217986f, 0.099707f, 0.682307f},   59}  ,{  { 0.055718f, 0.838710f, 0.105572f},   61}  ,{  { 0.094819f, 0.371457f, 0.533724f},   92}  ,{  { 0.172043f, 0.618768f, 0.209189f},   14}  ,
{  { 0.197458f, 0.487781f, 0.314761f},  104}  ,{  { 0.377322f, 0.380254f, 0.242424f},  240}  ,{  { 0.118280f, 0.764418f, 0.117302f},  106}  ,{  { 0.535679f, 0.179863f, 0.284457f},   34}  ,{  { 0.504399f, 0.290323f, 0.205279f},  131}  ,{  { 0.362659f, 0.264907f, 0.372434f},  190}  ,{  { 0.010753f, 0.841642f, 0.147605f},    1}  ,{  { 0.477028f, 0.117302f, 0.405670f},   78}  ,{  { 0.747801f, 0.133920f, 0.118280f},  198}  ,{  { 0.717498f, 0.147605f, 0.134897f},   50}  ,{  { 0.156403f, 0.012708f, 0.830890f},   47}  ,{  { 0.056696f, 0.518084f, 0.425220f},  107}  ,{  { 0.213099f, 0.548387f, 0.238514f},  169}  ,{  { 0.328446f, 0.542522f, 0.129032f},  143}  ,{  { 0.213099f, 0.643206f, 0.143695f},  206}  ,{  { 0.145650f, 0.058651f, 0.795699f},   62}  ,{  { 0.445748f, 0.409580f, 0.144673f},  177}  ,{  { 0.250244f, 0.677419f, 0.072336f},  249}  ,{  { 0.005865f, 0.365591f, 0.628543f},  102}  ,{  { 0.807429f, 0.016618f, 0.175953f},  220}  ,{  { 0.133920f, 0.641251f, 0.224829f},   28}  ,{  { 0.421310f, 0.518084f, 0.060606f},   95}  ,{  { 0.370479f, 0.573803f, 0.055718f},  252}  ,{  { 0.320626f, 0.205279f, 0.474096f},  225}  ,{  { 0.902248f, 0.083089f, 0.014663f},  157}  ,{  { 0.752688f, 0.207234f, 0.040078f},   33}  ,{  { 0.420332f, 0.438905f, 0.140762f},    5}  ,{  { 0.479961f, 0.158358f, 0.361681f},   63}  ,{  { 0.034213f, 0.409580f, 0.556207f},   67}  ,{  { 0.565005f, 0.370479f, 0.064516f},  237}  ,{  { 0.156403f, 0.260020f, 0.583578f},  134}  ,{  { 0.347019f, 0.014663f, 0.638319f},  178}  ,
{  { 0.150538f, 0.086999f, 0.762463f},   20}  ,{  { 0.558162f, 0.239492f, 0.202346f},  238}  ,{  { 0.667644f, 0.294233f, 0.038123f},   16}  ,{  { 0.249267f, 0.384164f, 0.366569f},  216}  ,{  { 0.545455f, 0.124145f, 0.330401f},  221}  ,{  { 0.407625f, 0.052786f, 0.539589f},  175}  ,{  { 0.218964f, 0.426197f, 0.354839f},   92}  ,{  { 0.034213f, 0.290323f, 0.675464f},  154}  ,{  { 0.402737f, 0.241447f, 0.355816f},   27}  ,{  { 0.284457f, 0.239492f, 0.476051f},   56}  ,{  { 0.000000f, 0.298143f, 0.701857f},   56}  ,{  { 0.336266f, 0.559140f, 0.104594f},   73}  ,{  { 0.057674f, 0.615836f, 0.326491f},   60}  ,{  { 0.043011f, 0.757576f, 0.199413f},   14}  ,{  { 0.913979f, 0.022483f, 0.063539f},  138}  ,{  { 0.355816f, 0.162268f, 0.481916f},  226}  ,{  { 0.514174f, 0.060606f, 0.425220f},   11}  ,{  { 0.279570f, 0.330401f, 0.390029f},  189}  ,{  { 0.647116f, 0.121212f, 0.231672f},  182}  ,{  { 0.390029f, 0.377322f, 0.232649f},  255}  ,{  { 0.121212f, 0.153470f, 0.725318f},  206}  ,{  { 0.092864f, 0.418377f, 0.488759f},  175}  ,{  { 0.382209f, 0.314761f, 0.303030f},   78}  ,{  { 0.021505f, 0.585533f, 0.392962f},  107}  ,{  { 0.366569f, 0.018573f, 0.614858f},  248}  ,{  { 0.743891f, 0.192571f, 0.063539f},  250}  ,{  { 0.032258f, 0.912023f, 0.055718f},  136}  ,{  { 0.064516f, 0.605083f, 0.330401f},  114}  ,{  { 0.363636f, 0.015640f, 0.620723f},  235}  ,{  { 0.466276f, 0.274682f, 0.259042f},  156}  ,{  { 0.229717f, 0.480938f, 0.289345f},  133}  ,{  { 0.252199f, 0.559140f, 0.188661f},   17}  ,
{  { 0.341153f, 0.078201f, 0.580645f},  204}  ,{  { 0.140762f, 0.157380f, 0.701857f},  123}  ,{  { 0.523949f, 0.057674f, 0.418377f},   68}  ,{  { 0.268817f, 0.134897f, 0.596285f},  125}  ,{  { 0.399805f, 0.042033f, 0.558162f},   96}  ,{  { 0.069404f, 0.907136f, 0.023460f},  140}  ,{  { 0.048876f, 0.039101f, 0.912023f},  123}  ,{  { 0.138807f, 0.740958f, 0.120235f},  141}  ,{  { 0.750733f, 0.008798f, 0.240469f},  109}  ,{  { 0.037146f, 0.739003f, 0.223851f},   27}  ,{  { 0.501466f, 0.311828f, 0.186706f},   29}  ,{  { 0.041056f, 0.679374f, 0.279570f},  178}  ,{  { 0.040078f, 0.570870f, 0.389052f},  196}  ,{  { 0.112414f, 0.615836f, 0.271750f},  187}  ,{  { 0.383187f, 0.043011f, 0.573803f},  193}  ,{  { 0.715542f, 0.240469f, 0.043988f},   79}  ,{  { 0.715542f, 0.066471f, 0.217986f},  114}  ,{  { 0.073314f, 0.205279f, 0.721408f},  159}  ,{  { 0.060606f, 0.850440f, 0.088954f},  198}  ,{  { 0.530792f, 0.467253f, 0.001955f},  108}  ,{  { 0.542522f, 0.188661f, 0.268817f},  212}  ,{  { 0.276637f, 0.307918f, 0.415445f},  239}  ,{  { 0.558162f, 0.148583f, 0.293255f},   86}  ,{  { 0.119257f, 0.095797f, 0.784946f},   19}  ,{  { 0.578690f, 0.224829f, 0.196481f},   94}  ,{  { 0.784946f, 0.039101f, 0.175953f},  234}  ,{  { 0.859238f, 0.036168f, 0.104594f},   88}  ,{  { 0.043988f, 0.878788f, 0.077224f},   26}  ,{  { 0.344086f, 0.434018f, 0.221896f},   27}  ,{  { 0.008798f, 0.755621f, 0.235582f},   35}  ,{  { 0.301075f, 0.332356f, 0.366569f},  163}  ,{  { 0.359726f, 0.255132f, 0.385142f},  220}  ,
{  { 0.218964f, 0.200391f, 0.580645f},  138}  ,{  { 0.106549f, 0.522972f, 0.370479f},  180}  ,{  { 0.304985f, 0.126100f, 0.568915f},   52}  ,{  { 0.206256f, 0.189638f, 0.604106f},   49}  ,{  { 0.137830f, 0.643206f, 0.218964f},  189}  ,{  { 0.241447f, 0.244379f, 0.514174f},  162}  ,{  { 0.054741f, 0.456501f, 0.488759f},   38}  ,{  { 0.585533f, 0.025415f, 0.389052f},  109}  ,{  { 0.011730f, 0.199413f, 0.788856f},  190}  ,{  { 0.492669f, 0.198436f, 0.308895f},  110}  ,{  { 0.194526f, 0.093842f, 0.711632f},   20}  ,{  { 0.408602f, 0.473118f, 0.118280f},  151}  ,{  { 0.112414f, 0.529814f, 0.357771f},  225}  ,{  { 0.022483f, 0.975562f, 0.001955f},  187}  ,{  { 0.247312f, 0.100684f, 0.652004f},  216}  ,{  { 0.241447f, 0.567937f, 0.190616f},    5}  ,{  { 0.594330f, 0.167155f, 0.238514f},   15}  ,{  { 0.380254f, 0.138807f, 0.480938f},   20}  ,{  { 0.152493f, 0.681329f, 0.166178f},  174}  ,{  { 0.095797f, 0.298143f, 0.606061f},  239}  ,{  { 0.508309f, 0.454545f, 0.037146f},  142}  ,{  { 0.572825f, 0.006843f, 0.420332f},  162}  ,{  { 0.355816f, 0.119257f, 0.524927f},   42}  ,{  { 0.782014f, 0.200391f, 0.017595f},  216}  ,{  { 0.827957f, 0.080156f, 0.091887f},   73}  ,{  { 0.304985f, 0.209189f, 0.485826f},  131}  ,{  { 0.186706f, 0.179863f, 0.633431f},  251}  ,{  { 0.169110f, 0.012708f, 0.818182f},  100}  ,{  { 0.235582f, 0.126100f, 0.638319f},   79}  ,{  { 0.561095f, 0.270772f, 0.168133f},  212}  ,{  { 0.563050f, 0.224829f, 0.212121f},  127}  ,{  { 0.369501f, 0.373412f, 0.257087f},  245}  ,
{  { 0.048876f, 0.759531f, 0.191593f},   12}  ,{  { 0.260020f, 0.524927f, 0.215054f},  226}  ,{  { 0.756598f, 0.032258f, 0.211144f},   92}  ,{  { 0.419355f, 0.521994f, 0.058651f},  235}  ,{  { 0.727273f, 0.212121f, 0.060606f},  169}  ,{  { 0.545455f, 0.227761f, 0.226784f},   14}  ,{  { 0.355816f, 0.516129f, 0.128055f},   85}  ,{  { 0.360704f, 0.566960f, 0.072336f},  130}  ,{  { 0.608993f, 0.088954f, 0.302053f},  193}  ,{  { 0.738025f, 0.109482f, 0.152493f},   18}  ,{  { 0.114370f, 0.512219f, 0.373412f},  160}  ,{  { 0.278592f, 0.290323f, 0.431085f},   19}  ,{  { 0.341153f, 0.512219f, 0.146628f},  229}  ,{  { 0.069404f, 0.125122f, 0.805474f},   85}  ,{  { 0.459433f, 0.173021f, 0.367546f},  119}  ,{  { 0.080156f, 0.029326f, 0.890518f},  142}  ,{  { 0.263930f, 0.615836f, 0.120235f},  229}  ,{  { 0.274682f, 0.515152f, 0.210166f},  124}  ,{  { 0.155425f, 0.262952f, 0.581623f},   77}  ,{  { 0.202346f, 0.131965f, 0.665689f},   48}  ,{  { 0.031281f, 0.108504f, 0.860215f},   46}  ,{  { 0.102639f, 0.124145f, 0.773216f},  236}  ,{  { 0.718475f, 0.160313f, 0.121212f},   48}  ,{  { 0.399805f, 0.317693f, 0.282502f},  179}  ,{  { 0.563050f, 0.369501f, 0.067449f},  105}  ,{  { 0.684262f, 0.211144f, 0.104594f},  180}  ,{  { 0.308895f, 0.521017f, 0.170088f},  208}  ,{  { 0.040078f, 0.220919f, 0.739003f},   52}  ,{  { 0.135875f, 0.766373f, 0.097752f},   23}  ,{  { 0.254154f, 0.410557f, 0.335288f},  177}  ,{  { 0.544477f, 0.113392f, 0.342131f},    5}  ,{  { 0.152493f, 0.820137f, 0.027370f},  183}  ,
{  { 0.011730f, 0.819159f, 0.169110f},   42}  ,{  { 0.216031f, 0.216031f, 0.567937f},  140}  ,{  { 0.506354f, 0.433040f, 0.060606f},  148}  ,{  { 0.110459f, 0.340176f, 0.549365f},  110}  ,{  { 0.344086f, 0.330401f, 0.325513f},   39}  ,{  { 0.517107f, 0.455523f, 0.027370f},  192}  ,{  { 0.219941f, 0.179863f, 0.600196f},   54}  ,{  { 0.044966f, 0.252199f, 0.702835f},   13}  ,{  { 0.644184f, 0.061584f, 0.294233f},  133}  ,{  { 0.098729f, 0.130010f, 0.771261f},  223}  ,{  { 0.196481f, 0.777126f, 0.026393f},  210}  ,{  { 0.738025f, 0.230694f, 0.031281f},  233}  ,{  { 0.195503f, 0.779081f, 0.025415f},   58}  ,{  { 0.481916f, 0.252199f, 0.265885f},   44}  ,{  { 0.145650f, 0.201369f, 0.652981f},   26}  ,{  { 0.736070f, 0.247312f, 0.016618f},  164}  ,{  { 0.200391f, 0.182796f, 0.616813f},  178}  ,{  { 0.355816f, 0.569892f, 0.074291f},  104}  ,{  { 0.209189f, 0.551320f, 0.239492f},  181}  ,{  { 0.563050f, 0.074291f, 0.362659f},  155}  ,{  { 0.274682f, 0.708700f, 0.016618f},  125}  ,{  { 0.429130f, 0.235582f, 0.335288f},  227}  ,{  { 0.728250f, 0.157380f, 0.114370f},   79}  ,{  { 0.642229f, 0.070381f, 0.287390f},   77}  ,{  { 0.107527f, 0.527859f, 0.364614f},  217}  ,{  { 0.453568f, 0.033236f, 0.513196f},  243}  ,{  { 0.670577f, 0.084066f, 0.245357f},   71}  ,{  { 0.225806f, 0.324536f, 0.449658f},  211}  ,{  { 0.136852f, 0.225806f, 0.637341f},  243}  ,{  { 0.799609f, 0.071359f, 0.129032f},  148}  ,{  { 0.193548f, 0.311828f, 0.494624f},  148}  ,{  { 0.055718f, 0.593353f, 0.350929f},   61}  ,
{  { 0.124145f, 0.552297f, 0.323558f},  212}  ,{  { 0.009775f, 0.410557f, 0.579668f},  181}  ,{  { 0.172043f, 0.245357f, 0.582600f},    8}  ,{  { 0.026393f, 0.027370f, 0.946237f},   57}  ,{  { 0.048876f, 0.455523f, 0.495601f},  121}  ,{  { 0.718475f, 0.122190f, 0.159335f},    8}  ,{  { 0.219941f, 0.480938f, 0.299120f},  137}  ,{  { 0.288368f, 0.650049f, 0.061584f},  226}  ,{  { 0.743891f, 0.086999f, 0.169110f},  186}  ,{  { 0.335288f, 0.480938f, 0.183773f},  227}  ,{  { 0.540567f, 0.235582f, 0.223851f},   58}  ,{  { 0.027370f, 0.608016f, 0.364614f},   89}  ,{  { 0.246334f, 0.300098f, 0.453568f},   50}  ,{  { 0.025415f, 0.085044f, 0.889541f},  113}  ,{  { 0.067449f, 0.726295f, 0.206256f},  150}  ,{  { 0.112414f, 0.860215f, 0.027370f},   84}  ,{  { 0.580645f, 0.233627f, 0.185728f},   75}  ,{  { 0.022483f, 0.088954f, 0.888563f},   76}  ,{  { 0.004888f, 0.621701f, 0.373412f},  201}  ,{  { 0.074291f, 0.077224f, 0.848485f},  140}  ,{  { 0.087977f, 0.181818f, 0.730205f},  170}  ,{  { 0.672532f, 0.223851f, 0.103617f},   50}  ,{  { 0.226784f, 0.297165f, 0.476051f},   90}  ,{  { 0.858260f, 0.092864f, 0.048876f},  246}  ,{  { 0.865103f, 0.099707f, 0.035191f},  169}  ,{  { 0.013685f, 0.174976f, 0.811339f},  217}  ,{  { 0.413490f, 0.143695f, 0.442815f},  148}  ,{  { 0.206256f, 0.670577f, 0.123167f},  124}  ,{  { 0.167155f, 0.016618f, 0.816227f},   77}  ,{  { 0.134897f, 0.005865f, 0.859238f},  185}  ,{  { 0.410557f, 0.160313f, 0.429130f},  181}  ,{  { 0.301075f, 0.066471f, 0.632454f},  147}  ,
{  { 0.495601f, 0.221896f, 0.282502f},    9}  ,{  { 0.010753f, 0.469208f, 0.520039f},  220}  ,{  { 0.276637f, 0.026393f, 0.696970f},   24}  ,{  { 0.510264f, 0.250244f, 0.239492f},   27}  ,{  { 0.392962f, 0.405670f, 0.201369f},  188}  ,{  { 0.580645f, 0.346041f, 0.073314f},  243}  ,{  { 0.781036f, 0.147605f, 0.071359f},  217}  ,{  { 0.304008f, 0.581623f, 0.114370f},   84}  ,{  { 0.563050f, 0.117302f, 0.319648f},    1}  ,{  { 0.092864f, 0.308895f, 0.598240f},  239}  ,{  { 0.347996f, 0.297165f, 0.354839f},  188}  ,{  { 0.297165f, 0.674487f, 0.028348f},   61}  ,{  { 0.278592f, 0.045943f, 0.675464f},   12}  ,{  { 0.224829f, 0.585533f, 0.189638f},   34}  ,{  { 0.312805f, 0.284457f, 0.402737f},   50}  ,{  { 0.123167f, 0.140762f, 0.736070f},  169}  ,{  { 0.213099f, 0.229717f, 0.557185f},   17}  ,{  { 0.051808f, 0.156403f, 0.791789f},  231}  ,{  { 0.357771f, 0.427175f, 0.215054f},   20}  ,{  { 0.050831f, 0.580645f, 0.368524f},   13}  ,{  { 0.435973f, 0.293255f, 0.270772f},  158}  ,{  { 0.167155f, 0.500489f, 0.332356f},  195}  ,{  { 0.107527f, 0.180841f, 0.711632f},  245}  ,{  { 0.423265f, 0.526882f, 0.049853f},   89}  ,{  { 0.023460f, 0.802542f, 0.173998f},  189}  ,{  { 0.205279f, 0.386119f, 0.408602f},  208}  ,{  { 0.046921f, 0.075269f, 0.877810f},    7}  ,{  { 0.097752f, 0.102639f, 0.799609f},  162}  ,{  { 0.006843f, 0.550342f, 0.442815f},   21}  ,{  { 0.612903f, 0.350929f, 0.036168f},   57}  ,{  { 0.818182f, 0.076246f, 0.105572f},   25}  ,{  { 0.143695f, 0.158358f, 0.697947f},  106}  ,
{  { 0.781036f, 0.185728f, 0.033236f},    3}  ,{  { 0.463343f, 0.506354f, 0.030303f},  106}  ,{  { 0.085044f, 0.048876f, 0.866080f},  249}  ,{  { 0.147605f, 0.834800f, 0.017595f},  187}  ,{  { 0.686217f, 0.054741f, 0.259042f},  243}  ,{  { 0.310850f, 0.385142f, 0.304008f},   92}  ,{  { 0.090909f, 0.855327f, 0.053763f},  128}  ,{  { 0.605083f, 0.365591f, 0.029326f},  134}  ,{  { 0.065494f, 0.336266f, 0.598240f},    1}  ,{  { 0.419355f, 0.420332f, 0.160313f},  215}  ,{  { 0.000978f, 0.400782f, 0.598240f},   34}  ,{  { 0.844575f, 0.095797f, 0.059629f},   38}  ,{  { 0.808407f, 0.139785f, 0.051808f},  196}  ,{  { 0.095797f, 0.760508f, 0.143695f},  252}  ,{  { 0.397849f, 0.281525f, 0.320626f},  190}  ,{  { 0.546432f, 0.156403f, 0.297165f},  179}  ,{  { 0.478983f, 0.496579f, 0.024438f},  116}  ,{  { 0.220919f, 0.713587f, 0.065494f},  171}  ,{  { 0.082111f, 0.745846f, 0.172043f},  246}  ,{  { 0.309873f, 0.411535f, 0.278592f},   39}  ,{  { 0.117302f, 0.037146f, 0.845552f},  197}  ,{  { 0.114370f, 0.843597f, 0.042033f},   73}  ,{  { 0.076246f, 0.019550f, 0.904203f},   70}  ,{  { 0.402737f, 0.214076f, 0.383187f},   98}  ,{  { 0.402737f, 0.536657f, 0.060606f},  214}  ,{  { 0.510264f, 0.408602f, 0.081134f},  116}  ,{  { 0.052786f, 0.254154f, 0.693060f},  237}  ,{  { 0.192571f, 0.351906f, 0.455523f},   78}  ,{  { 0.260997f, 0.149560f, 0.589443f},  198}  ,{  { 0.449658f, 0.426197f, 0.124145f},   54}  ,{  { 0.382209f, 0.496579f, 0.121212f},   91}  ,{  { 0.026393f, 0.111437f, 0.862170f},  213}  ,
{  { 0.343109f, 0.615836f, 0.041056f},   77}  ,{  { 0.435973f, 0.556207f, 0.007820f},  102}  ,{  { 0.516129f, 0.285435f, 0.198436f},   58}  ,{  { 0.088954f, 0.493646f, 0.417400f},   29}  ,{  { 0.192571f, 0.423265f, 0.384164f},   48}  ,{  { 0.584555f, 0.160313f, 0.255132f},  216}  ,{  { 0.342131f, 0.269795f, 0.388074f},   24}  ,{  { 0.148583f, 0.746823f, 0.104594f},  223}  ,{  { 0.012708f, 0.962854f, 0.024438f},  150}  ,{  { 0.000978f, 0.336266f, 0.662757f},  187}  ,{  { 0.235582f, 0.068426f, 0.695992f},  189}  ,{  { 0.283480f, 0.333333f, 0.383187f},  154}  ,{  { 0.380254f, 0.595308f, 0.024438f},    9}  ,{  { 0.068426f, 0.669599f, 0.261975f},  228}  ,{  { 0.434018f, 0.461388f, 0.104594f},   90}  ,{  { 0.130987f, 0.376344f, 0.492669f},   97}  ,{  { 0.789834f, 0.159335f, 0.050831f},  154}  ,{  { 0.036168f, 0.332356f, 0.631476f},  170}  ,{  { 0.554252f, 0.315738f, 0.130010f},  165}  ,{  { 0.417400f, 0.072336f, 0.510264f},  151}  ,{  { 0.124145f, 0.661779f, 0.214076f},  103}  ,{  { 0.925709f, 0.020528f, 0.053763f},    4}  ,{  { 0.242424f, 0.228739f, 0.528837f},   60}  ,{  { 0.835777f, 0.130010f, 0.034213f},  128}  ,{  { 0.157380f, 0.608016f, 0.234604f},   78}  ,{  { 0.956012f, 0.002933f, 0.041056f},  119}  ,{  { 0.032258f, 0.484848f, 0.482893f},  171}  ,{  { 0.429130f, 0.220919f, 0.349951f},  191}  ,{  { 0.627566f, 0.016618f, 0.355816f},   32}  ,{  { 0.327468f, 0.405670f, 0.266862f},  242}  ,{  { 0.377322f, 0.354839f, 0.267840f},  194}  ,{  { 0.392962f, 0.154448f, 0.452590f},  134}  ,
{  { 0.115347f, 0.657869f, 0.226784f},    2}  ,{  { 0.141740f, 0.166178f, 0.692082f},  108}  ,{  { 0.443793f, 0.553275f, 0.002933f},  106}  ,{  { 0.145650f, 0.440860f, 0.413490f},  196}  ,{  { 0.411535f, 0.323558f, 0.264907f},   68}  ,{  { 0.209189f, 0.638319f, 0.152493f},  193}  ,{  { 0.199413f, 0.340176f, 0.460411f},  184}  ,{  { 0.226784f, 0.737048f, 0.036168f},    8}  ,{  { 0.252199f, 0.510264f, 0.237537f},  241}  ,{  { 0.188661f, 0.002933f, 0.808407f},  212}  ,{  { 0.074291f, 0.336266f, 0.589443f},   44}  ,{  { 0.025415f, 0.153470f, 0.821114f},   52}  ,{  { 0.406647f, 0.306940f, 0.286413f},   11}  ,{  { 0.143695f, 0.420332f, 0.435973f},   74}  ,{  { 0.092864f, 0.303030f, 0.604106f},    6}  ,{  { 0.650049f, 0.294233f, 0.055718f},  237}  ,{  { 0.100684f, 0.210166f, 0.689150f},  161}  ,{  { 0.565982f, 0.298143f, 0.135875f},  194}  ,{  { 0.046921f, 0.635386f, 0.317693f},  127}  ,{  { 0.196481f, 0.571847f, 0.231672f},  252}  ,{  { 0.081134f, 0.806452f, 0.112414f},  116}  ,{  { 0.363636f, 0.038123f, 0.598240f},   64}  ,{  { 0.503421f, 0.240469f, 0.256109f},   74}  ,{  { 0.043011f, 0.291300f, 0.665689f},  176}  ,{  { 0.518084f, 0.059629f, 0.422287f},   76}  ,{  { 0.566960f, 0.220919f, 0.212121f},    9}  ,{  { 0.003910f, 0.597263f, 0.398827f},  251}  ,{  { 0.197458f, 0.259042f, 0.543500f},  181}  ,{  { 0.506354f, 0.476051f, 0.017595f},  206}  ,{  { 0.555230f, 0.239492f, 0.205279f},  198}  ,{  { 0.233627f, 0.321603f, 0.444770f},  251}  ,{  { 0.705767f, 0.000978f, 0.293255f},  181}  ,
{  { 0.814272f, 0.004888f, 0.180841f},  236}  ,{  { 0.071359f, 0.764418f, 0.164223f},   12}  ,{  { 0.258065f, 0.032258f, 0.709677f},   36}  ,{  { 0.257087f, 0.474096f, 0.268817f},  116}  ,{  { 0.187683f, 0.348974f, 0.463343f},  181}  ,{  { 0.179863f, 0.465298f, 0.354839f},  150}  ,{  { 0.252199f, 0.194526f, 0.553275f},  208}  ,{  { 0.226784f, 0.059629f, 0.713587f},  144}  ,{  { 0.588465f, 0.134897f, 0.276637f},  232}  ,{  { 0.373412f, 0.524927f, 0.101662f},  212}  ,{  { 0.210166f, 0.537634f, 0.252199f},   40}  ,{  { 0.396872f, 0.514174f, 0.088954f},  245}  ,{  { 0.827957f, 0.013685f, 0.158358f},  113}  ,{  { 0.742913f, 0.228739f, 0.028348f},  172}  ,{  { 0.281525f, 0.508309f, 0.210166f},  203}  ,{  { 0.376344f, 0.506354f, 0.117302f},  212}  ,{  { 0.273705f, 0.116325f, 0.609971f},  205}  ,{  { 0.260997f, 0.083089f, 0.655914f},  162}  ,{  { 0.893451f, 0.091887f, 0.014663f},  191}  ,{  { 0.524927f, 0.447703f, 0.027370f},  119}  ,{  { 0.051808f, 0.592375f, 0.355816f},  115}  ,{  { 0.095797f, 0.695015f, 0.209189f},  112}  ,{  { 0.554252f, 0.436950f, 0.008798f},  201}  ,{  { 0.028348f, 0.550342f, 0.421310f},   39}  ,{  { 0.689150f, 0.207234f, 0.103617f},  203}  ,{  { 0.111437f, 0.463343f, 0.425220f},  145}  ,{  { 0.021505f, 0.278592f, 0.699902f},  182}  ,{  { 0.888563f, 0.040078f, 0.071359f},   68}  ,{  { 0.169110f, 0.478006f, 0.352884f},  202}  ,{  { 0.461388f, 0.410557f, 0.128055f},  190}  ,{  { 0.630499f, 0.137830f, 0.231672f},   65}  ,{  { 0.700880f, 0.045943f, 0.253177f},  127}  ,
{  { 0.060606f, 0.873900f, 0.065494f},   29}  ,{  { 0.415445f, 0.084066f, 0.500489f},   19}  ,{  { 0.429130f, 0.409580f, 0.161290f},  239}  ,{  { 0.291300f, 0.110459f, 0.598240f},  168}  ,{  { 0.962854f, 0.006843f, 0.030303f},  194}  ,{  { 0.140762f, 0.814272f, 0.044966f},    7}  ,{  { 0.734115f, 0.194526f, 0.071359f},  174}  ,{  { 0.196481f, 0.755621f, 0.047898f},  172}  ,{  { 0.730205f, 0.045943f, 0.223851f},  195}  ,{  { 0.509286f, 0.189638f, 0.301075f},  147}  ,{  { 0.311828f, 0.235582f, 0.452590f},   62}  ,{  { 0.546432f, 0.349951f, 0.103617f},  188}  ,{  { 0.166178f, 0.280547f, 0.553275f},  222}  ,{  { 0.554252f, 0.088954f, 0.356794f},   93}  ,{  { 0.015640f, 0.535679f, 0.448680f},  135}  ,{  { 0.363636f, 0.497556f, 0.138807f},  245}  ,{  { 0.727273f, 0.162268f, 0.110459f},   65}  ,{  { 0.664712f, 0.076246f, 0.259042f},  218}  ,{  { 0.697947f, 0.211144f, 0.090909f},   70}  ,{  { 0.289345f, 0.476051f, 0.234604f},  202}  ,{  { 0.210166f, 0.435973f, 0.353861f},  164}  ,{  { 0.450635f, 0.218964f, 0.330401f},  190}  ,{  { 0.566960f, 0.332356f, 0.100684f},  101}  ,{  { 0.230694f, 0.220919f, 0.548387f},  175}  ,{  { 0.060606f, 0.648094f, 0.291300f},  251}  ,{  { 0.467253f, 0.404692f, 0.128055f},    4}  ,{  { 0.051808f, 0.178886f, 0.769306f},  137}  ,{  { 0.416422f, 0.191593f, 0.391984f},  136}  ,{  { 0.582600f, 0.086022f, 0.331378f},   51}  ,{  { 0.030303f, 0.078201f, 0.891496f},   61}  ,{  { 0.388074f, 0.362659f, 0.249267f},  137}  ,{  { 0.265885f, 0.582600f, 0.151515f},  186}  ,
{  { 0.618768f, 0.082111f, 0.299120f},   11}  ,{  { 0.041056f, 0.240469f, 0.718475f},  213}  ,{  { 0.212121f, 0.429130f, 0.358749f},  232}  ,{  { 0.514174f, 0.302053f, 0.183773f},  134}  ,{  { 0.513196f, 0.131965f, 0.354839f},  179}  ,{  { 0.154448f, 0.742913f, 0.102639f},   13}  ,{  { 0.284457f, 0.562072f, 0.153470f},  233}  ,{  { 0.662757f, 0.297165f, 0.040078f},  154}  ,{  { 0.858260f, 0.018573f, 0.123167f},   11}  ,{  { 0.385142f, 0.343109f, 0.271750f},  153}  ,{  { 0.529814f, 0.210166f, 0.260020f},  210}  ,{  { 0.169110f, 0.183773f, 0.647116f},  183}  ,{  { 0.449658f, 0.402737f, 0.147605f},   71}  ,{  { 0.153470f, 0.182796f, 0.663734f},   24}  ,{  { 0.839687f, 0.148583f, 0.011730f},  244}  ,{  { 0.664712f, 0.021505f, 0.313783f},  227}  ,{  { 0.381232f, 0.035191f, 0.583578f},  201}  ,{  { 0.756598f, 0.088954f, 0.154448f},  106}  ,{  { 0.836755f, 0.097752f, 0.065494f},   12}  ,{  { 0.112414f, 0.472141f, 0.415445f},   25}  ,{  { 0.078201f, 0.125122f, 0.796676f},  239}  ,{  { 0.557185f, 0.320626f, 0.122190f},  238}  ,{  { 0.012708f, 0.970675f, 0.016618f},  252}  ,{  { 0.209189f, 0.262952f, 0.527859f},  143}  ,{  { 0.487781f, 0.437928f, 0.074291f},  208}  ,{  { 0.404692f, 0.512219f, 0.083089f},  235}  ,{  { 0.388074f, 0.405670f, 0.206256f},   51}  ,{  { 0.175953f, 0.161290f, 0.662757f},  231}  ,{  { 0.240469f, 0.687195f, 0.072336f},  172}  ,{  { 0.680352f, 0.046921f, 0.272727f},   47}  ,{  { 0.446725f, 0.484848f, 0.068426f},  168}  ,{  { 0.012708f, 0.250244f, 0.737048f},  122}  ,
{  { 0.595308f, 0.372434f, 0.032258f},  147}  ,{  { 0.389052f, 0.066471f, 0.544477f},   10}  ,{  { 0.059629f, 0.145650f, 0.794721f},   15}  ,{  { 0.094819f, 0.642229f, 0.262952f},   74}  ,{  { 0.227761f, 0.643206f, 0.129032f},  135}  ,{  { 0.245357f, 0.127077f, 0.627566f},  107}  ,{  { 0.854350f, 0.116325f, 0.029326f},   97}  ,{  { 0.069404f, 0.377322f, 0.553275f},  159}  ,{  { 0.337243f, 0.636364f, 0.026393f},   19}  ,{  { 0.657869f, 0.129032f, 0.213099f},   40}  ,{  { 0.221896f, 0.261975f, 0.516129f},  205}  ,{  { 0.662757f, 0.326491f, 0.010753f},  178}  ,{  { 0.428153f, 0.359726f, 0.212121f},  112}  ,{  { 0.336266f, 0.043011f, 0.620723f},    2}  ,{  { 0.957967f, 0.003910f, 0.038123f},  101}  ,{  { 0.017595f, 0.789834f, 0.192571f},    3}  ,{  { 0.550342f, 0.030303f, 0.419355f},   94}  ,{  { 0.366569f, 0.138807f, 0.494624f},   40}  ,{  { 0.114370f, 0.718475f, 0.167155f},   57}  ,{  { 0.575758f, 0.014663f, 0.409580f},  115}  ,{  { 0.235582f, 0.621701f, 0.142717f},   53}  ,{  { 0.161290f, 0.367546f, 0.471163f},   85}  ,{  { 0.353861f, 0.598240f, 0.047898f},  252}  ,{  { 0.474096f, 0.322581f, 0.203324f},  163}  ,{  { 0.196481f, 0.651026f, 0.152493f},   75}  ,{  { 0.003910f, 0.867058f, 0.129032f},  156}  ,{  { 0.224829f, 0.143695f, 0.631476f},    1}  ,{  { 0.736070f, 0.066471f, 0.197458f},   49}  ,{  { 0.180841f, 0.703812f, 0.115347f},   62}  ,{  { 0.270772f, 0.337243f, 0.391984f},  214}  ,{  { 0.445748f, 0.050831f, 0.503421f},  137}  ,{  { 0.037146f, 0.555230f, 0.407625f},   30}  ,
{  { 0.009775f, 0.963832f, 0.026393f},  165}  ,{  { 0.168133f, 0.046921f, 0.784946f},  180}  ,{  { 0.568915f, 0.116325f, 0.314761f},  241}  ,{  { 0.514174f, 0.427175f, 0.058651f},  111}  ,{  { 0.000978f, 0.000978f, 0.998045f},  215}  ,{  { 0.147605f, 0.687195f, 0.165200f},   15}  ,{  { 0.002933f, 0.578690f, 0.418377f},  203}  ,{  { 0.470186f, 0.409580f, 0.120235f},   58}  ,{  { 0.106549f, 0.849462f, 0.043988f},   50}  ,{  { 0.495601f, 0.042033f, 0.462366f},   37}  ,{  { 0.031281f, 0.217009f, 0.751711f},  196}  ,{  { 0.671554f, 0.112414f, 0.216031f},  213}  ,{  { 0.069404f, 0.585533f, 0.345064f},  170}  ,{  { 0.413490f, 0.079179f, 0.507331f},  161}  ,{  { 0.499511f, 0.201369f, 0.299120f},  101}  ,{  { 0.751711f, 0.093842f, 0.154448f},  220}  ,{  { 0.411535f, 0.388074f, 0.200391f},  226}  ,{  { 0.321603f, 0.485826f, 0.192571f},   69}  ,{  { 0.132942f, 0.652004f, 0.215054f},  197}  ,{  { 0.589443f, 0.277615f, 0.132942f},  209}  ,{  { 0.217009f, 0.738025f, 0.044966f},   34}  ,{  { 0.478983f, 0.306940f, 0.214076f},   11}  ,{  { 0.401760f, 0.118280f, 0.479961f},   46}  ,{  { 0.649071f, 0.085044f, 0.265885f},   43}  ,{  { 0.839687f, 0.153470f, 0.006843f},   75}  ,{  { 0.846530f, 0.036168f, 0.117302f},   61}  ,{  { 0.096774f, 0.147605f, 0.755621f},   75}  ,{  { 0.178886f, 0.514174f, 0.306940f},  162}  ,{  { 0.117302f, 0.716520f, 0.166178f},  235}  ,{  { 0.233627f, 0.042033f, 0.724340f},  243}  ,{  { 0.722385f, 0.195503f, 0.082111f},   57}  ,{  { 0.304008f, 0.437928f, 0.258065f},   60}  ,
{  { 0.451613f, 0.522972f, 0.025415f},  206}  ,{  { 0.416422f, 0.205279f, 0.378299f},   10}  ,{  { 0.221896f, 0.334311f, 0.443793f},   34}  ,{  { 0.002933f, 0.516129f, 0.480938f},  221}  ,{  { 0.191593f, 0.807429f, 0.000978f},  147}  ,{  { 0.541544f, 0.337243f, 0.121212f},  144}  ,{  { 0.451613f, 0.357771f, 0.190616f},  159}  ,{  { 0.018573f, 0.381232f, 0.600196f},  146}  ,{  { 0.309873f, 0.633431f, 0.056696f},   43}  ,{  { 0.390029f, 0.184751f, 0.425220f},   90}  ,{  { 0.364614f, 0.161290f, 0.474096f},   72}  ,{  { 0.470186f, 0.303030f, 0.226784f},    3}  ,{  { 0.271750f, 0.694037f, 0.034213f},   36}  ,{  { 0.549365f, 0.248289f, 0.202346f},   57}  ,{  { 0.320626f, 0.356794f, 0.322581f},  219}  ,{  { 0.116325f, 0.401760f, 0.481916f},  125}  ,{  { 0.263930f, 0.585533f, 0.150538f},  166}  ,{  { 0.565005f, 0.256109f, 0.178886f},  105}  ,{  { 0.408602f, 0.051808f, 0.539589f},  209}  ,{  { 0.572825f, 0.328446f, 0.098729f},  237}  ,{  { 0.367546f, 0.181818f, 0.450635f},  114}  ,{  { 0.616813f, 0.022483f, 0.360704f},   64}  ,{  { 0.130987f, 0.853372f, 0.015640f},   64}  ,{  { 0.428153f, 0.317693f, 0.254154f},  144}  ,{  { 0.268817f, 0.479961f, 0.251222f},  181}  ,{  { 0.026393f, 0.478983f, 0.494624f},  133}  ,{  { 0.478006f, 0.157380f, 0.364614f},   31}  ,{  { 0.262952f, 0.662757f, 0.074291f},   18}  ,{  { 0.237537f, 0.020528f, 0.741935f},   61}  ,{  { 0.023460f, 0.656891f, 0.319648f},    6}  ,{  { 0.321603f, 0.334311f, 0.344086f},  206}  ,{  { 0.726295f, 0.004888f, 0.268817f},  232}  ,
{  { 0.583578f, 0.068426f, 0.347996f},  200}  ,{  { 0.503421f, 0.492669f, 0.003910f},  129}  ,{  { 0.514174f, 0.291300f, 0.194526f},   21}  ,{  { 0.814272f, 0.016618f, 0.169110f},   42}  ,{  { 0.701857f, 0.257087f, 0.041056f},    7}  ,{  { 0.009775f, 0.066471f, 0.923754f},   29}  ,{  { 0.084066f, 0.241447f, 0.674487f},   73}  ,{  { 0.763441f, 0.200391f, 0.036168f},   62}  ,{  { 0.118280f, 0.872923f, 0.008798f},   82}  ,{  { 0.060606f, 0.402737f, 0.536657f},   65}  ,{  { 0.293255f, 0.516129f, 0.190616f},   43}  ,{  { 0.367546f, 0.627566f, 0.004888f},   32}  ,{  { 0.727273f, 0.240469f, 0.032258f},  250}  ,{  { 0.177908f, 0.074291f, 0.747801f},  219}  ,{  { 0.143695f, 0.013685f, 0.842620f},   38}  ,{  { 0.795699f, 0.120235f, 0.084066f},   16}  ,{  { 0.236559f, 0.246334f, 0.517107f},  209}  ,{  { 0.333333f, 0.489736f, 0.176931f},  243}  ,{  { 0.333333f, 0.007820f, 0.658847f},  100}  ,{  { 0.123167f, 0.811339f, 0.065494f},  142}  ,{  { 0.204301f, 0.402737f, 0.392962f},    1}  ,{  { 0.145650f, 0.835777f, 0.018573f},   39}  ,{  { 0.471163f, 0.447703f, 0.081134f},    6}  ,{  { 0.484848f, 0.458456f, 0.056696f},  250}  ,{  { 0.334311f, 0.110459f, 0.555230f},   10}  ,{  { 0.599218f, 0.007820f, 0.392962f},   23}  ,{  { 0.434995f, 0.144673f, 0.420332f},  109}  ,{  { 0.374389f, 0.260997f, 0.364614f},   53}  ,{  { 0.371457f, 0.046921f, 0.581623f},  208}  ,{  { 0.225806f, 0.131965f, 0.642229f},   34}  ,{  { 0.212121f, 0.034213f, 0.753666f},  225}  ,{  { 0.697947f, 0.152493f, 0.149560f},  182}  ,
{  { 0.164223f, 0.276637f, 0.559140f},  139}  ,{  { 0.913001f, 0.014663f, 0.072336f},  103}  ,{  { 0.503421f, 0.185728f, 0.310850f},   38}  ,{  { 0.132942f, 0.200391f, 0.666667f},   91}  ,{  { 0.661779f, 0.173998f, 0.164223f},   56}  ,{  { 0.208211f, 0.103617f, 0.688172f},  188}  ,{  { 0.306940f, 0.297165f, 0.395894f},  139}  ,{  { 0.815249f, 0.000000f, 0.184751f},  126}  ,{  { 0.203324f, 0.680352f, 0.116325f},  205}  ,{  { 0.049853f, 0.764418f, 0.185728f},   85}  ,{  { 0.038123f, 0.048876f, 0.913001f},   14}  ,{  { 0.141740f, 0.288368f, 0.569892f},   92}  ,{  { 0.040078f, 0.376344f, 0.583578f},  109}  ,{  { 0.579668f, 0.270772f, 0.149560f},  153}  ,{  { 0.233627f, 0.166178f, 0.600196f},   55}  ,{  { 0.260020f, 0.200391f, 0.539589f},   41}  ,{  { 0.111437f, 0.556207f, 0.332356f},   78}  ,{  { 0.482893f, 0.484848f, 0.032258f},  154}  ,{  { 0.540567f, 0.254154f, 0.205279f},  237}  ,{  { 0.233627f, 0.040078f, 0.726295f},  111}  ,{  { 0.392962f, 0.216031f, 0.391007f},  110}  ,{  { 0.259042f, 0.700880f, 0.040078f},  113}  ,{  { 0.139785f, 0.679374f, 0.180841f},  178}  ,{  { 0.012708f, 0.305963f, 0.681329f},   43}  ,{  { 0.087977f, 0.325513f, 0.586510f},  136}  ,{  { 0.902248f, 0.036168f, 0.061584f},   89}  ,{  { 0.224829f, 0.027370f, 0.747801f},    7}  ,{  { 0.708700f, 0.236559f, 0.054741f},  198}  ,{  { 0.523949f, 0.350929f, 0.125122f},   80}  ,{  { 0.308895f, 0.391007f, 0.300098f},  243}  ,{  { 0.447703f, 0.162268f, 0.390029f},  136}  ,{  { 0.432063f, 0.502444f, 0.065494f},  145}  ,
{  { 0.783969f, 0.131965f, 0.084066f},  225}  ,{  { 0.427175f, 0.236559f, 0.336266f},  190}  ,{  { 0.422287f, 0.041056f, 0.536657f},   10}  ,{  { 0.353861f, 0.591398f, 0.054741f},    7}  ,{  { 0.501466f, 0.034213f, 0.464321f},   50}  ,{  { 0.234604f, 0.411535f, 0.353861f},   20}  ,{  { 0.021505f, 0.928641f, 0.049853f},  199}  ,{  { 0.189638f, 0.206256f, 0.604106f},  213}  ,{  { 0.259042f, 0.170088f, 0.570870f},   55}  ,{  { 0.114370f, 0.424242f, 0.461388f},   17}  ,{  { 0.849462f, 0.117302f, 0.033236f},  201}  ,{  { 0.507331f, 0.117302f, 0.375367f},   69}  ,{  { 0.277615f, 0.436950f, 0.285435f},   60}  ,{  { 0.573803f, 0.212121f, 0.214076f},  156}  ,{  { 0.114370f, 0.576735f, 0.308895f},   87}  ,{  { 0.787879f, 0.168133f, 0.043988f},   83}  ,{  { 0.146628f, 0.747801f, 0.105572f},  176}  ,{  { 0.337243f, 0.022483f, 0.640274f},   94}  ,{  { 0.669599f, 0.254154f, 0.076246f},  193}  ,{  { 0.205279f, 0.439883f, 0.354839f},  230}  ,{  { 0.834800f, 0.115347f, 0.049853f},   54}  ,{  { 0.291300f, 0.670577f, 0.038123f},   12}  ,{  { 0.522972f, 0.269795f, 0.207234f},  147}  ,{  { 0.060606f, 0.235582f, 0.703812f},  182}  ,{  { 0.078201f, 0.123167f, 0.798631f},  252}  ,{  { 0.526882f, 0.375367f, 0.097752f},  163}  ,{  { 0.775171f, 0.039101f, 0.185728f},  210}  ,{  { 0.094819f, 0.893451f, 0.011730f},  226}  ,{  { 0.849462f, 0.028348f, 0.122190f},  118}  ,{  { 0.050831f, 0.617791f, 0.331378f},   28}  ,{  { 0.419355f, 0.304985f, 0.275660f},   34}  ,{  { 0.408602f, 0.464321f, 0.127077f},  101}  ,
{  { 0.261975f, 0.443793f, 0.294233f},   48}  ,{  { 0.467253f, 0.149560f, 0.383187f},  193}  ,{  { 0.228739f, 0.168133f, 0.603128f},  188}  ,{  { 0.693060f, 0.059629f, 0.247312f},   77}  ,{  { 0.831867f, 0.039101f, 0.129032f},  253}  ,{  { 0.449658f, 0.145650f, 0.404692f},  238}  ,{  { 0.105572f, 0.075269f, 0.819159f},  159}  ,{  { 0.063539f, 0.025415f, 0.911046f},   39}  ,{  { 0.021505f, 0.973607f, 0.004888f},  227}  ,{  { 0.419355f, 0.088954f, 0.491691f},   28}  ,{  { 0.709677f, 0.197458f, 0.092864f},  130}  ,{  { 0.272727f, 0.679374f, 0.047898f},  240}  ,{  { 0.375367f, 0.142717f, 0.481916f},   22}  ,{  { 0.332356f, 0.203324f, 0.464321f},  163}  ,{  { 0.173998f, 0.243402f, 0.582600f},  165}  ,{  { 0.017595f, 0.553275f, 0.429130f},  147}  ,{  { 0.468231f, 0.197458f, 0.334311f},   57}  ,{  { 0.739003f, 0.217986f, 0.043011f},  154}  ,{  { 0.891496f, 0.027370f, 0.081134f},   60}  ,{  { 0.150538f, 0.452590f, 0.396872f},  229}  ,{  { 0.634409f, 0.154448f, 0.211144f},  227}  ,{  { 0.575758f, 0.173021f, 0.251222f},    4}  ,{  { 0.074291f, 0.823069f, 0.102639f},  251}  ,{  { 0.335288f, 0.232649f, 0.432063f},   66}  ,{  { 0.359726f, 0.086022f, 0.554252f},   38}  ,{  { 0.538612f, 0.243402f, 0.217986f},    8}  ,{  { 0.826979f, 0.057674f, 0.115347f},  184}  ,{  { 0.342131f, 0.582600f, 0.075269f},   63}  ,{  { 0.112414f, 0.199413f, 0.688172f},   86}  ,{  { 0.010753f, 0.129032f, 0.860215f},  173}  ,{  { 0.074291f, 0.915934f, 0.009775f},   56}  ,{  { 0.209189f, 0.523949f, 0.266862f},    9}  ,
{  { 0.226784f, 0.106549f, 0.666667f},  214}  ,{  { 0.037146f, 0.920821f, 0.042033f},   21}  ,{  { 0.199413f, 0.647116f, 0.153470f},   38}  ,{  { 0.153470f, 0.772238f, 0.074291f},  183}  ,{  { 0.595308f, 0.044966f, 0.359726f},  153}  ,{  { 0.338221f, 0.605083f, 0.056696f},   89}  ,{  { 0.158358f, 0.046921f, 0.794721f},  243}  ,{  { 0.015640f, 0.470186f, 0.514174f},   80}  ,{  { 0.541544f, 0.037146f, 0.421310f},  218}  ,{  { 0.147605f, 0.089932f, 0.762463f},  206}  ,{  { 0.513196f, 0.449658f, 0.037146f},  126}  ,{  { 0.824047f, 0.100684f, 0.075269f},   86}  ,{  { 0.534702f, 0.263930f, 0.201369f},   61}  ,{  { 0.715542f, 0.002933f, 0.281525f},   23}  ,{  { 0.238514f, 0.067449f, 0.694037f},  212}  ,{  { 0.093842f, 0.738025f, 0.168133f},   59}  ,{  { 0.110459f, 0.264907f, 0.624633f},   89}  ,{  { 0.089932f, 0.167155f, 0.742913f},   12}  ,{  { 0.713587f, 0.054741f, 0.231672f},  249}  ,{  { 0.031281f, 0.578690f, 0.390029f},  144}  ,{  { 0.626588f, 0.099707f, 0.273705f},  252}  ,{  { 0.497556f, 0.003910f, 0.498534f},   77}  ,{  { 0.013685f, 0.531769f, 0.454545f},  156}  ,{  { 0.149560f, 0.088954f, 0.761486f},   90}  ,{  { 0.044966f, 0.307918f, 0.647116f},  194}  ,{  { 0.091887f, 0.735093f, 0.173021f},  142}  ,{  { 0.359726f, 0.460411f, 0.179863f},   64}  ,{  { 0.828934f, 0.149560f, 0.021505f},  222}  ,{  { 0.431085f, 0.051808f, 0.517107f},   74}  ,{  { 0.246334f, 0.097752f, 0.655914f},   64}  ,{  { 0.053763f, 0.493646f, 0.452590f},   93}  ,{  { 0.189638f, 0.123167f, 0.687195f},   46}  ,
{  { 0.576735f, 0.181818f, 0.241447f},  217}  ,{  { 0.326491f, 0.646139f, 0.027370f},   19}  ,{  { 0.572825f, 0.108504f, 0.318671f},  106}  ,{  { 0.240469f, 0.455523f, 0.304008f},  224}  ,{  { 0.210166f, 0.434995f, 0.354839f},   90}  ,{  { 0.309873f, 0.294233f, 0.395894f},  151}  ,{  { 0.182796f, 0.214076f, 0.603128f},  146}  ,{  { 0.103617f, 0.855327f, 0.041056f},  248}  ,{  { 0.268817f, 0.580645f, 0.150538f},  250}  ,{  { 0.347996f, 0.049853f, 0.602151f},   16}  ,{  { 0.406647f, 0.464321f, 0.129032f},   91}  ,{  { 0.174976f, 0.170088f, 0.654936f},  202}  ,{  { 0.343109f, 0.098729f, 0.558162f},  161}  ,{  { 0.402737f, 0.594330f, 0.002933f},  228}  ,{  { 0.398827f, 0.405670f, 0.195503f},  138}  ,{  { 0.121212f, 0.508309f, 0.370479f},   77}  ,{  { 0.360704f, 0.542522f, 0.096774f},  173}  ,{  { 0.573803f, 0.334311f, 0.091887f},  111}  ,{  { 0.377322f, 0.295210f, 0.327468f},   43}  ,{  { 0.418377f, 0.045943f, 0.535679f},  209}  ,{  { 0.015640f, 0.842620f, 0.141740f},  205}  ,{  { 0.317693f, 0.602151f, 0.080156f},   31}  ,{  { 0.337243f, 0.222874f, 0.439883f},   66}  ,{  { 0.870968f, 0.118280f, 0.010753f},  101}  ,{  { 0.416422f, 0.026393f, 0.557185f},   27}  ,{  { 0.177908f, 0.471163f, 0.350929f},   32}  ,{  { 0.160313f, 0.256109f, 0.583578f},  218}  ,{  { 0.040078f, 0.347019f, 0.612903f},   51}  ,{  { 0.586510f, 0.089932f, 0.323558f},   27}  ,{  { 0.219941f, 0.635386f, 0.144673f},   59}  ,{  { 0.868035f, 0.002933f, 0.129032f},  142}  ,{  { 0.005865f, 0.934506f, 0.059629f},  165}  ,
{  { 0.144673f, 0.843597f, 0.011730f},  236}  ,{  { 0.156403f, 0.381232f, 0.462366f},  229}  ,{  { 0.212121f, 0.057674f, 0.730205f},   87}  ,{  { 0.419355f, 0.154448f, 0.426197f},    7}  ,{  { 0.295210f, 0.049853f, 0.654936f},  117}  ,{  { 0.043988f, 0.920821f, 0.035191f},  163}  ,{  { 0.238514f, 0.696970f, 0.064516f},   57}  ,{  { 0.053763f, 0.582600f, 0.363636f},   30}  ,{  { 0.044966f, 0.804497f, 0.150538f},   50}  ,{  { 0.150538f, 0.030303f, 0.819159f},   47}  ,{  { 0.320626f, 0.391007f, 0.288368f},   91}  ,{  { 0.261975f, 0.610948f, 0.127077f},   95}  ,{  { 0.497556f, 0.376344f, 0.126100f},   70}  ,{  { 0.085044f, 0.493646f, 0.421310f},   35}  ,{  { 0.056696f, 0.350929f, 0.592375f},  187}  ,{  { 0.042033f, 0.251222f, 0.706745f},   25}  ,{  { 0.070381f, 0.789834f, 0.139785f},  226}  ,{  { 0.265885f, 0.459433f, 0.274682f},  139}  ,{  { 0.215054f, 0.076246f, 0.708700f},  209}  ,{  { 0.409580f, 0.189638f, 0.400782f},  152}  ,{  { 0.277615f, 0.033236f, 0.689150f},   18}  ,{  { 0.082111f, 0.168133f, 0.749756f},  195}  ,{  { 0.897361f, 0.013685f, 0.088954f},  176}  ,{  { 0.330401f, 0.341153f, 0.328446f},  231}  ,{  { 0.490714f, 0.269795f, 0.239492f},  245}  ,{  { 0.032258f, 0.233627f, 0.734115f},  195}  ,{  { 0.407625f, 0.429130f, 0.163245f},  154}  ,{  { 0.697947f, 0.244379f, 0.057674f},   59}  ,{  { 0.511241f, 0.055718f, 0.433040f},  112}  ,{  { 0.136852f, 0.061584f, 0.801564f},  125}  ,{  { 0.738025f, 0.171065f, 0.090909f},   78}  ,{  { 0.294233f, 0.097752f, 0.608016f},  230}  ,
{  { 0.252199f, 0.082111f, 0.665689f},  114}  ,{  { 0.498534f, 0.354839f, 0.146628f},   36}  ,{  { 0.455523f, 0.391007f, 0.153470f},  242}  ,{  { 0.233627f, 0.451613f, 0.314761f},   68}  ,{  { 0.311828f, 0.113392f, 0.574780f},  228}  ,{  { 0.218964f, 0.171065f, 0.609971f},   81}  ,{  { 0.523949f, 0.318671f, 0.157380f},  247}  ,{  { 0.339198f, 0.050831f, 0.609971f},  171}  ,{  { 0.855327f, 0.013685f, 0.130987f},  229}  ,{  { 0.636364f, 0.019550f, 0.344086f},   49}  ,{  { 0.368524f, 0.579668f, 0.051808f},  254}  ,{  { 0.414467f, 0.527859f, 0.057674f},   11}  ,{  { 0.099707f, 0.391007f, 0.509286f},  149}  ,{  { 0.314761f, 0.615836f, 0.069404f},  243}  ,{  { 0.181818f, 0.008798f, 0.809384f},   95}  ,{  { 0.500489f, 0.303030f, 0.196481f},   47}  ,{  { 0.317693f, 0.666667f, 0.015640f},   92}  ,{  { 0.553275f, 0.130010f, 0.316716f},   14}  ,{  { 0.673509f, 0.043988f, 0.282502f},  239}  ,{  { 0.280547f, 0.385142f, 0.334311f},   16}  ,{  { 0.013685f, 0.332356f, 0.653959f},  192}  ,{  { 0.428153f, 0.313783f, 0.258065f},  190}  ,{  { 0.248289f, 0.264907f, 0.486804f},  174}  ,{  { 0.253177f, 0.287390f, 0.459433f},  188}  ,{  { 0.495601f, 0.425220f, 0.079179f},  118}  ,{  { 0.547410f, 0.167155f, 0.285435f},   81}  ,{  { 0.546432f, 0.451613f, 0.001955f},  217}  ,{  { 0.336266f, 0.655914f, 0.007820f},  199}  ,{  { 0.061584f, 0.506354f, 0.432063f},  167}  ,{  { 0.361681f, 0.513196f, 0.125122f},  106}  ,{  { 0.258065f, 0.420332f, 0.321603f},   88}  ,{  { 0.736070f, 0.262952f, 0.000978f},   86}  ,
{  { 0.714565f, 0.278592f, 0.006843f},  142}  ,{  { 0.022483f, 0.524927f, 0.452590f},  242}  ,{  { 0.613881f, 0.224829f, 0.161290f},  225}  ,{  { 0.173021f, 0.434995f, 0.391984f},   29}  ,{  { 0.720430f, 0.220919f, 0.058651f},   11}  ,{  { 0.415445f, 0.260997f, 0.323558f},  243}  ,{  { 0.384164f, 0.513196f, 0.102639f},  236}  ,{  { 0.408602f, 0.277615f, 0.313783f},  197}  ,{  { 0.494624f, 0.073314f, 0.432063f},   93}  ,{  { 0.506354f, 0.271750f, 0.221896f},  237}  ,{  { 0.437928f, 0.123167f, 0.438905f},  183}  ,{  { 0.701857f, 0.263930f, 0.034213f},   63}  ,{  { 0.012708f, 0.397849f, 0.589443f},  188}  ,{  { 0.365591f, 0.480938f, 0.153470f},   49}  ,{  { 0.008798f, 0.375367f, 0.615836f},  189}  ,{  { 0.024438f, 0.929619f, 0.045943f},   97}  ,{  { 0.449658f, 0.068426f, 0.481916f},  223}  ,{  { 0.125122f, 0.259042f, 0.615836f},   35}  ,{  { 0.598240f, 0.330401f, 0.071359f},  175}  ,{  { 0.044966f, 0.634409f, 0.320626f},  255}  ,{  { 0.160313f, 0.652004f, 0.187683f},  246}  ,{  { 0.343109f, 0.359726f, 0.297165f},  208}  ,{  { 0.725318f, 0.073314f, 0.201369f},  194}  ,{  { 0.520039f, 0.185728f, 0.294233f},    5}  ,{  { 0.185728f, 0.250244f, 0.564027f},   83}  ,{  { 0.046921f, 0.523949f, 0.429130f},  241}  ,{  { 0.043988f, 0.200391f, 0.755621f},  102}  ,{  { 0.718475f, 0.015640f, 0.265885f},    9}  ,{  { 0.164223f, 0.413490f, 0.422287f},  215}  ,{  { 0.229717f, 0.652004f, 0.118280f},   38}  ,{  { 0.030303f, 0.605083f, 0.364614f},  247}  ,{  { 0.394917f, 0.540567f, 0.064516f},   88}  ,
{  { 0.111437f, 0.650049f, 0.238514f},  193}  ,{  { 0.065494f, 0.075269f, 0.859238f},  126}  ,{  { 0.515152f, 0.244379f, 0.240469f},  137}  ,{  { 0.146628f, 0.816227f, 0.037146f},  106}  ,{  { 0.798631f, 0.043988f, 0.157380f},   87}  ,{  { 0.226784f, 0.684262f, 0.088954f},  224}  ,{  { 0.738025f, 0.013685f, 0.248289f},  193}  ,{  { 0.302053f, 0.428153f, 0.269795f},   90}  ,{  { 0.512219f, 0.036168f, 0.451613f},   70}  ,{  { 0.039101f, 0.444770f, 0.516129f},  113}  ,{  { 0.617791f, 0.063539f, 0.318671f},   47}  ,{  { 0.542522f, 0.234604f, 0.222874f},  127}  ,{  { 0.055718f, 0.815249f, 0.129032f},   22}  ,{  { 0.484848f, 0.341153f, 0.173998f},  137}  ,{  { 0.758553f, 0.155425f, 0.086022f},  193}  ,{  { 0.424242f, 0.134897f, 0.440860f},  197}  ,{  { 0.058651f, 0.221896f, 0.719453f},   25}  ,{  { 0.351906f, 0.209189f, 0.438905f},   96}  ,{  { 0.127077f, 0.473118f, 0.399805f},  180}  ,{  { 0.802542f, 0.068426f, 0.129032f},   85}  ,{  { 0.675464f, 0.279570f, 0.044966f},   63}  ,{  { 0.529814f, 0.465298f, 0.004888f},  225}  ,{  { 0.567937f, 0.413490f, 0.018573f},  121}  ,{  { 0.225806f, 0.130987f, 0.643206f},  178}  ,{  { 0.829912f, 0.033236f, 0.136852f},    5}  ,{  { 0.260020f, 0.546432f, 0.193548f},  221}  ,{  { 0.001955f, 0.485826f, 0.512219f},  140}  ,{  { 0.704790f, 0.105572f, 0.189638f},  100}  ,{  { 0.155425f, 0.204301f, 0.640274f},    6}  ,{  { 0.105572f, 0.139785f, 0.754643f},  110}  ,{  { 0.088954f, 0.747801f, 0.163245f},  237}  ,{  { 0.280547f, 0.212121f, 0.507331f},   14}  ,
{  { 0.066471f, 0.337243f, 0.596285f},  147}  ,{  { 0.590420f, 0.000000f, 0.409580f},   44}  ,{  { 0.771261f, 0.029326f, 0.199413f},   13}  ,{  { 0.924731f, 0.071359f, 0.003910f},  176}  ,{  { 0.165200f, 0.507331f, 0.327468f},   21}  ,{  { 0.051808f, 0.931574f, 0.016618f},   53}  ,{  { 0.478983f, 0.267840f, 0.253177f},   45}  ,{  { 0.191593f, 0.330401f, 0.478006f},   27}  ,{  { 0.738025f, 0.188661f, 0.073314f},  220}  ,{  { 0.440860f, 0.208211f, 0.350929f},  124}  ,{  { 0.213099f, 0.530792f, 0.256109f},   97}  ,{  { 0.314761f, 0.593353f, 0.091887f},   72}  ,{  { 0.769306f, 0.008798f, 0.221896f},   97}  ,{  { 0.381232f, 0.394917f, 0.223851f},  253}  ,{  { 0.888563f, 0.008798f, 0.102639f},  227}  ,{  { 0.006843f, 0.898338f, 0.094819f},  147}  ,{  { 0.022483f, 0.547410f, 0.430108f},   92}  ,{  { 0.404692f, 0.349951f, 0.245357f},  171}  ,{  { 0.036168f, 0.410557f, 0.553275f},   23}  ,{  { 0.098729f, 0.761486f, 0.139785f},  165}  ,{  { 0.307918f, 0.608993f, 0.083089f},  249}  ,{  { 0.702835f, 0.048876f, 0.248289f},   85}  ,{  { 0.507331f, 0.384164f, 0.108504f},   99}  ,{  { 0.156403f, 0.295210f, 0.548387f},    5}  ,{  { 0.383187f, 0.249267f, 0.367546f},  223}  ,{  { 0.049853f, 0.706745f, 0.243402f},  130}  ,{  { 0.520039f, 0.243402f, 0.236559f},   12}  ,{  { 0.351906f, 0.207234f, 0.440860f},   68}  ,{  { 0.221896f, 0.695015f, 0.083089f},  218}  ,{  { 0.391984f, 0.512219f, 0.095797f},   86}  ,{  { 0.713587f, 0.164223f, 0.122190f},  240}  ,{  { 0.320626f, 0.060606f, 0.618768f},   36}  ,
{  { 0.237537f, 0.669599f, 0.092864f},  166}  ,{  { 0.280547f, 0.560117f, 0.159335f},  234}  ,{  { 0.694037f, 0.091887f, 0.214076f},  100}  ,{  { 0.078201f, 0.442815f, 0.478983f},  138}  ,{  { 0.384164f, 0.282502f, 0.333333f},   98}  ,{  { 0.001955f, 0.340176f, 0.657869f},  151}  ,{  { 0.016618f, 0.854350f, 0.129032f},   87}  ,{  { 0.384164f, 0.329423f, 0.286413f},  125}  ,{  { 0.372434f, 0.023460f, 0.604106f},  198}  ,{  { 0.002933f, 0.599218f, 0.397849f},   87}  ,{  { 0.236559f, 0.347996f, 0.415445f},  104}  ,{  { 0.243402f, 0.488759f, 0.267840f},   64}  ,{  { 0.352884f, 0.160313f, 0.486804f},   17}  ,{  { 0.585533f, 0.229717f, 0.184751f},  106}  ,{  { 0.333333f, 0.248289f, 0.418377f},  134}  ,{  { 0.005865f, 0.454545f, 0.539589f},  144}  ,{  { 0.562072f, 0.167155f, 0.270772f},  234}  ,{  { 0.025415f, 0.959922f, 0.014663f},   46}  ,{  { 0.063539f, 0.049853f, 0.886608f},  153}  ,{  { 0.400782f, 0.568915f, 0.030303f},  161}  ,{  { 0.808407f, 0.181818f, 0.009775f},  215}  ,{  { 0.495601f, 0.108504f, 0.395894f},   39}  ,{  { 0.344086f, 0.652004f, 0.003910f},  106}  ,{  { 0.312805f, 0.481916f, 0.205279f},  139}  ,{  { 0.759531f, 0.204301f, 0.036168f},   43}  ,{  { 0.738025f, 0.239492f, 0.022483f},    7}  ,{  { 0.521994f, 0.450635f, 0.027370f},  134}  ,{  { 0.375367f, 0.080156f, 0.544477f},   33}  ,{  { 0.327468f, 0.346041f, 0.326491f},  205}  ,{  { 0.569892f, 0.071359f, 0.358749f},   57}  ,{  { 0.362659f, 0.581623f, 0.055718f},   80}  ,{  { 0.485826f, 0.431085f, 0.083089f},  166}  ,
{  { 0.500489f, 0.083089f, 0.416422f},  214}  ,{  { 0.220919f, 0.204301f, 0.574780f},   19}  ,{  { 0.316716f, 0.324536f, 0.358749f},   25}  ,{  { 0.260020f, 0.233627f, 0.506354f},  255}  ,{  { 0.619746f, 0.369501f, 0.010753f},  240}  ,{  { 0.852395f, 0.116325f, 0.031281f},  150}  ,{  { 0.621701f, 0.270772f, 0.107527f},   12}  ,{  { 0.006843f, 0.455523f, 0.537634f},    7}  ,{  { 0.220919f, 0.182796f, 0.596285f},  124}  ,{  { 0.408602f, 0.387097f, 0.204301f},  139}  ,{  { 0.437928f, 0.511241f, 0.050831f},  203}  ,{  { 0.284457f, 0.200391f, 0.515152f},   58}  ,{  { 0.471163f, 0.145650f, 0.383187f},   49}  ,{  { 0.089932f, 0.306940f, 0.603128f},   69}  ,{  { 0.211144f, 0.249267f, 0.539589f},  205}  ,{  { 0.611926f, 0.269795f, 0.118280f},  250}  ,{  { 0.428153f, 0.004888f, 0.566960f},   45}  ,{  { 0.684262f, 0.062561f, 0.253177f},  244}  ,{  { 0.761486f, 0.132942f, 0.105572f},  174}  ,{  { 0.247312f, 0.170088f, 0.582600f},  204}  ,{  { 0.690127f, 0.229717f, 0.080156f},  124}  ,{  { 0.113392f, 0.489736f, 0.396872f},  184}  ,{  { 0.530792f, 0.050831f, 0.418377f},   12}  ,{  { 0.031281f, 0.736070f, 0.232649f},  122}  ,{  { 0.277615f, 0.107527f, 0.614858f},   19}  ,{  { 0.259042f, 0.282502f, 0.458456f},  182}  ,{  { 0.104594f, 0.201369f, 0.694037f},  119}  ,{  { 0.122190f, 0.742913f, 0.134897f},  200}  ,{  { 0.059629f, 0.638319f, 0.302053f},   67}  ,{  { 0.394917f, 0.371457f, 0.233627f},   13}  ,{  { 0.309873f, 0.151515f, 0.538612f},  103}  ,{  { 0.018573f, 0.693060f, 0.288368f},  131}  ,
{  { 0.052786f, 0.331378f, 0.615836f},   10}  ,{  { 0.536657f, 0.301075f, 0.162268f},  189}  ,{  { 0.219941f, 0.111437f, 0.668622f},   75}  ,{  { 0.205279f, 0.785924f, 0.008798f},   11}  ,{  { 0.426197f, 0.346041f, 0.227761f},   94}  ,{  { 0.242424f, 0.437928f, 0.319648f},   27}  ,{  { 0.189638f, 0.218964f, 0.591398f},   10}  ,{  { 0.226784f, 0.416422f, 0.356794f},  158}  ,{  { 0.654936f, 0.202346f, 0.142717f},   53}  ,{  { 0.470186f, 0.413490f, 0.116325f},  238}  ,{  { 0.347996f, 0.609971f, 0.042033f},  116}  ,{  { 0.217009f, 0.604106f, 0.178886f},  152}  ,{  { 0.058651f, 0.140762f, 0.800587f},  120}  ,{  { 0.209189f, 0.034213f, 0.756598f},   51}  ,{  { 0.074291f, 0.025415f, 0.900293f},    7}  ,{  { 0.040078f, 0.604106f, 0.355816f},   31}  ,{  { 0.008798f, 0.496579f, 0.494624f},   55}  ,{  { 0.472141f, 0.080156f, 0.447703f},  127}  ,{  { 0.474096f, 0.130987f, 0.394917f},   37}  ,{  { 0.573803f, 0.125122f, 0.301075f},  182}  ,{  { 0.797654f, 0.018573f, 0.183773f},   52}  ,{  { 0.078201f, 0.416422f, 0.505376f},  117}  ,{  { 0.028348f, 0.427175f, 0.544477f},   28}  ,{  { 0.540567f, 0.407625f, 0.051808f},  232}  ,{  { 0.745846f, 0.167155f, 0.086999f},   52}  ,{  { 0.223851f, 0.184751f, 0.591398f},  172}  ,{  { 0.088954f, 0.480938f, 0.430108f},   62}  ,{  { 0.040078f, 0.257087f, 0.702835f},  244}  ,{  { 0.258065f, 0.086022f, 0.655914f},  132}  ,{  { 0.293255f, 0.632454f, 0.074291f},   83}  ,{  { 0.651026f, 0.267840f, 0.081134f},  215}  ,{  { 0.008798f, 0.138807f, 0.852395f},  177}  ,
{  { 0.623656f, 0.204301f, 0.172043f},   29}  ,{  { 0.182796f, 0.518084f, 0.299120f},   63}  ,{  { 0.623656f, 0.284457f, 0.091887f},   44}  ,{  { 0.792766f, 0.133920f, 0.073314f},    3}  ,{  { 0.618768f, 0.346041f, 0.035191f},  120}  ,{  { 0.167155f, 0.200391f, 0.632454f},  153}  ,{  { 0.279570f, 0.130010f, 0.590420f},  195}  ,{  { 0.264907f, 0.636364f, 0.098729f},  216}  ,{  { 0.123167f, 0.082111f, 0.794721f},  182}  ,{  { 0.327468f, 0.146628f, 0.525904f},   38}  ,{  { 0.040078f, 0.295210f, 0.664712f},  250}  ,{  { 0.204301f, 0.173021f, 0.622678f},  125}  ,{  { 0.378299f, 0.088954f, 0.532747f},   87}  ,{  { 0.551320f, 0.407625f, 0.041056f},  131}  ,{  { 0.630499f, 0.260997f, 0.108504f},   51}  ,{  { 0.024438f, 0.670577f, 0.304985f},   10}  ,{  { 0.259042f, 0.360704f, 0.380254f},  229}  ,{  { 0.214076f, 0.195503f, 0.590420f},  212}  ,{  { 0.473118f, 0.020528f, 0.506354f},  156}  ,{  { 0.467253f, 0.095797f, 0.436950f},   53}  ,{  { 0.156403f, 0.298143f, 0.545455f},  113}  ,{  { 0.031281f, 0.374389f, 0.594330f},  253}  ,{  { 0.665689f, 0.303030f, 0.031281f},  229}  ,{  { 0.655914f, 0.205279f, 0.138807f},  137}  ,{  { 0.572825f, 0.071359f, 0.355816f},  224}  ,{  { 0.054741f, 0.744868f, 0.200391f},    6}  ,{  { 0.522972f, 0.394917f, 0.082111f},  251}  ,{  { 0.515152f, 0.163245f, 0.321603f},   78}  ,{  { 0.284457f, 0.671554f, 0.043988f},  182}  ,{  { 0.539589f, 0.011730f, 0.448680f},  143}  ,{  { 0.438905f, 0.286413f, 0.274682f},  183}  ,{  { 0.041056f, 0.698925f, 0.260020f},  234}  ,
{  { 0.018573f, 0.837732f, 0.143695f},   25}  ,{  { 0.080156f, 0.747801f, 0.172043f},   83}  ,{  { 0.379277f, 0.363636f, 0.257087f},  115}  ,{  { 0.378299f, 0.209189f, 0.412512f},  241}  ,{  { 0.058651f, 0.356794f, 0.584555f},  184}  ,{  { 0.004888f, 0.569892f, 0.425220f},  192}  ,{  { 0.646139f, 0.122190f, 0.231672f},   84}  ,{  { 0.370479f, 0.528837f, 0.100684f},   27}  ,{  { 0.476051f, 0.266862f, 0.257087f},  227}  ,{  { 0.817204f, 0.169110f, 0.013685f},  137}  ,{  { 0.226784f, 0.521017f, 0.252199f},  253}  ,{  { 0.461388f, 0.337243f, 0.201369f},  151}  ,{  { 0.222874f, 0.420332f, 0.356794f},   88}  ,{  { 0.550342f, 0.421310f, 0.028348f},  138}  ,{  { 0.565982f, 0.063539f, 0.370479f},  217}  ,{  { 0.110459f, 0.610948f, 0.278592f},   66}  ,{  { 0.370479f, 0.190616f, 0.438905f},   36}  ,{  { 0.455523f, 0.206256f, 0.338221f},  205}  ,{  { 0.563050f, 0.208211f, 0.228739f},  207}  ,{  { 0.262952f, 0.096774f, 0.640274f},  170}  ,{  { 0.001955f, 0.395894f, 0.602151f},  161}  ,{  { 0.135875f, 0.120235f, 0.743891f},  160}  ,{  { 0.710655f, 0.090909f, 0.198436f},  253}  ,{  { 0.427175f, 0.094819f, 0.478006f},  128}  ,{  { 0.950147f, 0.010753f, 0.039101f},   92}  ,{  { 0.105572f, 0.441838f, 0.452590f},  135}  ,{  { 0.506354f, 0.152493f, 0.341153f},   59}  ,{  { 0.177908f, 0.582600f, 0.239492f},   83}  ,{  { 0.048876f, 0.444770f, 0.506354f},  146}  ,{  { 0.365591f, 0.446725f, 0.187683f},   75}  ,{  { 0.240469f, 0.273705f, 0.485826f},  135}  ,{  { 0.216031f, 0.414467f, 0.369501f},   96}  ,
{  { 0.297165f, 0.578690f, 0.124145f},    3}  ,{  { 0.529814f, 0.196481f, 0.273705f},   32}  ,{  { 0.346041f, 0.532747f, 0.121212f},  123}  ,{  { 0.138807f, 0.684262f, 0.176931f},  123}  ,{  { 0.320626f, 0.138807f, 0.540567f},  169}  ,{  { 0.396872f, 0.421310f, 0.181818f},   35}  ,{  { 0.154448f, 0.291300f, 0.554252f},  104}  ,{  { 0.260997f, 0.640274f, 0.098729f},  222}  ,{  { 0.034213f, 0.626588f, 0.339198f},  112}  ,{  { 0.510264f, 0.146628f, 0.343109f},   91}  ,{  { 0.294233f, 0.020528f, 0.685239f},   59}  ,{  { 0.461388f, 0.157380f, 0.381232f},  215}  ,{  { 0.243402f, 0.673509f, 0.083089f},  232}  ,{  { 0.618768f, 0.081134f, 0.300098f},  123}  ,{  { 0.308895f, 0.315738f, 0.375367f},   98}  ,{  { 0.826002f, 0.043988f, 0.130010f},   68}  ,{  { 0.150538f, 0.640274f, 0.209189f},  248}  ,{  { 0.123167f, 0.638319f, 0.238514f},    8}  ,{  { 0.303030f, 0.650049f, 0.046921f},   31}  ,{  { 0.576735f, 0.189638f, 0.233627f},  159}  ,{  { 0.120235f, 0.304008f, 0.575758f},  194}  ,{  { 0.571847f, 0.087977f, 0.340176f},   89}  ,{  { 0.037146f, 0.426197f, 0.536657f},   79}  ,{  { 0.654936f, 0.140762f, 0.204301f},  219}  ,{  { 0.272727f, 0.548387f, 0.178886f},   98}  ,{  { 0.238514f, 0.454545f, 0.306940f},  177}  ,{  { 0.014663f, 0.411535f, 0.573803f},  144}  ,{  { 0.122190f, 0.372434f, 0.505376f},  244}  ,{  { 0.349951f, 0.637341f, 0.012708f},   81}  ,{  { 0.641251f, 0.266862f, 0.091887f},  208}  ,{  { 0.082111f, 0.033236f, 0.884653f},   61}  ,{  { 0.330401f, 0.547410f, 0.122190f},  121}  ,
{  { 0.101662f, 0.010753f, 0.887586f},  177}  ,{  { 0.425220f, 0.266862f, 0.307918f},   73}  ,{  { 0.384164f, 0.294233f, 0.321603f},  214}  ,{  { 0.216031f, 0.746823f, 0.037146f},   52}  ,{  { 0.387097f, 0.200391f, 0.412512f},  168}  ,{  { 0.098729f, 0.845552f, 0.055718f},  225}  ,{  { 0.342131f, 0.337243f, 0.320626f},  203}  ,{  { 0.015640f, 0.452590f, 0.531769f},   39}  ,{  { 0.137830f, 0.444770f, 0.417400f},  231}  ,{  { 0.311828f, 0.283480f, 0.404692f},   69}  ,{  { 0.366569f, 0.050831f, 0.582600f},  170}  ,{  { 0.238514f, 0.050831f, 0.710655f},   15}  ,{  { 0.450635f, 0.121212f, 0.428153f},  121}  ,{  { 0.391007f, 0.269795f, 0.339198f},  236}  ,{  { 0.238514f, 0.208211f, 0.553275f},  100}  ,{  { 0.547410f, 0.388074f, 0.064516f},   70}  ,{  { 0.554252f, 0.308895f, 0.136852f},  140}  ,{  { 0.287390f, 0.498534f, 0.214076f},  209}  ,{  { 0.558162f, 0.192571f, 0.249267f},  161}  ,{  { 0.127077f, 0.191593f, 0.681329f},   55}  ,{  { 0.019550f, 0.871945f, 0.108504f},   65}  ,{  { 0.011730f, 0.065494f, 0.922776f},   97}  ,{  { 0.588465f, 0.131965f, 0.279570f},  102}  ,{  { 0.543500f, 0.248289f, 0.208211f},  235}  ,{  { 0.177908f, 0.787879f, 0.034213f},   52}  ,{  { 0.478006f, 0.095797f, 0.426197f},  104}  ,{  { 0.535679f, 0.337243f, 0.127077f},   50}  ,{  { 0.705767f, 0.233627f, 0.060606f},  219}  ,{  { 0.241447f, 0.480938f, 0.277615f},   64}  ,{  { 0.602151f, 0.394917f, 0.002933f},   66}  ,{  { 0.637341f, 0.239492f, 0.123167f},  185}  ,{  { 0.255132f, 0.001955f, 0.742913f},   22}  ,
{  { 0.199413f, 0.080156f, 0.720430f},  174}  ,{  { 0.113392f, 0.043011f, 0.843597f},  242}  ,{  { 0.080156f, 0.673509f, 0.246334f},  150}  ,{  { 0.199413f, 0.629521f, 0.171065f},   20}  ,{  { 0.181818f, 0.640274f, 0.177908f},  247}  ,{  { 0.262952f, 0.109482f, 0.627566f},  173}  ,{  { 0.335288f, 0.502444f, 0.162268f},  254}  ,{  { 0.591398f, 0.046921f, 0.361681f},  201}  ,{  { 0.155425f, 0.278592f, 0.565982f},  132}  ,{  { 0.269795f, 0.429130f, 0.301075f},  222}  ,{  { 0.638319f, 0.263930f, 0.097752f},  244}  ,{  { 0.506354f, 0.408602f, 0.085044f},   20}  ,{  { 0.287390f, 0.703812f, 0.008798f},  192}  ,{  { 0.682307f, 0.040078f, 0.277615f},  169}  ,{  { 0.437928f, 0.391007f, 0.171065f},   35}  ,{  { 0.366569f, 0.024438f, 0.608993f},   42}  ,{  { 0.005865f, 0.395894f, 0.598240f},  116}  ,{  { 0.211144f, 0.559140f, 0.229717f},   87}  ,{  { 0.059629f, 0.153470f, 0.786901f},  138}  ,{  { 0.441838f, 0.172043f, 0.386119f},  234}  ,{  { 0.152493f, 0.272727f, 0.574780f},   52}  ,{  { 0.391007f, 0.321603f, 0.287390f},  197}  ,{  { 0.173021f, 0.398827f, 0.428153f},   87}  ,{  { 0.008798f, 0.839687f, 0.151515f},   25}  ,{  { 0.251222f, 0.687195f, 0.061584f},  104}  ,{  { 0.536657f, 0.377322f, 0.086022f},    1}  ,{  { 0.690127f, 0.224829f, 0.085044f},    1}  ,{  { 0.629521f, 0.075269f, 0.295210f},   79}  ,{  { 0.169110f, 0.699902f, 0.130987f},  205}  ,{  { 0.280547f, 0.361681f, 0.357771f},   16}  ,{  { 0.391007f, 0.062561f, 0.546432f},   17}  ,{  { 0.200391f, 0.343109f, 0.456501f},  148}  ,
{  { 0.624633f, 0.146628f, 0.228739f},  181}  ,{  { 0.177908f, 0.805474f, 0.016618f},   36}  ,{  { 0.416422f, 0.518084f, 0.065494f},   84}  ,{  { 0.660802f, 0.219941f, 0.119257f},  102}  ,{  { 0.198436f, 0.067449f, 0.734115f},   79}  ,{  { 0.546432f, 0.260020f, 0.193548f},  187}  ,{  { 0.148583f, 0.553275f, 0.298143f},  162}  ,{  { 0.131965f, 0.447703f, 0.420332f},  161}  ,{  { 0.339198f, 0.107527f, 0.553275f},  102}  ,{  { 0.705767f, 0.128055f, 0.166178f},  207}  ,{  { 0.639296f, 0.158358f, 0.202346f},   73}  ,{  { 0.043011f, 0.339198f, 0.617791f},   28}  ,{  { 0.513196f, 0.380254f, 0.106549f},  199}  ,{  { 0.216031f, 0.398827f, 0.385142f},   81}  ,{  { 0.214076f, 0.429130f, 0.356794f},   43}  ,{  { 0.236559f, 0.007820f, 0.755621f},  169}  ,{  { 0.187683f, 0.387097f, 0.425220f},  217}  ,{  { 0.172043f, 0.124145f, 0.703812f},  115}  ,{  { 0.183773f, 0.690127f, 0.126100f},  133}  ,{  { 0.597263f, 0.047898f, 0.354839f},  109}  ,{  { 0.377322f, 0.394917f, 0.227761f},  155}  ,{  { 0.069404f, 0.644184f, 0.286413f},   28}  ,{  { 0.185728f, 0.138807f, 0.675464f},  149}  ,{  { 0.015640f, 0.268817f, 0.715542f},   14}  ,{  { 0.529814f, 0.193548f, 0.276637f},  133}  ,{  { 0.086999f, 0.484848f, 0.428153f},  142}  ,{  { 0.216031f, 0.341153f, 0.442815f},  208}  ,{  { 0.485826f, 0.076246f, 0.437928f},  154}  ,{  { 0.241447f, 0.043011f, 0.715542f},   48}  ,{  { 0.032258f, 0.889541f, 0.078201f},   59}  ,{  { 0.265885f, 0.048876f, 0.685239f},   97}  ,{  { 0.260020f, 0.685239f, 0.054741f},  115}  ,
{  { 0.715542f, 0.284457f, 0.000000f},  201}  ,{  { 0.033236f, 0.298143f, 0.668622f},  208}  ,{  { 0.020528f, 0.357771f, 0.621701f},  199}  ,{  { 0.685239f, 0.071359f, 0.243402f},  193}  ,{  { 0.529814f, 0.314761f, 0.155425f},    7}  ,{  { 0.476051f, 0.379277f, 0.144673f},  175}  ,{  { 0.369501f, 0.553275f, 0.077224f},  142}  ,{  { 0.325513f, 0.442815f, 0.231672f},   57}  ,{  { 0.038123f, 0.324536f, 0.637341f},    7}  ,{  { 0.181818f, 0.583578f, 0.234604f},   99}  ,{  { 0.027370f, 0.542522f, 0.430108f},  175}  ,{  { 0.287390f, 0.269795f, 0.442815f},  218}  ,{  { 0.542522f, 0.024438f, 0.433040f},  100}  ,{  { 0.486804f, 0.343109f, 0.170088f},   14}  ,{  { 0.483871f, 0.370479f, 0.145650f},   90}  ,{  { 0.042033f, 0.701857f, 0.256109f},   21}  ,{  { 0.167155f, 0.715542f, 0.117302f},  195}  ,{  { 0.410557f, 0.543500f, 0.045943f},   37}  ,{  { 0.260020f, 0.414467f, 0.325513f},  246}  ,{  { 0.750733f, 0.144673f, 0.104594f},  243}  ,{  { 0.222874f, 0.772238f, 0.004888f},  154}  ,{  { 0.042033f, 0.830890f, 0.127077f},   86}  ,{  { 0.716520f, 0.039101f, 0.244379f},   14}  ,{  { 0.370479f, 0.411535f, 0.217986f},  166}  ,{  { 0.286413f, 0.241447f, 0.472141f},   87}  ,{  { 0.243402f, 0.410557f, 0.346041f},   34}  ,{  { 0.085044f, 0.866080f, 0.048876f},  113}  ,{  { 0.163245f, 0.745846f, 0.090909f},  178}  ,{  { 0.122190f, 0.391007f, 0.486804f},   27}  ,{  { 0.163245f, 0.779081f, 0.057674f},  123}  ,{  { 0.434995f, 0.560117f, 0.004888f},  102}  ,{  { 0.246334f, 0.547410f, 0.206256f},  241}  ,
{  { 0.078201f, 0.826002f, 0.095797f},  234}  ,{  { 0.094819f, 0.854350f, 0.050831f},  122}  ,{  { 0.215054f, 0.214076f, 0.570870f},  110}  ,{  { 0.175953f, 0.762463f, 0.061584f},   52}  ,{  { 0.180841f, 0.535679f, 0.283480f},  141}  ,{  { 0.000000f, 0.376344f, 0.623656f},   12}  ,{  { 0.589443f, 0.287390f, 0.123167f},   74}  ,{  { 0.257087f, 0.627566f, 0.115347f},   27}  ,{  { 0.370479f, 0.086999f, 0.542522f},  104}  ,{  { 0.587488f, 0.393939f, 0.018573f},  188}  ,{  { 0.101662f, 0.442815f, 0.455523f},  195}  ,{  { 0.551320f, 0.001955f, 0.446725f},  195}  ,{  { 0.015640f, 0.312805f, 0.671554f},  227}  ,{  { 0.356794f, 0.529814f, 0.113392f},  147}  ,{  { 0.389052f, 0.053763f, 0.557185f},  186}  ,{  { 0.097752f, 0.762463f, 0.139785f},  167}  ,{  { 0.384164f, 0.104594f, 0.511241f},  153}  ,{  { 0.450635f, 0.084066f, 0.465298f},  219}  ,{  { 0.622678f, 0.337243f, 0.040078f},   40}  ,{  { 0.266862f, 0.010753f, 0.722385f},  250}  ,{  { 0.755621f, 0.147605f, 0.096774f},   56}  ,{  { 0.283480f, 0.269795f, 0.446725f},  214}  ,{  { 0.661779f, 0.159335f, 0.178886f},  118}  ,{  { 0.618768f, 0.377322f, 0.003910f},  143}  ,{  { 0.118280f, 0.132942f, 0.748778f},  221}  ,{  { 0.566960f, 0.064516f, 0.368524f},  152}  ,{  { 0.059629f, 0.671554f, 0.268817f},  111}  ,{  { 0.321603f, 0.315738f, 0.362659f},  121}  ,{  { 0.038123f, 0.191593f, 0.770283f},  228}  ,{  { 0.272727f, 0.340176f, 0.387097f},  195}  ,{  { 0.152493f, 0.392962f, 0.454545f},  224}  ,{  { 0.014663f, 0.944282f, 0.041056f},  112}  ,
{  { 0.658847f, 0.289345f, 0.051808f},  236}  ,{  { 0.278592f, 0.037146f, 0.684262f},  122}  ,{  { 0.345064f, 0.166178f, 0.488759f},   27}  ,{  { 0.760508f, 0.087977f, 0.151515f},   17}  ,{  { 0.727273f, 0.247312f, 0.025415f},  192}  ,{  { 0.241447f, 0.256109f, 0.502444f},  147}  ,{  { 0.359726f, 0.393939f, 0.246334f},  154}  ,{  { 0.140762f, 0.232649f, 0.626588f},  181}  ,{  { 0.487781f, 0.509286f, 0.002933f},  149}  ,{  { 0.008798f, 0.486804f, 0.504399f},  203}  ,{  { 0.581623f, 0.399805f, 0.018573f},  175}  ,{  { 0.524927f, 0.171065f, 0.304008f},  120}  ,{  { 0.389052f, 0.286413f, 0.324536f},  232}  ,{  { 0.474096f, 0.369501f, 0.156403f},   60}  ,{  { 0.766373f, 0.164223f, 0.069404f},  104}  ,{  { 0.117302f, 0.367546f, 0.515152f},   72}  ,{  { 0.406647f, 0.109482f, 0.483871f},  255}  ,{  { 0.180841f, 0.667644f, 0.151515f},  166}  ,{  { 0.941349f, 0.048876f, 0.009775f},  167}  ,{  { 0.287390f, 0.063539f, 0.649071f},   51}  ,{  { 0.316716f, 0.006843f, 0.676442f},   35}  ,{  { 0.521017f, 0.171065f, 0.307918f},   42}  ,{  { 0.028348f, 0.655914f, 0.315738f},  211}  ,{  { 0.262952f, 0.662757f, 0.074291f},  222}  ,{  { 0.412512f, 0.463343f, 0.124145f},   42}  ,{  { 0.426197f, 0.138807f, 0.434995f},  198}  ,{  { 0.349951f, 0.357771f, 0.292278f},  121}  ,{  { 0.142717f, 0.137830f, 0.719453f},  148}  ,{  { 0.217009f, 0.710655f, 0.072336f},   21}  ,{  { 0.043011f, 0.099707f, 0.857283f},  133}  ,{  { 0.280547f, 0.641251f, 0.078201f},  191}  ,{  { 0.052786f, 0.423265f, 0.523949f},  242}  ,
{  { 0.023460f, 0.726295f, 0.250244f},   47}  ,{  { 0.713587f, 0.171065f, 0.115347f},  164}  ,{  { 0.275660f, 0.498534f, 0.225806f},   35}  ,{  { 0.431085f, 0.560117f, 0.008798f},  104}  ,{  { 0.582600f, 0.351906f, 0.065494f},  225}  ,{  { 0.796676f, 0.117302f, 0.086022f},    6}  ,{  { 0.910068f, 0.078201f, 0.011730f},  101}  ,{  { 0.298143f, 0.700880f, 0.000978f},  203}  ,{  { 0.070381f, 0.889541f, 0.040078f},   18}  ,{  { 0.069404f, 0.370479f, 0.560117f},   45}  ,{  { 0.424242f, 0.397849f, 0.177908f},  163}  ,{  { 0.309873f, 0.395894f, 0.294233f},  153}  ,{  { 0.365591f, 0.230694f, 0.403715f},   31}  ,{  { 0.043011f, 0.462366f, 0.494624f},   53}  ,{  { 0.408602f, 0.530792f, 0.060606f},  108}  ,{  { 0.224829f, 0.153470f, 0.621701f},  213}  ,{  { 0.655914f, 0.108504f, 0.235582f},   35}  ,{  { 0.780059f, 0.157380f, 0.062561f},  127}  ,{  { 0.221896f, 0.009775f, 0.768328f},  245}  ,{  { 0.613881f, 0.378299f, 0.007820f},  180}  ,{  { 0.785924f, 0.160313f, 0.053763f},  165}  ,{  { 0.004888f, 0.027370f, 0.967742f},   31}  ,{  { 0.145650f, 0.173998f, 0.680352f},   88}  ,{  { 0.146628f, 0.776149f, 0.077224f},  195}  ,{  { 0.216031f, 0.400782f, 0.383187f},  146}  ,{  { 0.702835f, 0.260997f, 0.036168f},  247}  ,{  { 0.267840f, 0.670577f, 0.061584f},   96}  ,{  { 0.630499f, 0.183773f, 0.185728f},    7}  ,{  { 0.555230f, 0.273705f, 0.171065f},  168}  ,{  { 0.336266f, 0.538612f, 0.125122f},  249}  ,{  { 0.181818f, 0.592375f, 0.225806f},   59}  ,{  { 0.218964f, 0.140762f, 0.640274f},  107}  ,
{  { 0.189638f, 0.619746f, 0.190616f},  232}  ,{  { 0.226784f, 0.269795f, 0.503421f},   65}  ,{  { 0.015640f, 0.221896f, 0.762463f},   97}  ,{  { 0.385142f, 0.476051f, 0.138807f},  124}  ,{  { 0.673509f, 0.045943f, 0.280547f},  122}  ,{  { 0.057674f, 0.385142f, 0.557185f},  180}  ,{  { 0.862170f, 0.002933f, 0.134897f},   78}  ,{  { 0.941349f, 0.043988f, 0.014663f},  128}  ,{  { 0.216031f, 0.199413f, 0.584555f},  125}  ,{  { 0.458456f, 0.200391f, 0.341153f},  102}  ,{  { 0.245357f, 0.321603f, 0.433040f},  240}  ,{  { 0.074291f, 0.054741f, 0.870968f},   53}  ,{  { 0.434995f, 0.141740f, 0.423265f},  158}  ,{  { 0.409580f, 0.380254f, 0.210166f},  232}  ,{  { 0.487781f, 0.091887f, 0.420332f},  208}  ,{  { 0.235582f, 0.214076f, 0.550342f},    1}  ,{  { 0.079179f, 0.739003f, 0.181818f},   11}  ,{  { 0.225806f, 0.572825f, 0.201369f},   91}  ,{  { 0.110459f, 0.350929f, 0.538612f},  136}  ,{  { 0.266862f, 0.363636f, 0.369501f},  236}  ,{  { 0.554252f, 0.105572f, 0.340176f},   63}  ,{  { 0.282502f, 0.538612f, 0.178886f},   53}  ,{  { 0.586510f, 0.140762f, 0.272727f},  111}  ,{  { 0.534702f, 0.168133f, 0.297165f},  165}  ,{  { 0.017595f, 0.831867f, 0.150538f},   75}  ,{  { 0.145650f, 0.479961f, 0.374389f},   97}  ,{  { 0.287390f, 0.173021f, 0.539589f},   59}  ,{  { 0.094819f, 0.401760f, 0.503421f},   96}  ,{  { 0.383187f, 0.292278f, 0.324536f},  131}  ,{  { 0.105572f, 0.123167f, 0.771261f},   69}  ,{  { 0.387097f, 0.087977f, 0.524927f},  128}  ,{  { 0.176931f, 0.800587f, 0.022483f},  147}  ,
{  { 0.363636f, 0.082111f, 0.554252f},  106}  ,{  { 0.451613f, 0.394917f, 0.153470f},   29}  ,{  { 0.929619f, 0.063539f, 0.006843f},   95}  ,{  { 0.010753f, 0.901271f, 0.087977f},  253}  ,{  { 0.068426f, 0.720430f, 0.211144f},   40}  ,{  { 0.579668f, 0.153470f, 0.266862f},  109}  ,{  { 0.388074f, 0.005865f, 0.606061f},  198}  ,{  { 0.416422f, 0.169110f, 0.414467f},   81}  ,{  { 0.366569f, 0.560117f, 0.073314f},   10}  ,{  { 0.124145f, 0.856305f, 0.019550f},  121}  ,{  { 0.141740f, 0.490714f, 0.367546f},  115}  ,{  { 0.037146f, 0.527859f, 0.434995f},  152}  ,{  { 0.140762f, 0.721408f, 0.137830f},   95}  ,{  { 0.111437f, 0.419355f, 0.469208f},  139}  ,{  { 0.030303f, 0.197458f, 0.772238f},  102}  ,{  { 0.176931f, 0.386119f, 0.436950f},  100}  ,{  { 0.722385f, 0.020528f, 0.257087f},  229}  ,{  { 0.144673f, 0.646139f, 0.209189f},  127}  ,{  { 0.058651f, 0.465298f, 0.476051f},   54}  ,{  { 0.057674f, 0.127077f, 0.815249f},   44}  ,{  { 0.383187f, 0.075269f, 0.541544f},  149}  ,{  { 0.269795f, 0.568915f, 0.161290f},   10}  ,{  { 0.201369f, 0.568915f, 0.229717f},  105}  ,{  { 0.158358f, 0.279570f, 0.562072f},   98}  ,{  { 0.093842f, 0.329423f, 0.576735f},   83}  ,{  { 0.005865f, 0.463343f, 0.530792f},  219}  ,{  { 0.310850f, 0.566960f, 0.122190f},   44}  ,{  { 0.261975f, 0.417400f, 0.320626f},    7}  ,{  { 0.370479f, 0.477028f, 0.152493f},  238}  ,{  { 0.236559f, 0.235582f, 0.527859f},  235}  ,{  { 0.248289f, 0.322581f, 0.429130f},  197}  ,{  { 0.207234f, 0.144673f, 0.648094f},  136}  ,
{  { 0.608993f, 0.303030f, 0.087977f},  242}  ,{  { 0.009775f, 0.820137f, 0.170088f},  114}  ,{  { 0.942326f, 0.052786f, 0.004888f},   61}  ,{  { 0.071359f, 0.641251f, 0.287390f},  148}  ,{  { 0.086022f, 0.226784f, 0.687195f},   31}  ,{  { 0.206256f, 0.019550f, 0.774194f},  212}  ,{  { 0.452590f, 0.249267f, 0.298143f},  223}  ,{  { 0.836755f, 0.140762f, 0.022483f},  142}  ,{  { 0.144673f, 0.626588f, 0.228739f},   89}  ,{  { 0.242424f, 0.285435f, 0.472141f},  242}  ,{  { 0.539589f, 0.100684f, 0.359726f},   36}  ,{  { 0.957967f, 0.001955f, 0.040078f},  174}  ,{  { 0.224829f, 0.291300f, 0.483871f},  216}  ,{  { 0.707722f, 0.225806f, 0.066471f},  157}  ,{  { 0.009775f, 0.104594f, 0.885630f},  187}  ,{  { 0.298143f, 0.134897f, 0.566960f},  128}  ,{  { 0.093842f, 0.399805f, 0.506354f},   44}  ,{  { 0.320626f, 0.024438f, 0.654936f},   43}  ,{  { 0.339198f, 0.149560f, 0.511241f},  181}  ,{  { 0.333333f, 0.417400f, 0.249267f},  200}  ,{  { 0.436950f, 0.001955f, 0.561095f},  158}  ,{  { 0.283480f, 0.531769f, 0.184751f},  156}  ,{  { 0.040078f, 0.134897f, 0.825024f},  142}  ,{  { 0.114370f, 0.830890f, 0.054741f},  121}  ,{  { 0.326491f, 0.055718f, 0.617791f},   98}  ,{  { 0.400782f, 0.112414f, 0.486804f},   75}  ,{  { 0.057674f, 0.231672f, 0.710655f},  198}  ,{  { 0.252199f, 0.064516f, 0.683284f},  229}  ,{  { 0.028348f, 0.782991f, 0.188661f},   43}  ,{  { 0.050831f, 0.740958f, 0.208211f},  236}  ,{  { 0.267840f, 0.125122f, 0.607038f},  151}  ,{  { 0.813294f, 0.148583f, 0.038123f},   22}  ,
{  { 0.432063f, 0.526882f, 0.041056f},  131}  ,{  { 0.616813f, 0.296188f, 0.086999f},  235}  ,{  { 0.736070f, 0.042033f, 0.221896f},   18}  ,{  { 0.195503f, 0.217986f, 0.586510f},   38}  ,{  { 0.539589f, 0.337243f, 0.123167f},  173}  ,{  { 0.742913f, 0.106549f, 0.150538f},  167}  ,{  { 0.451613f, 0.154448f, 0.393939f},  170}  ,{  { 0.279570f, 0.718475f, 0.001955f},   80}  ,{  { 0.260020f, 0.261975f, 0.478006f},  132}  ,{  { 0.248289f, 0.693060f, 0.058651f},  139}  ,{  { 0.519062f, 0.292278f, 0.188661f},  136}  ,{  { 0.386119f, 0.233627f, 0.380254f},  222}  ,{  { 0.268817f, 0.327468f, 0.403715f},   13}  ,{  { 0.227761f, 0.004888f, 0.767351f},  247}  ,{  { 0.127077f, 0.762463f, 0.110459f},  129}  ,{  { 0.245357f, 0.464321f, 0.290323f},   50}  ,{  { 0.363636f, 0.570870f, 0.065494f},  241}  ,{  { 0.116325f, 0.175953f, 0.707722f},  247}  ,{  { 0.608993f, 0.147605f, 0.243402f},  171}  ,{  { 0.742913f, 0.039101f, 0.217986f},  186}  ,{  { 0.355816f, 0.303030f, 0.341153f},   12}  ,{  { 0.081134f, 0.078201f, 0.840665f},   83}  ,{  { 0.125122f, 0.342131f, 0.532747f},  144}  ,{  { 0.011730f, 0.215054f, 0.773216f},    6}  ,{  { 0.017595f, 0.850440f, 0.131965f},  230}  ,{  { 0.165200f, 0.120235f, 0.714565f},    9}  ,{  { 0.039101f, 0.736070f, 0.224829f},   40}  ,{  { 0.350929f, 0.371457f, 0.277615f},   37}  ,{  { 0.582600f, 0.029326f, 0.388074f},  150}  ,{  { 0.009775f, 0.035191f, 0.955034f},  127}  ,{  { 0.738025f, 0.146628f, 0.115347f},  188}  ,{  { 0.278592f, 0.108504f, 0.612903f},  115}  ,
{  { 0.165200f, 0.552297f, 0.282502f},   87}  ,{  { 0.354839f, 0.028348f, 0.616813f},  129}  ,{  { 0.221896f, 0.571847f, 0.206256f},   32}  ,{  { 0.241447f, 0.643206f, 0.115347f},  194}  ,{  { 0.370479f, 0.000978f, 0.628543f},  150}  ,{  { 0.432063f, 0.373412f, 0.194526f},  224}  ,{  { 0.290323f, 0.448680f, 0.260997f},    4}  ,{  { 0.088954f, 0.362659f, 0.548387f},  170}  ,{  { 0.031281f, 0.650049f, 0.318671f},  186}  ,{  { 0.275660f, 0.026393f, 0.697947f},   52}  ,{  { 0.357771f, 0.403715f, 0.238514f},   66}  ,{  { 0.016618f, 0.963832f, 0.019550f},   71}  ,{  { 0.587488f, 0.026393f, 0.386119f},   56}  ,{  { 0.272727f, 0.048876f, 0.678397f},  249}  ,{  { 0.086999f, 0.563050f, 0.349951f},  232}  ,{  { 0.191593f, 0.801564f, 0.006843f},  153}  ,{  { 0.170088f, 0.794721f, 0.035191f},   84}  ,{  { 0.039101f, 0.812317f, 0.148583f},  177}  ,{  { 0.126100f, 0.062561f, 0.811339f},  161}  ,{  { 0.584555f, 0.104594f, 0.310850f},  224}  ,{  { 0.195503f, 0.442815f, 0.361681f},  147}  ,{  { 0.127077f, 0.737048f, 0.135875f},   29}  ,{  { 0.180841f, 0.249267f, 0.569892f},  237}  ,{  { 0.209189f, 0.321603f, 0.469208f},  149}  ,{  { 0.384164f, 0.523949f, 0.091887f},  240}  ,{  { 0.194526f, 0.038123f, 0.767351f},  203}  ,{  { 0.752688f, 0.088954f, 0.158358f},  165}  ,{  { 0.180841f, 0.425220f, 0.393939f},  107}  ,{  { 0.597263f, 0.383187f, 0.019550f},  148}  ,{  { 0.173998f, 0.118280f, 0.707722f},  154}  ,{  { 0.527859f, 0.374389f, 0.097752f},  220}  ,{  { 0.397849f, 0.230694f, 0.371457f},   32}  ,
{  { 0.202346f, 0.724340f, 0.073314f},   16}  ,{  { 0.472141f, 0.447703f, 0.080156f},   25}  ,{  { 0.434018f, 0.042033f, 0.523949f},  248}  ,{  { 0.260997f, 0.487781f, 0.251222f},   21}  ,{  { 0.565982f, 0.102639f, 0.331378f},  108}  ,{  { 0.327468f, 0.125122f, 0.547410f},   79}  ,{  { 0.291300f, 0.528837f, 0.179863f},  215}  ,{  { 0.286413f, 0.483871f, 0.229717f},   85}  ,{  { 0.221896f, 0.623656f, 0.154448f},  245}  ,{  { 0.123167f, 0.629521f, 0.247312f},  180}  ,{  { 0.642229f, 0.039101f, 0.318671f},  191}  ,{  { 0.349951f, 0.535679f, 0.114370f},  102}  ,{  { 0.009775f, 0.334311f, 0.655914f},  198}  ,{  { 0.236559f, 0.407625f, 0.355816f},   44}  ,{  { 0.407625f, 0.307918f, 0.284457f},   75}  ,{  { 0.408602f, 0.014663f, 0.576735f},  221}  ,{  { 0.033236f, 0.685239f, 0.281525f},  141}  ,{  { 0.356794f, 0.542522f, 0.100684f},  157}  ,{  { 0.808407f, 0.150538f, 0.041056f},   20}  ,{  { 0.490714f, 0.202346f, 0.306940f},   34}  ,{  { 0.330401f, 0.646139f, 0.023460f},   27}  ,{  { 0.200391f, 0.191593f, 0.608016f},  169}  ,{  { 0.060606f, 0.097752f, 0.841642f},  153}  ,{  { 0.412512f, 0.112414f, 0.475073f},   31}  ,{  { 0.260997f, 0.557185f, 0.181818f},  162}  ,{  { 0.081134f, 0.861193f, 0.057674f},   45}  ,{  { 0.433040f, 0.216031f, 0.350929f},  249}  ,{  { 0.094819f, 0.113392f, 0.791789f},  159}  ,{  { 0.400782f, 0.284457f, 0.314761f},  180}  ,{  { 0.436950f, 0.197458f, 0.365591f},   21}  ,{  { 0.495601f, 0.355816f, 0.148583f},   96}  ,{  { 0.059629f, 0.798631f, 0.141740f},   91}  ,
{  { 0.662757f, 0.266862f, 0.070381f},   81}  ,{  { 0.139785f, 0.811339f, 0.048876f},   14}  ,{  { 0.080156f, 0.039101f, 0.880743f},  221}  ,{  { 0.161290f, 0.474096f, 0.364614f},  186}  ,{  { 0.212121f, 0.554252f, 0.233627f},   38}  ,{  { 0.738025f, 0.012708f, 0.249267f},  105}  ,{  { 0.233627f, 0.283480f, 0.482893f},  225}  ,{  { 0.684262f, 0.010753f, 0.304985f},   82}  ,{  { 0.315738f, 0.014663f, 0.669599f},  124}  ,{  { 0.622678f, 0.121212f, 0.256109f},  138}  ,{  { 0.173998f, 0.311828f, 0.514174f},  121}  ,{  { 0.043011f, 0.908113f, 0.048876f},  177}  ,{  { 0.396872f, 0.022483f, 0.580645f},   58}  ,{  { 0.523949f, 0.390029f, 0.086022f},  242}  ,{  { 0.241447f, 0.150538f, 0.608016f},   80}  ,{  { 0.004888f, 0.889541f, 0.105572f},  163}  ,{  { 0.135875f, 0.428153f, 0.435973f},   22}  ,{  { 0.513196f, 0.315738f, 0.171065f},  174}  ,{  { 0.545455f, 0.078201f, 0.376344f},   78}  ,{  { 0.269795f, 0.467253f, 0.262952f},   68}  ,{  { 0.525904f, 0.267840f, 0.206256f},   33}  ,{  { 0.256109f, 0.015640f, 0.728250f},  132}  ,{  { 0.010753f, 0.893451f, 0.095797f},   50}  ,{  { 0.331378f, 0.242424f, 0.426197f},  145}  ,{  { 0.248289f, 0.059629f, 0.692082f},   45}  ,{  { 0.034213f, 0.151515f, 0.814272f},   50}  ,{  { 0.304008f, 0.631476f, 0.064516f},  184}  ,{  { 0.213099f, 0.310850f, 0.476051f},   68}  ,{  { 0.317693f, 0.227761f, 0.454545f},   11}  ,{  { 0.400782f, 0.469208f, 0.130010f},  163}  ,{  { 0.117302f, 0.216031f, 0.666667f},   35}  ,{  { 0.715542f, 0.115347f, 0.169110f},  198}  ,
{  { 0.637341f, 0.062561f, 0.300098f},   58}  ,{  { 0.734115f, 0.052786f, 0.213099f},  159}  ,{  { 0.217986f, 0.356794f, 0.425220f},  254}  ,{  { 0.455523f, 0.003910f, 0.540567f},  132}  ,{  { 0.386119f, 0.253177f, 0.360704f},   31}  ,{  { 0.488759f, 0.163245f, 0.347996f},  137}  ,{  { 0.149560f, 0.006843f, 0.843597f},  108}  ,{  { 0.338221f, 0.431085f, 0.230694f},   82}  ,{  { 0.015640f, 0.913001f, 0.071359f},  237}  ,{  { 0.245357f, 0.242424f, 0.512219f},  215}  ,{  { 0.088954f, 0.391007f, 0.520039f},   84}  ,{  { 0.044966f, 0.746823f, 0.208211f},  123}  ,{  { 0.081134f, 0.773216f, 0.145650f},  124}  ,{  { 0.661779f, 0.226784f, 0.111437f},  132}  ,{  { 0.134897f, 0.176931f, 0.688172f},    5}  ,{  { 0.249267f, 0.408602f, 0.342131f},   21}  ,{  { 0.668622f, 0.130010f, 0.201369f},  255}  ,{  { 0.354839f, 0.587488f, 0.057674f},   75}  ,{  { 0.355816f, 0.210166f, 0.434018f},   95}  ,{  { 0.384164f, 0.368524f, 0.247312f},   74}  ,{  { 0.049853f, 0.844575f, 0.105572f},   49}  ,{  { 0.004888f, 0.817204f, 0.177908f},  117}  ,{  { 0.258065f, 0.430108f, 0.311828f},   38}  ,{  { 0.047898f, 0.633431f, 0.318671f},    2}  ,{  { 0.570870f, 0.147605f, 0.281525f},   43}  ,{  { 0.306940f, 0.525904f, 0.167155f},    2}  ,{  { 0.398827f, 0.119257f, 0.481916f},  122}  ,{  { 0.964809f, 0.012708f, 0.022483f},  241}  ,{  { 0.144673f, 0.399805f, 0.455523f},  252}  ,{  { 0.344086f, 0.467253f, 0.188661f},  206}  ,{  { 0.369501f, 0.062561f, 0.567937f},  232}  ,{  { 0.811339f, 0.173021f, 0.015640f},  110}  ,
{  { 0.492669f, 0.164223f, 0.343109f},  166}  ,{  { 0.411535f, 0.512219f, 0.076246f},   83}  ,{  { 0.813294f, 0.158358f, 0.028348f},  237}  ,{  { 0.792766f, 0.176931f, 0.030303f},  205}  ,{  { 0.114370f, 0.263930f, 0.621701f},  116}  ,{  { 0.327468f, 0.147605f, 0.524927f},  204}  ,{  { 0.591398f, 0.352884f, 0.055718f},  136}  ,{  { 0.221896f, 0.415445f, 0.362659f},   40}  ,{  { 0.675464f, 0.236559f, 0.087977f},  100}  ,{  { 0.183773f, 0.219941f, 0.596285f},   94}  ,{  { 0.558162f, 0.302053f, 0.139785f},    4}  ,{  { 0.422287f, 0.335288f, 0.242424f},  116}  ,{  { 0.577713f, 0.249267f, 0.173021f},   97}  ,{  { 0.183773f, 0.469208f, 0.347019f},  237}  ,{  { 0.124145f, 0.280547f, 0.595308f},  114}  ,{  { 0.544477f, 0.054741f, 0.400782f},  136}  ,{  { 0.252199f, 0.468231f, 0.279570f},  146}  ,{  { 0.020528f, 0.697947f, 0.281525f},  226}  ,{  { 0.880743f, 0.117302f, 0.001955f},  174}  ,{  { 0.100684f, 0.713587f, 0.185728f},    3}  ,{  { 0.100684f, 0.626588f, 0.272727f},  132}  ,{  { 0.287390f, 0.189638f, 0.522972f},   32}  ,{  { 0.174976f, 0.428153f, 0.396872f},   33}  ,{  { 0.008798f, 0.038123f, 0.953079f},   48}  ,{  { 0.786901f, 0.066471f, 0.146628f},  252}  ,{  { 0.272727f, 0.423265f, 0.304008f},  185}  ,{  { 0.070381f, 0.886608f, 0.043011f},  196}  ,{  { 0.624633f, 0.237537f, 0.137830f},  115}  ,{  { 0.074291f, 0.089932f, 0.835777f},    1}  ,{  { 0.487781f, 0.329423f, 0.182796f},   87}  ,{  { 0.072336f, 0.898338f, 0.029326f},  248}  ,{  { 0.285435f, 0.148583f, 0.565982f},  190}  ,
{  { 0.089932f, 0.295210f, 0.614858f},   78}  ,{  { 0.013685f, 0.828934f, 0.157380f},   13}  ,{  { 0.169110f, 0.041056f, 0.789834f},  253}  ,{  { 0.093842f, 0.095797f, 0.810362f},  125}  ,{  { 0.049853f, 0.325513f, 0.624633f},   19}  ,{  { 0.272727f, 0.652004f, 0.075269f},   11}  ,{  { 0.142717f, 0.136852f, 0.720430f},  230}  ,{  { 0.273705f, 0.454545f, 0.271750f},   56}  ,{  { 0.467253f, 0.426197f, 0.106549f},   86}  ,{  { 0.128055f, 0.381232f, 0.490714f},   67}  ,{  { 0.651026f, 0.037146f, 0.311828f},   16}  ,{  { 0.292278f, 0.061584f, 0.646139f},   83}  ,{  { 0.652004f, 0.266862f, 0.081134f},  194}  ,{  { 0.077224f, 0.511241f, 0.411535f},  214}  ,{  { 0.382209f, 0.253177f, 0.364614f},   82}  ,{  { 0.107527f, 0.709677f, 0.182796f},   21}  ,{  { 0.404692f, 0.317693f, 0.277615f},   68}  ,{  { 0.434018f, 0.229717f, 0.336266f},  203}  ,{  { 0.407625f, 0.375367f, 0.217009f},  174}  ,{  { 0.467253f, 0.381232f, 0.151515f},  193}  ,{  { 0.162268f, 0.140762f, 0.696970f},   82}  ,{  { 0.106549f, 0.072336f, 0.821114f},   51}  ,{  { 0.253177f, 0.470186f, 0.276637f},   78}  ,{  { 0.021505f, 0.749756f, 0.228739f},   54}  ,{  { 0.215054f, 0.731183f, 0.053763f},  146}  ,{  { 0.160313f, 0.613881f, 0.225806f},  178}  ,{  { 0.122190f, 0.388074f, 0.489736f},  166}  ,{  { 0.101662f, 0.664712f, 0.233627f},  225}  ,{  { 0.421310f, 0.232649f, 0.346041f},   21}  ,{  { 0.210166f, 0.474096f, 0.315738f},  136}  ,{  { 0.791789f, 0.088954f, 0.119257f},  156}  ,{  { 0.134897f, 0.276637f, 0.588465f},   43}  ,
{  { 0.862170f, 0.049853f, 0.087977f},   11}  ,{  { 0.907136f, 0.018573f, 0.074291f},  107}  ,{  { 0.260997f, 0.072336f, 0.666667f},   65}  ,{  { 0.452590f, 0.157380f, 0.390029f},  206}  ,{  { 0.100684f, 0.589443f, 0.309873f},  121}  ,{  { 0.471163f, 0.386119f, 0.142717f},  215}  ,{  { 0.345064f, 0.353861f, 0.301075f},   15}  ,{  { 0.333333f, 0.420332f, 0.246334f},  128}  ,{  { 0.069404f, 0.658847f, 0.271750f},  249}  ,{  { 0.287390f, 0.342131f, 0.370479f},  234}  ,{  { 0.389052f, 0.434995f, 0.175953f},  231}  ,{  { 0.141740f, 0.399805f, 0.458456f},  186}  ,{  { 0.307918f, 0.042033f, 0.650049f},  216}  ,{  { 0.065494f, 0.484848f, 0.449658f},  114}  ,{  { 0.413490f, 0.081134f, 0.505376f},  182}  ,{  { 0.130010f, 0.739980f, 0.130010f},  217}  ,{  { 0.869990f, 0.117302f, 0.012708f},   84}  ,{  { 0.306940f, 0.305963f, 0.387097f},  138}  ,{  { 0.739980f, 0.209189f, 0.050831f},  248}  ,{  { 0.086999f, 0.420332f, 0.492669f},   51}  ,{  { 0.170088f, 0.156403f, 0.673509f},  217}  ,{  { 0.758553f, 0.232649f, 0.008798f},  156}  ,{  { 0.072336f, 0.871945f, 0.055718f},   81}  ,{  { 0.392962f, 0.000978f, 0.606061f},  124}  ,{  { 0.026393f, 0.675464f, 0.298143f},  150}  ,{  { 0.201369f, 0.348974f, 0.449658f},   70}  ,{  { 0.652981f, 0.335288f, 0.011730f},  209}  ,{  { 0.964809f, 0.003910f, 0.031281f},  160}  ,{  { 0.069404f, 0.808407f, 0.122190f},  119}  ,{  { 0.182796f, 0.415445f, 0.401760f},   85}  ,{  { 0.095797f, 0.092864f, 0.811339f},  192}  ,{  { 0.349951f, 0.568915f, 0.081134f},   82}  ,
{  { 0.178886f, 0.577713f, 0.243402f},  237}  ,{  { 0.598240f, 0.148583f, 0.253177f},  233}  ,{  { 0.257087f, 0.495601f, 0.247312f},  232}  ,{  { 0.362659f, 0.019550f, 0.617791f},  167}  ,{  { 0.635386f, 0.065494f, 0.299120f},   60}  ,{  { 0.292278f, 0.537634f, 0.170088f},  127}  ,{  { 0.137830f, 0.364614f, 0.497556f},  187}  ,{  { 0.646139f, 0.208211f, 0.145650f},  187}  ,{  { 0.034213f, 0.082111f, 0.883675f},  186}  ,{  { 0.263930f, 0.069404f, 0.666667f},   29}  ,{  { 0.269795f, 0.646139f, 0.084066f},  175}  ,{  { 0.254154f, 0.009775f, 0.736070f},   14}  ,{  { 0.073314f, 0.071359f, 0.855327f},  194}  ,{  { 0.363636f, 0.361681f, 0.274682f},   98}  ,{  { 0.252199f, 0.606061f, 0.141740f},    6}  ,{  { 0.545455f, 0.266862f, 0.187683f},  100}  ,{  { 0.368524f, 0.447703f, 0.183773f},  207}  ,{  { 0.456501f, 0.367546f, 0.175953f},  212}  ,{  { 0.543500f, 0.159335f, 0.297165f},  123}  ,{  { 0.369501f, 0.509286f, 0.121212f},   13}  ,{  { 0.178886f, 0.614858f, 0.206256f},  164}  ,{  { 0.107527f, 0.032258f, 0.860215f},   55}  ,{  { 0.203324f, 0.057674f, 0.739003f},  100}  ,{  { 0.293255f, 0.446725f, 0.260020f},  137}  ,{  { 0.179863f, 0.456501f, 0.363636f},   20}  ,{  { 0.489736f, 0.182796f, 0.327468f},   68}  ,{  { 0.301075f, 0.193548f, 0.505376f},   56}  ,{  { 0.258065f, 0.232649f, 0.509286f},    4}  ,{  { 0.107527f, 0.258065f, 0.634409f},  255}  ,{  { 0.142717f, 0.215054f, 0.642229f},   70}  ,{  { 0.834800f, 0.044966f, 0.120235f},   25}  ,{  { 0.228739f, 0.081134f, 0.690127f},  161}  ,
{  { 0.095797f, 0.067449f, 0.836755f},  137}  ,{  { 0.328446f, 0.560117f, 0.111437f},  157}  ,{  { 0.459433f, 0.314761f, 0.225806f},  170}  ,{  { 0.109482f, 0.037146f, 0.853372f},  175}  ,{  { 0.460411f, 0.251222f, 0.288368f},  192}  ,{  { 0.263930f, 0.583578f, 0.152493f},  157}  ,{  { 0.078201f, 0.914956f, 0.006843f},    6}  ,{  { 0.224829f, 0.186706f, 0.588465f},  242}  ,{  { 0.411535f, 0.230694f, 0.357771f},   25}  ,{  { 0.033236f, 0.196481f, 0.770283f},  218}  ,{  { 0.435973f, 0.131965f, 0.432063f},  207}  ,{  { 0.867058f, 0.052786f, 0.080156f},  159}  ,{  { 0.436950f, 0.029326f, 0.533724f},  246}  ,{  { 0.600196f, 0.276637f, 0.123167f},   45}  ,{  { 0.932551f, 0.047898f, 0.019550f},   28}  ,{  { 0.103617f, 0.301075f, 0.595308f},  202}  ,{  { 0.298143f, 0.431085f, 0.270772f},   38}  ,{  { 0.540567f, 0.383187f, 0.076246f},  101}  ,{  { 0.860215f, 0.011730f, 0.128055f},   88}  ,{  { 0.002933f, 0.713587f, 0.283480f},  104}  ,{  { 0.050831f, 0.292278f, 0.656891f},  172}  ,{  { 0.090909f, 0.145650f, 0.763441f},   62}  ,{  { 0.350929f, 0.092864f, 0.556207f},  180}  ,{  { 0.515152f, 0.146628f, 0.338221f},  104}  ,{  { 0.862170f, 0.128055f, 0.009775f},  117}  ,{  { 0.243402f, 0.277615f, 0.478983f},  130}  ,{  { 0.627566f, 0.250244f, 0.122190f},   36}  ,{  { 0.238514f, 0.566960f, 0.194526f},   72}  ,{  { 0.076246f, 0.006843f, 0.916911f},   18}  ,{  { 0.098729f, 0.684262f, 0.217009f},   48}  ,{  { 0.377322f, 0.570870f, 0.051808f},  205}  ,{  { 0.367546f, 0.617791f, 0.014663f},  217}  ,
{  { 0.232649f, 0.336266f, 0.431085f},  234}  ,{  { 0.333333f, 0.146628f, 0.520039f},  153}  ,{  { 0.731183f, 0.199413f, 0.069404f},   11}  ,{  { 0.882698f, 0.058651f, 0.058651f},  205}  ,{  { 0.078201f, 0.522972f, 0.398827f},  235}  ,{  { 0.311828f, 0.513196f, 0.174976f},  130}  ,{  { 0.698925f, 0.149560f, 0.151515f},  102}  ,{  { 0.377322f, 0.385142f, 0.237537f},   36}  ,{  { 0.377322f, 0.130987f, 0.491691f},  210}  ,{  { 0.267840f, 0.624633f, 0.107527f},  194}  ,{  { 0.159335f, 0.378299f, 0.462366f},  175}  ,{  { 0.067449f, 0.044966f, 0.887586f},  190}  ,{  { 0.192571f, 0.293255f, 0.514174f},  182}  ,{  { 0.429130f, 0.160313f, 0.410557f},   24}  ,{  { 0.489736f, 0.005865f, 0.504399f},  246}  ,{  { 0.289345f, 0.166178f, 0.544477f},  119}  ,{  { 0.440860f, 0.200391f, 0.358749f},  215}  ,{  { 0.216031f, 0.198436f, 0.585533f},  172}  ,{  { 0.664712f, 0.072336f, 0.262952f},  234}  ,{  { 0.181818f, 0.293255f, 0.524927f},   66}  ,{  { 0.566960f, 0.094819f, 0.338221f},  108}  ,{  { 0.364614f, 0.614858f, 0.020528f},   11}  ,{  { 0.440860f, 0.289345f, 0.269795f},   93}  ,{  { 0.353861f, 0.042033f, 0.604106f},   50}  ,{  { 0.449658f, 0.090909f, 0.459433f},   30}  ,{  { 0.302053f, 0.616813f, 0.081134f},   64}  ,{  { 0.026393f, 0.468231f, 0.505376f},  118}  ,{  { 0.167155f, 0.490714f, 0.342131f},   23}  ,{  { 0.311828f, 0.235582f, 0.452590f},  177}  ,{  { 0.461388f, 0.049853f, 0.488759f},   83}  ,{  { 0.335288f, 0.069404f, 0.595308f},  147}  ,{  { 0.325513f, 0.025415f, 0.649071f},   45}  ,
{  { 0.286413f, 0.217009f, 0.496579f},  212}  ,{  { 0.263930f, 0.189638f, 0.546432f},  140}  ,{  { 0.082111f, 0.747801f, 0.170088f},   78}  ,{  { 0.039101f, 0.468231f, 0.492669f},  121}  ,{  { 0.507331f, 0.294233f, 0.198436f},  193}  ,{  { 0.298143f, 0.340176f, 0.361681f},  155}  ,{  { 0.639296f, 0.287390f, 0.073314f},  122}  ,{  { 0.086022f, 0.804497f, 0.109482f},  231}  ,{  { 0.429130f, 0.353861f, 0.217009f},   37}  ,{  { 0.426197f, 0.135875f, 0.437928f},   21}  ,{  { 0.274682f, 0.108504f, 0.616813f},   12}  ,{  { 0.213099f, 0.522972f, 0.263930f},   86}  ,{  { 0.033236f, 0.942326f, 0.024438f},   41}  ,{  { 0.045943f, 0.437928f, 0.516129f},  135}  ,{  { 0.021505f, 0.004888f, 0.973607f},  225}  ,{  { 0.005865f, 0.775171f, 0.218964f},  157}  ,{  { 0.072336f, 0.384164f, 0.543500f},  123}  ,{  { 0.204301f, 0.096774f, 0.698925f},  212}  ,{  { 0.200391f, 0.181818f, 0.617791f},  137}  ,{  { 0.544477f, 0.051808f, 0.403715f},  241}  ,{  { 0.331378f, 0.663734f, 0.004888f},  210}  ,{  { 0.851417f, 0.012708f, 0.135875f},   64}  ,{  { 0.923754f, 0.032258f, 0.043988f},  129}  ,{  { 0.315738f, 0.021505f, 0.662757f},  166}  ,{  { 0.347019f, 0.625611f, 0.027370f},  167}  ,{  { 0.256109f, 0.048876f, 0.695015f},  184}  ,{  { 0.131965f, 0.158358f, 0.709677f},  228}  ,{  { 0.748778f, 0.007820f, 0.243402f},  172}  ,{  { 0.042033f, 0.510264f, 0.447703f},   79}  ,{  { 0.384164f, 0.097752f, 0.518084f},   13}  ,{  { 0.175953f, 0.077224f, 0.746823f},  147}  ,{  { 0.186706f, 0.701857f, 0.111437f},  100}  ,
{  { 0.235582f, 0.412512f, 0.351906f},  149}  ,{  { 0.055718f, 0.757576f, 0.186706f},  190}  ,{  { 0.364614f, 0.603128f, 0.032258f},  101}  ,{  { 0.669599f, 0.134897f, 0.195503f},  210}  ,{  { 0.599218f, 0.125122f, 0.275660f},  163}  ,{  { 0.626588f, 0.217009f, 0.156403f},  178}  ,{  { 0.085044f, 0.029326f, 0.885630f},  106}  ,{  { 0.287390f, 0.566960f, 0.145650f},  128}  ,{  { 0.088954f, 0.432063f, 0.478983f},   78}  ,{  { 0.257087f, 0.455523f, 0.287390f},  180}  ,{  { 0.104594f, 0.488759f, 0.406647f},   12}  ,{  { 0.270772f, 0.518084f, 0.211144f},  167}  ,{  { 0.361681f, 0.372434f, 0.265885f},   51}  ,{  { 0.432063f, 0.045943f, 0.521994f},   49}  ,{  { 0.087977f, 0.473118f, 0.438905f},  130}  ,{  { 0.445748f, 0.071359f, 0.482893f},  188}  ,{  { 0.317693f, 0.319648f, 0.362659f},  113}  ,{  { 0.922776f, 0.051808f, 0.025415f},   24}  ,{  { 0.149560f, 0.096774f, 0.753666f},  128}  ,{  { 0.204301f, 0.163245f, 0.632454f},  149}  ,{  { 0.424242f, 0.463343f, 0.112414f},  169}  ,{  { 0.180841f, 0.797654f, 0.021505f},  210}  ,{  { 0.130987f, 0.200391f, 0.668622f},  138}  ,{  { 0.941349f, 0.043011f, 0.015640f},  167}  ,{  { 0.659824f, 0.222874f, 0.117302f},  183}  ,{  { 0.205279f, 0.203324f, 0.591398f},  105}  ,{  { 0.489736f, 0.237537f, 0.272727f},  184}  ,{  { 0.169110f, 0.443793f, 0.387097f},  198}  ,{  { 0.129032f, 0.238514f, 0.632454f},  120}  ,{  { 0.542522f, 0.083089f, 0.374389f},   33}  ,{  { 0.027370f, 0.632454f, 0.340176f},  192}  ,{  { 0.196481f, 0.698925f, 0.104594f},    8}  ,
{  { 0.862170f, 0.025415f, 0.112414f},  163}  ,{  { 0.054741f, 0.778104f, 0.167155f},   80}  ,{  { 0.597263f, 0.044966f, 0.357771f},  216}  ,{  { 0.073314f, 0.504399f, 0.422287f},   54}  ,{  { 0.374389f, 0.606061f, 0.019550f},  248}  ,{  { 0.711632f, 0.274682f, 0.013685f},  136}  ,{  { 0.744868f, 0.147605f, 0.107527f},   53}  ,{  { 0.091887f, 0.565982f, 0.342131f},  164}  ,{  { 0.621701f, 0.137830f, 0.240469f},  245}  ,{  { 0.334311f, 0.145650f, 0.520039f},   51}  ,{  { 0.152493f, 0.530792f, 0.316716f},   24}  ,{  { 0.660802f, 0.075269f, 0.263930f},  185}  ,{  { 0.230694f, 0.453568f, 0.315738f},   75}  ,{  { 0.493646f, 0.027370f, 0.478983f},   48}  ,{  { 0.705767f, 0.251222f, 0.043011f},   98}  ,{  { 0.830890f, 0.145650f, 0.023460f},  247}  ,{  { 0.647116f, 0.083089f, 0.269795f},   44}  ,{  { 0.359726f, 0.183773f, 0.456501f},   55}  ,{  { 0.587488f, 0.263930f, 0.148583f},  179}  ,{  { 0.137830f, 0.473118f, 0.389052f},    5}  ,{  { 0.212121f, 0.289345f, 0.498534f},   21}  ,{  { 0.186706f, 0.722385f, 0.090909f},   55}  ,{  { 0.330401f, 0.345064f, 0.324536f},   48}  ,{  { 0.374389f, 0.217009f, 0.408602f},   41}  ,{  { 0.210166f, 0.460411f, 0.329423f},   72}  ,{  { 0.521994f, 0.308895f, 0.169110f},  177}  ,{  { 0.124145f, 0.610948f, 0.264907f},  218}  ,{  { 0.148583f, 0.566960f, 0.284457f},   93}  ,{  { 0.186706f, 0.745846f, 0.067449f},  135}  ,{  { 0.707722f, 0.219941f, 0.072336f},   37}  ,{  { 0.881720f, 0.046921f, 0.071359f},  159}  ,{  { 0.331378f, 0.126100f, 0.542522f},   44}  ,
{  { 0.365591f, 0.477028f, 0.157380f},  236}  ,{  { 0.412512f, 0.053763f, 0.533724f},  105}  ,{  { 0.464321f, 0.331378f, 0.204301f},   36}  ,{  { 0.209189f, 0.619746f, 0.171065f},   93}  ,{  { 0.709677f, 0.097752f, 0.192571f},  246}  ,{  { 0.227761f, 0.081134f, 0.691105f},  180}  ,{  { 0.408602f, 0.552297f, 0.039101f},  182}  ,{  { 0.533724f, 0.179863f, 0.286413f},  180}  ,{  { 0.469208f, 0.113392f, 0.417400f},    6}  ,{  { 0.057674f, 0.012708f, 0.929619f},   57}  ,{  { 0.108504f, 0.471163f, 0.420332f},  147}  ,{  { 0.285435f, 0.534702f, 0.179863f},   61}  ,{  { 0.003910f, 0.653959f, 0.342131f},  210}  ,{  { 0.508309f, 0.225806f, 0.265885f},   65}  ,{  { 0.076246f, 0.520039f, 0.403715f},  169}  ,{  { 0.447703f, 0.249267f, 0.303030f},  135}  ,{  { 0.261975f, 0.437928f, 0.300098f},  227}  ,{  { 0.150538f, 0.799609f, 0.049853f},    5}  ,{  { 0.372434f, 0.343109f, 0.284457f},  172}  ,{  { 0.143695f, 0.650049f, 0.206256f},   83}  ,{  { 0.326491f, 0.082111f, 0.591398f},  156}  ,{  { 0.152493f, 0.038123f, 0.809384f},   97}  ,{  { 0.609971f, 0.316716f, 0.073314f},  232}  ,{  { 0.107527f, 0.740958f, 0.151515f},   67}  ,{  { 0.207234f, 0.756598f, 0.036168f},  206}  ,{  { 0.318671f, 0.447703f, 0.233627f},  177}  ,{  { 0.699902f, 0.038123f, 0.261975f},  173}  ,{  { 0.347019f, 0.075269f, 0.577713f},  196}  ,{  { 0.094819f, 0.333333f, 0.571847f},  114}  ,{  { 0.186706f, 0.466276f, 0.347019f},  164}  ,{  { 0.051808f, 0.160313f, 0.787879f},    9}  ,{  { 0.022483f, 0.096774f, 0.880743f},  109}  ,
{  { 0.633431f, 0.345064f, 0.021505f},  228}  ,{  { 0.040078f, 0.078201f, 0.881720f},  146}  ,{  { 0.435973f, 0.232649f, 0.331378f},   88}  ,{  { 0.412512f, 0.525904f, 0.061584f},  161}  ,{  { 0.501466f, 0.443793f, 0.054741f},  221}  ,{  { 0.558162f, 0.286413f, 0.155425f},  177}  ,{  { 0.725318f, 0.128055f, 0.146628f},  233}  ,{  { 0.131965f, 0.245357f, 0.622678f},  169}  ,{  { 0.166178f, 0.343109f, 0.490714f},  191}  ,{  { 0.181818f, 0.225806f, 0.592375f},   64}  ,{  { 0.303030f, 0.594330f, 0.102639f},   14}  ,{  { 0.126100f, 0.701857f, 0.172043f},    3}  ,{  { 0.330401f, 0.224829f, 0.444770f},  141}  ,{  { 0.285435f, 0.265885f, 0.448680f},   28}  ,{  { 0.462366f, 0.252199f, 0.285435f},  127}  ,{  { 0.368524f, 0.186706f, 0.444770f},  249}  ,{  { 0.571847f, 0.234604f, 0.193548f},   35}  ,{  { 0.184751f, 0.271750f, 0.543500f},    5}  ,{  { 0.782991f, 0.036168f, 0.180841f},   64}  ,{  { 0.766373f, 0.118280f, 0.115347f},  172}  ,{  { 0.210166f, 0.509286f, 0.280547f},   83}  ,{  { 0.194526f, 0.175953f, 0.629521f},  223}  ,{  { 0.165200f, 0.016618f, 0.818182f},   43}  ,{  { 0.077224f, 0.760508f, 0.162268f},  151}  ,{  { 0.190616f, 0.143695f, 0.665689f},   47}  ,{  { 0.262952f, 0.499511f, 0.237537f},  163}  ,{  { 0.098729f, 0.035191f, 0.866080f},  222}  ,{  { 0.519062f, 0.069404f, 0.411535f},  163}  ,{  { 0.499511f, 0.444770f, 0.055718f},  162}  ,{  { 0.564027f, 0.406647f, 0.029326f},  123}  ,{  { 0.218964f, 0.304008f, 0.477028f},  124}  ,{  { 0.620723f, 0.242424f, 0.136852f},  151}  ,
{  { 0.326491f, 0.499511f, 0.173998f},    2}  ,{  { 0.177908f, 0.536657f, 0.285435f},  187}  ,{  { 0.488759f, 0.420332f, 0.090909f},    4}  ,{  { 0.102639f, 0.556207f, 0.341153f},   74}  ,{  { 0.533724f, 0.121212f, 0.345064f},  170}  ,{  { 0.122190f, 0.236559f, 0.641251f},   97}  ,{  { 0.454545f, 0.280547f, 0.264907f},  197}  ,{  { 0.108504f, 0.791789f, 0.099707f},   36}  ,{  { 0.536657f, 0.450635f, 0.012708f},   69}  ,{  { 0.323558f, 0.207234f, 0.469208f},   48}  ,{  { 0.335288f, 0.106549f, 0.558162f},   77}  ,{  { 0.272727f, 0.443793f, 0.283480f},  171}  ,{  { 0.115347f, 0.801564f, 0.083089f},   54}  ,{  { 0.293255f, 0.263930f, 0.442815f},  129}  ,{  { 0.639296f, 0.284457f, 0.076246f},  174}  ,{  { 0.626588f, 0.027370f, 0.346041f},  234}  ,{  { 0.523949f, 0.327468f, 0.148583f},   31}  ,{  { 0.701857f, 0.292278f, 0.005865f},  162}  ,{  { 0.429130f, 0.423265f, 0.147605f},   66}  ,{  { 0.308895f, 0.634409f, 0.056696f},  152}  ,{  { 0.001955f, 0.216031f, 0.782014f},  162}  ,{  { 0.116325f, 0.222874f, 0.660802f},   51}  ,{  { 0.144673f, 0.287390f, 0.567937f},  171}  ,{  { 0.812317f, 0.070381f, 0.117302f},  194}  ,{  { 0.167155f, 0.078201f, 0.754643f},   77}  ,{  { 0.002933f, 0.606061f, 0.391007f},  247}  ,{  { 0.890518f, 0.010753f, 0.098729f},  255}  ,{  { 0.287390f, 0.357771f, 0.354839f},  175}  ,{  { 0.436950f, 0.289345f, 0.273705f},   36}  ,{  { 0.071359f, 0.504399f, 0.424242f},   23}  ,{  { 0.139785f, 0.336266f, 0.523949f},  169}  ,{  { 0.721408f, 0.129032f, 0.149560f},  242}  ,
{  { 0.137830f, 0.568915f, 0.293255f},  152}  ,{  { 0.239492f, 0.460411f, 0.300098f},    4}  ,{  { 0.716520f, 0.273705f, 0.009775f},   32}  ,{  { 0.219941f, 0.720430f, 0.059629f},   50}  ,{  { 0.355816f, 0.342131f, 0.302053f},   57}  ,{  { 0.076246f, 0.157380f, 0.766373f},   92}  ,{  { 0.650049f, 0.223851f, 0.126100f},  141}  ,{  { 0.000000f, 0.874878f, 0.125122f},  160}  ,{  { 0.522972f, 0.263930f, 0.213099f},   90}  ,{  { 0.106549f, 0.565005f, 0.328446f},   89}  ,{  { 0.476051f, 0.506354f, 0.017595f},  253}  ,{  { 0.548387f, 0.450635f, 0.000978f},   34}  ,{  { 0.471163f, 0.357771f, 0.171065f},  227}  ,{  { 0.379277f, 0.031281f, 0.589443f},  147}  ,{  { 0.607038f, 0.391984f, 0.000978f},  250}  ,{  { 0.562072f, 0.049853f, 0.388074f},  158}  ,{  { 0.169110f, 0.807429f, 0.023460f},  160}  ,{  { 0.158358f, 0.478006f, 0.363636f},   18}  ,{  { 0.303030f, 0.550342f, 0.146628f},   63}  ,{  { 0.448680f, 0.254154f, 0.297165f},   83}  ,{  { 0.011730f, 0.093842f, 0.894428f},  152}  ,{  { 0.462366f, 0.305963f, 0.231672f},  141}  ,{  { 0.870968f, 0.038123f, 0.090909f},  121}  ,{  { 0.022483f, 0.137830f, 0.839687f},   14}  ,{  { 0.529814f, 0.202346f, 0.267840f},  114}  ,{  { 0.325513f, 0.596285f, 0.078201f},   70}  ,{  { 0.055718f, 0.451613f, 0.492669f},  100}  ,{  { 0.294233f, 0.175953f, 0.529814f},  139}  ,{  { 0.241447f, 0.109482f, 0.649071f},  137}  ,{  { 0.127077f, 0.421310f, 0.451613f},   49}  ,{  { 0.273705f, 0.344086f, 0.382209f},  243}  ,{  { 0.428153f, 0.026393f, 0.545455f},  184}  ,
{  { 0.401760f, 0.564027f, 0.034213f},  126}  ,{  { 0.221896f, 0.090909f, 0.687195f},   56}  ,{  { 0.364614f, 0.161290f, 0.474096f},  143}  ,{  { 0.137830f, 0.861193f, 0.000978f},   15}  ,{  { 0.934506f, 0.027370f, 0.038123f},  122}  ,{  { 0.533724f, 0.238514f, 0.227761f},   87}  ,{  { 0.656891f, 0.247312f, 0.095797f},   30}  ,{  { 0.465298f, 0.253177f, 0.281525f},  158}  ,{  { 0.577713f, 0.214076f, 0.208211f},   99}  ,{  { 0.437928f, 0.342131f, 0.219941f},  145}  ,{  { 0.503421f, 0.132942f, 0.363636f},   52}  ,{  { 0.058651f, 0.451613f, 0.489736f},  150}  ,{  { 0.973607f, 0.014663f, 0.011730f},  171}  ,{  { 0.350929f, 0.239492f, 0.409580f},   89}  ,{  { 0.031281f, 0.437928f, 0.530792f},  176}  ,{  { 0.195503f, 0.280547f, 0.523949f},  100}  ,{  { 0.194526f, 0.107527f, 0.697947f},  150}  ,{  { 0.146628f, 0.676442f, 0.176931f},   59}  ,{  { 0.527859f, 0.438905f, 0.033236f},  146}  ,{  { 0.415445f, 0.224829f, 0.359726f},   10}  ,{  { 0.018573f, 0.659824f, 0.321603f},  140}  ,{  { 0.834800f, 0.091887f, 0.073314f},   47}  ,{  { 0.318671f, 0.429130f, 0.252199f},   52}  ,{  { 0.181818f, 0.388074f, 0.430108f},  127}  ,{  { 0.267840f, 0.483871f, 0.248289f},  196}  ,{  { 0.592375f, 0.245357f, 0.162268f},  102}  ,{  { 0.209189f, 0.629521f, 0.161290f},  121}  ,{  { 0.308895f, 0.600196f, 0.090909f},   36}  ,{  { 0.421310f, 0.423265f, 0.155425f},    1}  ,{  { 0.666667f, 0.250244f, 0.083089f},  155}  ,{  { 0.322581f, 0.461388f, 0.216031f},  195}  ,{  { 0.748778f, 0.069404f, 0.181818f},   49}  ,
{  { 0.204301f, 0.481916f, 0.313783f},  187}  ,{  { 0.066471f, 0.403715f, 0.529814f},  173}  ,{  { 0.557185f, 0.186706f, 0.256109f},  221}  ,{  { 0.204301f, 0.052786f, 0.742913f},  233}  ,{  { 0.070381f, 0.919844f, 0.009775f},   38}  ,{  { 0.326491f, 0.508309f, 0.165200f},  135}  ,{  { 0.325513f, 0.624633f, 0.049853f},   25}  ,{  { 0.208211f, 0.688172f, 0.103617f},  183}  ,{  { 0.688172f, 0.168133f, 0.143695f},   11}  ,{  { 0.624633f, 0.283480f, 0.091887f},  228}  ,{  { 0.438905f, 0.463343f, 0.097752f},   73}  ,{  { 0.276637f, 0.521994f, 0.201369f},  194}  ,{  { 0.217986f, 0.721408f, 0.060606f},  171}  ,{  { 0.370479f, 0.201369f, 0.428153f},  100}  ,{  { 0.407625f, 0.219941f, 0.372434f},  152}  ,{  { 0.027370f, 0.622678f, 0.349951f},  166}  ,{  { 0.288368f, 0.703812f, 0.007820f},  238}  ,{  { 0.612903f, 0.265885f, 0.121212f},   60}  ,{  { 0.286413f, 0.448680f, 0.264907f},  163}  ,{  { 0.404692f, 0.129032f, 0.466276f},  150}  ,{  { 0.196481f, 0.042033f, 0.761486f},  158}  ,{  { 0.010753f, 0.694037f, 0.295210f},  218}  ,{  { 0.013685f, 0.417400f, 0.568915f},   17}  ,{  { 0.605083f, 0.356794f, 0.038123f},  178}  ,{  { 0.603128f, 0.239492f, 0.157380f},  109}  ,{  { 0.060606f, 0.389052f, 0.550342f},  165}  ,{  { 0.049853f, 0.645161f, 0.304985f},  169}  ,{  { 0.145650f, 0.473118f, 0.381232f},  212}  ,{  { 0.273705f, 0.448680f, 0.277615f},   67}  ,{  { 0.041056f, 0.738025f, 0.220919f},  134}  ,{  { 0.652981f, 0.178886f, 0.168133f},  245}  ,{  { 0.157380f, 0.147605f, 0.695015f},  108}  ,
{  { 0.079179f, 0.753666f, 0.167155f},   14}  ,{  { 0.000978f, 0.726295f, 0.272727f},   72}  ,{  { 0.402737f, 0.225806f, 0.371457f},  114}  ,{  { 0.011730f, 0.003910f, 0.984360f},  188}  ,{  { 0.341153f, 0.409580f, 0.249267f},   19}  ,{  { 0.221896f, 0.189638f, 0.588465f},  127}  ,{  { 0.589443f, 0.163245f, 0.247312f},  226}  ,{  { 0.592375f, 0.253177f, 0.154448f},   35}  ,{  { 0.204301f, 0.157380f, 0.638319f},  118}  ,{  { 0.896383f, 0.049853f, 0.053763f},  240}  ,{  { 0.098729f, 0.700880f, 0.200391f},  211}  ,{  { 0.790811f, 0.012708f, 0.196481f},   62}  ,{  { 0.325513f, 0.259042f, 0.415445f},  244}  ,{  { 0.655914f, 0.157380f, 0.186706f},  134}  ,{  { 0.013685f, 0.425220f, 0.561095f},  139}  ,{  { 0.862170f, 0.040078f, 0.097752f},  196}  ,{  { 0.131965f, 0.853372f, 0.014663f},   32}  ,{  { 0.160313f, 0.393939f, 0.445748f},  177}  ,{  { 0.068426f, 0.228739f, 0.702835f},   31}  ,{  { 0.058651f, 0.297165f, 0.644184f},  201}  ,{  { 0.834800f, 0.148583f, 0.016618f},  181}  ,{  { 0.368524f, 0.042033f, 0.589443f},   48}  ,{  { 0.046921f, 0.483871f, 0.469208f},  200}  ,{  { 0.534702f, 0.058651f, 0.406647f},  160}  ,{  { 0.955034f, 0.030303f, 0.014663f},  110}  ,{  { 0.179863f, 0.704790f, 0.115347f},  227}  ,{  { 0.166178f, 0.494624f, 0.339198f},  220}  ,{  { 0.361681f, 0.486804f, 0.151515f},  245}  ,{  { 0.502444f, 0.045943f, 0.451613f},    8}  ,{  { 0.093842f, 0.717498f, 0.188661f},  217}  ,{  { 0.386119f, 0.249267f, 0.364614f},   77}  ,{  { 0.608016f, 0.233627f, 0.158358f},  173}  ,
{  { 0.008798f, 0.511241f, 0.479961f},   43}  ,{  { 0.204301f, 0.172043f, 0.623656f},  112}  ,{  { 0.106549f, 0.612903f, 0.280547f},   75}  ,{  { 0.216031f, 0.033236f, 0.750733f},   38}  ,{  { 0.110459f, 0.089932f, 0.799609f},   20}  ,{  { 0.416422f, 0.440860f, 0.142717f},   52}  ,{  { 0.199413f, 0.200391f, 0.600196f},  161}  ,{  { 0.016618f, 0.597263f, 0.386119f},  135}  ,{  { 0.784946f, 0.190616f, 0.024438f},   67}  ,{  { 0.217009f, 0.761486f, 0.021505f},   29}  ,{  { 0.319648f, 0.565982f, 0.114370f},  132}  ,{  { 0.213099f, 0.416422f, 0.370479f},  107}  ,{  { 0.091887f, 0.474096f, 0.434018f},   41}  ,{  { 0.036168f, 0.195503f, 0.768328f},   42}  ,{  { 0.730205f, 0.170088f, 0.099707f},    3}  ,{  { 0.264907f, 0.380254f, 0.354839f},    1}  ,{  { 0.585533f, 0.001955f, 0.412512f},  100}  ,{  { 0.000000f, 0.284457f, 0.715542f},  173}  ,{  { 0.231672f, 0.224829f, 0.543500f},   13}  ,{  { 0.056696f, 0.298143f, 0.645161f},  149}  ,{  { 0.298143f, 0.072336f, 0.629521f},  189}  ,{  { 0.251222f, 0.213099f, 0.535679f},  177}  ,{  { 0.480938f, 0.113392f, 0.405670f},  130}  ,{  { 0.070381f, 0.619746f, 0.309873f},   38}  ,{  { 0.235582f, 0.078201f, 0.686217f},   62}  ,{  { 0.282502f, 0.196481f, 0.521017f},  245}  ,{  { 0.896383f, 0.066471f, 0.037146f},  180}  ,{  { 0.081134f, 0.175953f, 0.742913f},   52}  ,{  { 0.171065f, 0.305963f, 0.522972f},  189}  ,{  { 0.751711f, 0.057674f, 0.190616f},   35}  ,{  { 0.038123f, 0.012708f, 0.949169f},    6}  ,{  { 0.224829f, 0.549365f, 0.225806f},  184}  ,
{  { 0.124145f, 0.306940f, 0.568915f},  200}  ,{  { 0.304985f, 0.050831f, 0.644184f},   92}  ,{  { 0.166178f, 0.530792f, 0.303030f},  247}  ,{  { 0.183773f, 0.641251f, 0.174976f},  202}  ,{  { 0.112414f, 0.540567f, 0.347019f},   42}  ,{  { 0.203324f, 0.052786f, 0.743891f},  189}  ,{  { 0.266862f, 0.307918f, 0.425220f},  115}  ,{  { 0.241447f, 0.315738f, 0.442815f},  185}  ,{  { 0.436950f, 0.558162f, 0.004888f},  108}  ,{  { 0.598240f, 0.111437f, 0.290323f},  105}  ,{  { 0.203324f, 0.007820f, 0.788856f},  162}  ,{  { 0.188661f, 0.724340f, 0.086999f},  113}  ,{  { 0.652981f, 0.276637f, 0.070381f},   64}  ,{  { 0.866080f, 0.110459f, 0.023460f},  114}  ,{  { 0.844575f, 0.086999f, 0.068426f},    3}  ,{  { 0.165200f, 0.608016f, 0.226784f},  234}  ,{  { 0.501466f, 0.497556f, 0.000978f},  231}  ,{  { 0.355816f, 0.515152f, 0.129032f},  146}  ,{  { 0.035191f, 0.430108f, 0.534702f},  246}  ,{  { 0.080156f, 0.149560f, 0.770283f},   11}  ,{  { 0.501466f, 0.495601f, 0.002933f},   88}  ,{  { 0.361681f, 0.321603f, 0.316716f},  188}  ,{  { 0.299120f, 0.285435f, 0.415445f},    7}  ,{  { 0.254154f, 0.386119f, 0.359726f},  110}  ,{  { 0.284457f, 0.334311f, 0.381232f},   85}  ,{  { 0.165200f, 0.204301f, 0.630499f},  188}  ,{  { 0.146628f, 0.273705f, 0.579668f},   56}  ,{  { 0.005865f, 0.393939f, 0.600196f},  205}  ,{  { 0.519062f, 0.181818f, 0.299120f},   73}  ,{  { 0.776149f, 0.102639f, 0.121212f},  250}  ,{  { 0.218964f, 0.113392f, 0.667644f},  244}  ,{  { 0.181818f, 0.660802f, 0.157380f},   82}  ,
{  { 0.274682f, 0.227761f, 0.497556f},   61}  ,{  { 0.628543f, 0.293255f, 0.078201f},   31}  ,{  { 0.004888f, 0.808407f, 0.186706f},  225}  ,{  { 0.278592f, 0.395894f, 0.325513f},  123}  ,{  { 0.713587f, 0.022483f, 0.263930f},  206}  ,{  { 0.539589f, 0.347019f, 0.113392f},  218}  ,{  { 0.671554f, 0.107527f, 0.220919f},  108}  ,{  { 0.098729f, 0.253177f, 0.648094f},    4}  ,{  { 0.144673f, 0.203324f, 0.652004f},  244}  ,{  { 0.380254f, 0.552297f, 0.067449f},  139}  ,{  { 0.180841f, 0.817204f, 0.001955f},  114}  ,{  { 0.088954f, 0.454545f, 0.456501f},   85}  ,{  { 0.598240f, 0.308895f, 0.092864f},  174}  ,{  { 0.402737f, 0.022483f, 0.574780f},   44}  ,{  { 0.465298f, 0.207234f, 0.327468f},   43}  ,{  { 0.270772f, 0.075269f, 0.653959f},   92}  ,{  { 0.540567f, 0.430108f, 0.029326f},   85}  ,{  { 0.803519f, 0.135875f, 0.060606f},   22}  ,{  { 0.162268f, 0.434018f, 0.403715f},  101}  ,{  { 0.485826f, 0.417400f, 0.096774f},  180}  ,{  { 0.456501f, 0.382209f, 0.161290f},   30}  ,{  { 0.278592f, 0.392962f, 0.328446f},   49}  ,{  { 0.501466f, 0.439883f, 0.058651f},  184}  ,{  { 0.018573f, 0.504399f, 0.477028f},  230}  ,{  { 0.136852f, 0.143695f, 0.719453f},   55}  ,{  { 0.309873f, 0.128055f, 0.562072f},  162}  ,{  { 0.224829f, 0.043988f, 0.731183f},   74}  ,{  { 0.872923f, 0.071359f, 0.055718f},   13}  ,{  { 0.201369f, 0.181818f, 0.616813f},  187}  ,{  { 0.386119f, 0.557185f, 0.056696f},   94}  ,{  { 0.670577f, 0.218964f, 0.110459f},  122}  ,{  { 0.618768f, 0.312805f, 0.068426f},   59}  ,
{  { 0.306940f, 0.406647f, 0.286413f},  155}  ,{  { 0.593353f, 0.103617f, 0.303030f},  249}  ,{  { 0.537634f, 0.383187f, 0.079179f},   94}  ,{  { 0.613881f, 0.361681f, 0.024438f},  156}  ,{  { 0.142717f, 0.595308f, 0.261975f},   74}  ,{  { 0.359726f, 0.613881f, 0.026393f},  153}  ,{  { 0.306940f, 0.433040f, 0.260020f},  144}  ,{  { 0.811339f, 0.112414f, 0.076246f},   19}  ,{  { 0.451613f, 0.068426f, 0.479961f},   72}  ,{  { 0.261975f, 0.732160f, 0.005865f},   31}  ,{  { 0.576735f, 0.146628f, 0.276637f},  109}  ,{  { 0.654936f, 0.051808f, 0.293255f},    2}  ,{  { 0.017595f, 0.136852f, 0.845552f},    8}  ,{  { 0.246334f, 0.309873f, 0.443793f},  243}  ,{  { 0.379277f, 0.451613f, 0.169110f},   56}  ,{  { 0.261975f, 0.606061f, 0.131965f},  143}  ,{  { 0.190616f, 0.531769f, 0.277615f},  188}  ,{  { 0.741935f, 0.063539f, 0.194526f},  128}  ,{  { 0.708700f, 0.070381f, 0.220919f},  106}  ,{  { 0.202346f, 0.174976f, 0.622678f},  246}  ,{  { 0.034213f, 0.181818f, 0.783969f},  212}  ,{  { 0.054741f, 0.576735f, 0.368524f},  195}  ,{  { 0.274682f, 0.152493f, 0.572825f},   63}  ,{  { 0.181818f, 0.737048f, 0.081134f},  205}  ,{  { 0.194526f, 0.308895f, 0.496579f},   23}  ,{  { 0.317693f, 0.090909f, 0.591398f},  124}  ,{  { 0.184751f, 0.146628f, 0.668622f},   45}  ,{  { 0.109482f, 0.596285f, 0.294233f},  216}  ,{  { 0.034213f, 0.287390f, 0.678397f},  253}  ,{  { 0.474096f, 0.445748f, 0.080156f},  247}  ,{  { 0.434995f, 0.391984f, 0.173021f},   42}  ,{  { 0.310850f, 0.644184f, 0.044966f},   30}  ,
{  { 0.697947f, 0.067449f, 0.234604f},   95}  ,{  { 0.184751f, 0.650049f, 0.165200f},  208}  ,{  { 0.292278f, 0.278592f, 0.429130f},   71}  ,{  { 0.880743f, 0.048876f, 0.070381f},  120}  ,{  { 0.386119f, 0.595308f, 0.018573f},  130}  ,{  { 0.719453f, 0.088954f, 0.191593f},  146}  ,{  { 0.477028f, 0.151515f, 0.371457f},   48}  ,{  { 0.326491f, 0.326491f, 0.347019f},  233}  ,{  { 0.341153f, 0.363636f, 0.295210f},   14}  ,{  { 0.095797f, 0.212121f, 0.692082f},  179}  ,{  { 0.212121f, 0.237537f, 0.550342f},   13}  ,{  { 0.195503f, 0.366569f, 0.437928f},  127}  ,{  { 0.175953f, 0.778104f, 0.045943f},    4}  ,{  { 0.230694f, 0.313783f, 0.455523f},  123}  ,{  { 0.122190f, 0.405670f, 0.472141f},   79}  ,{  { 0.809384f, 0.138807f, 0.051808f},  184}  ,{  { 0.568915f, 0.296188f, 0.134897f},  147}  ,{  { 0.315738f, 0.403715f, 0.280547f},   44}  ,{  { 0.514174f, 0.031281f, 0.454545f},   37}  ,{  { 0.001955f, 0.848485f, 0.149560f},   78}  ,{  { 0.187683f, 0.219941f, 0.592375f},  158}  ,{  { 0.198436f, 0.063539f, 0.738025f},  211}  ,{  { 0.564027f, 0.310850f, 0.125122f},  204}  ,{  { 0.101662f, 0.739003f, 0.159335f},  199}  ,{  { 0.594330f, 0.329423f, 0.076246f},   72}  ,{  { 0.565005f, 0.116325f, 0.318671f},   36}  ,{  { 0.496579f, 0.483871f, 0.019550f},   11}  ,{  { 0.449658f, 0.282502f, 0.267840f},    4}  ,{  { 0.512219f, 0.090909f, 0.396872f},  184}  ,{  { 0.715542f, 0.282502f, 0.001955f},  151}  ,{  { 0.180841f, 0.389052f, 0.430108f},  191}  ,{  { 0.400782f, 0.156403f, 0.442815f},  239}  ,
{  { 0.090909f, 0.080156f, 0.828934f},  240}  ,{  { 0.345064f, 0.148583f, 0.506354f},  147}  ,{  { 0.419355f, 0.478006f, 0.102639f},  163}  ,{  { 0.495601f, 0.071359f, 0.433040f},  231}  ,{  { 0.002933f, 0.508309f, 0.488759f},  177}  ,{  { 0.668622f, 0.327468f, 0.003910f},  169}  ,{  { 0.482893f, 0.165200f, 0.351906f},  216}  ,{  { 0.584555f, 0.156403f, 0.259042f},   27}  ,{  { 0.187683f, 0.026393f, 0.785924f},   42}  ,{  { 0.264907f, 0.503421f, 0.231672f},  187}  ,{  { 0.328446f, 0.045943f, 0.625611f},  127}  ,{  { 0.171065f, 0.542522f, 0.286413f},  197}  ,{  { 0.538612f, 0.317693f, 0.143695f},   57}  ,{  { 0.006843f, 0.835777f, 0.157380f},  126}  ,{  { 0.300098f, 0.262952f, 0.436950f},   27}  ,{  { 0.348974f, 0.304008f, 0.347019f},  177}  ,{  { 0.590420f, 0.277615f, 0.131965f},  228}  ,{  { 0.567937f, 0.230694f, 0.201369f},    7}  ,{  { 0.279570f, 0.306940f, 0.413490f},    5}  ,{  { 0.049853f, 0.567937f, 0.382209f},  239}  ,{  { 0.253177f, 0.217009f, 0.529814f},   54}  ,{  { 0.264907f, 0.249267f, 0.485826f},  207}  ,{  { 0.352884f, 0.504399f, 0.142717f},   26}  ,{  { 0.089932f, 0.242424f, 0.667644f},  101}  ,{  { 0.205279f, 0.443793f, 0.350929f},  197}  ,{  { 0.135875f, 0.754643f, 0.109482f},  149}  ,{  { 0.403715f, 0.380254f, 0.216031f},  123}  ,{  { 0.119257f, 0.717498f, 0.163245f},  126}  ,{  { 0.636364f, 0.150538f, 0.213099f},  239}  ,{  { 0.356794f, 0.598240f, 0.044966f},  217}  ,{  { 0.008798f, 0.283480f, 0.707722f},   86}  ,{  { 0.250244f, 0.090909f, 0.658847f},  136}  ,
{  { 0.014663f, 0.019550f, 0.965787f},  148}  ,{  { 0.295210f, 0.604106f, 0.100684f},   93}  ,{  { 0.246334f, 0.636364f, 0.117302f},  254}  ,{  { 0.238514f, 0.596285f, 0.165200f},   26}  ,{  { 0.051808f, 0.019550f, 0.928641f},   58}  ,{  { 0.406647f, 0.309873f, 0.283480f},  180}  ,{  { 0.359726f, 0.043988f, 0.596285f},  117}  ,{  { 0.579668f, 0.076246f, 0.344086f},  234}  ,{  { 0.911046f, 0.023460f, 0.065494f},   42}  ,{  { 0.484848f, 0.135875f, 0.379277f},  134}  ,{  { 0.566960f, 0.120235f, 0.312805f},  150}  ,{  { 0.422287f, 0.219941f, 0.357771f},   60}  ,{  { 0.612903f, 0.101662f, 0.285435f},   97}  ,{  { 0.181818f, 0.567937f, 0.250244f},   97}  ,{  { 0.412512f, 0.581623f, 0.005865f},  117}  ,{  { 0.055718f, 0.813294f, 0.130987f},  203}  ,{  { 0.575758f, 0.029326f, 0.394917f},  144}  ,{  { 0.002933f, 0.340176f, 0.656891f},  232}  ,{  { 0.182796f, 0.111437f, 0.705767f},  161}  ,{  { 0.539589f, 0.255132f, 0.205279f},  145}  ,{  { 0.035191f, 0.509286f, 0.455523f},  142}  ,{  { 0.354839f, 0.568915f, 0.076246f},  176}  ,{  { 0.081134f, 0.182796f, 0.736070f},  157}  ,{  { 0.321603f, 0.404692f, 0.273705f},   16}  ,{  { 0.463343f, 0.435973f, 0.100684f},  151}  ,{  { 0.221896f, 0.047898f, 0.730205f},  241}  ,{  { 0.191593f, 0.772238f, 0.036168f},   44}  ,{  { 0.051808f, 0.124145f, 0.824047f},  192}  ,{  { 0.664712f, 0.106549f, 0.228739f},   75}  ,{  { 0.076246f, 0.444770f, 0.478983f},  194}  ,{  { 0.205279f, 0.194526f, 0.600196f},  111}  ,{  { 0.238514f, 0.398827f, 0.362659f},   74}  ,
{  { 0.091887f, 0.359726f, 0.548387f},  131}  ,{  { 0.359726f, 0.433040f, 0.207234f},    7}  ,{  { 0.213099f, 0.565982f, 0.220919f},  253}  ,{  { 0.445748f, 0.309873f, 0.244379f},  250}  ,{  { 0.301075f, 0.579668f, 0.119257f},   19}  ,{  { 0.253177f, 0.605083f, 0.141740f},  150}  ,{  { 0.285435f, 0.622678f, 0.091887f},   71}  ,{  { 0.043988f, 0.761486f, 0.194526f},   30}  ,{  { 0.432063f, 0.059629f, 0.508309f},  158}  ,{  { 0.623656f, 0.147605f, 0.228739f},  197}  ,{  { 0.353861f, 0.166178f, 0.479961f},   58}  ,{  { 0.585533f, 0.040078f, 0.374389f},   86}  ,{  { 0.076246f, 0.803519f, 0.120235f},   87}  ,{  { 0.071359f, 0.523949f, 0.404692f},  107}  ,{  { 0.097752f, 0.069404f, 0.832845f},  237}  ,{  { 0.410557f, 0.578690f, 0.010753f},   99}  ,{  { 0.110459f, 0.691105f, 0.198436f},   29}  ,{  { 0.715542f, 0.102639f, 0.181818f},   16}  ,{  { 0.655914f, 0.118280f, 0.225806f},   83}  ,{  { 0.248289f, 0.104594f, 0.647116f},  129}  ,{  { 0.769306f, 0.094819f, 0.135875f},   13}  ,{  { 0.084066f, 0.430108f, 0.485826f},  236}  ,{  { 0.123167f, 0.139785f, 0.737048f},  167}  ,{  { 0.061584f, 0.482893f, 0.455523f},  194}  ,{  { 0.844575f, 0.038123f, 0.117302f},   12}  ,{  { 0.615836f, 0.289345f, 0.094819f},    2}  ,{  { 0.108504f, 0.193548f, 0.697947f},  184}  ,{  { 0.062561f, 0.220919f, 0.716520f},  185}  ,{  { 0.496579f, 0.169110f, 0.334311f},  186}  ,{  { 0.347996f, 0.523949f, 0.128055f},  167}  ,{  { 0.708700f, 0.242424f, 0.048876f},  196}  ,{  { 0.025415f, 0.004888f, 0.969697f},  163}  ,
{  { 0.389052f, 0.409580f, 0.201369f},  153}  ,{  { 0.527859f, 0.428153f, 0.043988f},   60}  ,{  { 0.109482f, 0.468231f, 0.422287f},  190}  ,{  { 0.422287f, 0.153470f, 0.424242f},  131}  ,{  { 0.687195f, 0.272727f, 0.040078f},  229}  ,{  { 0.602151f, 0.118280f, 0.279570f},  147}  ,{  { 0.133920f, 0.480938f, 0.385142f},   77}  ,{  { 0.357771f, 0.562072f, 0.080156f},  164}  ,{  { 0.226784f, 0.436950f, 0.336266f},   77}  ,{  { 0.799609f, 0.082111f, 0.118280f},  227}  ,{  { 0.062561f, 0.213099f, 0.724340f},   33}  ,{  { 0.223851f, 0.231672f, 0.544477f},  152}  ,{  { 0.036168f, 0.358749f, 0.605083f},  224}  ,{  { 0.030303f, 0.306940f, 0.662757f},   45}  ,{  { 0.199413f, 0.755621f, 0.044966f},   93}  ,{  { 0.150538f, 0.564027f, 0.285435f},  236}  ,{  { 0.741935f, 0.173021f, 0.085044f},  157}  ,{  { 0.202346f, 0.214076f, 0.583578f},   27}  ,{  { 0.255132f, 0.170088f, 0.574780f},  201}  ,{  { 0.738025f, 0.195503f, 0.066471f},  216}  ,{  { 0.083089f, 0.589443f, 0.327468f},  121}  ,{  { 0.780059f, 0.117302f, 0.102639f},   91}  ,{  { 0.520039f, 0.102639f, 0.377322f},  147}  ,{  { 0.162268f, 0.356794f, 0.480938f},  157}  ,{  { 0.781036f, 0.217009f, 0.001955f},  159}  ,{  { 0.201369f, 0.588465f, 0.210166f},  129}  ,{  { 0.381232f, 0.233627f, 0.385142f},  113}  ,{  { 0.217986f, 0.499511f, 0.282502f},  135}  ,{  { 0.355816f, 0.337243f, 0.306940f},  211}  ,{  { 0.319648f, 0.267840f, 0.412512f},   74}  ,{  { 0.455523f, 0.357771f, 0.186706f},   41}  ,{  { 0.626588f, 0.183773f, 0.189638f},   32}  ,
{  { 0.335288f, 0.330401f, 0.334311f},   31}  ,{  { 0.872923f, 0.019550f, 0.107527f},  151}  ,{  { 0.286413f, 0.690127f, 0.023460f},  194}  ,{  { 0.564027f, 0.007820f, 0.428153f},  146}  ,{  { 0.186706f, 0.406647f, 0.406647f},  133}  ,{  { 0.066471f, 0.036168f, 0.897361f},  242}  ,{  { 0.476051f, 0.338221f, 0.185728f},  208}  ,{  { 0.490714f, 0.476051f, 0.033236f},  117}  ,{  { 0.098729f, 0.740958f, 0.160313f},  207}  ,{  { 0.088954f, 0.807429f, 0.103617f},  118}  ,{  { 0.005865f, 0.068426f, 0.925709f},   69}  ,{  { 0.456501f, 0.409580f, 0.133920f},  143}  ,{  { 0.474096f, 0.098729f, 0.427175f},  236}  ,{  { 0.358749f, 0.141740f, 0.499511f},   30}  ,{  { 0.513196f, 0.392962f, 0.093842f},   28}  ,{  { 0.268817f, 0.179863f, 0.551320f},  166}  ,{  { 0.403715f, 0.258065f, 0.338221f},  122}  ,{  { 0.831867f, 0.033236f, 0.134897f},  188}  ,{  { 0.241447f, 0.152493f, 0.606061f},   60}  ,{  { 0.277615f, 0.137830f, 0.584555f},   83}  ,{  { 0.767351f, 0.139785f, 0.092864f},   50}  ,{  { 0.535679f, 0.164223f, 0.300098f},   70}  ,{  { 0.460411f, 0.427175f, 0.112414f},  211}  ,{  { 0.173998f, 0.327468f, 0.498534f},  109}  ,{  { 0.088954f, 0.021505f, 0.889541f},  132}  ,{  { 0.459433f, 0.293255f, 0.247312f},  116}  ,{  { 0.576735f, 0.282502f, 0.140762f},   85}  ,{  { 0.810362f, 0.040078f, 0.149560f},  212}  ,{  { 0.066471f, 0.280547f, 0.652981f},   16}  ,{  { 0.026393f, 0.464321f, 0.509286f},  229}  ,{  { 0.149560f, 0.257087f, 0.593353f},  150}  ,{  { 0.530792f, 0.435973f, 0.033236f},  224}  ,
{  { 0.229717f, 0.596285f, 0.173998f},   25}  ,{  { 0.020528f, 0.864125f, 0.115347f},  228}  ,{  { 0.619746f, 0.241447f, 0.138807f},  208}  ,{  { 0.280547f, 0.376344f, 0.343109f},  141}  ,{  { 0.268817f, 0.579668f, 0.151515f},  106}  ,{  { 0.044966f, 0.696970f, 0.258065f},  151}  ,{  { 0.599218f, 0.243402f, 0.157380f},  125}  ,{  { 0.306940f, 0.489736f, 0.203324f},  152}  ,{  { 0.644184f, 0.194526f, 0.161290f},   97}  ,{  { 0.699902f, 0.202346f, 0.097752f},  232}  ,{  { 0.033236f, 0.311828f, 0.654936f},   16}  ,{  { 0.139785f, 0.745846f, 0.114370f},   85}  ,{  { 0.239492f, 0.643206f, 0.117302f},  159}  ,{  { 0.124145f, 0.613881f, 0.261975f},  237}  ,{  { 0.140762f, 0.293255f, 0.565982f},  191}  ,{  { 0.005865f, 0.946237f, 0.047898f},  249}  ,{  { 0.253177f, 0.103617f, 0.643206f},   24}  ,{  { 0.686217f, 0.172043f, 0.141740f},  110}  ,{  { 0.398827f, 0.580645f, 0.020528f},  162}  ,{  { 0.053763f, 0.479961f, 0.466276f},   12}  ,{  { 0.350929f, 0.147605f, 0.501466f},  229}  ,{  { 0.167155f, 0.258065f, 0.574780f},   16}  ,{  { 0.227761f, 0.457478f, 0.314761f},   39}  ,{  { 0.351906f, 0.467253f, 0.180841f},  242}  ,{  { 0.607038f, 0.369501f, 0.023460f},  104}  ,{  { 0.480938f, 0.024438f, 0.494624f},  114}  ,{  { 0.525904f, 0.327468f, 0.146628f},   36}  ,{  { 0.601173f, 0.275660f, 0.123167f},   61}  ,{  { 0.318671f, 0.099707f, 0.581623f},  178}  ,{  { 0.241447f, 0.615836f, 0.142717f},   86}  ,{  { 0.371457f, 0.523949f, 0.104594f},  203}  ,{  { 0.495601f, 0.449658f, 0.054741f},  123}  ,
{  { 0.884653f, 0.010753f, 0.104594f},   54}  ,{  { 0.297165f, 0.499511f, 0.203324f},  162}  ,{  { 0.065494f, 0.534702f, 0.399805f},   26}  ,{  { 0.478006f, 0.183773f, 0.338221f},   78}  ,{  { 0.036168f, 0.830890f, 0.132942f},   31}  ,{  { 0.032258f, 0.395894f, 0.571847f},  238}  ,{  { 0.398827f, 0.347019f, 0.254154f},  102}  ,{  { 0.701857f, 0.145650f, 0.152493f},  243}  ,{  { 0.084066f, 0.376344f, 0.539589f},  133}  ,{  { 0.093842f, 0.769306f, 0.136852f},  232}  ,{  { 0.287390f, 0.677419f, 0.035191f},   39}  ,{  { 0.019550f, 0.519062f, 0.461388f},   35}  ,{  { 0.216031f, 0.541544f, 0.242424f},  226}  ,{  { 0.051808f, 0.143695f, 0.804497f},  109}  ,{  { 0.314761f, 0.007820f, 0.677419f},   97}  ,{  { 0.477028f, 0.060606f, 0.462366f},   77}  ,{  { 0.379277f, 0.260997f, 0.359726f},  175}  ,{  { 0.103617f, 0.641251f, 0.255132f},   16}  ,{  { 0.560117f, 0.054741f, 0.385142f},  182}  ,{  { 0.403715f, 0.292278f, 0.304008f},  202}  ,{  { 0.003910f, 0.000000f, 0.996090f},  218}  ,{  { 0.342131f, 0.121212f, 0.536657f},   57}  ,{  { 0.041056f, 0.063539f, 0.895406f},   27}  ,{  { 0.767351f, 0.178886f, 0.053763f},   32}  ,{  { 0.297165f, 0.583578f, 0.119257f},   93}  ,{  { 0.334311f, 0.227761f, 0.437928f},   82}  ,{  { 0.542522f, 0.098729f, 0.358749f},   92}  ,{  { 0.004888f, 0.924731f, 0.070381f},   42}  ,{  { 0.761486f, 0.172043f, 0.066471f},  205}  ,{  { 0.062561f, 0.230694f, 0.706745f},  146}  ,{  { 0.169110f, 0.778104f, 0.052786f},   38}  ,{  { 0.010753f, 0.847507f, 0.141740f},  252}  ,
{  { 0.339198f, 0.550342f, 0.110459f},  210}  ,{  { 0.757576f, 0.171065f, 0.071359f},  254}  ,{  { 0.358749f, 0.390029f, 0.251222f},  253}  ,{  { 0.040078f, 0.637341f, 0.322581f},  104}  ,{  { 0.538612f, 0.437928f, 0.023460f},  107}  ,{  { 0.213099f, 0.559140f, 0.227761f},   55}  ,{  { 0.303030f, 0.249267f, 0.447703f},   39}  ,{  { 0.374389f, 0.466276f, 0.159335f},  142}  ,{  { 0.077224f, 0.178886f, 0.743891f},  165}  ,{  { 0.164223f, 0.523949f, 0.311828f},   19}  ,{  { 0.128055f, 0.606061f, 0.265885f},  129}  ,{  { 0.217009f, 0.308895f, 0.474096f},  150}  ,{  { 0.370479f, 0.556207f, 0.073314f},  199}  ,{  { 0.655914f, 0.119257f, 0.224829f},  113}  ,{  { 0.599218f, 0.051808f, 0.348974f},  162}  ,{  { 0.363636f, 0.456501f, 0.179863f},  208}  ,{  { 0.022483f, 0.427175f, 0.550342f},  203}  ,{  { 0.435973f, 0.080156f, 0.483871f},  137}  ,{  { 0.084066f, 0.517107f, 0.398827f},   59}  ,{  { 0.239492f, 0.603128f, 0.157380f},  232}  ,{  { 0.593353f, 0.289345f, 0.117302f},  211}  ,{  { 0.040078f, 0.562072f, 0.397849f},  104}  ,{  { 0.524927f, 0.251222f, 0.223851f},   14}  ,{  { 0.283480f, 0.187683f, 0.528837f},   48}  ,{  { 0.612903f, 0.380254f, 0.006843f},   52}  ,{  { 0.087977f, 0.509286f, 0.402737f},  145}  ,{  { 0.039101f, 0.631476f, 0.329423f},   78}  ,{  { 0.104594f, 0.640274f, 0.255132f},   35}  ,{  { 0.071359f, 0.043988f, 0.884653f},   21}  ,{  { 0.086022f, 0.583578f, 0.330401f},   48}  ,{  { 0.589443f, 0.302053f, 0.108504f},   56}  ,{  { 0.670577f, 0.119257f, 0.210166f},   57}  ,
{  { 0.776149f, 0.095797f, 0.128055f},  181}  ,{  { 0.031281f, 0.400782f, 0.567937f},   16}  ,{  { 0.047898f, 0.098729f, 0.853372f},  224}  ,{  { 0.087977f, 0.683284f, 0.228739f},  135}  ,{  { 0.050831f, 0.399805f, 0.549365f},  210}  ,{  { 0.545455f, 0.046921f, 0.407625f},   83}  ,{  { 0.770283f, 0.084066f, 0.145650f},  253}  ,{  { 0.467253f, 0.420332f, 0.112414f},  123}  ,{  { 0.121212f, 0.413490f, 0.465298f},  164}  ,{  { 0.445748f, 0.112414f, 0.441838f},   90}  ,{  { 0.199413f, 0.649071f, 0.151515f},   25}  ,{  { 0.262952f, 0.043011f, 0.694037f},  111}  ,{  { 0.507331f, 0.345064f, 0.147605f},   97}  ,{  { 0.148583f, 0.667644f, 0.183773f},   79}  ,{  { 0.567937f, 0.150538f, 0.281525f},   68}  ,{  { 0.667644f, 0.241447f, 0.090909f},  104}  ,{  { 0.130010f, 0.853372f, 0.016618f},  206}  ,{  { 0.712610f, 0.084066f, 0.203324f},   60}  ,{  { 0.164223f, 0.318671f, 0.517107f},  139}  ,{  { 0.949169f, 0.020528f, 0.030303f},  134}  ,{  { 0.455523f, 0.418377f, 0.126100f},  121}  ,{  { 0.009775f, 0.548387f, 0.441838f},  109}  ,{  { 0.371457f, 0.288368f, 0.340176f},  111}  ,{  { 0.268817f, 0.509286f, 0.221896f},   14}  ,{  { 0.157380f, 0.106549f, 0.736070f},   74}  ,{  { 0.200391f, 0.774194f, 0.025415f},  181}  ,{  { 0.613881f, 0.366569f, 0.019550f},   16}  ,{  { 0.208211f, 0.593353f, 0.198436f},   58}  ,{  { 0.054741f, 0.190616f, 0.754643f},   10}  ,{  { 0.616813f, 0.061584f, 0.321603f},   94}  ,{  { 0.526882f, 0.422287f, 0.050831f},  176}  ,{  { 0.123167f, 0.024438f, 0.852395f},   18}  ,
{  { 0.243402f, 0.699902f, 0.056696f},   45}  ,{  { 0.197458f, 0.380254f, 0.422287f},   33}  ,{  { 0.096774f, 0.692082f, 0.211144f},    2}  ,{  { 0.483871f, 0.225806f, 0.290323f},   85}  ,{  { 0.186706f, 0.088954f, 0.724340f},   45}  ,{  { 0.814272f, 0.105572f, 0.080156f},   70}  ,{  { 0.034213f, 0.838710f, 0.127077f},  108}  ,{  { 0.559140f, 0.232649f, 0.208211f},  242}  ,{  { 0.555230f, 0.426197f, 0.018573f},  249}  ,{  { 0.285435f, 0.485826f, 0.228739f},   90}  ,{  { 0.341153f, 0.632454f, 0.026393f},   27}  ,{  { 0.383187f, 0.545455f, 0.071359f},    5}  ,{  { 0.505376f, 0.360704f, 0.133920f},  191}  ,{  { 0.291300f, 0.153470f, 0.555230f},  239}  ,{  { 0.627566f, 0.036168f, 0.336266f},  110}  ,{  { 0.144673f, 0.594330f, 0.260997f},  108}  ,{  { 0.134897f, 0.663734f, 0.201369f},  246}  ,{  { 0.638319f, 0.149560f, 0.212121f},  176}  ,{  { 0.848485f, 0.121212f, 0.030303f},  213}  ,{  { 0.727273f, 0.027370f, 0.245357f},   30}  ,{  { 0.069404f, 0.117302f, 0.813294f},   34}  ,{  { 0.020528f, 0.406647f, 0.572825f},  175}  ,{  { 0.255132f, 0.195503f, 0.549365f},   33}  ,{  { 0.918866f, 0.007820f, 0.073314f},  188}  ,{  { 0.275660f, 0.211144f, 0.513196f},  248}  ,{  { 0.241447f, 0.295210f, 0.463343f},  255}  ,{  { 0.396872f, 0.467253f, 0.135875f},   69}  ,{  { 0.091887f, 0.650049f, 0.258065f},  105}  ,{  { 0.245357f, 0.434018f, 0.320626f},  208}  ,{  { 0.304008f, 0.013685f, 0.682307f},  136}  ,{  { 0.117302f, 0.756598f, 0.126100f},  180}  ,{  { 0.280547f, 0.091887f, 0.627566f},  151}  ,
{  { 0.059629f, 0.405670f, 0.534702f},  168}  ,{  { 0.284457f, 0.389052f, 0.326491f},  195}  ,{  { 0.319648f, 0.117302f, 0.563050f},   33}  ,{  { 0.544477f, 0.384164f, 0.071359f},  156}  ,{  { 0.243402f, 0.236559f, 0.520039f},   40}  ,{  { 0.024438f, 0.759531f, 0.216031f},  149}  ,{  { 0.483871f, 0.099707f, 0.416422f},  250}  ,{  { 0.904203f, 0.051808f, 0.043988f},  214}  ,{  { 0.710655f, 0.218964f, 0.070381f},   55}  ,{  { 0.320626f, 0.526882f, 0.152493f},   43}  ,{  { 0.011730f, 0.298143f, 0.690127f},   21}  ,{  { 0.184751f, 0.051808f, 0.763441f},  251}  ,{  { 0.545455f, 0.222874f, 0.231672f},  231}  ,{  { 0.376344f, 0.079179f, 0.544477f},   22}  ,{  { 0.181818f, 0.007820f, 0.810362f},  202}  ,{  { 0.508309f, 0.007820f, 0.483871f},  157}  ,{  { 0.035191f, 0.908113f, 0.056696f},    2}  ,{  { 0.268817f, 0.049853f, 0.681329f},  240}  ,{  { 0.288368f, 0.180841f, 0.530792f},   83}  ,{  { 0.482893f, 0.238514f, 0.278592f},  248}  ,{  { 0.098729f, 0.576735f, 0.324536f},   86}  ,{  { 0.304985f, 0.467253f, 0.227761f},  135}  ,{  { 0.332356f, 0.294233f, 0.373412f},   76}  ,{  { 0.501466f, 0.371457f, 0.127077f},   32}  ,{  { 0.393939f, 0.293255f, 0.312805f},   39}  ,{  { 0.715542f, 0.104594f, 0.179863f},  249}  ,{  { 0.365591f, 0.476051f, 0.158358f},   96}  ,{  { 0.164223f, 0.703812f, 0.131965f},  106}  ,{  { 0.104594f, 0.290323f, 0.605083f},   99}  ,{  { 0.869990f, 0.068426f, 0.061584f},   82}  ,{  { 0.547410f, 0.093842f, 0.358749f},   94}  ,{  { 0.043988f, 0.681329f, 0.274682f},   17}  ,
{  { 0.033236f, 0.960899f, 0.005865f},  180}  ,{  { 0.086022f, 0.236559f, 0.677419f},   73}  ,{  { 0.174976f, 0.513196f, 0.311828f},   76}  ,{  { 0.066471f, 0.899316f, 0.034213f},   24}  ,{  { 0.714565f, 0.054741f, 0.230694f},   14}  ,{  { 0.039101f, 0.158358f, 0.802542f},  150}  ,{  { 0.080156f, 0.635386f, 0.284457f},   99}  ,{  { 0.126100f, 0.543500f, 0.330401f},  154}  ,{  { 0.527859f, 0.150538f, 0.321603f},    8}  ,{  { 0.318671f, 0.327468f, 0.353861f},  128}  ,{  { 0.181818f, 0.417400f, 0.400782f},  170}  ,{  { 0.051808f, 0.422287f, 0.525904f},  192}  ,{  { 0.779081f, 0.049853f, 0.171065f},   19}  ,{  { 0.304008f, 0.133920f, 0.562072f},  196}  ,{  { 0.005865f, 0.454545f, 0.539589f},  153}  ,{  { 0.359726f, 0.404692f, 0.235582f},  163}  ,{  { 0.391007f, 0.087977f, 0.521017f},   86}  ,{  { 0.199413f, 0.192571f, 0.608016f},   61}  ,{  { 0.028348f, 0.067449f, 0.904203f},  147}  ,{  { 0.458456f, 0.251222f, 0.290323f},   22}  ,{  { 0.415445f, 0.553275f, 0.031281f},  144}  ,{  { 0.539589f, 0.408602f, 0.051808f},  242}  ,{  { 0.086022f, 0.512219f, 0.401760f},   39}  ,{  { 0.148583f, 0.829912f, 0.021505f},  118}  ,{  { 0.015640f, 0.237537f, 0.746823f},  226}  ,{  { 0.229717f, 0.088954f, 0.681329f},  186}  ,{  { 0.224829f, 0.312805f, 0.462366f},   87}  ,{  { 0.137830f, 0.585533f, 0.276637f},  116}  ,{  { 0.164223f, 0.385142f, 0.450635f},   52}  ,{  { 0.024438f, 0.497556f, 0.478006f},  209}  ,{  { 0.323558f, 0.478983f, 0.197458f},  229}  ,{  { 0.481916f, 0.232649f, 0.285435f},  187}  ,
{  { 0.268817f, 0.445748f, 0.285435f},  161}  ,{  { 0.062561f, 0.257087f, 0.680352f},  188}  ,{  { 0.219941f, 0.580645f, 0.199413f},  128}  ,{  { 0.081134f, 0.026393f, 0.892473f},   76}  ,{  { 0.190616f, 0.475073f, 0.334311f},  129}  ,{  { 0.285435f, 0.622678f, 0.091887f},  105}  ,{  { 0.040078f, 0.014663f, 0.945259f},  104}  ,{  { 0.226784f, 0.431085f, 0.342131f},  174}  ,{  { 0.184751f, 0.467253f, 0.347996f},    8}  ,{  { 0.790811f, 0.026393f, 0.182796f},  205}  ,{  { 0.168133f, 0.074291f, 0.757576f},  237}  ,{  { 0.287390f, 0.121212f, 0.591398f},  224}  ,{  { 0.478983f, 0.107527f, 0.413490f},  136}  ,{  { 0.272727f, 0.453568f, 0.273705f},   31}  ,{  { 0.009775f, 0.363636f, 0.626588f},   98}  ,{  { 0.300098f, 0.528837f, 0.171065f},  102}  ,{  { 0.131965f, 0.502444f, 0.365591f},   59}  ,{  { 0.520039f, 0.150538f, 0.329423f},  166}  ,{  { 0.304008f, 0.216031f, 0.479961f},  130}  ,{  { 0.957967f, 0.036168f, 0.005865f},  136}  ,{  { 0.221896f, 0.592375f, 0.185728f},  207}  ,{  { 0.400782f, 0.405670f, 0.193548f},  192}  ,{  { 0.179863f, 0.113392f, 0.706745f},  222}  ,{  { 0.358749f, 0.452590f, 0.188661f},  224}  ,{  { 0.178886f, 0.409580f, 0.411535f},   69}  ,{  { 0.139785f, 0.345064f, 0.515152f},  126}  ,{  { 0.713587f, 0.014663f, 0.271750f},  186}  ,{  { 0.961877f, 0.005865f, 0.032258f},  100}  ,{  { 0.190616f, 0.047898f, 0.761486f},  112}  ,{  { 0.641251f, 0.159335f, 0.199413f},  127}  ,{  { 0.210166f, 0.077224f, 0.712610f},  208}  ,{  { 0.216031f, 0.179863f, 0.604106f},  151}  ,
{  { 0.393939f, 0.234604f, 0.371457f},   84}  ,{  { 0.127077f, 0.345064f, 0.527859f},  155}  ,{  { 0.795699f, 0.047898f, 0.156403f},   18}  ,{  { 0.278592f, 0.434995f, 0.286413f},   97}  ,{  { 0.634409f, 0.202346f, 0.163245f},  111}  ,{  { 0.094819f, 0.712610f, 0.192571f},  147}  ,{  { 0.740958f, 0.001955f, 0.257087f},  154}  ,{  { 0.417400f, 0.077224f, 0.505376f},  214}  ,{  { 0.050831f, 0.519062f, 0.430108f},   80}  ,{  { 0.221896f, 0.025415f, 0.752688f},  251}  ,{  { 0.246334f, 0.447703f, 0.305963f},   79}  ,{  { 0.270772f, 0.362659f, 0.366569f},  146}  ,{  { 0.130987f, 0.258065f, 0.610948f},  219}  ,{  { 0.632454f, 0.027370f, 0.340176f},  141}  ,{  { 0.381232f, 0.290323f, 0.328446f},  106}  ,{  { 0.349951f, 0.342131f, 0.307918f},  118}  ,{  { 0.473118f, 0.440860f, 0.086022f},   23}  ,{  { 0.021505f, 0.199413f, 0.779081f},  121}  ,{  { 0.173998f, 0.214076f, 0.611926f},  154}  ,{  { 0.687195f, 0.183773f, 0.129032f},   47}  ,{  { 0.043988f, 0.728250f, 0.227761f},  246}  ,{  { 0.806452f, 0.110459f, 0.083089f},  105}  ,{  { 0.460411f, 0.358749f, 0.180841f},  184}  ,{  { 0.346041f, 0.187683f, 0.466276f},  218}  ,{  { 0.699902f, 0.001955f, 0.298143f},  226}  ,{  { 0.340176f, 0.520039f, 0.139785f},   55}  ,{  { 0.682307f, 0.279570f, 0.038123f},  214}  ,{  { 0.008798f, 0.540567f, 0.450635f},   10}  ,{  { 0.555230f, 0.327468f, 0.117302f},  174}  ,{  { 0.762463f, 0.215054f, 0.022483f},    1}  ,{  { 0.290323f, 0.666667f, 0.043011f},  173}  ,{  { 0.666667f, 0.055718f, 0.277615f},   29}  ,
{  { 0.439883f, 0.324536f, 0.235582f},  224}  ,{  { 0.621701f, 0.016618f, 0.361681f},  140}  ,{  { 0.186706f, 0.689150f, 0.124145f},  158}  ,{  { 0.434995f, 0.086999f, 0.478006f},  182}  ,{  { 0.105572f, 0.077224f, 0.817204f},   19}  ,{  { 0.820137f, 0.117302f, 0.062561f},  243}  ,{  { 0.199413f, 0.690127f, 0.110459f},  199}  ,{  { 0.117302f, 0.033236f, 0.849462f},  169}  ,{  { 0.244379f, 0.528837f, 0.226784f},  192}  ,{  { 0.636364f, 0.000978f, 0.362659f},  160}  ,{  { 0.285435f, 0.574780f, 0.139785f},  117}  ,{  { 0.318671f, 0.236559f, 0.444770f},    4}  ,{  { 0.115347f, 0.870968f, 0.013685f},   89}  ,{  { 0.669599f, 0.033236f, 0.297165f},  227}  ,{  { 0.588465f, 0.311828f, 0.099707f},   30}  ,{  { 0.454545f, 0.098729f, 0.446725f},   51}  ,{  { 0.169110f, 0.216031f, 0.614858f},   88}  ,{  { 0.086022f, 0.721408f, 0.192571f},   69}  ,{  { 0.285435f, 0.161290f, 0.553275f},   35}  ,{  { 0.387097f, 0.220919f, 0.391984f},  126}  ,{  { 0.051808f, 0.911046f, 0.037146f},  139}  ,{  { 0.434995f, 0.158358f, 0.406647f},   85}  ,{  { 0.191593f, 0.619746f, 0.188661f},  156}  ,{  { 0.230694f, 0.211144f, 0.558162f},   27}  ,{  { 0.549365f, 0.343109f, 0.107527f},  217}  ,{  { 0.112414f, 0.422287f, 0.465298f},  208}  ,{  { 0.122190f, 0.239492f, 0.638319f},   69}  ,{  { 0.304985f, 0.347019f, 0.347996f},  252}  ,{  { 0.086022f, 0.865103f, 0.048876f},  149}  ,{  { 0.092864f, 0.081134f, 0.826002f},   67}  ,{  { 0.450635f, 0.342131f, 0.207234f},  164}  ,{  { 0.232649f, 0.617791f, 0.149560f},  153}  ,
{  { 0.631476f, 0.314761f, 0.053763f},  158}  ,{  { 0.430108f, 0.355816f, 0.214076f},   30}  ,{  { 0.292278f, 0.497556f, 0.210166f},  146}  ,{  { 0.011730f, 0.274682f, 0.713587f},  114}  ,{  { 0.377322f, 0.409580f, 0.213099f},    2}  ,{  { 0.258065f, 0.690127f, 0.051808f},  244}  ,{  { 0.061584f, 0.706745f, 0.231672f},  226}  ,{  { 0.106549f, 0.166178f, 0.727273f},   21}  ,{  { 0.174976f, 0.810362f, 0.014663f},  200}  ,{  { 0.052786f, 0.706745f, 0.240469f},  232}  ,{  { 0.084066f, 0.818182f, 0.097752f},   80}  ,{  { 0.513196f, 0.176931f, 0.309873f},   66}  ,{  { 0.166178f, 0.243402f, 0.590420f},   35}  ,{  { 0.061584f, 0.028348f, 0.910068f},  142}  ,{  { 0.350929f, 0.039101f, 0.609971f},  105}  ,{  { 0.757576f, 0.221896f, 0.020528f},  120}  ,{  { 0.661779f, 0.245357f, 0.092864f},  153}  ,{  { 0.350929f, 0.275660f, 0.373412f},  178}  ,{  { 0.023460f, 0.382209f, 0.594330f},  238}  ,{  { 0.867058f, 0.080156f, 0.052786f},  234}  ,{  { 0.152493f, 0.458456f, 0.389052f},    4}  ,{  { 0.194526f, 0.779081f, 0.026393f},   19}  ,{  { 0.276637f, 0.294233f, 0.429130f},   79}  ,{  { 0.314761f, 0.393939f, 0.291300f},  207}  ,{  { 0.002933f, 0.028348f, 0.968719f},   17}  ,{  { 0.079179f, 0.034213f, 0.886608f},  209}  ,{  { 0.720430f, 0.086022f, 0.193548f},  173}  ,{  { 0.329423f, 0.447703f, 0.222874f},   68}  ,{  { 0.199413f, 0.457478f, 0.343109f},  126}  ,{  { 0.442815f, 0.193548f, 0.363636f},  180}  ,{  { 0.198436f, 0.651026f, 0.150538f},  232}  ,{  { 0.362659f, 0.154448f, 0.482893f},  173}  ,
{  { 0.053763f, 0.406647f, 0.539589f},  115}  ,{  { 0.601173f, 0.395894f, 0.002933f},  191}  ,{  { 0.009775f, 0.954057f, 0.036168f},   14}  ,{  { 0.201369f, 0.360704f, 0.437928f},   93}  ,{  { 0.170088f, 0.609971f, 0.219941f},   79}  ,{  { 0.188661f, 0.738025f, 0.073314f},  252}  ,{  { 0.317693f, 0.492669f, 0.189638f},  168}  ,{  { 0.361681f, 0.594330f, 0.043988f},  101}  ,{  { 0.071359f, 0.268817f, 0.659824f},  223}  ,{  { 0.601173f, 0.330401f, 0.068426f},  121}  ,{  { 0.325513f, 0.132942f, 0.541544f},  139}  ,{  { 0.317693f, 0.384164f, 0.298143f},   76}  ,{  { 0.066471f, 0.167155f, 0.766373f},  145}  ,{  { 0.211144f, 0.351906f, 0.436950f},  255}  ,{  { 0.077224f, 0.803519f, 0.119257f},   35}  ,{  { 0.461388f, 0.131965f, 0.406647f},  185}  ,{  { 0.378299f, 0.362659f, 0.259042f},   27}  ,{  { 0.218964f, 0.282502f, 0.498534f},   60}  ,{  { 0.053763f, 0.671554f, 0.274682f},   38}  ,{  { 0.419355f, 0.277615f, 0.303030f},   39}  ,{  { 0.408602f, 0.547410f, 0.043988f},   64}  ,{  { 0.434018f, 0.331378f, 0.234604f},   86}  ,{  { 0.782991f, 0.038123f, 0.178886f},  215}  ,{  { 0.007820f, 0.375367f, 0.616813f},   79}  ,{  { 0.048876f, 0.068426f, 0.882698f},  250}  ,{  { 0.728250f, 0.180841f, 0.090909f},   54}  ,{  { 0.045943f, 0.305963f, 0.648094f},  190}  ,{  { 0.158358f, 0.264907f, 0.576735f},  147}  ,{  { 0.386119f, 0.036168f, 0.577713f},   94}  ,{  { 0.315738f, 0.542522f, 0.141740f},  117}  ,{  { 0.223851f, 0.437928f, 0.338221f},  107}  ,{  { 0.560117f, 0.208211f, 0.231672f},   39}  ,
{  { 0.538612f, 0.291300f, 0.170088f},  245}  ,{  { 0.375367f, 0.318671f, 0.305963f},  227}  ,{  { 0.381232f, 0.204301f, 0.414467f},  171}  ,{  { 0.628543f, 0.056696f, 0.314761f},  122}  ,{  { 0.300098f, 0.023460f, 0.676442f},  157}  ,{  { 0.223851f, 0.407625f, 0.368524f},   26}  ,{  { 0.833822f, 0.084066f, 0.082111f},  129}  ,{  { 0.297165f, 0.098729f, 0.604106f},  143}  ,{  { 0.137830f, 0.519062f, 0.343109f},   30}  ,{  { 0.139785f, 0.671554f, 0.188661f},   97}  ,{  { 0.343109f, 0.166178f, 0.490714f},  237}  ,{  { 0.381232f, 0.222874f, 0.395894f},  112}  ,{  { 0.537634f, 0.271750f, 0.190616f},  236}  ,{  { 0.208211f, 0.301075f, 0.490714f},   24}  ,{  { 0.602151f, 0.313783f, 0.084066f},  188}  ,{  { 0.376344f, 0.315738f, 0.307918f},  180}  ,{  { 0.863148f, 0.092864f, 0.043988f},   58}  ,{  { 0.556207f, 0.086999f, 0.356794f},  100}  ,{  { 0.278592f, 0.632454f, 0.088954f},  129}  ,{  { 0.242424f, 0.069404f, 0.688172f},  177}  ,{  { 0.398827f, 0.274682f, 0.326491f},  154}  ,{  { 0.285435f, 0.219941f, 0.494624f},  124}  ,{  { 0.772238f, 0.213099f, 0.014663f},   14}  ,{  { 0.298143f, 0.160313f, 0.541544f},   75}  ,{  { 0.178886f, 0.019550f, 0.801564f},  176}  ,{  { 0.195503f, 0.394917f, 0.409580f},  131}  ,{  { 0.085044f, 0.020528f, 0.894428f},  101}  ,{  { 0.147605f, 0.323558f, 0.528837f},  120}  ,{  { 0.045943f, 0.620723f, 0.333333f},   25}  ,{  { 0.846530f, 0.072336f, 0.081134f},  222}  ,{  { 0.194526f, 0.397849f, 0.407625f},   21}  ,{  { 0.034213f, 0.379277f, 0.586510f},  120}  ,
{  { 0.087977f, 0.859238f, 0.052786f},   76}  ,{  { 0.551320f, 0.410557f, 0.038123f},  192}  ,{  { 0.605083f, 0.051808f, 0.343109f},  243}  ,{  { 0.329423f, 0.220919f, 0.449658f},  221}  ,{  { 0.645161f, 0.285435f, 0.069404f},   20}  ,{  { 0.178886f, 0.185728f, 0.635386f},   36}  ,{  { 0.025415f, 0.478006f, 0.496579f},  136}  ,{  { 0.508309f, 0.310850f, 0.180841f},   40}  ,{  { 0.088954f, 0.809384f, 0.101662f},   59}  ,{  { 0.094819f, 0.844575f, 0.060606f},  118}  ,{  { 0.630499f, 0.133920f, 0.235582f},   49}  ,{  { 0.144673f, 0.741935f, 0.113392f},  163}  ,{  { 0.414467f, 0.180841f, 0.404692f},   13}  ,{  { 0.259042f, 0.493646f, 0.247312f},  241}  ,{  { 0.204301f, 0.207234f, 0.588465f},   65}  ,{  { 0.135875f, 0.657869f, 0.206256f},  243}  ,{  { 0.179863f, 0.770283f, 0.049853f},  139}  ,{  { 0.058651f, 0.642229f, 0.299120f},  135}  ,{  { 0.138807f, 0.546432f, 0.314761f},  128}  ,{  { 0.900293f, 0.000978f, 0.098729f},  208}  ,{  { 0.543500f, 0.042033f, 0.414467f},   23}  ,{  { 0.073314f, 0.280547f, 0.646139f},  185}  ,{  { 0.099707f, 0.763441f, 0.136852f},   33}  ,{  { 0.006843f, 0.387097f, 0.606061f},  198}  ,{  { 0.000000f, 0.066471f, 0.933529f},   91}  ,{  { 0.651026f, 0.229717f, 0.119257f},  150}  ,{  { 0.002933f, 0.703812f, 0.293255f},  216}  ,{  { 0.004888f, 0.026393f, 0.968719f},  117}  ,{  { 0.230694f, 0.587488f, 0.181818f},  235}  ,{  { 0.392962f, 0.482893f, 0.124145f},  132}  ,{  { 0.836755f, 0.037146f, 0.126100f},   62}  ,{  { 0.079179f, 0.563050f, 0.357771f},  246}  ,
{  { 0.276637f, 0.390029f, 0.333333f},  211}  ,{  { 0.261975f, 0.362659f, 0.375367f},  149}  ,{  { 0.452590f, 0.188661f, 0.358749f},  145}  ,{  { 0.099707f, 0.144673f, 0.755621f},    5}  ,{  { 0.305963f, 0.444770f, 0.249267f},   65}  ,{  { 0.220919f, 0.191593f, 0.587488f},  188}  ,{  { 0.122190f, 0.043988f, 0.833822f},   67}  ,{  { 0.416422f, 0.466276f, 0.117302f},   12}  ,{  { 0.015640f, 0.787879f, 0.196481f},  124}  ,{  { 0.248289f, 0.608016f, 0.143695f},  156}  ,{  { 0.767351f, 0.130987f, 0.101662f},   36}  ,{  { 0.072336f, 0.591398f, 0.336266f},  163}  ,{  { 0.025415f, 0.901271f, 0.073314f},  131}  ,{  { 0.177908f, 0.516129f, 0.305963f},  140}  ,{  { 0.071359f, 0.607038f, 0.321603f},   76}  ,{  { 0.650049f, 0.159335f, 0.190616f},  155}  ,{  { 0.337243f, 0.647116f, 0.015640f},   16}  ,{  { 0.473118f, 0.194526f, 0.332356f},   94}  ,{  { 0.040078f, 0.206256f, 0.753666f},  109}  ,{  { 0.225806f, 0.259042f, 0.515152f},   67}  ,{  { 0.720430f, 0.199413f, 0.080156f},  201}  ,{  { 0.182796f, 0.455523f, 0.361681f},  111}  ,{  { 0.041056f, 0.278592f, 0.680352f},   39}  ,{  { 0.242424f, 0.700880f, 0.056696f},  252}  ,{  { 0.685239f, 0.311828f, 0.002933f},  127}  ,{  { 0.068426f, 0.081134f, 0.850440f},  176}  ,{  { 0.841642f, 0.005865f, 0.152493f},  231}  ,{  { 0.075269f, 0.305963f, 0.618768f},  143}  ,{  { 0.236559f, 0.504399f, 0.259042f},  201}  ,{  { 0.640274f, 0.120235f, 0.239492f},    8}  ,{  { 0.044966f, 0.782014f, 0.173021f},  192}  ,{  { 0.108504f, 0.757576f, 0.133920f},   77}  ,
{  { 0.020528f, 0.930596f, 0.048876f},  218}  ,{  { 0.038123f, 0.193548f, 0.768328f},  210}  ,{  { 0.169110f, 0.608993f, 0.221896f},  140}  ,{  { 0.524927f, 0.046921f, 0.428153f},  123}  ,{  { 0.414467f, 0.477028f, 0.108504f},  153}  ,{  { 0.208211f, 0.347996f, 0.443793f},  173}  ,{  { 0.574780f, 0.224829f, 0.200391f},  109}  ,{  { 0.694037f, 0.118280f, 0.187683f},   86}  ,{  { 0.330401f, 0.000000f, 0.669599f},  230}  ,{  { 0.611926f, 0.014663f, 0.373412f},   48}  ,{  { 0.168133f, 0.436950f, 0.394917f},   42}  ,{  { 0.158358f, 0.256109f, 0.585533f},   47}  ,{  { 0.014663f, 0.178886f, 0.806452f},  147}  ,{  { 0.218964f, 0.515152f, 0.265885f},  144}  ,{  { 0.712610f, 0.055718f, 0.231672f},   15}  ,{  { 0.297165f, 0.684262f, 0.018573f},  163}  ,{  { 0.541544f, 0.085044f, 0.373412f},  147}  ,{  { 0.348974f, 0.045943f, 0.605083f},   91}  ,{  { 0.882698f, 0.092864f, 0.024438f},  175}  ,{  { 0.314761f, 0.580645f, 0.104594f},  251}  ,{  { 0.044966f, 0.115347f, 0.839687f},  106}  ,{  { 0.229717f, 0.357771f, 0.412512f},  178}  ,{  { 0.273705f, 0.600196f, 0.126100f},   41}  ,{  { 0.214076f, 0.007820f, 0.778104f},  206}  ,{  { 0.340176f, 0.469208f, 0.190616f},  183}  ,{  { 0.330401f, 0.335288f, 0.334311f},  120}  ,{  { 0.573803f, 0.388074f, 0.038123f},  167}  ,{  { 0.192571f, 0.005865f, 0.801564f},   73}  ,{  { 0.662757f, 0.086022f, 0.251222f},   12}  ,{  { 0.765396f, 0.233627f, 0.000978f},  177}  ,{  { 0.655914f, 0.018573f, 0.325513f},   12}  ,{  { 0.516129f, 0.248289f, 0.235582f},  173}  ,
{  { 0.424242f, 0.324536f, 0.251222f},   62}  ,{  { 0.151515f, 0.550342f, 0.298143f},   19}  ,{  { 0.074291f, 0.658847f, 0.266862f},  245}  ,{  { 0.021505f, 0.848485f, 0.130010f},   85}  ,{  { 0.003910f, 0.711632f, 0.284457f},    7}  ,{  { 0.793744f, 0.191593f, 0.014663f},  102}  ,{  { 0.348974f, 0.175953f, 0.475073f},  102}  ,{  { 0.373412f, 0.476051f, 0.150538f},  137}  ,{  { 0.212121f, 0.608993f, 0.178886f},   80}  ,{  { 0.172043f, 0.100684f, 0.727273f},  203}  ,{  { 0.210166f, 0.316716f, 0.473118f},  244}  ,{  { 0.107527f, 0.458456f, 0.434018f},   44}  ,{  { 0.158358f, 0.632454f, 0.209189f},  126}  ,{  { 0.233627f, 0.239492f, 0.526882f},  230}  ,{  { 0.165200f, 0.430108f, 0.404692f},  157}  ,{  { 0.480938f, 0.508309f, 0.010753f},  193}  ,{  { 0.509286f, 0.406647f, 0.084066f},   93}  ,{  { 0.720430f, 0.135875f, 0.143695f},   12}  ,{  { 0.208211f, 0.346041f, 0.445748f},  190}  ,{  { 0.485826f, 0.083089f, 0.431085f},   67}  ,{  { 0.472141f, 0.226784f, 0.301075f},   47}  ,{  { 0.371457f, 0.105572f, 0.522972f},  220}  ,{  { 0.332356f, 0.115347f, 0.552297f},  146}  ,{  { 0.112414f, 0.626588f, 0.260997f},   96}  ,{  { 0.139785f, 0.556207f, 0.304008f},  131}  ,{  { 0.092864f, 0.644184f, 0.262952f},  250}  ,{  { 0.134897f, 0.719453f, 0.145650f},  126}  ,{  { 0.333333f, 0.299120f, 0.367546f},   67}  ,{  { 0.681329f, 0.109482f, 0.209189f},  144}  ,{  { 0.577713f, 0.359726f, 0.062561f},  116}  ,{  { 0.525904f, 0.304985f, 0.169110f},  103}  ,{  { 0.728250f, 0.234604f, 0.037146f},  249}  ,
{  { 0.040078f, 0.714565f, 0.245357f},   36}  ,{  { 0.083089f, 0.585533f, 0.331378f},   37}  ,{  { 0.120235f, 0.848485f, 0.031281f},   87}  ,{  { 0.268817f, 0.024438f, 0.706745f},   75}  ,{  { 0.442815f, 0.505376f, 0.051808f},  117}  ,{  { 0.926686f, 0.014663f, 0.058651f},   80}  ,{  { 0.053763f, 0.225806f, 0.720430f},   45}  ,{  { 0.515152f, 0.312805f, 0.172043f},  228}  ,{  { 0.304008f, 0.281525f, 0.414467f},  127}  ,{  { 0.265885f, 0.459433f, 0.274682f},  233}  ,{  { 0.438905f, 0.500489f, 0.060606f},   95}  ,{  { 0.531769f, 0.389052f, 0.079179f},  151}  ,{  { 0.008798f, 0.091887f, 0.899316f},    7}  ,{  { 0.333333f, 0.051808f, 0.614858f},  168}  ,{  { 0.003910f, 0.518084f, 0.478006f},   51}  ,{  { 0.156403f, 0.626588f, 0.217009f},   73}  ,{  { 0.398827f, 0.484848f, 0.116325f},   12}  ,{  { 0.219941f, 0.780059f, 0.000000f},   57}  ,{  { 0.115347f, 0.116325f, 0.768328f},  128}  ,{  { 0.292278f, 0.637341f, 0.070381f},   58}  ,{  { 0.260020f, 0.293255f, 0.446725f},   14}  ,{  { 0.640274f, 0.124145f, 0.235582f},  155}  ,{  { 0.871945f, 0.051808f, 0.076246f},  126}  ,{  { 0.486804f, 0.047898f, 0.465298f},   51}  ,{  { 0.134897f, 0.357771f, 0.507331f},  179}  ,{  { 0.671554f, 0.321603f, 0.006843f},    7}  ,{  { 0.086999f, 0.186706f, 0.726295f},   66}  ,{  { 0.057674f, 0.192571f, 0.749756f},   98}  ,{  { 0.068426f, 0.274682f, 0.656891f},  102}  ,{  { 0.041056f, 0.412512f, 0.546432f},   32}  ,{  { 0.594330f, 0.277615f, 0.128055f},  212}  ,{  { 0.298143f, 0.169110f, 0.532747f},   18}  ,
{  { 0.334311f, 0.232649f, 0.433040f},   50}  ,{  { 0.243402f, 0.634409f, 0.122190f},  171}  ,{  { 0.647116f, 0.268817f, 0.084066f},   12}  ,{  { 0.769306f, 0.086999f, 0.143695f},  234}  ,{  { 0.406647f, 0.566960f, 0.026393f},  113}  ,{  { 0.054741f, 0.507331f, 0.437928f},   63}  ,{  { 0.114370f, 0.615836f, 0.269795f},   48}  ,{  { 0.711632f, 0.190616f, 0.097752f},  179}  ,{  { 0.126100f, 0.843597f, 0.030303f},   16}  ,{  { 0.277615f, 0.163245f, 0.559140f},  235}  ,{  { 0.303030f, 0.547410f, 0.149560f},  142}  ,{  { 0.488759f, 0.009775f, 0.501466f},   62}  ,{  { 0.002933f, 0.522972f, 0.474096f},  140}  ,{  { 0.465298f, 0.123167f, 0.411535f},  158}  ,{  { 0.298143f, 0.390029f, 0.311828f},  159}  ,{  { 0.042033f, 0.462366f, 0.495601f},  238}  ,{  { 0.286413f, 0.245357f, 0.468231f},  183}  ,{  { 0.562072f, 0.429130f, 0.008798f},   21}  ,{  { 0.638319f, 0.054741f, 0.306940f},  209}  ,{  { 0.039101f, 0.351906f, 0.608993f},   73}  ,{  { 0.091887f, 0.528837f, 0.379277f},  196}  ,{  { 0.591398f, 0.378299f, 0.030303f},  221}  ,{  { 0.028348f, 0.900293f, 0.071359f},   65}  ,{  { 0.131965f, 0.563050f, 0.304985f},   16}  ,{  { 0.455523f, 0.474096f, 0.070381f},  124}  ,{  { 0.085044f, 0.376344f, 0.538612f},  173}  ,{  { 0.003910f, 0.520039f, 0.476051f},   88}  ,{  { 0.270772f, 0.161290f, 0.567937f},  111}  ,{  { 0.031281f, 0.904203f, 0.064516f},  106}  ,{  { 0.865103f, 0.024438f, 0.110459f},  209}  ,{  { 0.210166f, 0.568915f, 0.220919f},  208}  ,{  { 0.098729f, 0.529814f, 0.371457f},  113}  ,
{  { 0.322581f, 0.094819f, 0.582600f},   81}  ,{  { 0.734115f, 0.156403f, 0.109482f},  253}  ,{  { 0.222874f, 0.249267f, 0.527859f},  212}  ,{  { 0.001955f, 0.998045f, 0.000000f},   18}  ,{  { 0.323558f, 0.091887f, 0.584555f},   27}  ,{  { 0.132942f, 0.778104f, 0.088954f},  163}  ,{  { 0.117302f, 0.014663f, 0.868035f},  151}  ,{  { 0.026393f, 0.921799f, 0.051808f},  203}  ,{  { 0.833822f, 0.014663f, 0.151515f},  193}  ,{  { 0.415445f, 0.515152f, 0.069404f},  152}  ,{  { 0.065494f, 0.598240f, 0.336266f},  113}  ,{  { 0.357771f, 0.037146f, 0.605083f},  106}  ,{  { 0.453568f, 0.321603f, 0.224829f},    2}  ,{  { 0.193548f, 0.240469f, 0.565982f},   86}  ,{  { 0.018573f, 0.384164f, 0.597263f},  181}  ,{  { 0.801564f, 0.037146f, 0.161290f},   44}  ,{  { 0.815249f, 0.066471f, 0.118280f},  138}  ,{  { 0.316716f, 0.585533f, 0.097752f},    4}  ,{  { 0.249267f, 0.443793f, 0.306940f},  227}  ,{  { 0.071359f, 0.899316f, 0.029326f},  229}  ,{  { 0.426197f, 0.115347f, 0.458456f},  205}  ,{  { 0.067449f, 0.279570f, 0.652981f},   23}  ,{  { 0.008798f, 0.935484f, 0.055718f},  200}  ,{  { 0.386119f, 0.365591f, 0.248289f},  106}  ,{  { 0.489736f, 0.415445f, 0.094819f},  111}  ,{  { 0.123167f, 0.862170f, 0.014663f},  113}  ,{  { 0.310850f, 0.353861f, 0.335288f},   28}  ,{  { 0.232649f, 0.151515f, 0.615836f},  195}  ,{  { 0.084066f, 0.688172f, 0.227761f},  136}  ,{  { 0.512219f, 0.036168f, 0.451613f},   76}  ,{  { 0.419355f, 0.017595f, 0.563050f},  145}  ,{  { 0.933529f, 0.021505f, 0.044966f},   18}  ,
{  { 0.185728f, 0.391007f, 0.423265f},  193}  ,{  { 0.150538f, 0.594330f, 0.255132f},   61}  ,{  { 0.028348f, 0.206256f, 0.765396f},  229}  ,{  { 0.189638f, 0.477028f, 0.333333f},  201}  ,{  { 0.507331f, 0.478983f, 0.013685f},  118}  ,{  { 0.655914f, 0.056696f, 0.287390f},   24}  ,{  { 0.071359f, 0.223851f, 0.704790f},  213}  ,{  { 0.657869f, 0.321603f, 0.020528f},   11}  ,{  { 0.078201f, 0.498534f, 0.423265f},  182}  ,{  { 0.248289f, 0.228739f, 0.522972f},   36}  ,{  { 0.486804f, 0.185728f, 0.327468f},   54}  ,{  { 0.692082f, 0.179863f, 0.128055f},   18}  ,{  { 0.431085f, 0.482893f, 0.086022f},  232}  ,{  { 0.027370f, 0.885630f, 0.086999f},  173}  ,{  { 0.028348f, 0.727273f, 0.244379f},   82}  ,{  { 0.215054f, 0.630499f, 0.154448f},  128}  ,{  { 0.306940f, 0.607038f, 0.086022f},   47}  ,{  { 0.216031f, 0.594330f, 0.189638f},   55}  ,{  { 0.549365f, 0.274682f, 0.175953f},  162}  ,{  { 0.335288f, 0.163245f, 0.501466f},  219}  ,{  { 0.210166f, 0.130010f, 0.659824f},  143}  ,{  { 0.579668f, 0.044966f, 0.375367f},  181}  ,{  { 0.335288f, 0.654936f, 0.009775f},  168}  ,{  { 0.494624f, 0.376344f, 0.129032f},  119}  ,{  { 0.010753f, 0.256109f, 0.733138f},  130}  ,{  { 0.086999f, 0.812317f, 0.100684f},   40}  ,{  { 0.183773f, 0.321603f, 0.494624f},  138}  ,{  { 0.350929f, 0.042033f, 0.607038f},   62}  ,{  { 0.495601f, 0.211144f, 0.293255f},  235}  ,{  { 0.092864f, 0.444770f, 0.462366f},  228}  ,{  { 0.416422f, 0.476051f, 0.107527f},  143}  ,{  { 0.584555f, 0.213099f, 0.202346f},  192}  ,
{  { 0.151515f, 0.260997f, 0.587488f},  238}  ,{  { 0.325513f, 0.297165f, 0.377322f},  162}  ,{  { 0.233627f, 0.267840f, 0.498534f},  123}  ,{  { 0.492669f, 0.179863f, 0.327468f},  123}  ,{  { 0.181818f, 0.232649f, 0.585533f},  134}  ,{  { 0.604106f, 0.104594f, 0.291300f},  244}  ,{  { 0.147605f, 0.133920f, 0.718475f},   69}  ,{  { 0.364614f, 0.194526f, 0.440860f},   69}  ,{  { 0.007820f, 0.493646f, 0.498534f},  206}  ,{  { 0.606061f, 0.018573f, 0.375367f},   23}  ,{  { 0.362659f, 0.285435f, 0.351906f},  110}  ,{  { 0.631476f, 0.204301f, 0.164223f},  163}  ,{  { 0.044966f, 0.453568f, 0.501466f},   25}  ,{  { 0.184751f, 0.545455f, 0.269795f},   35}  ,{  { 0.520039f, 0.159335f, 0.320626f},  205}  ,{  { 0.220919f, 0.764418f, 0.014663f},  218}  ,{  { 0.070381f, 0.394917f, 0.534702f},  214}  ,{  { 0.325513f, 0.502444f, 0.172043f},   69}  ,{  { 0.649071f, 0.116325f, 0.234604f},  198}  ,{  { 0.851417f, 0.106549f, 0.042033f},   64}  ,{  { 0.349951f, 0.085044f, 0.565005f},  220}  ,{  { 0.731183f, 0.218964f, 0.049853f},  181}  ,{  { 0.646139f, 0.069404f, 0.284457f},  180}  ,{  { 0.448680f, 0.143695f, 0.407625f},  159}  ,{  { 0.610948f, 0.058651f, 0.330401f},   84}  ,{  { 0.139785f, 0.026393f, 0.833822f},  181}  ,{  { 0.492669f, 0.452590f, 0.054741f},  210}  ,{  { 0.090909f, 0.850440f, 0.058651f},  224}  ,{  { 0.465298f, 0.323558f, 0.211144f},  217}  ,{  { 0.396872f, 0.417400f, 0.185728f},   60}  ,{  { 0.156403f, 0.114370f, 0.729228f},   83}  ,{  { 0.059629f, 0.893451f, 0.046921f},   54}  ,
{  { 0.252199f, 0.686217f, 0.061584f},   57}  ,{  { 0.157380f, 0.427175f, 0.415445f},  157}  ,{  { 0.179863f, 0.347996f, 0.472141f},  216}  ,{  { 0.330401f, 0.266862f, 0.402737f},  100}  ,{  { 0.605083f, 0.262952f, 0.131965f},  199}  ,{  { 0.318671f, 0.655914f, 0.025415f},   15}  ,{  { 0.145650f, 0.250244f, 0.604106f},  163}  ,{  { 0.394917f, 0.253177f, 0.351906f},   75}  ,{  { 0.778104f, 0.056696f, 0.165200f},  138}  ,{  { 0.089932f, 0.684262f, 0.225806f},  221}  ,{  { 0.440860f, 0.281525f, 0.277615f},   84}  ,{  { 0.407625f, 0.306940f, 0.285435f},  209}  ,{  { 0.282502f, 0.561095f, 0.156403f},   25}  ,{  { 0.396872f, 0.492669f, 0.110459f},  123}  ,{  { 0.095797f, 0.143695f, 0.760508f},  239}  ,{  { 0.120235f, 0.671554f, 0.208211f},  192}  ,{  { 0.018573f, 0.617791f, 0.363636f},   55}  ,{  { 0.565982f, 0.299120f, 0.134897f},  210}  ,{  { 0.206256f, 0.085044f, 0.708700f},   94}  ,{  { 0.009775f, 0.180841f, 0.809384f},   42}  ,{  { 0.107527f, 0.209189f, 0.683284f},  182}  ,{  { 0.380254f, 0.543500f, 0.076246f},   89}  ,{  { 0.220919f, 0.406647f, 0.372434f},  136}  ,{  { 0.937439f, 0.023460f, 0.039101f},   78}  ,{  { 0.074291f, 0.039101f, 0.886608f},    7}  ,{  { 0.054741f, 0.362659f, 0.582600f},   78}  ,{  { 0.705767f, 0.217986f, 0.076246f},   96}  ,{  { 0.796676f, 0.026393f, 0.176931f},  140}  ,{  { 0.528837f, 0.189638f, 0.281525f},  235}  ,{  { 0.046921f, 0.301075f, 0.652004f},  169}  ,{  { 0.146628f, 0.797654f, 0.055718f},  176}  ,{  { 0.115347f, 0.073314f, 0.811339f},   88}  ,
{  { 0.306940f, 0.217986f, 0.475073f},   24}  ,{  { 0.200391f, 0.553275f, 0.246334f},  125}  ,{  { 0.303030f, 0.005865f, 0.691105f},   58}  ,{  { 0.552297f, 0.150538f, 0.297165f},  123}  ,{  { 0.351906f, 0.460411f, 0.187683f},  219}  ,{  { 0.385142f, 0.190616f, 0.424242f},   77}  ,{  { 0.069404f, 0.026393f, 0.904203f},   49}  ,{  { 0.238514f, 0.408602f, 0.352884f},  169}  ,{  { 0.229717f, 0.665689f, 0.104594f},    7}  ,{  { 0.191593f, 0.739003f, 0.069404f},  158}  ,{  { 0.090909f, 0.603128f, 0.305963f},  252}  ,{  { 0.133920f, 0.246334f, 0.619746f},  183}  ,{  { 0.422287f, 0.060606f, 0.517107f},  103}  ,{  { 0.578690f, 0.203324f, 0.217986f},  151}  ,{  { 0.330401f, 0.219941f, 0.449658f},  148}  ,{  { 0.410557f, 0.139785f, 0.449658f},   69}  ,{  { 0.569892f, 0.005865f, 0.424242f},   49}  ,{  { 0.005865f, 0.990225f, 0.003910f},  137}  ,{  { 0.658847f, 0.276637f, 0.064516f},   38}  ,{  { 0.698925f, 0.098729f, 0.202346f},   17}  ,{  { 0.077224f, 0.557185f, 0.365591f},   33}  ,{  { 0.137830f, 0.125122f, 0.737048f},  193}  ,{  { 0.160313f, 0.507331f, 0.332356f},  173}  ,{  { 0.070381f, 0.268817f, 0.660802f},  103}  ,{  { 0.591398f, 0.193548f, 0.215054f},   63}  ,{  { 0.268817f, 0.576735f, 0.154448f},   99}  ,{  { 0.389052f, 0.459433f, 0.151515f},  215}  ,{  { 0.552297f, 0.331378f, 0.116325f},   54}  ,{  { 0.118280f, 0.551320f, 0.330401f},  132}  ,{  { 0.198436f, 0.056696f, 0.744868f},   37}  ,{  { 0.236559f, 0.624633f, 0.138807f},   20}  ,{  { 0.042033f, 0.276637f, 0.681329f},  190}  ,
{  { 0.548387f, 0.189638f, 0.261975f},   22}  ,{  { 0.466276f, 0.040078f, 0.493646f},   77}  ,{  { 0.797654f, 0.070381f, 0.131965f},   91}  ,{  { 0.537634f, 0.228739f, 0.233627f},   22}  ,{  { 0.255132f, 0.208211f, 0.536657f},   74}  ,{  { 0.341153f, 0.381232f, 0.277615f},   32}  ,{  { 0.092864f, 0.113392f, 0.793744f},  126}  ,{  { 0.526882f, 0.253177f, 0.219941f},  112}  ,{  { 0.316716f, 0.315738f, 0.367546f},   81}  ,{  { 0.121212f, 0.868035f, 0.010753f},  201}  ,{  { 0.255132f, 0.571847f, 0.173021f},  224}  ,{  { 0.515152f, 0.078201f, 0.406647f},   48}  ,{  { 0.164223f, 0.106549f, 0.729228f},  138}  ,{  { 0.580645f, 0.211144f, 0.208211f},  172}  ,{  { 0.064516f, 0.639296f, 0.296188f},   99}  ,{  { 0.429130f, 0.157380f, 0.413490f},  240}  ,{  { 0.046921f, 0.069404f, 0.883675f},  231}  ,{  { 0.516129f, 0.267840f, 0.216031f},    6}  ,{  { 0.661779f, 0.213099f, 0.125122f},  131}  ,{  { 0.201369f, 0.138807f, 0.659824f},  107}  ,{  { 0.661779f, 0.088954f, 0.249267f},  125}  ,{  { 0.720430f, 0.217009f, 0.062561f},  251}  ,{  { 0.532747f, 0.142717f, 0.324536f},  198}  ,{  { 0.211144f, 0.400782f, 0.388074f},  232}  ,{  { 0.011730f, 0.986315f, 0.001955f},   35}  ,{  { 0.129032f, 0.191593f, 0.679374f},  243}  ,{  { 0.578690f, 0.233627f, 0.187683f},  134}  ,{  { 0.752688f, 0.016618f, 0.230694f},  100}  ,{  { 0.100684f, 0.544477f, 0.354839f},   94}  ,{  { 0.174976f, 0.315738f, 0.509286f},  201}  ,{  { 0.558162f, 0.248289f, 0.193548f},   13}  ,{  { 0.041056f, 0.605083f, 0.353861f},  244}  ,
{  { 0.170088f, 0.524927f, 0.304985f},  166}  ,{  { 0.591398f, 0.128055f, 0.280547f},  182}  ,{  { 0.566960f, 0.367546f, 0.065494f},   23}  ,{  { 0.383187f, 0.437928f, 0.178886f},   19}  ,{  { 0.682307f, 0.017595f, 0.300098f},  112}  ,{  { 0.487781f, 0.208211f, 0.304008f},   70}  ,{  { 0.436950f, 0.191593f, 0.371457f},   21}  ,{  { 0.247312f, 0.072336f, 0.680352f},  189}  ,{  { 0.738025f, 0.175953f, 0.086022f},   44}  ,{  { 0.217986f, 0.227761f, 0.554252f},   83}  ,{  { 0.488759f, 0.024438f, 0.486804f},   92}  ,{  { 0.592375f, 0.092864f, 0.314761f},    6}  ,{  { 0.522972f, 0.159335f, 0.317693f},  176}  ,{  { 0.027370f, 0.089932f, 0.882698f},   99}  ,{  { 0.224829f, 0.724340f, 0.050831f},   50}  ,{  { 0.313783f, 0.139785f, 0.546432f},   55}  ,{  { 0.029326f, 0.905181f, 0.065494f},  100}  ,{  { 0.306940f, 0.382209f, 0.310850f},   53}  ,{  { 0.134897f, 0.258065f, 0.607038f},  149}  ,{  { 0.167155f, 0.739980f, 0.092864f},  239}  ,{  { 0.217009f, 0.394917f, 0.388074f},   33}  ,{  { 0.122190f, 0.442815f, 0.434995f},   69}  ,{  { 0.254154f, 0.093842f, 0.652004f},  245}  ,{  { 0.746823f, 0.106549f, 0.146628f},   29}  ,{  { 0.625611f, 0.090909f, 0.283480f},   97}  ,{  { 0.841642f, 0.033236f, 0.125122f},   87}  ,{  { 0.086022f, 0.173021f, 0.740958f},  253}  ,{  { 0.040078f, 0.672532f, 0.287390f},   39}  ,{  { 0.106549f, 0.753666f, 0.139785f},  247}  ,{  { 0.069404f, 0.103617f, 0.826979f},  126}  ,{  { 0.198436f, 0.466276f, 0.335288f},  115}  ,{  { 0.383187f, 0.517107f, 0.099707f},  211}  ,
{  { 0.108504f, 0.374389f, 0.517107f},  232}  ,{  { 0.322581f, 0.009775f, 0.667644f},  160}  ,{  { 0.174976f, 0.568915f, 0.256109f},   45}  ,{  { 0.018573f, 0.855327f, 0.126100f},  231}  ,{  { 0.270772f, 0.620723f, 0.108504f},   53}  ,{  { 0.369501f, 0.392962f, 0.237537f},  254}  ,{  { 0.240469f, 0.357771f, 0.401760f},   85}  ,{  { 0.020528f, 0.857283f, 0.122190f},   59}  ,{  { 0.255132f, 0.228739f, 0.516129f},  209}  ,{  { 0.677419f, 0.070381f, 0.252199f},  236}  ,{  { 0.659824f, 0.158358f, 0.181818f},   55}  ,{  { 0.085044f, 0.463343f, 0.451613f},  237}  ,{  { 0.446725f, 0.193548f, 0.359726f},  172}  ,{  { 0.908113f, 0.065494f, 0.026393f},  216}  ,{  { 0.575758f, 0.348974f, 0.075269f},  224}  ,{  { 0.112414f, 0.496579f, 0.391007f},  176}  ,{  { 0.071359f, 0.762463f, 0.166178f},   24}  ,{  { 0.124145f, 0.088954f, 0.786901f},   15}  ,{  { 0.464321f, 0.046921f, 0.488759f},  135}  ,{  { 0.408602f, 0.312805f, 0.278592f},  223}  ,{  { 0.105572f, 0.532747f, 0.361681f},  141}  ,{  { 0.440860f, 0.398827f, 0.160313f},  209}  ,{  { 0.352884f, 0.158358f, 0.488759f},   50}  ,{  { 0.117302f, 0.170088f, 0.712610f},  144}  ,{  { 0.393939f, 0.216031f, 0.390029f},   56}  ,{  { 0.516129f, 0.273705f, 0.210166f},  201}  ,{  { 0.080156f, 0.144673f, 0.775171f},   71}  ,{  { 0.157380f, 0.148583f, 0.694037f},  143}  ,{  { 0.429130f, 0.289345f, 0.281525f},  205}  ,{  { 0.125122f, 0.684262f, 0.190616f},   55}  ,{  { 0.634409f, 0.219941f, 0.145650f},   74}  ,{  { 0.483871f, 0.383187f, 0.132942f},  246}  ,
{  { 0.215054f, 0.471163f, 0.313783f},  104}  ,{  { 0.599218f, 0.388074f, 0.012708f},  186}  ,{  { 0.878788f, 0.025415f, 0.095797f},  107}  ,{  { 0.506354f, 0.306940f, 0.186706f},   25}  ,{  { 0.500489f, 0.354839f, 0.144673f},  187}  ,{  { 0.303030f, 0.369501f, 0.327468f},  229}  ,{  { 0.079179f, 0.628543f, 0.292278f},   11}  ,{  { 0.280547f, 0.177908f, 0.541544f},   11}  ,{  { 0.050831f, 0.920821f, 0.028348f},  116}  ,{  { 0.260997f, 0.089932f, 0.649071f},   16}  ,{  { 0.306940f, 0.423265f, 0.269795f},  191}  ,{  { 0.839687f, 0.055718f, 0.104594f},  242}  ,{  { 0.294233f, 0.561095f, 0.144673f},  229}  ,{  { 0.102639f, 0.462366f, 0.434995f},  216}  ,{  { 0.215054f, 0.405670f, 0.379277f},  213}  ,{  { 0.696970f, 0.200391f, 0.102639f},   25}  ,{  { 0.274682f, 0.433040f, 0.292278f},    9}  ,{  { 0.452590f, 0.462366f, 0.085044f},  102}  ,{  { 0.113392f, 0.780059f, 0.106549f},   94}  ,{  { 0.047898f, 0.783969f, 0.168133f},  244}  ,{  { 0.371457f, 0.605083f, 0.023460f},  243}  ,{  { 0.342131f, 0.133920f, 0.523949f},   94}  ,{  { 0.291300f, 0.140762f, 0.567937f},   66}  ,{  { 0.195503f, 0.182796f, 0.621701f},  233}  ,{  { 0.623656f, 0.071359f, 0.304985f},  216}  ,{  { 0.451613f, 0.224829f, 0.323558f},   20}  ,{  { 0.500489f, 0.200391f, 0.299120f},   68}  ,{  { 0.170088f, 0.394917f, 0.434995f},   15}  ,{  { 0.000000f, 0.312805f, 0.687195f},  174}  ,{  { 0.101662f, 0.532747f, 0.365591f},  144}  ,{  { 0.527859f, 0.308895f, 0.163245f},  165}  ,{  { 0.599218f, 0.205279f, 0.195503f},   43}  ,
{  { 0.652004f, 0.338221f, 0.009775f},  143}  ,{  { 0.284457f, 0.580645f, 0.134897f},  238}  ,{  { 0.259042f, 0.311828f, 0.429130f},  122}  ,{  { 0.383187f, 0.103617f, 0.513196f},  161}  ,{  { 0.737048f, 0.160313f, 0.102639f},   97}  ,{  { 0.274682f, 0.520039f, 0.205279f},  190}  ,{  { 0.492669f, 0.047898f, 0.459433f},   75}  ,{  { 0.342131f, 0.462366f, 0.195503f},   93}  ,{  { 0.583578f, 0.291300f, 0.125122f},  104}  ,{  { 0.095797f, 0.167155f, 0.737048f},  158}  ,{  { 0.401760f, 0.140762f, 0.457478f},    1}  ,{  { 0.083089f, 0.070381f, 0.846530f},   15}  ,{  { 0.434018f, 0.442815f, 0.123167f},  204}  ,{  { 0.255132f, 0.401760f, 0.343109f},   46}  ,{  { 0.055718f, 0.119257f, 0.825024f},   47}  ,{  { 0.607038f, 0.190616f, 0.202346f},   67}  ,{  { 0.246334f, 0.005865f, 0.747801f},  138}  ,{  { 0.052786f, 0.931574f, 0.015640f},  238}  ,{  { 0.138807f, 0.314761f, 0.546432f},   19}  ,{  { 0.164223f, 0.618768f, 0.217009f},   12}  ,{  { 0.038123f, 0.701857f, 0.260020f},  241}  ,{  { 0.159335f, 0.309873f, 0.530792f},  110}  ,{  { 0.663734f, 0.079179f, 0.257087f},   16}  ,{  { 0.030303f, 0.252199f, 0.717498f},  172}  ,{  { 0.219941f, 0.316716f, 0.463343f},  246}  ,{  { 0.915934f, 0.073314f, 0.010753f},  238}  ,{  { 0.130010f, 0.079179f, 0.790811f},   12}  ,{  { 0.041056f, 0.901271f, 0.057674f},  122}  ,{  { 0.396872f, 0.008798f, 0.594330f},  218}  ,{  { 0.746823f, 0.050831f, 0.202346f},  226}  ,{  { 0.712610f, 0.159335f, 0.128055f},    1}  ,{  { 0.231672f, 0.081134f, 0.687195f},  215}  ,
{  { 0.001955f, 0.275660f, 0.722385f},  170}  ,{  { 0.146628f, 0.450635f, 0.402737f},  108}  ,{  { 0.751711f, 0.215054f, 0.033236f},   30}  ,{  { 0.526882f, 0.101662f, 0.371457f},  144}  ,{  { 0.071359f, 0.126100f, 0.802542f},  136}  ,{  { 0.025415f, 0.778104f, 0.196481f},  188}  ,{  { 0.161290f, 0.513196f, 0.325513f},   15}  ,{  { 0.328446f, 0.093842f, 0.577713f},  211}  ,{  { 0.017595f, 0.730205f, 0.252199f},   81}  ,{  { 0.354839f, 0.439883f, 0.205279f},   30}  ,{  { 0.840665f, 0.131965f, 0.027370f},   14}  ,{  { 0.371457f, 0.570870f, 0.057674f},   42}  ,{  { 0.044966f, 0.683284f, 0.271750f},   22}  ,{  { 0.161290f, 0.646139f, 0.192571f},   37}  ,{  { 0.279570f, 0.289345f, 0.431085f},  193}  ,{  { 0.405670f, 0.029326f, 0.565005f},  168}  ,{  { 0.169110f, 0.162268f, 0.668622f},   82}  ,{  { 0.403715f, 0.092864f, 0.503421f},  145}  ,{  { 0.282502f, 0.381232f, 0.336266f},  117}  ,{  { 0.181818f, 0.304008f, 0.514174f},  113}  ,{  { 0.060606f, 0.815249f, 0.124145f},   53}  ,{  { 0.670577f, 0.142717f, 0.186706f},   91}  ,{  { 0.073314f, 0.862170f, 0.064516f},   67}  ,{  { 0.084066f, 0.800587f, 0.115347f},  187}  ,{  { 0.339198f, 0.029326f, 0.631476f},  159}  ,{  { 0.372434f, 0.439883f, 0.187683f},  132}  ,{  { 0.224829f, 0.475073f, 0.300098f},  150}  ,{  { 0.034213f, 0.225806f, 0.739980f},  119}  ,{  { 0.056696f, 0.186706f, 0.756598f},  253}  ,{  { 0.555230f, 0.317693f, 0.127077f},  226}  ,{  { 0.839687f, 0.081134f, 0.079179f},  142}  ,{  { 0.017595f, 0.052786f, 0.929619f},   72}  ,
{  { 0.113392f, 0.421310f, 0.465298f},    8}  ,{  { 0.174976f, 0.493646f, 0.331378f},  255}  ,{  { 0.754643f, 0.102639f, 0.142717f},  186}  ,{  { 0.622678f, 0.107527f, 0.269795f},  143}  ,{  { 0.546432f, 0.380254f, 0.073314f},  196}  ,{  { 0.593353f, 0.172043f, 0.234604f},  145}  ,{  { 0.358749f, 0.474096f, 0.167155f},  109}  ,{  { 0.694037f, 0.120235f, 0.185728f},  223}  ,{  { 0.179863f, 0.796676f, 0.023460f},   80}  ,{  { 0.160313f, 0.727273f, 0.112414f},  134}  ,{  { 0.013685f, 0.094819f, 0.891496f},  139}  ,{  { 0.320626f, 0.289345f, 0.390029f},  194}  ,{  { 0.632454f, 0.217986f, 0.149560f},   68}  ,{  { 0.623656f, 0.148583f, 0.227761f},  178}  ,{  { 0.330401f, 0.079179f, 0.590420f},  120}  ,{  { 0.117302f, 0.748778f, 0.133920f},  236}  ,{  { 0.161290f, 0.690127f, 0.148583f},   34}  ,{  { 0.127077f, 0.715542f, 0.157380f},  255}  ,{  { 0.510264f, 0.037146f, 0.452590f},   85}  ,{  { 0.338221f, 0.443793f, 0.217986f},  124}  ,{  { 0.141740f, 0.662757f, 0.195503f},  109}  ,{  { 0.423265f, 0.484848f, 0.091887f},  252}  ,{  { 0.212121f, 0.333333f, 0.454545f},  153}  ,{  { 0.575758f, 0.121212f, 0.303030f},   76}  ,{  { 0.406647f, 0.347019f, 0.246334f},  153}  ,{  { 0.122190f, 0.735093f, 0.142717f},  137}  ,{  { 0.649071f, 0.087977f, 0.262952f},  158}  ,{  { 0.165200f, 0.177908f, 0.656891f},  243}  ,{  { 0.868035f, 0.062561f, 0.069404f},  114}  ,{  { 0.363636f, 0.469208f, 0.167155f},   60}  ,{  { 0.606061f, 0.299120f, 0.094819f},  216}  ,{  { 0.422287f, 0.497556f, 0.080156f},  168}  ,
{  { 0.156403f, 0.377322f, 0.466276f},  206}  ,{  { 0.097752f, 0.768328f, 0.133920f},   58}  ,{  { 0.824047f, 0.166178f, 0.009775f},  112}  ,{  { 0.501466f, 0.011730f, 0.486804f},  226}  ,{  { 0.037146f, 0.081134f, 0.881720f},  231}  ,{  { 0.091887f, 0.843597f, 0.064516f},  170}  ,{  { 0.526882f, 0.449658f, 0.023460f},   70}  ,{  { 0.753666f, 0.104594f, 0.141740f},  100}  ,{  { 0.432063f, 0.477028f, 0.090909f},  127}  ,{  { 0.013685f, 0.831867f, 0.154448f},  150}  ,{  { 0.586510f, 0.176931f, 0.236559f},  143}  ,{  { 0.632454f, 0.280547f, 0.086999f},  203}  ,{  { 0.385142f, 0.028348f, 0.586510f},  121}  ,{  { 0.359726f, 0.140762f, 0.499511f},  136}  ,{  { 0.316716f, 0.654936f, 0.028348f},   50}  ,{  { 0.109482f, 0.157380f, 0.733138f},   49}  ,{  { 0.338221f, 0.003910f, 0.657869f},   53}  ,{  { 0.396872f, 0.360704f, 0.242424f},  145}  ,{  { 0.116325f, 0.712610f, 0.171065f},  199}  ,{  { 0.862170f, 0.129032f, 0.008798f},   45}  ,{  { 0.059629f, 0.276637f, 0.663734f},  162}  ,{  { 0.012708f, 0.487781f, 0.499511f},  114}  ,{  { 0.258065f, 0.591398f, 0.150538f},  254}  ,{  { 0.011730f, 0.552297f, 0.435973f},   11}  ,{  { 0.153470f, 0.834800f, 0.011730f},  214}  ,{  { 0.504399f, 0.452590f, 0.043011f},  199}  ,{  { 0.086022f, 0.194526f, 0.719453f},  220}  ,{  { 0.046921f, 0.685239f, 0.267840f},  148}  ,{  { 0.607038f, 0.113392f, 0.279570f},  230}  ,{  { 0.290323f, 0.665689f, 0.043988f},  136}  ,{  { 0.055718f, 0.436950f, 0.507331f},   36}  ,{  { 0.258065f, 0.653959f, 0.087977f},    3}  ,
{  { 0.624633f, 0.007820f, 0.367546f},   73}  ,{  { 0.032258f, 0.892473f, 0.075269f},  236}  ,{  { 0.535679f, 0.107527f, 0.356794f},  234}  ,{  { 0.157380f, 0.744868f, 0.097752f},   94}  ,{  { 0.582600f, 0.250244f, 0.167155f},    4}  ,{  { 0.086022f, 0.836755f, 0.077224f},  219}  ,{  { 0.049853f, 0.053763f, 0.896383f},  149}  ,{  { 0.260997f, 0.188661f, 0.550342f},  154}  ,{  { 0.500489f, 0.147605f, 0.351906f},   90}  ,{  { 0.608016f, 0.183773f, 0.208211f},   79}  ,{  { 0.383187f, 0.388074f, 0.228739f},   51}  ,{  { 0.164223f, 0.080156f, 0.755621f},   31}  ,{  { 0.007820f, 0.641251f, 0.350929f},  157}  ,{  { 0.729228f, 0.218964f, 0.051808f},  101}  ,{  { 0.108504f, 0.645161f, 0.246334f},  140}  ,{  { 0.288368f, 0.047898f, 0.663734f},  114}  ,{  { 0.554252f, 0.043988f, 0.401760f},  213}  ,{  { 0.132942f, 0.621701f, 0.245357f},  105}  ,{  { 0.037146f, 0.391984f, 0.570870f},  181}  ,{  { 0.702835f, 0.232649f, 0.064516f},  226}  ,{  { 0.004888f, 0.415445f, 0.579668f},   43}  ,{  { 0.639296f, 0.325513f, 0.035191f},  195}  ,{  { 0.062561f, 0.822092f, 0.115347f},  254}  ,{  { 0.005865f, 0.182796f, 0.811339f},   38}  ,{  { 0.074291f, 0.743891f, 0.181818f},  137}  ,{  { 0.299120f, 0.231672f, 0.469208f},  206}  ,{  { 0.274682f, 0.141740f, 0.583578f},  239}  ,{  { 0.323558f, 0.066471f, 0.609971f},  121}  ,{  { 0.536657f, 0.132942f, 0.330401f},   73}  ,{  { 0.272727f, 0.289345f, 0.437928f},   16}  ,{  { 0.166178f, 0.114370f, 0.719453f},  158}  ,{  { 0.256109f, 0.356794f, 0.387097f},  115}  ,
{  { 0.324536f, 0.671554f, 0.003910f},   56}  ,{  { 0.151515f, 0.295210f, 0.553275f},  234}  ,{  { 0.925709f, 0.044966f, 0.029326f},   63}  ,{  { 0.713587f, 0.111437f, 0.174976f},   35}  ,{  { 0.438905f, 0.333333f, 0.227761f},  116}  ,{  { 0.514174f, 0.161290f, 0.324536f},   26}  ,{  { 0.639296f, 0.031281f, 0.329423f},  198}  ,{  { 0.469208f, 0.404692f, 0.126100f},   69}  ,{  { 0.630499f, 0.015640f, 0.353861f},   45}  ,{  { 0.075269f, 0.231672f, 0.693060f},  201}  ,{  { 0.065494f, 0.582600f, 0.351906f},  250}  ,{  { 0.160313f, 0.576735f, 0.262952f},  106}  ,{  { 0.564027f, 0.108504f, 0.327468f},   22}  ,{  { 0.070381f, 0.605083f, 0.324536f},   31}  ,{  { 0.533724f, 0.301075f, 0.165200f},  137}  ,{  { 0.375367f, 0.011730f, 0.612903f},  199}  ,{  { 0.377322f, 0.088954f, 0.533724f},  116}  ,{  { 0.082111f, 0.168133f, 0.749756f},  217}  ,{  { 0.707722f, 0.211144f, 0.081134f},  231}  ,{  { 0.374389f, 0.026393f, 0.599218f},  230}  ,{  { 0.083089f, 0.006843f, 0.910068f},  194}  ,{  { 0.354839f, 0.166178f, 0.478983f},  208}  ,{  { 0.724340f, 0.206256f, 0.069404f},   10}  ,{  { 0.707722f, 0.196481f, 0.095797f},  156}  ,{  { 0.634409f, 0.043011f, 0.322581f},    6}  ,{  { 0.782991f, 0.073314f, 0.143695f},   34}  ,{  { 0.292278f, 0.147605f, 0.560117f},  154}  ,{  { 0.750733f, 0.047898f, 0.201369f},   68}  ,{  { 0.126100f, 0.619746f, 0.254154f},  246}  ,{  { 0.173021f, 0.778104f, 0.048876f},  135}  ,{  { 0.458456f, 0.275660f, 0.265885f},  213}  ,{  { 0.251222f, 0.130987f, 0.617791f},  104}  ,
{  { 0.426197f, 0.075269f, 0.498534f},  225}  ,{  { 0.057674f, 0.685239f, 0.257087f},    8}  ,{  { 0.340176f, 0.599218f, 0.060606f},   52}  ,{  { 0.261975f, 0.726295f, 0.011730f},  213}  ,{  { 0.177908f, 0.274682f, 0.547410f},   63}  ,{  { 0.830890f, 0.081134f, 0.087977f},   43}  ,{  { 0.015640f, 0.200391f, 0.783969f},  229}  ,{  { 0.170088f, 0.244379f, 0.585533f},  183}  ,{  { 0.118280f, 0.318671f, 0.563050f},  140}  ,{  { 0.237537f, 0.077224f, 0.685239f},  233}  ,{  { 0.230694f, 0.238514f, 0.530792f},  166}  ,{  { 0.901271f, 0.020528f, 0.078201f},  229}  ,{  { 0.772238f, 0.046921f, 0.180841f},  247}  ,{  { 0.027370f, 0.874878f, 0.097752f},   94}  ,{  { 0.273705f, 0.128055f, 0.598240f},  101}  ,{  { 0.478006f, 0.175953f, 0.346041f},   22}  ,{  { 0.824047f, 0.139785f, 0.036168f},   78}  ,{  { 0.096774f, 0.705767f, 0.197458f},  117}  ,{  { 0.010753f, 0.462366f, 0.526882f},   79}  ,{  { 0.460411f, 0.208211f, 0.331378f},   29}  ,{  { 0.399805f, 0.037146f, 0.563050f},   94}  ,{  { 0.071359f, 0.717498f, 0.211144f},  198}  ,{  { 0.699902f, 0.220919f, 0.079179f},  179}  ,{  { 0.338221f, 0.173021f, 0.488759f},  150}  ,{  { 0.181818f, 0.794721f, 0.023460f},   97}  ,{  { 0.946237f, 0.011730f, 0.042033f},  179}  ,{  { 0.137830f, 0.263930f, 0.598240f},  148}  ,{  { 0.308895f, 0.617791f, 0.073314f},   86}  ,{  { 0.647116f, 0.096774f, 0.256109f},  117}  ,{  { 0.168133f, 0.220919f, 0.610948f},  200}  ,{  { 0.177908f, 0.249267f, 0.572825f},   19}  ,{  { 0.576735f, 0.379277f, 0.043988f},    3}  ,
{  { 0.139785f, 0.036168f, 0.824047f},   31}  ,{  { 0.478983f, 0.240469f, 0.280547f},  147}  ,{  { 0.357771f, 0.364614f, 0.277615f},  178}  ,{  { 0.195503f, 0.047898f, 0.756598f},  155}  ,{  { 0.159335f, 0.092864f, 0.747801f},    1}  ,{  { 0.410557f, 0.164223f, 0.425220f},  123}  ,{  { 0.054741f, 0.848485f, 0.096774f},  220}  ,{  { 0.342131f, 0.179863f, 0.478006f},  174}  ,{  { 0.292278f, 0.547410f, 0.160313f},  254}  ,{  { 0.042033f, 0.845552f, 0.112414f},  208}  ,{  { 0.193548f, 0.704790f, 0.101662f},   30}  ,{  { 0.380254f, 0.109482f, 0.510264f},    6}  ,{  { 0.304008f, 0.413490f, 0.282502f},   71}  ,{  { 0.460411f, 0.506354f, 0.033236f},  108}  ,{  { 0.153470f, 0.388074f, 0.458456f},  141}  ,{  { 0.384164f, 0.482893f, 0.132942f},   30}  ,{  { 0.514174f, 0.298143f, 0.187683f},  141}  ,{  { 0.446725f, 0.420332f, 0.132942f},   91}  ,{  { 0.060606f, 0.580645f, 0.358749f},   42}  ,{  { 0.471163f, 0.146628f, 0.382209f},   49}  ,{  { 0.469208f, 0.270772f, 0.260020f},  108}  ,{  { 0.199413f, 0.131965f, 0.668622f},  245}  ,{  { 0.557185f, 0.302053f, 0.140762f},  241}  ,{  { 0.371457f, 0.559140f, 0.069404f},  164}  ,{  { 0.177908f, 0.493646f, 0.328446f},   78}  ,{  { 0.695992f, 0.302053f, 0.001955f},   50}  ,{  { 0.081134f, 0.497556f, 0.421310f},   21}  ,{  { 0.491691f, 0.132942f, 0.375367f},   33}  ,{  { 0.630499f, 0.178886f, 0.190616f},  190}  ,{  { 0.347996f, 0.231672f, 0.420332f},   82}  ,{  { 0.360704f, 0.456501f, 0.182796f},   83}  ,{  { 0.204301f, 0.509286f, 0.286413f},  167}  ,
{  { 0.130987f, 0.217986f, 0.651026f},   38}  ,{  { 0.059629f, 0.354839f, 0.585533f},   41}  ,{  { 0.227761f, 0.010753f, 0.761486f},   63}  ,{  { 0.626588f, 0.362659f, 0.010753f},   62}  ,{  { 0.073314f, 0.642229f, 0.284457f},   15}  ,{  { 0.354839f, 0.303030f, 0.342131f},  254}  ,{  { 0.154448f, 0.137830f, 0.707722f},  154}  ,{  { 0.175953f, 0.073314f, 0.750733f},   65}  ,{  { 0.211144f, 0.272727f, 0.516129f},  132}  ,{  { 0.030303f, 0.175953f, 0.793744f},  106}  ,{  { 0.458456f, 0.392962f, 0.148583f},  218}  ,{  { 0.042033f, 0.227761f, 0.730205f},  175}  ,{  { 0.574780f, 0.204301f, 0.220919f},    5}  ,{  { 0.017595f, 0.620723f, 0.361681f},  108}  ,{  { 0.194526f, 0.585533f, 0.219941f},   39}  ,{  { 0.688172f, 0.220919f, 0.090909f},   91}  ,{  { 0.343109f, 0.626588f, 0.030303f},  160}  ,{  { 0.143695f, 0.826979f, 0.029326f},  145}  ,{  { 0.031281f, 0.378299f, 0.590420f},  230}  ,{  { 0.004888f, 0.203324f, 0.791789f},  154}  ,{  { 0.288368f, 0.440860f, 0.270772f},  195}  ,{  { 0.673509f, 0.135875f, 0.190616f},   33}  ,{  { 0.871945f, 0.086022f, 0.042033f},   99}  ,{  { 0.297165f, 0.012708f, 0.690127f},  117}  ,{  { 0.681329f, 0.003910f, 0.314761f},   80}  ,{  { 0.460411f, 0.308895f, 0.230694f},   18}  ,{  { 0.404692f, 0.433040f, 0.162268f},   31}  ,{  { 0.073314f, 0.860215f, 0.066471f},  157}  ,{  { 0.833822f, 0.074291f, 0.091887f},   80}  ,{  { 0.126100f, 0.616813f, 0.257087f},   63}  ,{  { 0.290323f, 0.173021f, 0.536657f},  238}  ,{  { 0.173021f, 0.211144f, 0.615836f},   76}  ,
{  { 0.633431f, 0.008798f, 0.357771f},  122}  ,{  { 0.086022f, 0.341153f, 0.572825f},  218}  ,{  { 0.166178f, 0.135875f, 0.697947f},   56}  ,{  { 0.126100f, 0.659824f, 0.214076f},   92}  ,{  { 0.693060f, 0.304985f, 0.001955f},  147}  ,{  { 0.355816f, 0.078201f, 0.565982f},   33}  ,{  { 0.626588f, 0.033236f, 0.340176f},  221}  ,{  { 0.491691f, 0.161290f, 0.347019f},  255}  ,{  { 0.219941f, 0.458456f, 0.321603f},   60}  ,{  { 0.893451f, 0.008798f, 0.097752f},  120}  ,{  { 0.243402f, 0.368524f, 0.388074f},   97}  ,{  { 0.563050f, 0.282502f, 0.154448f},  184}  ,{  { 0.168133f, 0.006843f, 0.825024f},  145}  ,{  { 0.247312f, 0.455523f, 0.297165f},   53}  ,{  { 0.141740f, 0.458456f, 0.399805f},   22}  ,{  { 0.067449f, 0.232649f, 0.699902f},  216}  ,{  { 0.347996f, 0.062561f, 0.589443f},  107}  ,{  { 0.041056f, 0.743891f, 0.215054f},  123}  ,{  { 0.303030f, 0.197458f, 0.499511f},   54}  ,{  { 0.252199f, 0.506354f, 0.241447f},  172}  ,{  { 0.282502f, 0.273705f, 0.443793f},   49}  ,{  { 0.007820f, 0.378299f, 0.613881f},  125}  ,{  { 0.412512f, 0.009775f, 0.577713f},  105}  ,{  { 0.242424f, 0.202346f, 0.555230f},  183}  ,{  { 0.518084f, 0.326491f, 0.155425f},  223}  ,{  { 0.176931f, 0.118280f, 0.704790f},  141}  ,{  { 0.448680f, 0.299120f, 0.252199f},   71}  ,{  { 0.116325f, 0.145650f, 0.738025f},  193}  ,{  { 0.051808f, 0.381232f, 0.566960f},  154}  ,{  { 0.201369f, 0.487781f, 0.310850f},   64}  ,{  { 0.172043f, 0.368524f, 0.459433f},   48}  ,{  { 0.144673f, 0.303030f, 0.552297f},    3}  ,
{  { 0.725318f, 0.141740f, 0.132942f},  226}  ,{  { 0.229717f, 0.522972f, 0.247312f},  122}  ,{  { 0.481916f, 0.154448f, 0.363636f},  109}  ,{  { 0.614858f, 0.272727f, 0.112414f},  169}  ,{  { 0.684262f, 0.261975f, 0.053763f},  127}  ,{  { 0.099707f, 0.779081f, 0.121212f},  153}  ,{  { 0.350929f, 0.382209f, 0.266862f},  151}  ,{  { 0.167155f, 0.070381f, 0.762463f},   39}  ,{  { 0.418377f, 0.104594f, 0.477028f},   95}  ,{  { 0.336266f, 0.265885f, 0.397849f},  167}  ,{  { 0.352884f, 0.003910f, 0.643206f},   78}  ,{  { 0.328446f, 0.384164f, 0.287390f},  231}  ,{  { 0.102639f, 0.809384f, 0.087977f},  236}  ,{  { 0.210166f, 0.508309f, 0.281525f},  252}  ,{  { 0.070381f, 0.317693f, 0.611926f},  149}  ,{  { 0.062561f, 0.245357f, 0.692082f},  233}  ,{  { 0.385142f, 0.361681f, 0.253177f},   98}  ,{  { 0.192571f, 0.351906f, 0.455523f},   72}  ,{  { 0.055718f, 0.249267f, 0.695015f},  141}  ,{  { 0.839687f, 0.043011f, 0.117302f},  239}  ,{  { 0.572825f, 0.010753f, 0.416422f},  162}  ,{  { 0.071359f, 0.110459f, 0.818182f},   76}  ,{  { 0.720430f, 0.262952f, 0.016618f},  126}  ,{  { 0.405670f, 0.279570f, 0.314761f},  201}  ,{  { 0.429130f, 0.019550f, 0.551320f},  181}  ,{  { 0.451613f, 0.132942f, 0.415445f},  247}  ,{  { 0.062561f, 0.695992f, 0.241447f},  198}  ,{  { 0.154448f, 0.205279f, 0.640274f},   72}  ,{  { 0.234604f, 0.544477f, 0.220919f},  166}  ,{  { 0.322581f, 0.105572f, 0.571847f},  109}  ,{  { 0.113392f, 0.278592f, 0.608016f},  253}  ,{  { 0.449658f, 0.167155f, 0.383187f},  213}  ,
{  { 0.608993f, 0.313783f, 0.077224f},  152}  ,{  { 0.092864f, 0.016618f, 0.890518f},  225}  ,{  { 0.450635f, 0.499511f, 0.049853f},  166}  ,{  { 0.060606f, 0.390029f, 0.549365f},  139}  ,{  { 0.186706f, 0.356794f, 0.456501f},  242}  ,{  { 0.263930f, 0.443793f, 0.292278f},   10}  ,{  { 0.134897f, 0.813294f, 0.051808f},   66}  ,{  { 0.157380f, 0.651026f, 0.191593f},   10}  ,{  { 0.859238f, 0.014663f, 0.126100f},  251}  ,{  { 0.000978f, 0.471163f, 0.527859f},  243}  ,{  { 0.070381f, 0.258065f, 0.671554f},  204}  ,{  { 0.127077f, 0.533724f, 0.339198f},  170}  ,{  { 0.018573f, 0.877810f, 0.103617f},   13}  ,{  { 0.672532f, 0.110459f, 0.217009f},   42}  ,{  { 0.580645f, 0.417400f, 0.001955f},   16}  ,{  { 0.265885f, 0.082111f, 0.652004f},  163}  ,{  { 0.293255f, 0.074291f, 0.632454f},  229}  ,{  { 0.078201f, 0.728250f, 0.193548f},    5}  ,{  { 0.053763f, 0.534702f, 0.411535f},   30}  ,{  { 0.118280f, 0.537634f, 0.344086f},  187}  ,{  { 0.078201f, 0.777126f, 0.144673f},   49}  ,{  { 0.076246f, 0.045943f, 0.877810f},   54}  ,{  { 0.696970f, 0.217986f, 0.085044f},   87}  ,{  { 0.687195f, 0.163245f, 0.149560f},  183}  ,{  { 0.039101f, 0.033236f, 0.927664f},   12}  ,{  { 0.423265f, 0.129032f, 0.447703f},  182}  ,{  { 0.117302f, 0.598240f, 0.284457f},  111}  ,{  { 0.594330f, 0.355816f, 0.049853f},  192}  ,{  { 0.260020f, 0.666667f, 0.073314f},  248}  ,{  { 0.419355f, 0.027370f, 0.553275f},  232}  ,{  { 0.080156f, 0.733138f, 0.186706f},   57}  ,{  { 0.168133f, 0.581623f, 0.250244f},   24}  ,
{  { 0.133920f, 0.260020f, 0.606061f},   57}  ,{  { 0.311828f, 0.674487f, 0.013685f},   82}  ,{  { 0.524927f, 0.440860f, 0.034213f},   30}  ,{  { 0.226784f, 0.501466f, 0.271750f},   40}  ,{  { 0.002933f, 0.606061f, 0.391007f},  212}  ,{  { 0.613881f, 0.154448f, 0.231672f},  246}  ,{  { 0.086999f, 0.805474f, 0.107527f},  126}  ,{  { 0.054741f, 0.646139f, 0.299120f},    1}  ,{  { 0.566960f, 0.034213f, 0.398827f},   44}  ,{  { 0.098729f, 0.759531f, 0.141740f},    1}  ,{  { 0.134897f, 0.702835f, 0.162268f},  141}  ,{  { 0.110459f, 0.176931f, 0.712610f},  154}  ,{  { 0.052786f, 0.565005f, 0.382209f},  197}  ,{  { 0.814272f, 0.182796f, 0.002933f},  253}  ,{  { 0.466276f, 0.426197f, 0.107527f},  205}  ,{  { 0.246334f, 0.749756f, 0.003910f},   74}  ,{  { 0.191593f, 0.119257f, 0.689150f},  156}  ,{  { 0.788856f, 0.202346f, 0.008798f},   56}  ,{  { 0.539589f, 0.337243f, 0.123167f},   12}  ,{  { 0.142717f, 0.780059f, 0.077224f},  170}  ,{  { 0.172043f, 0.541544f, 0.286413f},   20}  ,{  { 0.066471f, 0.174976f, 0.758553f},  218}  ,{  { 0.334311f, 0.207234f, 0.458456f},  116}  ,{  { 0.141740f, 0.452590f, 0.405670f},   13}  ,{  { 0.231672f, 0.032258f, 0.736070f},  159}  ,{  { 0.024438f, 0.312805f, 0.662757f},   97}  ,{  { 0.627566f, 0.254154f, 0.118280f},   54}  ,{  { 0.082111f, 0.080156f, 0.837732f},  113}  ,{  { 0.097752f, 0.754643f, 0.147605f},    1}  ,{  { 0.417400f, 0.067449f, 0.515152f},  161}  ,{  { 0.590420f, 0.291300f, 0.118280f},  131}  ,{  { 0.392962f, 0.105572f, 0.501466f},  241}  ,
{  { 0.853372f, 0.055718f, 0.090909f},  247}  ,{  { 0.256109f, 0.521017f, 0.222874f},  211}  ,{  { 0.296188f, 0.208211f, 0.495601f},  175}  ,{  { 0.162268f, 0.197458f, 0.640274f},  185}  ,{  { 0.848485f, 0.021505f, 0.130010f},  156}  ,{  { 0.156403f, 0.108504f, 0.735093f},  144}  ,{  { 0.095797f, 0.314761f, 0.589443f},  170}  ,{  { 0.650049f, 0.043011f, 0.306940f},  154}  ,{  { 0.080156f, 0.553275f, 0.366569f},  108}  ,{  { 0.149560f, 0.816227f, 0.034213f},  170}  ,{  { 0.138807f, 0.217009f, 0.644184f},   80}  ,{  { 0.697947f, 0.184751f, 0.117302f},  244}  ,{  { 0.147605f, 0.736070f, 0.116325f},  172}  ,{  { 0.516129f, 0.268817f, 0.215054f},   95}  ,{  { 0.608993f, 0.260020f, 0.130987f},  239}  ,{  { 0.429130f, 0.391984f, 0.178886f},  193}  ,{  { 0.058651f, 0.356794f, 0.584555f},   32}  ,{  { 0.081134f, 0.222874f, 0.695992f},  120}  ,{  { 0.184751f, 0.555230f, 0.260020f},   99}  ,{  { 0.051808f, 0.898338f, 0.049853f},   49}  ,{  { 0.351906f, 0.069404f, 0.578690f},  196}  ,{  { 0.177908f, 0.687195f, 0.134897f},  249}  ,{  { 0.129032f, 0.137830f, 0.733138f},   77}  ,{  { 0.775171f, 0.085044f, 0.139785f},  182}  ,{  { 0.123167f, 0.843597f, 0.033236f},  147}  ,{  { 0.260997f, 0.461388f, 0.277615f},   62}  ,{  { 0.086999f, 0.819159f, 0.093842f},  213}  ,{  { 0.066471f, 0.855327f, 0.078201f},  253}  ,{  { 0.615836f, 0.246334f, 0.137830f},  186}  ,{  { 0.070381f, 0.004888f, 0.924731f},  143}  ,{  { 0.035191f, 0.407625f, 0.557185f},   44}  ,{  { 0.051808f, 0.180841f, 0.767351f},  186}  ,
{  { 0.557185f, 0.339198f, 0.103617f},  172}  ,{  { 0.124145f, 0.434995f, 0.440860f},  223}  ,{  { 0.577713f, 0.069404f, 0.352884f},  194}  ,{  { 0.027370f, 0.438905f, 0.533724f},   62}  ,{  { 0.350929f, 0.114370f, 0.534702f},  249}  ,{  { 0.710655f, 0.233627f, 0.055718f},  218}  ,{  { 0.017595f, 0.438905f, 0.543500f},  189}  ,{  { 0.569892f, 0.384164f, 0.045943f},  236}  ,{  { 0.482893f, 0.033236f, 0.483871f},  153}  ,{  { 0.403715f, 0.358749f, 0.237537f},   85}  ,{  { 0.110459f, 0.349951f, 0.539589f},  246}  ,{  { 0.141740f, 0.002933f, 0.855327f},   60}  ,{  { 0.044966f, 0.580645f, 0.374389f},   76}  ,{  { 0.594330f, 0.315738f, 0.089932f},  185}  ,{  { 0.301075f, 0.032258f, 0.666667f},   45}  ,{  { 0.191593f, 0.485826f, 0.322581f},   95}  ,{  { 0.341153f, 0.266862f, 0.391984f},   70}  ,{  { 0.140762f, 0.088954f, 0.770283f},  222}  ,{  { 0.748778f, 0.200391f, 0.050831f},   48}  ,{  { 0.434995f, 0.454545f, 0.110459f},  173}  ,{  { 0.329423f, 0.058651f, 0.611926f},   38}  ,{  { 0.327468f, 0.323558f, 0.348974f},  155}  ,{  { 0.327468f, 0.221896f, 0.450635f},  105}  ,{  { 0.632454f, 0.169110f, 0.198436f},  218}  ,{  { 0.689150f, 0.123167f, 0.187683f},  207}  ,{  { 0.232649f, 0.608016f, 0.159335f},  108}  ,{  { 0.308895f, 0.109482f, 0.581623f},   42}  ,{  { 0.399805f, 0.520039f, 0.080156f},   94}  ,{  { 0.593353f, 0.066471f, 0.340176f},  101}  ,{  { 0.070381f, 0.271750f, 0.657869f},  168}  ,{  { 0.826979f, 0.046921f, 0.126100f},   85}  ,{  { 0.648094f, 0.166178f, 0.185728f},   90}  ,
{  { 0.743891f, 0.044966f, 0.211144f},   32}  ,{  { 0.067449f, 0.347996f, 0.584555f},  113}  ,{  { 0.560117f, 0.157380f, 0.282502f},  189}  ,{  { 0.486804f, 0.441838f, 0.071359f},  183}  ,{  { 0.127077f, 0.846530f, 0.026393f},  151}  ,{  { 0.766373f, 0.067449f, 0.166178f},  186}  ,{  { 0.668622f, 0.072336f, 0.259042f},  140}  ,{  { 0.654936f, 0.095797f, 0.249267f},  169}  ,{  { 0.245357f, 0.594330f, 0.160313f},    2}  ,{  { 0.050831f, 0.701857f, 0.247312f},  128}  ,{  { 0.523949f, 0.097752f, 0.378299f},    4}  ,{  { 0.389052f, 0.117302f, 0.493646f},  102}  ,{  { 0.081134f, 0.851417f, 0.067449f},   49}  ,{  { 0.185728f, 0.664712f, 0.149560f},   48}  ,{  { 0.148583f, 0.124145f, 0.727273f},  216}  ,{  { 0.151515f, 0.448680f, 0.399805f},  122}  ,{  { 0.426197f, 0.492669f, 0.081134f},   37}  ,{  { 0.501466f, 0.112414f, 0.386119f},   51}  ,{  { 0.154448f, 0.294233f, 0.551320f},  169}  ,{  { 0.722385f, 0.118280f, 0.159335f},   31}  ,{  { 0.041056f, 0.228739f, 0.730205f},  156}  ,{  { 0.503421f, 0.183773f, 0.312805f},  135}  ,{  { 0.619746f, 0.037146f, 0.343109f},   71}  ,{  { 0.126100f, 0.170088f, 0.703812f},   93}  ,{  { 0.296188f, 0.430108f, 0.273705f},   61}  ,{  { 0.020528f, 0.926686f, 0.052786f},  144}  ,{  { 0.186706f, 0.327468f, 0.485826f},  232}  ,{  { 0.279570f, 0.286413f, 0.434018f},  215}  ,{  { 0.073314f, 0.548387f, 0.378299f},   39}  ,{  { 0.109482f, 0.162268f, 0.728250f},  229}  ,{  { 0.045943f, 0.754643f, 0.199413f},  183}  ,{  { 0.320626f, 0.572825f, 0.106549f},   73}  ,
{  { 0.451613f, 0.090909f, 0.457478f},  249}  ,{  { 0.071359f, 0.892473f, 0.036168f},  156}  ,{  { 0.374389f, 0.104594f, 0.521017f},   78}  ,{  { 0.206256f, 0.644184f, 0.149560f},  158}  ,{  { 0.095797f, 0.812317f, 0.091887f},  151}  ,{  { 0.670577f, 0.320626f, 0.008798f},  215}  ,{  { 0.224829f, 0.150538f, 0.624633f},  138}  ,{  { 0.606061f, 0.169110f, 0.224829f},   27}  ,{  { 0.315738f, 0.253177f, 0.431085f},  140}  ,{  { 0.134897f, 0.307918f, 0.557185f},   12}  ,{  { 0.254154f, 0.405670f, 0.340176f},   16}  ,{  { 0.537634f, 0.423265f, 0.039101f},    3}  ,{  { 0.096774f, 0.044966f, 0.858260f},  204}  ,{  { 0.207234f, 0.372434f, 0.420332f},   13}  ,{  { 0.153470f, 0.749756f, 0.096774f},    9}  ,{  { 0.308895f, 0.144673f, 0.546432f},   53}  ,{  { 0.179863f, 0.626588f, 0.193548f},  177}  ,{  { 0.387097f, 0.217009f, 0.395894f},   67}  ,{  { 0.499511f, 0.249267f, 0.251222f},  141}  ,{  { 0.289345f, 0.511241f, 0.199413f},  215}  ,{  { 0.460411f, 0.129032f, 0.410557f},  151}  ,{  { 0.654936f, 0.179863f, 0.165200f},   49}  ,{  { 0.829912f, 0.164223f, 0.005865f},  175}  ,{  { 0.160313f, 0.245357f, 0.594330f},  230}  ,{  { 0.353861f, 0.077224f, 0.568915f},   93}  ,{  { 0.516129f, 0.351906f, 0.131965f},  171}  ,{  { 0.081134f, 0.237537f, 0.681329f},   43}  ,{  { 0.578690f, 0.249267f, 0.172043f},   15}  ,{  { 0.680352f, 0.038123f, 0.281525f},  245}  ,{  { 0.161290f, 0.691105f, 0.147605f},  241}  ,{  { 0.041056f, 0.382209f, 0.576735f},  136}  ,{  { 0.180841f, 0.432063f, 0.387097f},  210}  ,
{  { 0.336266f, 0.579668f, 0.084066f},  184}  ,{  { 0.006843f, 0.102639f, 0.890518f},   72}  ,{  { 0.148583f, 0.758553f, 0.092864f},  174}  ,{  { 0.300098f, 0.124145f, 0.575758f},   30}  ,{  { 0.243402f, 0.742913f, 0.013685f},    5}  ,{  { 0.623656f, 0.001955f, 0.374389f},  234}  ,{  { 0.101662f, 0.616813f, 0.281525f},  177}  ,{  { 0.721408f, 0.061584f, 0.217009f},  224}  ,{  { 0.130987f, 0.596285f, 0.272727f},   80}  ,{  { 0.020528f, 0.601173f, 0.378299f},  112}  ,{  { 0.333333f, 0.234604f, 0.432063f},  120}  ,{  { 0.375367f, 0.326491f, 0.298143f},   50}  ,{  { 0.075269f, 0.672532f, 0.252199f},  254}  ,{  { 0.919844f, 0.056696f, 0.023460f},  156}  ,{  { 0.561095f, 0.387097f, 0.051808f},  252}  ,{  { 0.166178f, 0.497556f, 0.336266f},   63}  ,{  { 0.532747f, 0.338221f, 0.129032f},  120}  ,{  { 0.213099f, 0.496579f, 0.290323f},  155}  ,{  { 0.323558f, 0.478006f, 0.198436f},  212}  ,{  { 0.464321f, 0.348974f, 0.186706f},   64}  ,{  { 0.281525f, 0.342131f, 0.376344f},   93}  ,{  { 0.197458f, 0.528837f, 0.273705f},  172}  ,{  { 0.216031f, 0.452590f, 0.331378f},  130}  ,{  { 0.395894f, 0.455523f, 0.148583f},   99}  ,{  { 0.117302f, 0.556207f, 0.326491f},  233}  ,{  { 0.953079f, 0.039101f, 0.007820f},  150}  ,{  { 0.448680f, 0.395894f, 0.155425f},  109}  ,{  { 0.043011f, 0.661779f, 0.295210f},  119}  ,{  { 0.351906f, 0.380254f, 0.267840f},  124}  ,{  { 0.655914f, 0.246334f, 0.097752f},   71}  ,{  { 0.344086f, 0.224829f, 0.431085f},  108}  ,{  { 0.218964f, 0.718475f, 0.062561f},  190}  ,
{  { 0.523949f, 0.010753f, 0.465298f},   39}  ,{  { 0.657869f, 0.094819f, 0.247312f},   51}  ,{  { 0.013685f, 0.202346f, 0.783969f},  246}  ,{  { 0.018573f, 0.164223f, 0.817204f},   89}  ,{  { 0.311828f, 0.104594f, 0.583578f},    8}  ,{  { 0.331378f, 0.460411f, 0.208211f},  246}  ,{  { 0.221896f, 0.412512f, 0.365591f},   27}  ,{  { 0.041056f, 0.790811f, 0.168133f},    8}  ,{  { 0.351906f, 0.277615f, 0.370479f},  108}  ,{  { 0.167155f, 0.819159f, 0.013685f},  133}  ,{  { 0.552297f, 0.245357f, 0.202346f},   10}  ,{  { 0.697947f, 0.023460f, 0.278592f},   60}  ,{  { 0.471163f, 0.481916f, 0.046921f},  159}  ,{  { 0.679374f, 0.015640f, 0.304985f},  250}  ,{  { 0.062561f, 0.086999f, 0.850440f},   90}  ,{  { 0.072336f, 0.785924f, 0.141740f},  106}  ,{  { 0.030303f, 0.719453f, 0.250244f},    1}  ,{  { 0.357771f, 0.028348f, 0.613881f},  253}  ,{  { 0.196481f, 0.146628f, 0.656891f},  222}  ,{  { 0.042033f, 0.601173f, 0.356794f},   65}  ,{  { 0.190616f, 0.655914f, 0.153470f},  199}  ,{  { 0.207234f, 0.411535f, 0.381232f},  141}  ,{  { 0.634409f, 0.167155f, 0.198436f},   64}  ,{  { 0.636364f, 0.179863f, 0.183773f},  161}  ,{  { 0.125122f, 0.652004f, 0.222874f},   11}  ,{  { 0.173021f, 0.452590f, 0.374389f},   48}  ,{  { 0.391007f, 0.568915f, 0.040078f},  194}  ,{  { 0.159335f, 0.294233f, 0.546432f},  175}  ,{  { 0.619746f, 0.273705f, 0.106549f},   18}  ,{  { 0.678397f, 0.250244f, 0.071359f},  184}  ,{  { 0.183773f, 0.304008f, 0.512219f},  126}  ,{  { 0.148583f, 0.025415f, 0.826002f},  225}  ,
{  { 0.089932f, 0.421310f, 0.488759f},  236}  ,{  { 0.698925f, 0.274682f, 0.026393f},  154}  ,{  { 0.262952f, 0.256109f, 0.480938f},   92}  ,{  { 0.208211f, 0.739003f, 0.052786f},  254}  ,{  { 0.222874f, 0.431085f, 0.346041f},   22}  ,{  { 0.136852f, 0.777126f, 0.086022f},   12}  ,{  { 0.719453f, 0.153470f, 0.127077f},  169}  ,{  { 0.471163f, 0.375367f, 0.153470f},   58}  ,{  { 0.449658f, 0.216031f, 0.334311f},  129}  ,{  { 0.226784f, 0.090909f, 0.682307f},  138}  ,{  { 0.228739f, 0.315738f, 0.455523f},   30}  ,{  { 0.907136f, 0.087977f, 0.004888f},  157}  ,{  { 0.054741f, 0.706745f, 0.238514f},  171}  ,{  { 0.013685f, 0.044966f, 0.941349f},  209}  ,{  { 0.258065f, 0.405670f, 0.336266f},   10}  ,{  { 0.516129f, 0.072336f, 0.411535f},   35}  ,{  { 0.141740f, 0.149560f, 0.708700f},  243}  ,{  { 0.223851f, 0.748778f, 0.027370f},  150}  ,{  { 0.538612f, 0.086022f, 0.375367f},   10}  ,{  { 0.413490f, 0.404692f, 0.181818f},   99}  ,{  { 0.217986f, 0.583578f, 0.198436f},   47}  ,{  { 0.348974f, 0.264907f, 0.386119f},  206}  ,{  { 0.243402f, 0.213099f, 0.543500f},  169}  ,{  { 0.086999f, 0.841642f, 0.071359f},   21}  ,{  { 0.179863f, 0.722385f, 0.097752f},    4}  ,{  { 0.173021f, 0.750733f, 0.076246f},   59}  ,{  { 0.491691f, 0.341153f, 0.167155f},   91}  ,{  { 0.326491f, 0.664712f, 0.008798f},  222}  ,{  { 0.892473f, 0.031281f, 0.076246f},  201}  ,{  { 0.063539f, 0.288368f, 0.648094f},  166}  ,{  { 0.095797f, 0.474096f, 0.430108f},   44}  ,{  { 0.550342f, 0.046921f, 0.402737f},   18}  ,
{  { 0.400782f, 0.116325f, 0.482893f},  192}  ,{  { 0.390029f, 0.304008f, 0.305963f},  146}  ,{  { 0.084066f, 0.614858f, 0.301075f},   63}  ,{  { 0.073314f, 0.862170f, 0.064516f},  177}  ,{  { 0.197458f, 0.296188f, 0.506354f},  213}  ,{  { 0.159335f, 0.779081f, 0.061584f},  108}  ,{  { 0.401760f, 0.034213f, 0.564027f},  153}  ,{  { 0.486804f, 0.190616f, 0.322581f},    2}  ,{  { 0.577713f, 0.288368f, 0.133920f},  189}  ,{  { 0.106549f, 0.348974f, 0.544477f},   79}  ,{  { 0.171065f, 0.204301f, 0.624633f},  109}  ,{  { 0.375367f, 0.051808f, 0.572825f},   73}  ,{  { 0.591398f, 0.261975f, 0.146628f},   92}  ,{  { 0.045943f, 0.209189f, 0.744868f},  111}  ,{  { 0.176931f, 0.642229f, 0.180841f},  226}  ,{  { 0.165200f, 0.647116f, 0.187683f},  129}  ,{  { 0.756598f, 0.153470f, 0.089932f},  101}  ,{  { 0.345064f, 0.622678f, 0.032258f},  122}  ,{  { 0.123167f, 0.608016f, 0.268817f},  175}  ,{  { 0.697947f, 0.231672f, 0.070381f},  169}  ,{  { 0.403715f, 0.459433f, 0.136852f},  108}  ,{  { 0.933529f, 0.040078f, 0.026393f},   28}  ,{  { 0.333333f, 0.086999f, 0.579668f},  152}  ,{  { 0.478983f, 0.145650f, 0.375367f},  187}  ,{  { 0.106549f, 0.179863f, 0.713587f},  243}  ,{  { 0.194526f, 0.010753f, 0.794721f},   89}  ,{  { 0.046921f, 0.411535f, 0.541544f},    7}  ,{  { 0.033236f, 0.534702f, 0.432063f},  115}  ,{  { 0.282502f, 0.388074f, 0.329423f},  101}  ,{  { 0.812317f, 0.157380f, 0.030303f},  219}  ,{  { 0.295210f, 0.314761f, 0.390029f},  134}  ,{  { 0.029326f, 0.733138f, 0.237537f},  138}  ,
{  { 0.129032f, 0.045943f, 0.825024f},  106}  ,{  { 0.102639f, 0.880743f, 0.016618f},   14}  ,{  { 0.636364f, 0.206256f, 0.157380f},   99}  ,{  { 0.017595f, 0.091887f, 0.890518f},   30}  ,{  { 0.523949f, 0.429130f, 0.046921f},   52}  ,{  { 0.134897f, 0.063539f, 0.801564f},  209}  ,{  { 0.507331f, 0.122190f, 0.370479f},   92}  ,{  { 0.317693f, 0.546432f, 0.135875f},   58}  ,{  { 0.231672f, 0.556207f, 0.212121f},   17}  ,{  { 0.229717f, 0.221896f, 0.548387f},  133}  ,{  { 0.317693f, 0.478983f, 0.203324f},  247}  ,{  { 0.602151f, 0.355816f, 0.042033f},   62}  ,{  { 0.401760f, 0.118280f, 0.479961f},   78}  ,{  { 0.414467f, 0.573803f, 0.011730f},   39}  ,{  { 0.307918f, 0.344086f, 0.347996f},  245}  ,{  { 0.101662f, 0.828934f, 0.069404f},   86}  ,{  { 0.314761f, 0.493646f, 0.191593f},  200}  ,{  { 0.752688f, 0.193548f, 0.053763f},   57}  ,{  { 0.304008f, 0.290323f, 0.405670f},   80}  ,{  { 0.176931f, 0.209189f, 0.613881f},   49}  ,{  { 0.374389f, 0.490714f, 0.134897f},   41}  ,{  { 0.539589f, 0.274682f, 0.185728f},  123}  ,{  { 0.465298f, 0.187683f, 0.347019f},  179}  ,{  { 0.589443f, 0.158358f, 0.252199f},  191}  ,{  { 0.484848f, 0.329423f, 0.185728f},   70}  ,{  { 0.332356f, 0.474096f, 0.193548f},   60}  ,{  { 0.181818f, 0.437928f, 0.380254f},  114}  ,{  { 0.403715f, 0.521994f, 0.074291f},  166}  ,{  { 0.167155f, 0.436950f, 0.395894f},   92}  ,{  { 0.331378f, 0.524927f, 0.143695f},   23}  ,{  { 0.566960f, 0.130987f, 0.302053f},   54}  ,{  { 0.381232f, 0.511241f, 0.107527f},   11}  ,
{  { 0.197458f, 0.380254f, 0.422287f},   33}  };  ONLY_PSX2_ALIGNED(16);

/*$4
 ***********************************************************************************************************************
 ***********************************************************************************************************************
 */
u32 SPG2_IsLocked = 0;
/*#if defined(_GAMECUBE) 
# define SPG2_DYNAMIC_CACHELINE_NB
#endif*/

#ifdef SPG2_DYNAMIC_CACHELINE_NB
SPG2_CachedPrimitivs *SPG2_FirstFree = NULL;
int SPG2_iModifierNb = 0; 
#else
	#if defined(PSX2_TARGET) 
	#define SPG2_NumberOfCacheLine 400 // 250 is not enough.
	#elif defined(_XBOX)
	#define SPG2_NumberOfCacheLine 650 // 200 is not enough.
	#elif defined(ACTIVE_EDITORS)
	#define SPG2_NumberOfCacheLine 10000 // For editor...
	#else
	#define SPG2_NumberOfCacheLine 400 // 200 is not enough.
	#endif

#ifndef _XENON_RENDER
ONLY_XBOX_ALIGNED(16) SPG2_CachedPrimitivs SPG2_AllCachedData[SPG2_NumberOfCacheLine] ONLY_PSX2_ALIGNED(16); // 256 * 64 = 16384 = ~ 1 Mo
SPG2_CachedPrimitivs *SPG2_FirstFree = (SPG2_CachedPrimitivs *)1;

void SPG2_Modifier_FlushAll();

u32 SPG2_Allocate(u32 *pTR)
{
	SPG2_IsLocked = 1;
	
	SPG2_Modifier_FlushAll();
	
	*pTR = sizeof(SPG2_AllCachedData);
	return (u32)SPG2_AllCachedData;
}

void SPG2_InitCachedData();
void SPG2_Free()
{
	if (SPG2_IsLocked)
	{
		SPG2_IsLocked = 0;
		L_memset(SPG2_AllCachedData ,0,sizeof(SPG2_AllCachedData) );
		SPG2_FirstFree = (SPG2_CachedPrimitivs *)1;
		SPG2_InitCachedData();
	}
}
#endif
#endif

#ifdef JADEFUSION
SPG2_CachedPrimitivs *SPG2_FirstFree = (SPG2_CachedPrimitivs *)1;
#endif

SPG2_CachedPrimitivs SPG2_TmpPrim ONLY_PSX2_ALIGNED(16);

#ifndef JADEFUSION
typedef struct SPG2_GridMazpperNode_
{
	MATH_tdst_Vector		stPos;
	u16						GridSrc;
	u16						Grid2Src;
	ULONG					Color;
	u8						GridValue;
	u8						GridFire;
} SPG2_GridMazpperNode;

typedef struct SPG2_GridMazpper_
{
	ULONG 					ulNumbeOfNode;
	SPG2_GridMazpperNode 	*p_AllNodes;
	ULONG 					IsComputed;
	u32						SPG2_GRID_MAKS;
	float					GRID_NOISES[16];
	GRID_tdst_World			*_pst_GridUsed;
	GRID_tdst_World			*_pst_Grid2Used;
#ifdef SPG2_RELATIVE_COMPUTING
	MATH_tdst_Vector		OLDBVMAX,OLDBVMIN;
	u32						OLDGRISMASK;
#endif

} SPG2_GridMazpper;
#endif

typedef struct SPG2_AINode_
{
	ULONG					ul_Id;
	MATH_tdst_Vector		stPos;
	float					f_Timer;
	float					f_SizeRatio;
	float					f_FireRatio;
	MATH_tdst_Vector		f_Zadd;
	u8						Flags;
	u8						Fire;
} SPG2_AINode;

typedef struct SPG2_AI_
{
	ULONG 				ul_NbNodes_Cur;
	ULONG				ul_NbNodes_Max;
	SPG2_AINode			*pst_Node;
} SPG2_AI;


SPG2_tdst_Modifier *pst_FirstSPG2Modifier = NULL;
SPG2_GridMazpper	st_CurrentGridMapper;
SPG2_AI				st_SPG2_AI = { 0, 0, NULL };
ULONG				ul_SPG2_AI_ID;
SPG2_AINode			*pst_SPG2_AI_CurNode = NULL;

#ifdef TEST_DETECT_LINE_OF_FIRE_SPG2
#define MaxLines   32
#endif

#ifndef JADEFUSION
#define MaxSpheres 8
#endif

ULONG				LODMinIndex;

float				SPG2_SphereLod	[MaxSpheres];
float				SPG2_SphereRadius[MaxSpheres];
MATH_tdst_Vector	SPG2_SphereCenters[MaxSpheres];
ULONG SPG2_ulNumberOfSpheres = 0;

#ifdef TEST_DETECT_LINE_OF_FIRE_SPG2
ULONG               SPG2_ulNumberOfLines = 0;
MATH_tdst_Vector    SPG2_LineDir[MaxLines];
MATH_tdst_Vector	SPG2_LinePos[MaxLines];
#endif

void SPG2_GRID_UpdateColors(SPG2_GridMazpper *st_GridMapper )
{
	SPG2_GridMazpperNode 	*p_Node,*p_LastNode;
	u32						MaxValue,MaxValue2;
	if (st_GridMapper ->_pst_GridUsed == NULL) return;
	if (st_GridMapper ->IsComputed == 0) return;
	if (st_GridMapper ->ulNumbeOfNode== 0) return;
	if (st_GridMapper ->p_AllNodes == NULL) return;
//	MEM_vCheckMem(&MEM_gst_MemoryInfo);
_GSP_BeginRaster(55);
	MaxValue = st_GridMapper ->_pst_GridUsed->w_NumRealGroupsX * st_GridMapper ->_pst_GridUsed->w_NumRealGroupsY * st_GridMapper ->_pst_GridUsed->c_SizeGroup * st_GridMapper ->_pst_GridUsed->c_SizeGroup;
	

	p_Node = st_GridMapper ->p_AllNodes;
	p_LastNode = p_Node + st_GridMapper ->ulNumbeOfNode;
	if (st_GridMapper ->_pst_Grid2Used)
	{
    	MaxValue2 = st_GridMapper ->_pst_Grid2Used->w_NumRealGroupsX * st_GridMapper ->_pst_Grid2Used->w_NumRealGroupsY * st_GridMapper ->_pst_Grid2Used->c_SizeGroup * st_GridMapper ->_pst_Grid2Used->c_SizeGroup;
		while (p_Node < p_LastNode)
		{
			if ((p_Node ->GridSrc < MaxValue) && (p_Node ->Grid2Src < MaxValue2))
			{
				p_Node ->GridValue = st_GridMapper ->_pst_GridUsed ->pst_RealArray [ p_Node ->GridSrc ].c_Capacities & 0xf;
				if (p_Node ->Grid2Src != -1)
					p_Node ->GridValue |= (st_GridMapper ->_pst_Grid2Used ->pst_RealArray [ p_Node ->Grid2Src ].c_Capacities & 0xc0)>>2;
				if (p_Node ->GridValue & 0x10)
#ifdef JADEFUSION
					p_Node ->GridFireContext[g_iCurrentFireContext] = p_Node ->GridFire = (u8)lMin((s32)p_Node ->GridFire + 10, 255);
#else
					p_Node ->GridFire = (u8)lMin((s32)p_Node ->GridFire + 10, 255);
#endif
				else
#ifdef JADEFUSION
					p_Node ->GridFireContext[g_iCurrentFireContext] = p_Node ->GridFire = (u8)lMax((s32)p_Node ->GridFire - 5, 0);
#else
					p_Node ->GridFire = (u8)lMax((s32)p_Node ->GridFire - 5, 0);
#endif
				p_Node ++;
			} else
				p_Node ++;
			}

	} else
	while (p_Node < p_LastNode)
	{
		if (p_Node ->GridSrc < MaxValue)
			p_Node ->GridValue = st_GridMapper ->_pst_GridUsed ->pst_RealArray [p_Node ->GridSrc].c_Capacities;
		p_Node ++;
	}
//	MEM_vCheckMem(&MEM_gst_MemoryInfo);
_GSP_EndRaster(55);
}

void SPG2_AddASphere(MATH_tdst_Vector	*Pos , float Radius)
{
	float LOD;
	if (SPG2_ulNumberOfSpheres == 0) LODMinIndex = 0;
	LOD = MATH_f_Distance(Pos,&GDI_gpst_CurDD->st_Camera.st_Matrix.T);
	if (LOD == 0.0f)
		LOD = 1000000.0f;
	else
		LOD = Radius / LOD ;
	if (SPG2_ulNumberOfSpheres < MaxSpheres)
	{
		if (SPG2_SphereLod[LODMinIndex] > LOD) LODMinIndex = SPG2_ulNumberOfSpheres;
		SPG2_SphereLod[SPG2_ulNumberOfSpheres] = LOD;
		SPG2_SphereCenters[SPG2_ulNumberOfSpheres] = *Pos;
		SPG2_SphereRadius[SPG2_ulNumberOfSpheres] = Radius;
		SPG2_ulNumberOfSpheres ++;
	} else
	if (LOD > SPG2_SphereLod[LODMinIndex])
	{
		ULONG Counter;
		/* Take place of LOD Min */
		SPG2_SphereLod[LODMinIndex] = LOD;
		SPG2_SphereCenters[LODMinIndex] = *Pos;
		SPG2_SphereRadius[LODMinIndex] = Radius;
		/* Recompute LODMinIndex */
		Counter = MaxSpheres - 1;
		LODMinIndex = MaxSpheres - 1;
		while (Counter--)
			if (SPG2_SphereLod[LODMinIndex] > SPG2_SphereLod[Counter]) LODMinIndex = Counter;
	}
}
#ifdef TEST_DETECT_LINE_OF_FIRE_SPG2
void SPG2_AddALine(MATH_tdst_Vector *Pos, MATH_tdst_Vector *Dir)
{
    float LOD;
    if (SPG2_ulNumberOfLines == 0) LODMinIndex = 0;
    if (SPG2_ulNumberOfLines < MaxLines)
    {
        SPG2_LinePos[SPG2_ulNumberOfLines] = *Pos;
        SPG2_LineDir[SPG2_ulNumberOfLines] = *Dir;
        SPG2_ulNumberOfLines++;
    }
}
#endif

void SPG2_DestroyCachedData() 
{
#ifdef SPG2_DYNAMIC_CACHELINE_NB
	while (SPG2_FirstFree)
	{
		SPG2_CachedPrimitivs *pNextCacheLine = SPG2_FirstFree->p_NextCacheLine;
		MEM_Free(SPG2_FirstFree);
		SPG2_FirstFree = pNextCacheLine;
	}
#endif // SPG2_DYNAMIC_CACHELINE_NB
}

#ifdef SPG2_DYNAMIC_CACHELINE_NB
ULONG GetSPG2CachePercent() {return 0;}
void SPG2_InitCachedData() {ERR_X_Assert(SPG2_FirstFree == NULL); }

#else // SPG2_DYNAMIC_CACHELINE_NB
ULONG GetSPG2CachePercent()
{
#ifdef _XENON_RENDER
    return 0;
#else
	ULONG Ret;
	SPG2_CachedPrimitivs *SPG2_FirstFreeLocal;
	Ret = SPG2_NumberOfCacheLine;
	SPG2_FirstFreeLocal = SPG2_FirstFree;
#ifdef JADEFUSION
	if ((unsigned int)SPG2_FirstFreeLocal != 1)
#else
		if ((u_int)SPG2_FirstFreeLocal != 1)
#endif
	{
		while (SPG2_FirstFreeLocal)
		{
			SPG2_FirstFreeLocal = SPG2_FirstFreeLocal->p_NextCacheLine;
			Ret--;
		}
	}
	Ret *= 100;
	Ret /= SPG2_NumberOfCacheLine;
	return Ret;
#endif
}


void SPG2_InitCachedData()
{
	if (SPG2_FirstFree == (SPG2_CachedPrimitivs *)1)
	{
#ifndef _XENON_RENDER
		ULONG Counter;
#endif
		L_memset(&st_CurrentGridMapper, 0, sizeof(SPG2_GridMazpper));
#ifdef _XENON_RENDER
        SPG2_FirstFree = (SPG2_CachedPrimitivs *)0;
#else
		Counter = SPG2_NumberOfCacheLine;
		while (Counter--)
		{
			SPG2_AllCachedData[Counter].p_NextCacheLine = &SPG2_AllCachedData[Counter + 1];
		}
		SPG2_AllCachedData[SPG2_NumberOfCacheLine - 1].p_NextCacheLine = NULL;
		SPG2_FirstFree = &SPG2_AllCachedData[0];		
#endif	
	}
}
#endif // SPG2_DYNAMIC_CACHELINE_NB


void MODIFIER_SPG2_FlushModifier(SPG2_tdst_Modifier *pst_SPG2);
void MODIFIER_SPG2_I_Need_Space()
{
#ifdef _XENON_RENDER
    return;
#else
	SPG2_tdst_Modifier *pst_Parser;
 	pst_Parser = pst_FirstSPG2Modifier ;
	while (pst_Parser)
	{
		if (pst_Parser->ulUsedSince < -8)
		{
           	MODIFIER_SPG2_FlushModifier(pst_Parser);
			pst_Parser->ulUsedSince = 0;
			if (SPG2_FirstFree) return;
		}
		pst_Parser = pst_Parser ->p_NextSPG2;
	}
#endif
};


SPG2_CachedPrimitivs *SPG2_GetAFreeLine()
{
#ifdef _XENON_RENDER
    return NULL;
#else
	SPG2_CachedPrimitivs *p_Ret;
	if (!SPG2_FirstFree) 
	{	
		MODIFIER_SPG2_I_Need_Space();
	}
	
	p_Ret = SPG2_FirstFree;
	if (SPG2_FirstFree)
	{
		SPG2_FirstFree = SPG2_FirstFree->p_NextCacheLine;
		p_Ret ->p_NextCacheLine = NULL;
		p_Ret->ulFlags = SPG2_CachedPrimitivsInitFlag;
	} 
#ifdef SPG2_DYNAMIC_CACHELINE_NB
	else
	{
		p_Ret = MEM_p_AllocAlignMem(sizeof(SPG2_CachedPrimitivs),16,&MEM_gst_GCMemoryInfo);
		p_Ret ->p_NextCacheLine = NULL;
		p_Ret->ulFlags = SPG2_CachedPrimitivsInitFlag;
	}
#endif // SPG2_DYNAMIC_CACHELINE_NB
	
	return p_Ret;
#endif
}

void MODIFIER_SPG2_FlushModifier(SPG2_tdst_Modifier *pst_SPG2)
{
#ifdef _XENON_RENDER
    if(pst_SPG2->stInstance.a_PtrLA2>0)
    {
        THREAD_SAFE_FREE(pst_SPG2->stInstance.a_PointLA2);
        THREAD_SAFE_FREE(pst_SPG2->stInstance.a_ColorLA2);

        THREAD_SAFE_VB_RELEASE(pst_SPG2->stInstance.pVB2X);
        THREAD_SAFE_VB_RELEASE(pst_SPG2->stInstance.pVBHelicoidal);
        THREAD_SAFE_MESH_DELETE(pst_SPG2->stInstance.pMesh2X);
        THREAD_SAFE_VB_RELEASE(pst_SPG2->stInstance.pVBSprites);
        THREAD_SAFE_MESH_DELETE(pst_SPG2->stInstance.pMeshSprites);

        pst_SPG2->stInstance.a_PtrLA2 = 0;
    }
#else
	SPG2_CachedPrimitivs *p_FirstFP,*p_NextFP;
	p_FirstFP = &pst_SPG2->SPG2_FirstCachedPrimitivs;

#ifdef JADEFUSION
    if(p_FirstFP)
#endif
	{
	p_FirstFP ->a_PtrLA2 = 0;
	p_FirstFP ->ulFlags = SPG2_CachedPrimitivsInitFlag;
	p_FirstFP ->a_PointLA2[0].x = 1.234567f;
		
	p_FirstFP = p_FirstFP->p_NextCacheLine;
	pst_SPG2->SPG2_FirstCachedPrimitivs.p_NextCacheLine = NULL;
	}
	while (p_FirstFP)
	{
#ifndef JADEFUSION
		p_FirstFP ->a_PtrLA2 = 0;
		p_FirstFP ->ulFlags = SPG2_CachedPrimitivsInitFlag;
		p_FirstFP ->a_PointLA2[0].x = 2.345678f;
#endif		
		p_NextFP = p_FirstFP->p_NextCacheLine;
		p_FirstFP->p_NextCacheLine = SPG2_FirstFree;
		SPG2_FirstFree = p_FirstFP;
		p_FirstFP = p_NextFP ;
	}
#endif // _XENON_RENDER
}

#ifdef SPG2_DYNAMIC_CACHELINE_NB
// Free all cached lines that are currently unused
void SPG2_FreeUnusedCachedData()
{
	// Put unused cached data in "SPG2_FirstFree" list
	SPG2_tdst_Modifier *pst_Parser;
 	pst_Parser = pst_FirstSPG2Modifier ;
	while (pst_Parser)
	{
		if (pst_Parser->ulUsedSince < -8)
		{
           	MODIFIER_SPG2_FlushModifier(pst_Parser);
			pst_Parser->ulUsedSince = 0;
		}
		pst_Parser = pst_Parser ->p_NextSPG2;
	}
	
	// Free unused cached data
	SPG2_DestroyCachedData();
};
#endif // SPG2_DYNAMIC_CACHELINE_NB

void SPG2_vEmergencyFreeMem()
{
#ifdef SPG2_DYNAMIC_CACHELINE_NB
	SPG2_FreeUnusedCachedData()
#endif // SPG2_DYNAMIC_CACHELINE_NB
}

#ifdef JADEFUSION
static unsigned int K = 0;
unsigned int FuckHELL(unsigned int EZ)
{
return  EZ + K;
}
#endif

#ifdef ACTIVE_EDITORS
ULONG SPG2_WHOLESCENENUM;
#endif

float SPG2_GlobalWind = 0.0f;
float SPG2_GlobalWindFactorMin = 0.8f;
float SPG2_GlobalWindFactorMax = 1.2f;
float SPG2_GlobalParams[5][20];
MATH_tdst_Vector SPG2_GlobalWindVec = {1,1,0};

static float CurrentWind = -1000.0f;
static float CurrentWindIntegrate = 0.0f; 

#ifndef JADEFUSION
static u32  SPG2_Repartiteur = 0;
static float Time = 0.0f;
#else
float Time = 0.0f;
#endif

void SPG2_Modifier_FlushModifiers()
{
	SPG2_tdst_Modifier *pst_Parser;
	
	pst_Parser = pst_FirstSPG2Modifier ;
	while (pst_Parser)
	{
		MODIFIER_SPG2_FlushModifier(pst_Parser);
		pst_Parser->ulUsedSince = 0;
		pst_Parser = pst_Parser ->p_NextSPG2;
	}
}

void SPG2_Modifier_FlushAll()
{
	SPG2_Modifier_FlushModifiers();
	SPG2_DestroySpecialGrid();
}

u32 LoadingHasBeenDetected = 0;
void MODIFIER_SPG2_OneFrameCall()
{
	SPG2_tdst_Modifier *pst_Parser,**pst_OldPtr;
#ifndef _XENON_RENDER
	SPG2_Repartiteur = 0;
#endif
	if (LoadingHasBeenDetected) LoadingHasBeenDetected--;
	/* Manage unused Cache data */
	{
	
		Time += TIM_gf_dt;
		if (TIM_gf_dt == 0)
			Time += 1.0f / 30.0f;
		if (Time > 600) Time = 0.f;
		CurrentWind = SPG2_GlobalWind;
/*		CurrentWind += fRand(-1.0f,1.0f) * fRand(-1.0f,1.0f) * 0.10f;*/
		if (CurrentWind > 1.0f) CurrentWind = 1.0f;
		if (CurrentWind < -0.0f) CurrentWind = 0.0f;
		CurrentWindIntegrate += CurrentWind;
		if (CurrentWindIntegrate > 1000.0f) CurrentWindIntegrate -= 1000.0f;
	}

	pst_Parser = pst_FirstSPG2Modifier ;
	pst_OldPtr = &pst_FirstSPG2Modifier ;
//	*(u_int *)0 = FuckHELL(*(u_int *)0);
	while (pst_Parser)
	{
		if (pst_Parser ->p_NextSPG2)
		{
			// Reorder with "firts is older" 
			if (pst_Parser ->ulUsedSince > pst_Parser ->p_NextSPG2 ->ulUsedSince)
			{
				*pst_OldPtr = pst_Parser ->p_NextSPG2 ;
				pst_Parser ->p_NextSPG2 = pst_Parser ->p_NextSPG2 ->p_NextSPG2;
				(*pst_OldPtr) ->p_NextSPG2 = pst_Parser ;
			}
		}
		pst_OldPtr = &pst_Parser ->p_NextSPG2;
		pst_Parser = pst_Parser ->p_NextSPG2;
	}//*/

#ifdef ACTIVE_EDITORS
	SPG2_WHOLESCENENUM = 0;
#endif
	pst_Parser = pst_FirstSPG2Modifier ;
	while (pst_Parser)
	{
#ifdef ACTIVE_EDITORS
		if (pst_Parser->ulNumberofgeneratedSprites != -1)
			SPG2_WHOLESCENENUM += pst_Parser->ulNumberofgeneratedSprites;
#endif
/*		if (pst_Parser->ulUsedSince < -8)
		{
           	MODIFIER_SPG2_FlushModifier(pst_Parser);
			pst_Parser->ulUsedSince = 0;
		}//*/
		pst_Parser->ulUsedSince --;
		pst_Parser = pst_Parser ->p_NextSPG2;
	}
	/* Grid Update colors */
	SPG2_GRID_UpdateColors(&st_CurrentGridMapper );

#ifdef _XENON_RENDER
    g_pXeContextManagerEngine->Xe_SPG2_ulNumberOfSpheres = SPG2_ulNumberOfSpheres;
    L_memcpy(g_pXeContextManagerEngine->Xe_SPG2_SphereRadius, SPG2_SphereRadius, Xe_MaxSPG2Spheres*sizeof(float));
    L_memcpy(g_pXeContextManagerEngine->Xe_SPG2_SphereCenters, SPG2_SphereCenters, Xe_MaxSPG2Spheres*sizeof(MATH_tdst_Vector));
#endif

#ifdef USE_DOUBLE_RENDERING	
	if (!(gpst_GSP_stDD.ul_DisplayInfo & GDI_Cul_DI_DoubleRendering_I)	)
#endif	
		SPG2_ulNumberOfSpheres = 0;

#ifdef TEST_DETECT_LINE_OF_FIRE_SPG2
    SPG2_ulNumberOfLines = 0;
#endif

#ifdef _GAMECUBE
	GXI_SPG2_OneFrameCall();
#endif // _GAMECUBE
		
}

void SPG2_InitModifier(SPG2_tdst_Modifier *pst_SPG2)
{
	SPG2_InitCachedData();
	pst_SPG2->f_GlobalRatio = 1.0f;
	pst_SPG2->f_GlobalSize = 1.0f;
	pst_SPG2->f_Noise	= 0.0f;
	pst_SPG2->f_Density	= 1.0f;
	pst_SPG2->f_Near = 100.0f;
	pst_SPG2->f_Far = 100000.0f;
	pst_SPG2->ulSubMaterialMask = (ULONG)-1;
#if defined(XML_CONV_TOOL)
	pst_SPG2->ulFlags = 0;
#else
	pst_SPG2->ulFlags = SPG2_FillSurface|SPG2_DrawHat|SPG2_DrawX|SPG2_DrawY;
#endif

#ifdef JADEFUSION
    pst_SPG2->f_HeatShimmerScroll = 0.0f;
#endif

#ifdef ACTIVE_EDITORS
	pst_SPG2->ulCodeKey = 0xC0DE2002;
#endif

	pst_SPG2->ulMustbeRecompute = 1;

#ifdef JADEFUSION
    pst_SPG2->f_HeatShimmerNoisePixelSize   = 5.0f;
    pst_SPG2->f_HeatShimmerScrollSpeed      = 0.75f;
    pst_SPG2->f_HeatShimmerRange            = 40.0f;
    pst_SPG2->f_HeatShimmerHeight           = 3.5f;
    pst_SPG2->f_HeatShimmerOpacity          = 0.80f;
#endif

}

ULONG SPG2_InterpolColorFull(register MATH_tdst_Vector    *pst_Pond, register ULONG C0 , register ULONG C1 , register ULONG C2  )
{
#ifdef PSX2_TARGET
	u32 REturnValue;
	asm __volatile__("
		.set noreorder
		lqc2 		$vf01 , 0(pst_Pond)
		PEXTLB		C0, zero, C0	/* Extend Color */
		PEXTLB		C1, zero, C1	/* Extend Color */
		PEXTLB		C2, zero, C2	/* Extend Color */
		PEXTLB		C0, zero, C0	/* Extend Color */
		PEXTLB		C1, zero, C1	/* Extend Color */
		PEXTLB		C2, zero, C2	/* Extend Color */
		qmtc2    	C0,	$vf02		
		qmtc2    	C1,	$vf03		
		qmtc2    	C2,	$vf04		
		VITOF0		$vf02,$vf02		/* VF02 = Color */
		VITOF0		$vf03,$vf03		/* VF02 = Color */
		VITOF0		$vf04,$vf04		/* VF02 = Color */
		VMULx.xyzw 	$vf02,$vf02,$vf01x
		VMULy.xyzw 	$vf03,$vf03,$vf01y
		VMULz.xyzw 	$vf04,$vf04,$vf01z
		VADD.xyzw	$vf02,$vf02,$vf03
		VADD.xyzw	$vf02,$vf02,$vf04
		VFTOI0		$vf02,$vf02		/* VF02 = Color */
		qmfc2.i    	REturnValue,	$vf02		
		PPACB		REturnValue,	zero, REturnValue	/* Pack Color Result 			*/
		PPACB		REturnValue,	zero, REturnValue	/* Pack Color Result 			*/
		.set reorder
	");
	return REturnValue;
#else
	ULONG X,Y,Z;
	ULONG CX , CY, CZ;
	ULONG CXp , CYp, CZp;
	X = (ULONG)(pst_Pond->x * 255.0f);
	Y = (ULONG)(pst_Pond->y * 255.0f);
	Z = (ULONG)(pst_Pond->z * 255.0f);
	CX = C0 & 0xff00ff;
	CY = C1 & 0xff00ff;
	CZ = C2 & 0xff00ff;
	CXp = (C0>>8) & 0xff00ff;
	CYp  =(C1>>8) & 0xff00ff;
	CZp  =(C2>>8) & 0xff00ff;
	CX *= X;
	CXp *= X;
	CY *= Y;
	CYp *= Y;
	CZ *= Z;
	CZp *= Z;

	CX &= 0xff00ff00;
	CY &= 0xff00ff00;
	CZ &= 0xff00ff00;
	CXp &= 0xff00ff00;
	CYp &= 0xff00ff00;
	CZp &= 0xff00ff00;
	CXp |= CX >> 8;
	CYp |= CY >> 8;
	CZp |= CZ >> 8;
	return CXp + CYp + CZp;
#endif
}


/*
		rcuparation de la grille

		GRID_tdst_World *_pst_Grid = pst_World->pst_Grid1; (donc 2e grille, attention, vrifier que c'est pas NULL si oublie du LD)

	conversion 3D (src) en coordonnes 2D x et y

		if(!GRI_3Dto2D(_pst_Grid, src, &x, &y)) return TRUE;
		if(!GRI_ConvertTo2DReal(_pst_Grid, &x, &y)) return TRUE;

	rcupration/criture d'une valeur 8 bits

	#define M_RealArr(g, x, y)		g->pst_RealArray[x + ((y) * (g)->w_NumRealGroupsX * (g)->c_SizeGroup)]

	g est la grille
	x et y les coords


	val = M_RealArr(_pst_Grid, x, y)

	les 4 bits de poids fort sont dynamiques et donc pour toi

	fonctions/exemples definis dans GRI_compute.c
*/
void SPG2_DestroySpecialGrid()
{
	u32 SaveGM1;
	if (st_CurrentGridMapper.p_AllNodes)
		MEM_Free(st_CurrentGridMapper.p_AllNodes);
	SaveGM1 = st_CurrentGridMapper.SPG2_GRID_MAKS ;
	L_memset(&st_CurrentGridMapper , 0 , sizeof(SPG2_GridMazpper)); 
	st_CurrentGridMapper.SPG2_GRID_MAKS = SaveGM1 ;
}
void SPG2_SpecialGridHasChanged()
{
#ifdef SPG2_RELATIVE_COMPUTING
	st_CurrentGridMapper.IsComputed = 0;
#else
	SPG2_DestroySpecialGrid();
#endif
}
void SPG2_AI_Destroy( SPG2_AI *_pst_SPG2_AI )
{
	if (_pst_SPG2_AI->pst_Node)
		MEM_Free(_pst_SPG2_AI->pst_Node);
	L_memset(_pst_SPG2_AI , 0 , sizeof( SPG2_AI ) ); 
	ul_SPG2_AI_ID = 0;
}

void SPG2_CloseWorldHook()
{
	st_CurrentGridMapper.SPG2_GRID_MAKS = 0;
	SPG2_DestroySpecialGrid();
	SPG2_AI_Destroy( &st_SPG2_AI );
}

void SPG2_ReinitWorldHook()
{
	st_SPG2_AI.ul_NbNodes_Cur = 0;
	ul_SPG2_AI_ID = 0;
	SPG2_LoadWorldHook();
	SPG2_DestroySpecialGrid();
}

void SPG2_LoadWorldHook()
{
	SPG2_GlobalWind = 0.0f;
	SPG2_GlobalWindFactorMin = 0.8f;
	SPG2_GlobalWindFactorMax = 1.2f;
	L_memset(SPG2_GlobalParams, 0, sizeof(SPG2_GlobalParams));
	SPG2_GlobalWindVec.x = 1.0f;
	SPG2_GlobalWindVec.y = 1.0f;
	SPG2_GlobalWindVec.z = 0.0f;
}

void SPG2_Get3Weights(MATH_tdst_Matrix *pGOMatrix, MATH_tdst_Vector *P0,MATH_tdst_Vector *P1,MATH_tdst_Vector *P2,MATH_tdst_Vector *CP,MATH_tdst_Vector *PDST)
{
	MATH_tdst_Vector Edge0,Edge1;
	MATH_tdst_Vector L0,L1,L2,LCP;
	f32				 f0,f1,f2;

	LCP = *CP;

	MATH_TransformVertex(&L0 , pGOMatrix , P0);
	MATH_TransformVertex(&L1 , pGOMatrix , P1);
	MATH_TransformVertex(&L2 , pGOMatrix , P2);
	LCP.z = L0.z = L1.z = L2.z = 0.0f;

	MATH_SubVector(&Edge0 , &L1 , &L0);
	MATH_SubVector(&Edge1 , &L2 , &L1);
	/* Turn 90 */
	Edge0.z = Edge0.x;
	Edge0.x =-Edge0.y;
	Edge0.y = Edge0.z;
	Edge0.z = 0.0f;

	Edge1.z = Edge1.x;
	Edge1.x =-Edge1.y;
	Edge1.y = Edge1.z;
	Edge1.z = 0.0f;

	f0 = MATH_f_DotProduct(&Edge0 , &L1);
	f1 = MATH_f_DotProduct(&Edge0 , &L2);
	f2 = MATH_f_DotProduct(&Edge0 , &LCP);

#if 0 && defined (JADEFUSION)// BUG : to be investigated : defined(_XENON)
	float fVal = f1 - f0;
	if(*(int*)&fVal == 0)
		PDST->z = 0.0f;
	else
		PDST->z = fMax(0.0f, (f2 - f0) / (f1 - f0));
#else
	if ((f1 - f0) == 0.0f)
		PDST->z = 0.0f;
	else
		PDST->z = fMax(0.0f , (f2 - f0) / (f1 - f0));
#endif

	f0 = MATH_f_DotProduct(&Edge1 , &L1);
	f1 = MATH_f_DotProduct(&Edge1 , &L0);
	f2 = MATH_f_DotProduct(&Edge1 , &LCP);

#if 0 && defined (JADEFUSION)// BUG : to be investigated : defined(_XENON)
	fVal = f1 - f0;
	if(*(int*)&fVal == 0)
		PDST->x = 0.0f;
	else
	PDST->x = fMax(0.0f, (f2 - f0) / (f1 - f0));
#else
	if ((f1 - f0) == 0.0f)
		PDST->x = 0.0f;
	else
		PDST->x = fMax(0.0f , (f2 - f0) / (f1 - f0));
#endif

#if defined(_XENON)
	PDST->y = fMax(0.0f , 1.0f - (PDST->x + PDST->z));
#else
	PDST->y = fMax(0.0f , 1.0f - (PDST->x + PDST->z));
#endif
}

BOOL SPG2_InBV(float fx, float fy, MATH_tdst_Vector *min, MATH_tdst_Vector *max)
{
	if(fx < min->x) return FALSE;
	if(fx > max->x) return FALSE;
	if(fy < min->y) return FALSE;
	if(fy > max->y) return FALSE;
	return TRUE;
}

void SPG2_AddBV(float fx, float fy, MATH_tdst_Vector *min, MATH_tdst_Vector *max)
{
	if(fx < min->x) {min->x = fx;};
	if(fx > max->x) {max->x = fx;};
	if(fy < min->y) {min->y = fy;};
	if(fy > max->y) {max->y = fy;};
}

extern ULONG MICRO_FREEZE_OPTMIS;
void GEO_I_Need_The_Triangles_End_Element(GEO_tdst_ElementIndexedTriangles    *pst_Element , ULONG FromEnd);
void GEO_I_Need_The_Triangles_FlushAll();

void SPG2_ComputeSpecialGrid(SPG2_tdst_Modifier *pst_SPG2, WOR_tdst_World *p_stWorld, OBJ_tdst_GameObject *pst_GO)
{
	GRID_tdst_World *_pst_Grid , *_pst_Grid1 ;
#ifdef SPG2_RELATIVE_COMPUTING
//	static MATH_tdst_Vector OLDBVMAX,OLDBVMIN;
//	static u32 OLDGRISMASK;
	MATH_tdst_Vector NEWBVMAX,NEWBVMIN;
	u32				 NumberToKeep, actualnumber;
#endif

#ifdef _XENON // make sure our rendering thread has finished as it is accessing the array of nodes

    g_oXeRenderer.WaitForEventComplete(eXeThreadEvent_Flip);

#endif

//	MEM_vCheckMem(&MEM_gst_MemoryInfo);
	MICRO_FREEZE_OPTMIS = 0;	
#ifdef PSX2_TARGET
	MICRO_FREEZE_OPTMIS = 0;
#endif
	_pst_Grid = p_stWorld->pst_Grid;
	_pst_Grid1 = p_stWorld->pst_Grid1;
	if (_pst_Grid)
	{
		ULONG NumberOfNode;
		MATH_tdst_Vector stMin,stMax;
		NumberOfNode = 0;
		st_CurrentGridMapper.SPG2_GRID_MAKS &= ~1; // No generation on 0

#ifdef SPG2_RELATIVE_COMPUTING
		/* Compute new BV */
		NEWBVMIN.x = 0.0f + _pst_Grid->f_MinXTotal + _pst_Grid->w_XRealGroup * _pst_Grid->c_SizeGroup;
		NEWBVMIN.y = 0.0f + _pst_Grid->f_MinYTotal + _pst_Grid->w_YRealGroup * _pst_Grid->c_SizeGroup, 
		NEWBVMAX.x = 1.0f + _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup + _pst_Grid->f_MinXTotal + _pst_Grid->w_XRealGroup * _pst_Grid->c_SizeGroup;
		NEWBVMAX.y = 1.0f + _pst_Grid->w_NumRealGroupsY * _pst_Grid->c_SizeGroup + _pst_Grid->f_MinYTotal + _pst_Grid->w_YRealGroup * _pst_Grid->c_SizeGroup;
#if 0
		if
		(
			NEWBVMIN.x == st_CurrentGridMapper.OLDBVMIN.x 
		&&	NEWBVMIN.y == st_CurrentGridMapper.OLDBVMIN.y
		&&	NEWBVMAX.x == st_CurrentGridMapper.OLDBVMAX.x 
		&&	NEWBVMAX.y == st_CurrentGridMapper.OLDBVMAX.y
		)
		{
			SPG2_DestroySpecialGrid();
		}
#endif
#endif		

		/* 1 : Count number of nodes */
		{
			ULONG ulSize;
			ulSize = _pst_Grid->w_NumRealGroupsX * _pst_Grid->w_NumRealGroupsY * _pst_Grid->c_SizeGroup * _pst_Grid->c_SizeGroup;
			while (ulSize--)
			{
				if ((1<<(_pst_Grid->pst_RealArray[ulSize].c_Capacities & 0xf)) & st_CurrentGridMapper.SPG2_GRID_MAKS)
					NumberOfNode++;
			}
		}

		// Option CB
/*		if(NumberOfNode == st_CurrentGridMapper.ulNumbeOfNode) 
		{
			return;
		}*/
#ifdef SPG2_RELATIVE_COMPUTING
		/* Check & Displace what I keep */
		actualnumber = st_CurrentGridMapper.ulNumbeOfNode;
		if (!NumberOfNode) 
		{
			st_CurrentGridMapper._pst_GridUsed = NULL;
			if (st_CurrentGridMapper.p_AllNodes) 
				MEM_Free(st_CurrentGridMapper.p_AllNodes);
			st_CurrentGridMapper.p_AllNodes = NULL;
			st_CurrentGridMapper.ulNumbeOfNode = 0;
			st_CurrentGridMapper.IsComputed = 1;
			return;
		}
#ifdef JADEFUSION
		if (!st_CurrentGridMapper.p_AllNodes || !st_CurrentGridMapper.ulNumbeOfNode)
#else
		if (!st_CurrentGridMapper.p_AllNodes)
#endif
		{
			st_CurrentGridMapper._pst_GridUsed = NULL;
			if (st_CurrentGridMapper.p_AllNodes) 
				MEM_Free(st_CurrentGridMapper.p_AllNodes);
			st_CurrentGridMapper.p_AllNodes = NULL;
			st_CurrentGridMapper.ulNumbeOfNode = 0;
			st_CurrentGridMapper.IsComputed = 1;
			if (!NumberOfNode) return;
			st_CurrentGridMapper.p_AllNodes = (SPG2_GridMazpperNode* )MEM_p_Alloc(sizeof(SPG2_GridMazpperNode) * NumberOfNode);
		} else
		{ // Recompute
			SPG2_GridMazpperNode 	*p_Node,*p_NodeBase,*p_LastNode;
			p_NodeBase = p_Node = st_CurrentGridMapper.p_AllNodes;
			p_LastNode = p_Node + st_CurrentGridMapper.ulNumbeOfNode;
			NumberToKeep = 0;
			while (p_Node < p_LastNode)
			{
				if ((SPG2_InBV(p_Node ->stPos.x, p_Node ->stPos.y, &NEWBVMIN, &NEWBVMAX) &&
					(1 << (p_Node->GridValue & 0xf)) & st_CurrentGridMapper.SPG2_GRID_MAKS))
				{

					int x,y;
					extern BOOL  GRI_3Dto2D(GRID_tdst_World *_pst_Grid, MATH_tdst_Vector *_pst_Vec, int *_pi_X, int *_pi_Y);
					extern BOOL GRI_ConvertTo2DReal(GRID_tdst_World *_pst_Grid, int *_pi_X, int *_pi_Y);
					if(_pst_Grid1 && GRI_3Dto2D(_pst_Grid1, &p_Node->stPos , &x, &y)) 
					{
						if(GRI_ConvertTo2DReal(_pst_Grid1, &x, &y)) 
						{
							u32 Address;
							Address = x + (y * _pst_Grid1->w_NumRealGroupsX * _pst_Grid1->c_SizeGroup);
							p_Node->Grid2Src = Address ;
						}
					}
					if(_pst_Grid && GRI_3Dto2D(_pst_Grid, &p_Node->stPos, &x, &y)) 
					{
						if(GRI_ConvertTo2DReal(_pst_Grid, &x, &y)) 
						{
							u32 Address;
							Address = x + (y * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup);
							p_Node->GridSrc = Address ;
						}
					}
					*(p_NodeBase++) = *(p_Node ++);

					NumberToKeep ++;
				} else
					p_Node ++;
			}//*/
			/* Reallocate */
			st_CurrentGridMapper.IsComputed = 1;
			if (NumberOfNode < NumberToKeep)
				NumberOfNode =NumberToKeep;
#ifdef JADEFUSION
			st_CurrentGridMapper.p_AllNodes = (SPG2_GridMazpperNode* )MEM_p_Realloc(st_CurrentGridMapper.p_AllNodes, sizeof(SPG2_GridMazpperNode) * (NumberOfNode+256)); // +256 because this algorithm is crappy and overwrites memory
#else
			st_CurrentGridMapper.p_AllNodes = (SPG2_GridMazpperNode* )MEM_p_Realloc(st_CurrentGridMapper.p_AllNodes, sizeof(SPG2_GridMazpperNode) * NumberOfNode);
#endif
			st_CurrentGridMapper.ulNumbeOfNode = NumberToKeep;
		}
#else
		/* 2 : Allocate */
		st_CurrentGridMapper._pst_GridUsed = NULL;
		if (st_CurrentGridMapper.p_AllNodes) 
			MEM_Free(st_CurrentGridMapper.p_AllNodes);
		st_CurrentGridMapper.p_AllNodes = NULL;
		st_CurrentGridMapper.ulNumbeOfNode = 0;
		st_CurrentGridMapper.IsComputed = 1;
		if (!NumberOfNode) return;
#ifdef JADEFUSION
		st_CurrentGridMapper.p_AllNodes = (SPG2_GridMazpperNode*)MEM_p_Alloc(sizeof(SPG2_GridMazpperNode) * NumberOfNode);
#else
		st_CurrentGridMapper.p_AllNodes = MEM_p_Alloc(sizeof(SPG2_GridMazpperNode) * NumberOfNode);
#endif
#endif
		st_CurrentGridMapper._pst_GridUsed = _pst_Grid;
		st_CurrentGridMapper._pst_Grid2Used = _pst_Grid1;



		stMin.x = _pst_Grid->f_MinXTotal;
		stMin.y = _pst_Grid->f_MinYTotal;
		stMin.z = 0.0f;

		stMax.x = _pst_Grid->f_MinXTotal;
		stMax.y = _pst_Grid->f_MinYTotal;
		stMax.z = 0.0f;

		{
			ULONG CounterX,CounterY;
			ULONG RandomCounter;
			FakeStr							*pst_CurrentPond;
			RandomCounter = 0;
			CounterX = _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup;
			while (CounterX--)
			{
				CounterY = _pst_Grid->w_NumRealGroupsY * _pst_Grid->c_SizeGroup;
				while (CounterY--)
				{
					if(pst_SPG2->ulFlags1 & SPG2_Damier)
					{
						if((CounterX & 1) && (CounterY & 1)) continue;
						if(!(CounterX & 1) && !(CounterY & 1)) continue;
					}
#ifdef SPG2_RELATIVE_COMPUTING
					/* check the "already here" Tag */
					if (SPG2_InBV(	0.5f + CounterX + _pst_Grid->f_MinXTotal + _pst_Grid->w_XRealGroup * _pst_Grid->c_SizeGroup, 
									0.5f + CounterY + _pst_Grid->f_MinYTotal + _pst_Grid->w_YRealGroup * _pst_Grid->c_SizeGroup, 
									&st_CurrentGridMapper.OLDBVMIN, &st_CurrentGridMapper.OLDBVMAX) && ((1 << (_pst_Grid->pst_RealArray[CounterX + ((CounterY) * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup)].c_Capacities & 0xf)) & st_CurrentGridMapper.OLDGRISMASK))//*/
					{
						continue;
					}
#endif
					{
						if ( (1 << (_pst_Grid->pst_RealArray[CounterX + ((CounterY) * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup)].c_Capacities & 0xf)) & st_CurrentGridMapper.SPG2_GRID_MAKS)
						{
							MATH_tdst_Vector stDirection,Grid2Test;
							u32 Capa;
							Capa = (_pst_Grid->pst_RealArray[CounterX + ((CounterY) * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup)].c_Capacities) & 0xf;
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridSrc = (short)(CounterX + ((CounterY) * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup));
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.x = 0.5f + /*_pst_Grid->f_MinXReal + *//*_pst_Grid->c_SizeGroup * */CounterX + _pst_Grid->f_MinXTotal + _pst_Grid->w_XRealGroup * _pst_Grid->c_SizeGroup;
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.y = 0.5f + /*_pst_Grid->f_MinYReal + *//*_pst_Grid->c_SizeGroup * */CounterY + _pst_Grid->f_MinYTotal + _pst_Grid->w_YRealGroup * _pst_Grid->c_SizeGroup;
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.z = 100000.0f;
							Grid2Test = st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos;
							pst_CurrentPond = &Fake[(RandomCounter ++) & (MAX_RND - 1) ] ;
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.x += (pst_CurrentPond->FakeXYZ.x - 0.333333f) * 0.5f;//st_CurrentGridMapper.GRID_NOISES[Capa];
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.y += (pst_CurrentPond->FakeXYZ.y - 0.333333f) * 0.5f;//st_CurrentGridMapper.GRID_NOISES[Capa];
							st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridValue = _pst_Grid->pst_RealArray[CounterX + ((CounterY) * _pst_Grid->w_NumRealGroupsX * _pst_Grid->c_SizeGroup)].c_Capacities;
							*(u32 *)&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.x &= ~1;
							if((CounterX ^ CounterY) & 1) *(u32 *)&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.x |= 1;

							stDirection.x = stDirection.y = 0.0f;
							stDirection.z = -1.0f;
#ifdef JADEFUSION
							if (COL_Visual_RayCast
								(
									p_stWorld,
									NULL,
									&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos,
									&stDirection,
									100000000000.0f,
									0xFFFFFFFF,
									OBJ_C_IdentityFlag_Dyna|OBJ_C_IdentityFlag_Anims|OBJ_C_IdentityFlag_NoSPG2,
									OBJ_C_OR_OR_IdentityFlags,
									NULL,
									TRUE,
								FALSE,
								FALSE
								))
#else

							if (COL_Visual_RayCast
								(
									p_stWorld,
									NULL,
									&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos,
									&stDirection,
									100000000000.0f,
									0xFFFFFFFF,
									OBJ_C_IdentityFlag_Dyna|OBJ_C_IdentityFlag_Anims|OBJ_C_IdentityFlag_NoSPG2,
									OBJ_C_OR_OR_IdentityFlags,
									NULL,
									TRUE,
								FALSE
								))
#endif
							{
								ULONG *pColor;
								GEO_tdst_Object			*_pst_Obj;
								/* Retreive Color */
								pColor  = NULL;
								_pst_Obj = NULL;
								if ((p_stWorld->st_RayInfo.pst_CollidedGO) && (p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base) && (p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu))
								{
									if (p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->dul_VertexColors)
										pColor = p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->dul_VertexColors;
#ifdef JADEFUSION
                                    // SC: Let's be consistent and use the same object that was used when casting the ray...
                                    _pst_Obj = (GEO_tdst_Object*)OBJ_p_GetCurrentGeo(p_stWorld->st_RayInfo.pst_CollidedGO);
#else
									if(OBJ_b_TestIdentityFlag(p_stWorld->st_RayInfo.pst_CollidedGO, OBJ_C_IdentityFlag_Visu))
									{
										if (p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->pst_Object->i->ul_Type  == GRO_Geometric)
											_pst_Obj = (GEO_tdst_Object	*)p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->pst_Object;
										if (p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->pst_Object->i->ul_Type  == GRO_GeoStaticLOD)
											_pst_Obj = (GEO_tdst_Object	*)(((GEO_tdst_StaticLOD *)(p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->pst_Object))->dpst_Id[0]);
									}
#endif								
								}
								if ((_pst_Obj) && (pColor == NULL))
									pColor = _pst_Obj->dul_PointColors;
								if (pColor && _pst_Obj)
								{
									ULONG Index0,Index1,Index2;
									MATH_tdst_Vector stPonderation ONLY_PSX2_ALIGNED(16);
									pColor+=1;
									GEO_I_Need_The_Triangles_Begin(_pst_Obj,0);
									Index0 = _pst_Obj->dst_Element[p_stWorld->st_RayInfo.uw_Element].dst_Triangle[p_stWorld->st_RayInfo.ul_Triangle].auw_Index[0];
									Index1 = _pst_Obj->dst_Element[p_stWorld->st_RayInfo.uw_Element].dst_Triangle[p_stWorld->st_RayInfo.ul_Triangle].auw_Index[1];
									Index2 = _pst_Obj->dst_Element[p_stWorld->st_RayInfo.uw_Element].dst_Triangle[p_stWorld->st_RayInfo.ul_Triangle].auw_Index[2];
									SPG2_Get3Weights(p_stWorld->st_RayInfo.pst_CollidedGO->pst_GlobalMatrix,
													(MATH_tdst_Vector *)(_pst_Obj->dst_Point + Index0),
													(MATH_tdst_Vector *)(_pst_Obj->dst_Point + Index1),
													(MATH_tdst_Vector *)(_pst_Obj->dst_Point + Index2),
													&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos,
													&stPonderation);

									


									st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color = 
										SPG2_InterpolColorFull(&stPonderation, pColor[Index0] , pColor[Index1] , pColor[Index2] );

									if ((GDI_gpst_CurDD->ul_DrawMask &
										p_stWorld->st_RayInfo.pst_CollidedGO->pst_Base->pst_Visu->ul_DrawMask) & GDI_Cul_DM_UseAmbient)
									{
										extern void LIGHT_AddColor(ULONG *pul_Diffuse, ULONG ul_Diffuse);
										LIGHT_AddColor(&st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color, p_stWorld->ul_AmbientColor);
									}
/*	#ifdef PSX2_TARGET
									st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color &= 0xfefefe;
									st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color >>= 1;
	#endif									*/
#if defined(_XENON_RENDER) // the shader wil multiply by 2 so divide by 2 
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color &= 0x00fefefe;
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color >>= 1;
#endif									
									GEO_I_Need_The_Triangles_End(_pst_Obj,0);
								} else	
									st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Color = 0;				

								/* Grid 2 detection */
#ifdef JADEFUSION
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Grid2Src = -1;
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFireContext[0] = st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFireContext[1] = st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFire = 0;
                                st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].MaxGlobalScale = 0.0f;
#else
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Grid2Src = -1;
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFire = 0;
#endif
								if (_pst_Grid1)
								{
									int x,y;
									extern BOOL  GRI_3Dto2D(GRID_tdst_World *_pst_Grid, MATH_tdst_Vector *_pst_Vec, int *_pi_X, int *_pi_Y);
									extern BOOL GRI_ConvertTo2DReal(GRID_tdst_World *_pst_Grid, int *_pi_X, int *_pi_Y);
									if(GRI_3Dto2D(_pst_Grid1, &Grid2Test , &x, &y)) 
									{
										if(GRI_ConvertTo2DReal(_pst_Grid1, &x, &y)) 
										{
											u32 Address;
											Address = x + (y * _pst_Grid1->w_NumRealGroupsX * _pst_Grid1->c_SizeGroup);
											st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].Grid2Src = Address ;
											st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridValue |= (_pst_Grid1->pst_RealArray[Address].c_Capacities & 0xc0)>>2;
											if (st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridValue & 0x10)
#ifdef JADEFUSION
                                            {
                                                st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFire = 255;
												st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFireContext[0] = 255;
                                                st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFireContext[1] = 255;
                                            }
#else	
												st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].GridFire = 255;
#endif										
										}
									}
								}
								st_CurrentGridMapper.p_AllNodes[st_CurrentGridMapper.ulNumbeOfNode].stPos.z = p_stWorld->st_RayInfo.st_CollidedPoint.z;
								st_CurrentGridMapper.ulNumbeOfNode++;
								if (st_CurrentGridMapper.ulNumbeOfNode == NumberOfNode)
								{
									CounterY = CounterX = 0;
								}
							}
						}
					}
				}
			}
		}
		/* Parse the grid. */
#ifdef SPG2_RELATIVE_COMPUTING
		st_CurrentGridMapper.OLDBVMAX = NEWBVMAX;
		st_CurrentGridMapper.OLDBVMIN = NEWBVMIN;
		st_CurrentGridMapper.OLDGRISMASK = st_CurrentGridMapper.SPG2_GRID_MAKS;
#endif
	}
	GEO_I_Need_The_Triangles_FlushAll();
	MICRO_FREEZE_OPTMIS = 0;
//	MEM_vCheckMem(&MEM_gst_MemoryInfo);
}
/*
 =======================================================================================================================
 =======================================================================================================================
 */

void SPG2_Modifier_Create(OBJ_tdst_GameObject *_pst_GO, MDF_tdst_Modifier *_pst_Mod, void *p_Data)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_tdst_Modifier *pst_Data;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	_pst_Mod->p_Data = MEM_p_AllocAlign(sizeof(SPG2_tdst_Modifier),16);
	
	pst_Data = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;
	L_memset(pst_Data , 0 , sizeof(SPG2_tdst_Modifier));

	if(!p_Data)
	{
		SPG2_InitModifier(pst_Data);
	}
	else
	{
		MODIFIER_SPG2_FlushModifier((SPG2_tdst_Modifier *)p_Data);
		L_memcpy(_pst_Mod->p_Data, p_Data, sizeof(SPG2_tdst_Modifier));
	}
	/* Add modifier in global Ring */
	pst_Data->p_NextSPG2 = pst_FirstSPG2Modifier;
	pst_FirstSPG2Modifier = pst_Data;
	
#ifdef SPG2_DYNAMIC_CACHELINE_NB
	SPG2_iModifierNb++;
#endif // SPG2_DYNAMIC_CACHELINE_NB
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_Modifier_Destroy(MDF_tdst_Modifier *_pst_Mod)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_tdst_Modifier *pst_Data;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	pst_Data = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;
	MODIFIER_SPG2_FlushModifier(pst_Data);

	/* Delete modifier in global Ring */
	{
		SPG2_tdst_Modifier *p_Finder;
		p_Finder = pst_FirstSPG2Modifier;
		if (pst_Data == p_Finder) 
			pst_FirstSPG2Modifier = pst_FirstSPG2Modifier->p_NextSPG2;
		else
		{
			while (p_Finder->p_NextSPG2 != pst_Data)
				p_Finder = p_Finder->p_NextSPG2;
			p_Finder ->p_NextSPG2 = p_Finder ->p_NextSPG2 ->p_NextSPG2;
		}
	}

	MEM_FreeAlign(pst_Data);
	
#ifdef SPG2_DYNAMIC_CACHELINE_NB
	SPG2_iModifierNb--;
	if (0 == SPG2_iModifierNb)
		SPG2_DestroyCachedData();
#endif // SPG2_DYNAMIC_CACHELINE_NB
}
OBJ_tdst_GameObject *SDW_GET_FK(OBJ_tdst_GameObject *p_stSon)
{
	if ((OBJ_ul_FlagsIdentityGet(p_stSon) & OBJ_C_IdentityFlag_Hierarchy) && p_stSon->pst_Base && p_stSon->pst_Base->pst_Hierarchy && (p_stSon->pst_Base->pst_Hierarchy->pst_FatherInit))
	{
		return SDW_GET_FK(p_stSon->pst_Base->pst_Hierarchy->pst_FatherInit);
	} 
	return p_stSon;
}

 
/*u32 THIS_IS_KONG(OBJ_tdst_GameObject *p_stSon)
{
	OBJ_tdst_GameObject *p_stSF;
	p_stSF = SDW_GET_FK(p_stSon);
	if (p_stSF->ul_MyKey == 0x72006cf9) 
    	return 1;

	if(p_stSF->ul_IdentityFlags & OBJ_C_IdentityFlag_Anims)
	{
		OBJ_tdst_Group			*pst_Skeleton;
		TAB_tdst_PFelem			*pst_CurrentBone;
		OBJ_tdst_GameObject		*pst_BoneGO;

		pst_Skeleton = p_stSF->pst_Base->pst_GameObjectAnim->pst_SkeletonModel;
		pst_CurrentBone = TAB_pst_PFtable_GetFirstElem(pst_Skeleton->pst_AllObjects);
		pst_BoneGO = (OBJ_tdst_GameObject *) pst_CurrentBone->p_Pointer;
		if(TAB_b_IsAHole(pst_BoneGO)) return 0;

		if(pst_BoneGO->ul_MyKey == 0x8f006c6b)
			return 1;

		return 0;
	}
	else
		return 0;

//	0x8f006c6b
}*/

/*
 =======================================================================================================================
 =======================================================================================================================
 */

void SPG2_Modifier_Apply
(
	MDF_tdst_Modifier		*_pst_Mod,
	GEO_tdst_Object			*_pst_Obj
)
{
#ifdef _GAMECUBE
/*xtern BOOL g_bUseHardwareLights;
	g_bUseHardwareLights=TRUE;
	if (THIS_IS_KONG(_pst_Mod->pst_GO)) // Kingkong ?)
	{
		g_bUseHardwareLights=FALSE;
	}*/
#endif
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void DBUGDRawSomething(MATH_tdst_Vector *Place,MATH_tdst_Vector *PlaceN , ULONG Color)
{
#ifdef ACTIVE_EDITORS
	extern void OGL_DrawLineEx(GDI_tdst_DisplayData *_pst_DD, GDI_tdst_Request_DrawLineEx *_pst_Data);
	GDI_tdst_Request_DrawLineEx stDLE;
	MATH_tdst_Vector A2,B2;
	A2 = *Place;
	B2 = *PlaceN;
	stDLE.ul_Flags = 0;
	stDLE.f_Width = 1.0f;
	stDLE.ul_Color = Color;
	stDLE.A = &A2;
	stDLE.B = &B2;
	OGL_DrawLineEx(GDI_gpst_CurDD, &stDLE);
#endif
}
float	MATH_ComputeCulling(
			MATH_tdst_Vector    *pst_CamPos , 
			MATH_tdst_Vector    *pst_CamDir , 
			float				CamCos , 
			float				CamOoSin , 
			MATH_tdst_Vector    *pst_SphereCenter , 
			float SphereRadius)
{
	float Lod ,Distance;
	MATH_tdst_Vector ProjectedCenter;
	MATH_tdst_Vector pCS;
	/* Fast Compute LOD (not the real formulae, but... OK)*/ 
	MATH_SubVector(&pCS , pst_SphereCenter , pst_CamPos );
	/* ZCulling 50 % of world */
	if (MATH_f_DotProduct(pst_CamDir , &pCS ) < -SphereRadius) 
		return 0.0f;
	/* into sphere ... Just use distance */
	Distance = MATH_f_NormVector(&pCS);
	if (Distance < SphereRadius) 
		return 1.0f;
	
	if (MATH_f_DotProduct(pst_CamDir , &pCS ) < 0.0f) 
		return 0.0f;
	
	Lod = 2.0f * (CamCos * CamOoSin * SphereRadius) / (2.0f * Distance);
	if (Lod > 1.0f) Lod = 1.0f;
	
	/* Out of View frustrum rejection */
	MATH_AddScaleVector(&ProjectedCenter , pst_CamPos , pst_CamDir , - SphereRadius * CamOoSin );
	MATH_SubVector(&pCS , pst_SphereCenter , &ProjectedCenter );
	MATH_NormalizeVector(&pCS , &pCS );
	if (MATH_f_DotProduct(&pCS,pst_CamDir) < CamCos) return 0.0f;

	return Lod;
}
#ifdef JADEFUSION
_inline_ void MATH_VectorMinMax(MATH_tdst_Vector    *pst_Point,MATH_tdst_Vector    *pst_Min,MATH_tdst_Vector    *pst_Max)
#else
void MATH_VectorMinMax(MATH_tdst_Vector    *pst_Point,MATH_tdst_Vector    *pst_Min,MATH_tdst_Vector    *pst_Max)
#endif
{
#if 0 && defined (JADEFUSION)// BUG : to be investigated : defined(_XENON)
	pst_Min->x = fMin(pst_Min->x, pst_Point->x);
	pst_Min->y = fMin(pst_Min->y, pst_Point->y);
	pst_Min->z = fMin(pst_Min->z, pst_Point->z);
	pst_Max->x = fMax(pst_Max->x, pst_Point->x);
	pst_Max->y = fMax(pst_Max->y, pst_Point->y);
	pst_Max->z = fMax(pst_Max->z, pst_Point->z);	
#else
	if (pst_Min->x > pst_Point->x) pst_Min->x = pst_Point->x;
	if (pst_Min->y > pst_Point->y) pst_Min->y = pst_Point->y;
	if (pst_Min->z > pst_Point->z) pst_Min->z = pst_Point->z;
	if (pst_Max->x < pst_Point->x) pst_Max->x = pst_Point->x;
	if (pst_Max->y < pst_Point->y) pst_Max->y = pst_Point->y;
	if (pst_Max->z < pst_Point->z) pst_Max->z = pst_Point->z;
#endif
}
_inline_ ULONG SPG2_InterpolColor(MATH_tdst_Vector    *pst_Pond, ULONG *CXXYYZZ )
{
	ULONG X,Y,Z;
	ULONG CX , CY, CZ;
	ULONG CXp , CYp, CZp;
	X = (ULONG)(pst_Pond->x * 255.0f);
	Y = (ULONG)(pst_Pond->y * 255.0f);
	Z = (ULONG)(pst_Pond->z * 255.0f);
	CX = CXXYYZZ[0];
	CY = CXXYYZZ[2];
	CZ = CXXYYZZ[4];
	CXp = CXXYYZZ[1];
	CYp  = CXXYYZZ[3];
	CZp  = CXXYYZZ[5];
	CX *= X;
	CXp *= X;
	CY *= Y;
	CYp *= Y;
	CZ *= Z;
	CZp *= Z;

	CX &= 0xff00ff00;
	CY &= 0xff00ff00;
	CZ &= 0xff00ff00;
	CXp &= 0xff00ff00;
	CYp &= 0xff00ff00;
	CZp &= 0xff00ff00;
	CXp |= CX >> 8;
	CYp |= CY >> 8;
	CZp |= CZ >> 8;

	return CXp + CYp + CZp;
	
}

_inline_ ULONG SPG2_ScaleColor(float Factor, ULONG C0 )
{
	ULONG X;
	ULONG CX ;
	ULONG CXp , CYp, CZp;
	X = (ULONG)(Factor * 255.0f);
	CX = C0 & 0xff00ff;
	CXp = (C0>>8) & 0xff00ff;
	CX *= X;
	CXp *= X;

	CX &= 0xff00ff00;
	CXp &= 0xff00ff00;
	CXp |= CX >> 8;

	return CXp + CYp + CZp;
	
}


#ifdef PSX2_TARGET
////////////////////////////////////////////////////////////////////////////////////
//								DrawSPG2 for PS2
////////////////////////////////////////////////////////////////////////////////////
extern void GSP_DrawSPG2(	SPG2_CachedPrimitivs				*pCachedLine,
							ULONG								*ulTextureID,
							GEO_Vertex					        *XCam,
							GEO_Vertex					        *YCam,
							SPG2_tdst_Modifier					*_pst_SPG2,
							SOFT_tdst_AVertex					*p_stWind,
							SPG2_InstanceInforamtion			*p_II
							);
#define DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind, pstii)	GSP_DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind , pstii)
							
extern void GSP_SPG2_PrepareCamra(SPG2_tdst_Modifier *_pst_SPG2 , SOFT_tdst_AVertex *p_stWind,float f_LOD);
extern void GSP_SPG2_CloseCamra(SPG2_tdst_Modifier					*_pst_SPG2);

#elif defined(_XENON_RENDER)
extern void Xe_l_DrawSPG2(	SPG2_Instance       				*pCachedLine,
							ULONG								*ulTextureID,
							GEO_Vertex					        *XCam,
							GEO_Vertex					        *YCam,
							SPG2_tdst_Modifier					*_pst_SPG2,
							SOFT_tdst_AVertex					*p_stWind,
							SPG2_InstanceInforamtion			*p_II
							);

#define DrawSPG2 			Xe_l_DrawSPG2


#elif defined(_GAMECUBE)
////////////////////////////////////////////////////////////////////////////////////
//								DrawSPG2 for GAMECUBE
////////////////////////////////////////////////////////////////////////////////////
extern void GXI_l_DrawSPG2(	SPG2_CachedPrimitivs				*pCachedLine,
							ULONG								*ulTextureID,
							GEO_Vertex					        *XCam,
							GEO_Vertex					        *YCam,
							SPG2_tdst_Modifier					*_pst_SPG2,
							SOFT_tdst_AVertex					*p_stWind,
							SPG2_InstanceInforamtion			*p_II
							);
#define DrawSPG2 			GXI_l_DrawSPG2
#elif defined (_XBOX)
////////////////////////////////////////////////////////////////////////////////////
//								 DrawSPG2 for XBOX
////////////////////////////////////////////////////////////////////////////////////
#define DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind, pstii)	Gx8_l_DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind , pstii)
#else
#ifdef JADEFUSION
#define DrawSPG2 			OGL_l_DrawSPG2
#endif
////////////////////////////////////////////////////////////////////////////////////
//								 DrawSPG2 for PC
////////////////////////////////////////////////////////////////////////////////////
extern void OGL_l_DrawSPG2(	SPG2_CachedPrimitivs				*pCachedLine,
							ULONG								*ulTextureID,
							GEO_Vertex					        *XCam,
							GEO_Vertex					        *YCam,
							SPG2_tdst_Modifier					*_pst_SPG2,
							SOFT_tdst_AVertex					*p_stWind,
							SPG2_InstanceInforamtion			*p_II
							);
#ifndef JADEFUSION
#define DrawSPG2 			OGL_l_DrawSPG2
#endif
#endif

#ifdef JADEFUSION
#if defined (_XBOX)
#undef DrawSPG2
//#define DrawSPG2 			Gx8_l_DrawSPG2
#define DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind, pstii)	Gx8_l_DrawSPG2(pCachedLine, ulTextureID, XCam, YCam, _pst_SPG2, p_stWind , pstii)

/*

extern void Gx8_l_DrawSPG2(	SPG2_CachedPrimitivs				*pCachedLine,
							ULONG								*ulTextureID,
							GEO_Vertex					        *XCam,
							GEO_Vertex					        *YCam,
							SPG2_tdst_Modifier					*_pst_SPG2,
							SOFT_tdst_AVertex					*p_stWind,
							SPG2_InstanceInforamtion			*p_II
							)
{
}

*/
#endif
#endif

static ULONG		WindSelector;
#ifdef PSX2_TARGET
_inline_ void SPG2_ExpandNormale(register u_int *Vector,register MATH_tdst_Vector *pDST )
{
	register u_long128 GH,GH2;
	asm __volatile__("
		.set noreorder
		lw			GH , 0 (Vector)
		PEXTLB		GH, zero, GH	/* Extend light Color */
		PEXTLB		GH, zero, GH	/* Extend light Color */
		qmtc2.i		GH , $vf10
		vitof0		$vf10 , $vf10 
		sqc2	$vf10,0(pDST)
		.set reorder
	");
	pDST->x -= 128.0f;
	pDST->y -= 128.0f;
	pDST->z -= 128.0f;
	pDST->x /= 128.0f;
	pDST->y /= 128.0f;
	pDST->z /= 128.0f;//*/
}
#endif

#ifdef _XBOX
extern unsigned int NoMDF2;
#endif

#ifdef JADEFUSION
/*OBJ_tdst_GameObject *SDW_GET_FK(OBJ_tdst_GameObject *p_stSon)
{
	if ((OBJ_ul_FlagsIdentityGet(p_stSon) & OBJ_C_IdentityFlag_Hierarchy) && p_stSon->pst_Base && p_stSon->pst_Base->pst_Hierarchy && (p_stSon->pst_Base->pst_Hierarchy->pst_FatherInit))
	{
		return SDW_GET_FK(p_stSon->pst_Base->pst_Hierarchy->pst_FatherInit);
	} 
	return p_stSon;
}

u32 THIS_IS_KONG(OBJ_tdst_GameObject *p_stSon)
{
	OBJ_tdst_GameObject *p_stSF;
	p_stSF = SDW_GET_FK(p_stSon);
	if (p_stSF->ul_MyKey == 0x72006cf9) return 1;

	if(p_stSF->ul_IdentityFlags & OBJ_C_IdentityFlag_Anims)
	{
		OBJ_tdst_Group			*pst_Skeleton;
		TAB_tdst_PFelem			*pst_CurrentBone;
		OBJ_tdst_GameObject		*pst_BoneGO;

		pst_Skeleton = p_stSF->pst_Base->pst_GameObjectAnim->pst_SkeletonModel;
		pst_CurrentBone = TAB_pst_PFtable_GetFirstElem(pst_Skeleton->pst_AllObjects);
		pst_BoneGO = (OBJ_tdst_GameObject *) pst_CurrentBone->p_Pointer;
		if(TAB_b_IsAHole(pst_BoneGO)) return 0;

		if(pst_BoneGO->ul_MyKey == 0x8f006c6b)
			return 1;

		return 0;
	}
	else
		return 0;

//	0x8f006c6b


}
*/
#ifdef TEST_DETECT_LINE_OF_FIRE_SPG2

FLOAT fGrowingSpeed1 = 0.0f;
FLOAT fGrowingSpeed2 = 0.0f;
FLOAT fGrowingFriction = 0.0f;
FLOAT fPhase1Duration = 0.2f;
FLOAT fPhase2Duration = 0.5f;
FLOAT fSizeMin = 0.02f;
FLOAT fSizeMax = 0.04f;
FLOAT fGravity = -6.0f;
FLOAT fGenerationRate = 0.001f;
FLOAT fSpeedMin = 1.0f;
FLOAT fSpeedMax = 3.0f;
FLOAT fTimeFactor = 0.2f;

int iPoolSize = 40;
int iSubMatNum = 0;
int iPhase1Color = 0xffffffff;
int iPhase2Color = 0xffffffff;
int iPhase3Color = 0xffffffff;
int iSpritesToGenerate = 64;

BOOL INT_RaySphere(MATH_tdst_Vector *_pst_Origin, MATH_tdst_Vector *_pst_Direction, INT_tdst_Sphere *_pst_Sphere);

void SPG2_GenerateLeafExplosion(OBJ_tdst_GameObject *pst_GO, MATH_tdst_Vector *_pos, FLOAT fRadius)
{   
    static BOOL bOff = TRUE;
    if(bOff) return;

    if (!SPG2_ulNumberOfLines)
        return;

    ULONG SphereCounter;
    ULONG LineCounter;
    MATH_tdst_Vector	LocalPos;

    INT_tdst_Sphere SPG2Sphere;
    SPG2Sphere.f_Radius = fRadius;//_pst_SPG2 -> SphereCollideRadius;
    if(SPG2Sphere.f_Radius<0.1f) 
        SPG2Sphere.f_Radius = 0.1f;
    if(SPG2Sphere.f_Radius>2.0f) 
        SPG2Sphere.f_Radius = 2.0f;
    SPG2Sphere.st_Center = *_pos;
    SPG2Sphere.st_Center.z += SPG2Sphere.f_Radius;
    WOR_tdst_World *pst_World = WOR_World_GetWorldOfObject(pst_GO);
    MATH_tdst_Vector stLocal, stZero, vPos;
    MATH_tdst_Matrix stInvWorld;

    BOOL bInt;

    LineCounter = SPG2_ulNumberOfLines;
    while (LineCounter --)                                    
    {
        bInt = INT_RaySphere(&SPG2_LinePos[LineCounter], &SPG2_LineDir[LineCounter], &SPG2Sphere);
        if (bInt)
        {
            vPos = *_pos;

            MATH_InitVector(&stZero ,0.0f , 0.0f , 0.0f);
            USHORT ti_GFX_Blam = GFX_i_Add(&pst_World->pst_GFX , 13 , NULL);

            GFX_FlagSet(pst_World->pst_GFX, ti_GFX_Blam, 0 , 1);
            GFX_FlagSet(pst_World->pst_GFX, ti_GFX_Blam, 2 , 1);

            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13000, fGrowingSpeed1     );    
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13001, fGrowingSpeed2     );    
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13002, fGrowingFriction   );  
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13003, fPhase1Duration    );   
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13004, fPhase2Duration    );   
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13005, fSizeMin           );          
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13006, fSizeMax           );          
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13007, fGravity           );          
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13008, fGenerationRate    );   
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13009, fSpeedMin          );         
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13010, fSpeedMax          );         
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13011, vPos.z             );           
            GFX_Setf(pst_World->pst_GFX, ti_GFX_Blam, 13012, fTimeFactor        );       

            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13100, iPoolSize          );          
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13101, iSubMatNum         );         
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13103, iPhase1Color       );       
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13104, iPhase2Color       );       
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13105, iPhase3Color       );       
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13106, iSpritesToGenerate ); 
            GFX_Seti(pst_World->pst_GFX, ti_GFX_Blam, 13107, 0                  );                  

            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13200, &vPos);            /* creation pos             */
            MATH_InitVector(&stLocal ,0.376f , 0.376f , 0.376f);
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13201, &stLocal);          /* speed direction min      */
            MATH_InitVector(&stLocal ,-0.376f , -0.376f , 0.0f);
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13202, &stLocal);          /* speed direction max      */
            MATH_InitVector(&stLocal ,0.02f , 0.02f , 0.02f);
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13203, &stLocal);         /* friction                 */
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13204, &stZero);          /* wind                     */
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13205, &stZero);          /* main position speed      */
            GFX_Setv(pst_World->pst_GFX, ti_GFX_Blam, 13206, &stZero);          /* main position friction   */

            GFX_SetMaterial(pst_World->pst_GFX, ti_GFX_Blam, (void *)pst_GO->pst_Base->pst_Visu->pst_Material);
        }
    }
}
#endif

BOOL g_bForceApply = FALSE;
void SPG2_Modifier_ApplyForInstances(SPG2_tdst_Modifier *pst_SPG2)
{
    GEO_tdst_Object* pst_Obj = (GEO_tdst_Object*)OBJ_p_GetCurrentGeo(pst_SPG2->pParentModifier->pst_GO);
    if(!pst_Obj)
        return;

    if(!(pst_SPG2->pParentModifier->ul_Flags & MDF_C_Modifier_Inactive))
    {
        g_bForceApply = TRUE;
        SPG2_Modifier_Unapply(pst_SPG2->pParentModifier, pst_Obj);    
        g_bForceApply = FALSE;
    }
}

void SPG2_Modifier_Unapply2
(
 MDF_tdst_Modifier		*_pst_Mod,
 GEO_tdst_Object			*_pst_Obj
 )
{
}

#endif

#ifdef _GAMECUBE
#define LOW_PART 0
#else
#define LOW_PART 1
#endif

#ifdef PSX2_TARGET
extern u32 ulPs2CacheFlags;
#endif

#ifdef Active_CloneListe
extern int renderState_Cloned;
#endif // Active_CloneListe
void SPG2_Modifier_Unapply
(
	MDF_tdst_Modifier		*_pst_Mod,
	GEO_tdst_Object			*_pst_Obj
)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifdef JADEFUSION
    SPG2_tdst_Modifier				*_pst_SPG2 = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;

    if(_pst_SPG2->pSPG2Holder && !g_bForceApply)
    {
        MDF_tdst_Modifier *pst_Mod = MDF_pst_GetByType(_pst_SPG2->pSPG2Holder, MDF_C_Modifier_SPG2Holder);
        if(pst_Mod && !(pst_Mod->ul_Flags & MDF_C_Modifier_Inactive))
            return;
    }

#else
	SPG2_tdst_Modifier				*_pst_SPG2;
#endif
	GEO_Vertex                      *pst_Point;
#ifdef PSX2_TARGET
    u_int                *pst_CompressedPointNormales;
#else
    MATH_tdst_Vector                *pst_PointNormales;
#endif
    MATH_tdst_Vector                st_CameraPos	ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                st_CameraX		ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                st_CameraY		ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                st_CameraX_BLOD	ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                st_CameraY_BLOD	ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                st_CameraDir	ONLY_PSX2_ALIGNED(16);
    MATH_tdst_Vector                stLocal,stModifierCenter;//,st000;
	float							fCameraNear;
	MATH_tdst_Matrix				stCurrentInverted;
    FakeStr							*pst_CurrentPond;
	MAT_tdst_Material *		pst_CurrentMat;
	MAT_tdst_MultiTexture * _pst_MaterialMLT;
	float					DeltaU;
	ULONG					TexturesID[4];
	SPG2_CachedPrimitivs	*p_CachedPrimitiv;
	ULONG					ulStartBase,CloneDetected;
	float					tf_sens;
	float					f_LOD;

	ULONG *pColor;
	float Coef,CullingS;
	ULONG fBigSurf;
	MATH_tdst_Vector	Gravity;
	ONLY_XBOX_ALIGNED(16) SOFT_tdst_AVertex	Wind[SPG2_WindNumbers] ONLY_PSX2_ALIGNED(16);
	
	float LocalWind;
	SPG2_InstanceInforamtion			stII;
	OBJ_tdst_GameObject					*pst_GO;
#ifdef _GAMECUBE	
/*xtern BOOL g_bUseHardwareLights;
	g_bUseHardwareLights=TRUE;*/
#endif
	
	if (SPG2_IsLocked) return; // CACHE is used by another one, so exit.


	if (_pst_Obj->st_Id.i->ul_Type != GRO_Geometric) return;
		
	#ifdef _XBOX 
	if ( NoMDF2 ) return;
	#endif


#ifdef JADEFUSION
#if defined(ACTIVE_EDITORS)
    if ((GDI_gpst_CurDD->ul_CurrentDrawMask & GDI_Cul_DM_NotWired) == 0) return;
    if (GDI_gpst_CurDD->ul_DisplayFlags & (GDI_Cul_DF_ShowCOB|GDI_Cul_DF_DoNotRender)) return;
#endif
#endif

	_pst_SPG2 = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;
	pst_GO = _pst_Mod->pst_GO;

	CloneDetected = 0;
#if defined( Active_CloneListe ) && !defined(_GAMECUBE)
	if ( renderState_Cloned &&
			( !(GDI_gpst_CurDD->ul_DrawMask & GDI_Cul_DM_NoAutoClone) ) && 
			(pst_GO->p_CloneNextGao))
			CloneDetected = 1;
#endif

	f_LOD = 1.0f;
	if (_pst_SPG2->ulFlags1 & SPG2_UseLOD)
	{
		float fDistance;
		fDistance = f_LOD = MATH_f_Distance(&pst_GO->pst_GlobalMatrix->T,&GDI_gpst_CurDD->st_Camera.st_Matrix.T);
		f_LOD -= _pst_SPG2->f_Near;
		f_LOD /= _pst_SPG2->f_Far - _pst_SPG2->f_Near;
		f_LOD = 1.0f - fMin(fMax(f_LOD,0.0f),1.0f);
		if ((f_LOD == 0)&&(!CloneDetected)) return;
		if (_pst_SPG2->ulFlags1 & SPG2_UseLOD2)
		{
			float f_LOD2;
			f_LOD2 = fDistance;
			f_LOD2 -= _pst_SPG2->f_Near2;
			f_LOD2 /= _pst_SPG2->f_Far2 - _pst_SPG2->f_Near2;
			f_LOD2 = 1.0f - fMin(fMax(f_LOD2,0.0f),1.0f);
			f_LOD *= f_LOD2;
			if ((f_LOD == 0)&&(!CloneDetected)) return;
		}
	}

#ifndef _XENON_RENDER
#if defined(_XENON_RENDER_PC)
    if (GDI_b_IsXenonGraphics())
    {
        if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
            pst_GO->pst_Base->pst_Visu->c_DisplayOrder =-1;
    }
    else
    {
#endif


	if (GDI_gpst_CurDD_SPR.ul_DisplayInfo & GDI_Cul_DI_RenderingTransparency)
	{
		_pst_SPG2->ulFlags |= SPG2_UsedInTransparency;
		if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
		{
			if( pst_GO->pst_Base && pst_GO->pst_Base->pst_Visu)
					pst_GO->pst_Base->pst_Visu->c_DisplayOrder =-1;
		else
		{
			if (pst_GO->pst_Base && pst_GO->pst_Base->pst_Visu)
					pst_GO->pst_Base->pst_Visu->c_DisplayOrder = 0 ;
	}
	}
	}
	else
	{	
		if (_pst_SPG2->ulFlags & SPG2_UsedInTransparency)
		{
			_pst_SPG2->ulFlags &= ~SPG2_UsedInTransparency;
			return;
		}
	}
#if defined(_XENON_RENDER_PC)
    }
#endif
#endif

	_GSP_BeginRaster(55);
//	MEM_vCheckMem(&MEM_gst_MemoryInfo);

	if (WindWavesBase == 0xffffffff)
	{
		ULONG Counter;
		Counter = 256;
		while (Counter--)
		{
			WindWaves[Counter] = fCos((float)Counter * 3.1415927f / 128.0f);
		}
		WindWavesBase  = 0;
	}
	WindWavesBase++;
	WindWavesBase&=255;
	

//return;

#ifdef JADEFUSION
    if(!_pst_Obj->l_NbPoints)
    {
        _GSP_EndRaster(55);
        return;
    }

    // make sure the compression doest not break the animation continuation
    int iTile = (int)(Time * _pst_SPG2->AnimTextureSpeed);
    int nbTiles = ((2<<_pst_SPG2->AnimTextureTileUPo2) * (2<<_pst_SPG2->AnimTextureTileVPo2));
    iTile %= nbTiles;
#else
	if(!_pst_Obj->l_NbPoints) return;
#endif

	stII.GlobalPos.x = stII.GlobalPos.y = stII.GlobalPos.z = 0.0f;
	stII.GlobalZADD.x = stII.GlobalZADD.y = stII.GlobalZADD.z = 0.0f;
	stII.BaseWind = 0;
	stII.GlobalSCale = 1.0f * f_LOD;
	stII.Culling = 1.0f;
	stII.GlobalColor = 0;
#ifdef JADEFUSION
	stII.BaseAnimUv = (iTile & 0xffff)<<16;
    stII.HeatShimmerIntensity = 0.0f;
#else
	stII.BaseAnimUv = ((u32)(Time * _pst_SPG2->AnimTextureSpeed * 256.0f) & 0xffff)<<8;
#endif
	stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileUPo2 << 24;
	stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileVPo2 << 28;

	//stII.BaseAnimUv = (u32)(Time * 10.3f * 65536.0f);


	
    
	_pst_SPG2->ulUsedSince =0;


#ifdef ACTIVE_EDITORS
	if (_pst_Obj->pst_SubObject) _pst_SPG2->ulMustbeRecompute = 1;
#endif

	if (_pst_SPG2->ulMustbeRecompute) 
	{
#ifdef ACTIVE_EDITORS
		if (_pst_SPG2->ulNumberofgeneratedSprites == -1) 
			_pst_SPG2->ulNumberofgeneratedSprites = 0;
#endif
		MODIFIER_SPG2_FlushModifier(_pst_SPG2);
	}

#ifdef JADEFUSION
    if (_pst_SPG2->ulNumberofgeneratedSprites == -1)
    {
        _GSP_EndRaster(55);
        return;
    }
#else
	if (_pst_SPG2->ulNumberofgeneratedSprites == -1) return;
#endif

#ifdef ACTIVE_EDITORS
	{
		extern ULONG SPG2_PrimitivLimit ;
#ifdef JADEFUSION
        if (SPG2_PrimitivLimit == 0)
        {
            _GSP_EndRaster(55);
            return;
        }
#else		
		if (SPG2_PrimitivLimit == 0) return;
#endif		
		if ((GDI_gpst_CurDD->ul_CurrentDrawMask & GDI_Cul_DM_NotWired) == 0) return;
		if (GDI_gpst_CurDD->ul_DisplayFlags & (GDI_Cul_DF_ShowCOB|GDI_Cul_DF_DoNotRender)) return;
	}
#endif

	_pst_SPG2->FrameCounter++;

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	/* Compute Wind & gravity begin *************************************************************************/
	Gravity.x = Gravity.y = 0.0f;
	Gravity.z = _pst_SPG2->Gravity;
	LocalWind = CurrentWind * WindWaves[(WindWavesBase + (ULONG)(256.0f * 0.1f * GDI_gpst_CurDD->st_MatrixStack.pst_CurrentMatrix->T.x)) & 255];
	LocalWind = fRand(LocalWind * SPG2_GlobalWindFactorMin,LocalWind * SPG2_GlobalWindFactorMax);
	LocalWind *= LocalWind ;
	LocalWind *= LocalWind ;

	/* Get sensitivity from global params (if not null) */
	tf_sens = 0.0f;
	if (_pst_SPG2->ulFlags & SPG2_GridGeneration)
		tf_sens = SPG2_GlobalParams[SPG2_PARAM_WINDS][(_pst_SPG2->GridFilter & 0x0F) + 1];
	else
		tf_sens = SPG2_GlobalParams[SPG2_PARAM_WINDS][(_pst_SPG2->GridFilter & 0x0F)];

	if(!tf_sens) tf_sens = _pst_SPG2 ->WindSensibility;
	Gravity.x = (LocalWind * tf_sens) * SPG2_GlobalWindVec.x;
	Gravity.y = (LocalWind * tf_sens) * SPG2_GlobalWindVec.y;
	
	GEO_UseNormals(_pst_Obj);

	/* Compute Wind & gravity begin *************************************************************************/


	MATH_InvertMatrix(&stCurrentInverted, GDI_gpst_CurDD->st_MatrixStack.pst_CurrentMatrix);
	MATH_InitVector(&stLocal , 0.0f,0.0f,0.0f);
	MATH_TransformVertex(&st_CameraPos,&stCurrentInverted,&stLocal );
	MATH_InitVector(&stLocal , _pst_SPG2 ->f_SpriteSize,0.0f,0.0f);
	MATH_TransformVector(&st_CameraX_BLOD,&stCurrentInverted,&stLocal );
	MATH_InitVector(&stLocal , 0.0f,_pst_SPG2 ->f_SpriteSize,0.0f);
	MATH_TransformVector(&st_CameraY_BLOD,&stCurrentInverted,&stLocal );
	MATH_InitVector(&stLocal , 0.0f,0.0f,1.0f);
	MATH_TransformVector(&st_CameraDir,&stCurrentInverted,&stLocal );
	MATH_ScaleVector(&st_CameraX,&st_CameraX_BLOD,f_LOD);
	MATH_ScaleVector(&st_CameraY,&st_CameraY_BLOD,f_LOD);

/*	TEST VENT SUR SPRITES
stLocal  = st_CameraX;
	{
		float CurrentWindIntegrateCos;
		CurrentWindIntegrateCos = fCos(CurrentWindIntegrate * 0.2f + _pst_Mod->pst_GO->pst_GlobalMatrix->T.x) * 0.1f;
	MATH_ScaleVector(&st_CameraX , &st_CameraX , fCos(CurrentWindIntegrateCos));
	MATH_AddScaleVector(&st_CameraX , &st_CameraX , &st_CameraY , fSin(CurrentWindIntegrateCos));
	
	MATH_ScaleVector(&st_CameraY , &st_CameraY , fCos(CurrentWindIntegrateCos));
	MATH_AddScaleVector(&st_CameraY , &st_CameraY , &stLocal , -fSin(CurrentWindIntegrateCos));
	}
	
//*/	
	

/*	MATH_TransformVector(&stLocal,&GDI_gpst_CurDD->st_Camera.st_InverseMatrix,&Gravity);
	MATH_TransformVector(&Gravity,&stCurrentInverted,&stLocal);*/

	MATH_InvertMatrix(&stCurrentInverted, pst_GO->pst_GlobalMatrix);
	MATH_BlendVector(&stLocal ,&_pst_SPG2->MinBox , &_pst_SPG2->MaxBox , 0.5f);
	MATH_TransformVertex(&stModifierCenter,_pst_Mod->pst_GO->pst_GlobalMatrix,&stLocal );
	

//	_pst_SPG2->GameObjectToDuplicate = (OBJ_tdst_GameObject*)LOA_ul_SearchAddress(BIG_ul_SearchKeyToPos((BIG_KEY)_pst_SPG2->GameObjectKey));

	if (_pst_SPG2->NumberOfSegments <= 1) _pst_SPG2->NumberOfSegments = 1;
	if (_pst_SPG2->NumberOfSegments >= 100) _pst_SPG2->NumberOfSegments = 100;

	/* Compute intertia Begin *********************************************************************************************************************************************************************************************************/
	WindSelector = SPG2_WindNumbers ;
	while (WindSelector--)
	{
			MATH_tdst_Vector	Spring;
			float Abs = 0.95f;
			float Spr = 2.2f;
			float DT = 1.0f / 30.0f;
			float WindStrenght;
			float Grabuge;
			float tf_SpringS = 0.0f;
			float tf_SpeedA = 0.0f;

			if (TIM_gf_dt) DT = TIM_gf_dt;
			Grabuge = 1.0f - 0.15f * (float)WindSelector;
			if (_pst_SPG2->SringStrenght == 0.0f) _pst_SPG2->SringStrenght = 2.2f;
			if (_pst_SPG2->SpeedAbsorbtion == 0.0f) _pst_SPG2->SpeedAbsorbtion = 0.95f;
			if (_pst_SPG2->Freedom == 0.0f) _pst_SPG2->Freedom = 0.015f;

			/* Spring str */
			if (_pst_SPG2->ulFlags & SPG2_GridGeneration)
				tf_SpringS = SPG2_GlobalParams[SPG2_PARAM_SPRINGS][(_pst_SPG2->GridFilter & 0x0F) + 1];
			else
				tf_SpringS = SPG2_GlobalParams[SPG2_PARAM_SPRINGS][(_pst_SPG2->GridFilter & 0x0F)];
			if(!tf_SpringS) tf_SpringS = _pst_SPG2->SringStrenght;

			/* Absorbtion */
			if (_pst_SPG2->ulFlags & SPG2_GridGeneration)
				tf_SpeedA = SPG2_GlobalParams[SPG2_PARAM_SPEEDA][(_pst_SPG2->GridFilter & 0x0F) + 1];
			else
				tf_SpeedA = SPG2_GlobalParams[SPG2_PARAM_SPEEDA][(_pst_SPG2->GridFilter & 0x0F)];
			if(!tf_SpeedA) tf_SpeedA = _pst_SPG2->SpeedAbsorbtion;

			/* Compute in world space */
			if(_pst_SPG2->FrameCounter<3)
				MATH_CopyVector(&_pst_SPG2->CurrentPos[WindSelector], &stModifierCenter);
			MATH_SubVector(&Spring, &stModifierCenter , &_pst_SPG2->CurrentPos[WindSelector]);
			/* Spring Force */
			MATH_AddScaleVector(&_pst_SPG2->CurrentSpeed[WindSelector] , &_pst_SPG2->CurrentSpeed[WindSelector] , &Spring, tf_SpringS + tf_SpringS * Grabuge );
			/* Gravity Force */
			MATH_AddScaleVector(&_pst_SPG2->CurrentSpeed[WindSelector] , &_pst_SPG2->CurrentSpeed[WindSelector] , &Gravity, 1.0f );
			/* Wind */
			MATH_ScaleEqualVector(&_pst_SPG2->CurrentSpeed[WindSelector] , tf_SpeedA/* * Grabuge*/);
			MATH_AddScaleVector(&_pst_SPG2->CurrentPos[WindSelector], &_pst_SPG2->CurrentPos[WindSelector], &_pst_SPG2->CurrentSpeed[WindSelector] , DT);
			MATH_SubVector((MATH_tdst_Vector *)&(Wind[WindSelector]), &_pst_SPG2->CurrentPos[WindSelector], &stModifierCenter );

			/* Sphere constraint */
			WindStrenght = MATH_f_NormVector((MATH_tdst_Vector *)&(Wind[WindSelector]));
			MATH_NormalizeAnyVector((MATH_tdst_Vector *)&(Wind[WindSelector]),(MATH_tdst_Vector *)&(Wind[WindSelector]));
			if (WindStrenght > _pst_SPG2->f_GlobalSize * _pst_SPG2->Freedom) 
			{
				WindStrenght = _pst_SPG2->f_GlobalSize * _pst_SPG2->Freedom;
				MATH_AddScaleVector(&_pst_SPG2->CurrentSpeed[WindSelector] , &_pst_SPG2->CurrentSpeed[WindSelector] , (MATH_tdst_Vector *)&(Wind[WindSelector]) , -MATH_f_DotProduct((MATH_tdst_Vector *)&(Wind[WindSelector]),&_pst_SPG2->CurrentSpeed[WindSelector]));
			}

			/* Recompute Current pos from actual pos */
			MATH_AddScaleVector(&_pst_SPG2->CurrentPos[WindSelector] ,&stModifierCenter, (MATH_tdst_Vector *)&(Wind[WindSelector]) , WindStrenght);
			WindStrenght /= _pst_SPG2->f_GlobalSize;
			Wind[WindSelector].w = WindStrenght;
			MATH_TransformVector((MATH_tdst_Vector *)&(Wind[WindSelector]),&stCurrentInverted,(MATH_tdst_Vector *)&(Wind[WindSelector]));
/*			if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
				MATH_ScaleEqualVector((MATH_tdst_Vector *)&(Wind[WindSelector]), 4.0f);*/
	}
	WindSelector = 0;

	/* Compute intertia End *********************************************************************************************************************************************************************************************************/


	/* Binormales computing *************************************************************************************************************************/
	GEO_UseNormals(_pst_Obj);
	
	if (!_pst_Obj ->pBiNormales)
	{
		_pst_Obj ->pBiNormales =  (ULONG* )MEM_p_VMAllocAlign(sizeof(ULONG) * 2 * _pst_Obj->l_NbPoints , 16);
	}
	if (_pst_SPG2->ulMustbeRecompute)
		GEO_ComputeBiNormals(_pst_Obj , _pst_Obj ->pBiNormales);

	if (_pst_SPG2 ->f_Density <= 0.0f)
	{
		_pst_SPG2 ->f_Density = 0.0f;
		_GSP_EndRaster(55);
		return;
	}

	/* Finding materials *************************************************************************************************************************/

	_pst_SPG2 ->ulSubMaterialNum &= 0xffff;
	TexturesID[3] = TexturesID[0] = TexturesID[1]= TexturesID[2]= 0;
	pst_CurrentMat = (MAT_tdst_Material *)_pst_Mod->pst_GO->pst_Base->pst_Visu->pst_Material;
	if(pst_CurrentMat  && (pst_CurrentMat->st_Id.i->ul_Type == GRO_MaterialMulti))
	{
		_pst_SPG2 ->ulSubMaterial_LOOKAT = ((MAT_tdst_Multi *)pst_CurrentMat)->l_NumberOfSubMaterials - 1;
		pst_CurrentMat = ((MAT_tdst_Multi *)pst_CurrentMat)->dpst_SubMaterial[lMin(_pst_SPG2 ->ulSubMaterialNum, ((MAT_tdst_Multi *)pst_CurrentMat)->l_NumberOfSubMaterials - 1)];
	}

	if(pst_CurrentMat  && (pst_CurrentMat->st_Id.i->ul_Type == GRO_MaterialMultiTexture))
	{
		_pst_MaterialMLT = (MAT_tdst_MultiTexture *) pst_CurrentMat ;
		if(_pst_MaterialMLT ->pst_FirstLevel)
		{
#if defined(_XENON_RENDER)
            GDI_gpst_CurDD->pst_CurrentMLTTXLVL = _pst_MaterialMLT ->pst_FirstLevel;
#endif
			TexturesID[0] = TexturesID[1]= TexturesID[2]= TexturesID[3] = _pst_MaterialMLT ->pst_FirstLevel->s_TextureId;
			if (_pst_MaterialMLT ->pst_FirstLevel && _pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel)
			{
				TexturesID[1]= TexturesID[2]= TexturesID[3] = _pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel->s_TextureId;
				if (_pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel->pst_NextLevel)
				{
					TexturesID[2]= TexturesID[3] = _pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel->pst_NextLevel->s_TextureId;
					if (_pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel->pst_NextLevel->pst_NextLevel)
						TexturesID[3] = _pst_MaterialMLT ->pst_FirstLevel->pst_NextLevel->pst_NextLevel->pst_NextLevel->s_TextureId;
				}
			}
		}
	}

#ifdef PSX2_TARGET
	GSP_SPG2_PrepareCamra(_pst_SPG2,Wind,f_LOD);
#endif	
/*#ifdef _GAMECUBE // Fast porting
	if (THIS_IS_KONG(_pst_Mod->pst_GO)) // Kingkong ?
	{
		pColor = _pst_Mod->pst_GO->pst_Base->pst_Visu->dul_VertexColors;
		pColor ++;
		_pst_SPG2->ulFlags &= ~SPG2_DrawinAlpha;		
		
	}
#endif*/


#ifdef _XENON_RENDER
    p_CachedPrimitiv = &SPG2_TmpPrim;
    ulStartBase = 0;
    p_CachedPrimitiv ->a_PtrLA2  = 0;
    if(_pst_SPG2->stInstance.a_PtrLA2>0)
    {
#ifdef VIDEOCONSOLE_ENABLE
        if(!NoSPG2_Geom || g_bForceApply)
#endif	
            DrawSPG2(&_pst_SPG2->stInstance,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
        if (_pst_SPG2->ulNumberofgeneratedSprites == (_pst_SPG2->stInstance.a_PtrLA2>>2))
            goto GRID_GEN;
    }
    else
    {
        _pst_SPG2->ulNumberofgeneratedSprites = 0;
    }
#else
/* CACHE RETREIVE B *********************************/
#ifdef PSX2_TARGET
	_pst_SPG2->ulFlags &= ~SPG2_DontUseCache;
#endif	
#ifdef _GAMECUBE
	_pst_SPG2->ulFlags &= ~SPG2_DontUseCache;
#endif	
/*#ifdef _XBOX
	_pst_SPG2->ulFlags &= ~SPG2_DontUseCache;
#endif*/	
	
	if (_pst_SPG2->ulFlags & SPG2_DontUseCache)
	{
 		p_CachedPrimitiv = &SPG2_TmpPrim;
		ulStartBase = 0;
	} else
	{            
		ulStartBase = 0;
		p_CachedPrimitiv = &_pst_SPG2->SPG2_FirstCachedPrimitivs;
#ifdef ACTIVE_EDITORS
		_pst_SPG2->ulNumberofUsedTriangles  = 0;
#endif
		if (p_CachedPrimitiv->a_PtrLA2 != 0)
		{
			SPG2_CachedPrimitivs	*pBeforeLast;
			while (p_CachedPrimitiv)
			{
				p_CachedPrimitiv->ulFlags &= ~1;
				p_CachedPrimitiv->ulFlags |= 2;
/*#if defined(PSX2_TARGET) || defined(_GAMECUBE)//|| defined(_XBOX)
#ifdef PSX2_TARGET
				if (!(ulPs2CacheFlags & GCF_AllStripCCAreIn) )
#endif				
				{
					if (THIS_IS_KONG(_pst_Mod->pst_GO)) // Kingkong ?
					{
						u32 Con;
						u32 *ptr;	
						SOFT_tdst_AVertex	*a_PointLA2Ptr;				
						pColor = GDI_gpst_CurDD->pst_ComputingBuffers->ComputedColors;
						ptr = p_CachedPrimitiv -> a_ColorLA2;
						a_PointLA2Ptr = p_CachedPrimitiv -> a_PointLA2;
						a_PointLA2Ptr++;
						Con = p_CachedPrimitiv -> a_PtrLA2 >> 2;
						while (Con--)
						{
#ifdef JADEFUSION
							*ptr = pColor[((u16 *)a_PointLA2Ptr)[1]] | 0xff000000;
#else
							*ptr = pColor[((u16 *)a_PointLA2Ptr)[LOW_PART]] | 0xff000000;
#endif
							a_PointLA2Ptr+=4;
							ptr++;
						}
					}
				}
#endif	*/
				
				DrawSPG2(p_CachedPrimitiv,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
				
				ulStartBase += p_CachedPrimitiv->a_PtrLA2;
				pBeforeLast = p_CachedPrimitiv;
				p_CachedPrimitiv = p_CachedPrimitiv->p_NextCacheLine;
			}
			/* If all is retreived return */
			ulStartBase >>= 2;
#ifdef ACTIVE_EDITORS
			_pst_SPG2->ulNumberofUsedTriangles = ulStartBase;
#endif
			if (_pst_SPG2->ulNumberofgeneratedSprites == ulStartBase) 
			{
				goto GRID_GEN;
			}

#ifdef PSX2_TARGET
			_GSP_EndRaster(55);
			GSP_SPG2_CloseCamra(_pst_SPG2);
			return;
#endif


			p_CachedPrimitiv  = pBeforeLast;
			p_CachedPrimitiv ->p_NextCacheLine = SPG2_GetAFreeLine();
			if (p_CachedPrimitiv ->p_NextCacheLine)
			/* POSSIBLE */
				p_CachedPrimitiv = p_CachedPrimitiv ->p_NextCacheLine ;
			else
			/* NOT POSSIBLE */
				p_CachedPrimitiv = &SPG2_TmpPrim;
			/* DRAW AND ADD IN CACHE IF POSSIBLE E */
		};
	}
	
#ifdef PSX2_TARGET
	if (ulPs2CacheFlags & GCF_AllStripCCAreIn) 
	{
		_GSP_EndRaster(55);
		GSP_SPG2_CloseCamra(_pst_SPG2);
		return;
	}
#endif
	
#ifdef ACTIVE_EDITORS	
	if (!_pst_Obj->pst_SubObject) 
#endif
#ifndef _XENON_RENDER
	if ((_pst_SPG2->ulFlags & SPG2_DontUseCache) == 0)
	{
#ifdef PSX2_TARGET
		if (SPG2_Repartiteur > 1) 
		{
			GSP_SPG2_CloseCamra(_pst_SPG2);
#else			
		if (SPG2_Repartiteur > 2) 
		{
#endif
			_GSP_EndRaster(55);
			return;
		}
		if (!LoadingHasBeenDetected)
			SPG2_Repartiteur++;
	}
#endif

	
	_pst_SPG2->ulNumberofgeneratedSprites = 0;
	
	p_CachedPrimitiv ->a_PtrLA2  = 0;

	if (!ulStartBase)
	{
		/* Min Max Box */
		MATH_InitVector(&_pst_SPG2->MinBox,1000000.0f,1000000.0f,1000000.0f);
		MATH_InitVector(&_pst_SPG2->MaxBox,-1000000.0f,-1000000.0f,-1000000.0f);
	}
#endif // #ifdef _XENON_RENDER

/* CACHE RETREIVE E *********************************/

/* Compute Alpha if taken from Bones Begin *************************************************************************************************************************************/
	pColor = GDI_gpst_CurDD->pst_ComputingBuffers->ComputedColors;
	if ((_pst_SPG2->ulFlags1 & SPG2_UseRLIOnly) && GDI_gpst_CurDD->pul_RLI_Used)
		pColor = GDI_gpst_CurDD->pul_RLI_Used;
	
/* DETECT KING KONG*/
//#ifdef PSX2_TARGET
//	_pst_SPG2->ulFlags |= SPG2_RotationNoise;
/*	if (THIS_IS_KONG(_pst_Mod->pst_GO)) // Kingkong ?
	{
		_pst_SPG2->ulFlags &= ~SPG2_RotationNoise;
	} */
//#endif//*/
	
	if (_pst_SPG2->ulAlphaFromPondSelector)
	{
		ULONG *pComputedColors;
		pComputedColors = GDI_gpst_CurDD->pst_ComputingBuffers->ComputedAlpha;
		if (_pst_Obj->p_SKN_Objectponderation)
			{
				GEO_tdst_VertexPonderationList *pPond;
				GEO_tdst_CompressedVertexPonderation	*p_PdrtVrc_C;
				ULONG CounterPond;
				CounterPond = _pst_Obj->l_NbPoints;
				while (CounterPond--) pComputedColors[CounterPond] = pColor[CounterPond] & 0xffffff;
				CounterPond = _pst_Obj->p_SKN_Objectponderation->NumberPdrtLists;
				pPond = NULL;
				while (CounterPond--)
				{
					pPond = _pst_Obj->p_SKN_Objectponderation->pp_PdrtLst[CounterPond];
					if (pPond->us_IndexOfMatrix == _pst_SPG2->ulAlphaFromPondSelector)
						CounterPond = 0;
					else pPond = NULL;
				}
				if (pPond)
				{
					p_PdrtVrc_C = pPond->p_PdrtVrc_C;
					CounterPond = pPond->us_NumberOfPonderatedVertices;
					while (CounterPond--)
					{
						pComputedColors[p_PdrtVrc_C->Index] |= (ULONG)(*(float *)p_PdrtVrc_C *255.0f) << 24;
						p_PdrtVrc_C ++;
					}
				}
				pColor = pComputedColors;
			}
	}

/* Compute Alpha if taken from Bones End *************************************************************************************************************************************/
	Coef = (fTan(GDI_gpst_CurDD->st_Camera.f_FieldOfVision / 2.0f));
	CullingS = _pst_SPG2->f_GlobalSize;

	{
		float Norm;
		Norm = 1.0f/ MATH_f_NormVector(&st_CameraDir);
		MATH_ScaleVector_ALIGNED(&st_CameraDir , &st_CameraDir , Norm * Norm);
	}
	fCameraNear = MATH_f_DotProduct_ALIGNED(&st_CameraDir , &st_CameraPos);

	_pst_SPG2->f_Noise = fMin(_pst_SPG2->f_Noise  , 1.0f);
	_pst_SPG2->f_Noise = fMax(_pst_SPG2->f_Noise  , 0.0f);

	fBigSurf = 0;
	pst_CurrentPond = &Fake[0];
	pst_Point = GDI_gpst_CurDD->p_Current_Vertex_List;
	if (!pst_Point) pst_Point = _pst_Obj->dst_Point;
#ifdef PSX2_TARGET
    pst_CompressedPointNormales = _pst_Obj->p_CompressedNormals;
#else
	pst_PointNormales = _pst_Obj->dst_PointNormal;
#endif	
	DeltaU = 1.0f / (float)_pst_SPG2->NumberOfSegments;
	/* parse triangles */
	if (_pst_SPG2->ulFlags & SPG2_FillSurface)
	{
		GEO_tdst_ElementIndexedTriangles	*p_stInd3,*p_stInd3L;
		ULONG ColorOr,ColorXor,SizeOr;
		SOFT_tdst_AVertex					*pCurrentPoint;
		ULONG					*pCurrentColor;
		float ZF0,ZF1;
		
		pCurrentColor = p_CachedPrimitiv->a_ColorLA2 + (p_CachedPrimitiv->a_PtrLA2 >> 2);
		pCurrentPoint = p_CachedPrimitiv->a_PointLA2 + p_CachedPrimitiv->a_PtrLA2;
#ifdef JADEFUSION
        if (_pst_SPG2->f_Near < Cf_Epsilon)
            _pst_SPG2->f_Near = Cf_Epsilon;
        if (_pst_SPG2->f_Far < 2.0f * Cf_Epsilon)
            _pst_SPG2->f_Far = 2.0f * Cf_Epsilon;
#endif

		ZF0 = Coef /  _pst_SPG2->f_Near;
		ZF1 = Coef / _pst_SPG2->f_Far;
		ZF0 = 255.0f / (ZF0 - ZF1);
		ZF1 *= ZF0;
		ColorOr = 0xff000000;
		ColorXor = 0x00000000;
		SizeOr  = 0xff;
		if (_pst_SPG2->ulFlags & SPG2_VertexAlphaIsDensity) ColorOr = 0;
		if (_pst_SPG2->ulFlags & SPG2_InversePrevious) ColorXor = 0xff000000;
		if (_pst_SPG2->ulFlags & SPG2_AlphaMeanSize) SizeOr = 0;
		
/**********************************************************************************/
/*************************** per triangle generation ******************************/
/**********************************************************************************/
#ifdef _GAMECUBE // Fast porting
		GEO_I_Need_The_Triangles_Begin(_pst_Obj,0);
#endif
		p_stInd3 = _pst_Obj->dst_Element;
		p_stInd3L = p_stInd3 + _pst_Obj->l_NbElements;
		while (p_stInd3 < p_stInd3L)
		{
			if ((1 << p_stInd3->l_MaterialId) & _pst_SPG2->ulSubMaterialMask)
			{
				GEO_tdst_IndexedTriangle	*p_Triangle, *p_TriangleL;
				ULONG RandomCounter;
#ifdef PSX2_TARGET // Fast porting
				GEO_tdst_IndexedTriangle	stFakeTriangle;
				u_short *pindex;
				pindex = NULL;
#endif
				RandomCounter = _pst_SPG2->BaseNoise;
				p_Triangle = p_stInd3->dst_Triangle;
				p_TriangleL = p_Triangle + p_stInd3->l_NbTriangles;
#ifdef PSX2_TARGET // Fast porting
				if (p_stInd3->pst_StripDataPS2)
				{
					p_Triangle = &stFakeTriangle;
					p_TriangleL = p_Triangle + p_stInd3->pst_StripDataPS2->ulNumberOfAtoms - 2;
					pindex = p_stInd3->pst_StripDataPS2->pVertexIndexes;
					p_Triangle->auw_Index[0] = *(pindex++) & 0x3fff;
					p_Triangle->auw_Index[1] = *(pindex++) & 0x3fff;
					p_Triangle->auw_Index[2] = *(pindex++) & 0x3fff;
				}
#endif				
				while (p_Triangle < p_TriangleL)
				{
					MATH_tdst_Vector Place ONLY_PSX2_ALIGNED(16);
					MATH_tdst_Vector PlaceN ONLY_PSX2_ALIGNED(16);
					MATH_tdst_Vector Surf ONLY_PSX2_ALIGNED(16);
					float LocalS;
					ULONG PrecalColors[6];
					ULONG CounterP;
					CounterP = 0;
#ifdef PSX2_TARGET // Fast porting
					if ((!pindex) || ((*(pindex-1) >> 15) == 0))
#endif					
					{
						MATH_SubVector_ALIGNED(&Place , pst_Point + p_Triangle ->auw_Index[1]  , pst_Point + p_Triangle ->auw_Index[0]);
						MATH_SubVector_ALIGNED(&PlaceN , pst_Point + p_Triangle ->auw_Index[2]  , pst_Point + p_Triangle ->auw_Index[0]);
						if (_pst_SPG2->ulFlags & SPG2_PreferenceZ)
							Place.z = PlaceN.z = 0.0f;
						MATH_CrossProduct_ALIGNED(&Surf , &Place , &PlaceN);

						if ((_pst_SPG2->ulFlags & SPG2_OnlyPositiveZ) && (Surf.z < 0.0f))
							LocalS = 0.0f;
						else
						{
							if (_pst_SPG2->ulFlags & SPG2_PreferenceXY)
								Surf.z = 0.0f;
							LocalS = MATH_f_NormVector_ALIGNED(&Surf);
						}

						fBigSurf += (ULONG)(256.0f * LocalS * _pst_SPG2->f_Density );
						CounterP = fBigSurf >> 8;
						fBigSurf &= 0xff;
					}

					if (CounterP)
					{
						if  (CounterP > MAX_RND) CounterP = MAX_RND;
						PrecalColors[0] = pColor [ p_Triangle ->auw_Index[0] ] ;
						PrecalColors[1] = pColor [ p_Triangle ->auw_Index[1] ]  ;
						PrecalColors[2] = pColor [ p_Triangle ->auw_Index[2] ]  ;
						
						if ((((PrecalColors[0] | PrecalColors[1] | PrecalColors[2]) ^ ColorXor ) | ColorOr) < (2<<16)) 
						{
							RandomCounter+=CounterP;
							CounterP = 0;
						}

						while  (CounterP--)
						{
							ULONG Color;
            				pst_CurrentPond = &Fake[(RandomCounter ++) & (MAX_RND - 1) ] ;
							Color = SPG2_InterpolColorFull(&pst_CurrentPond->FakeXYZ, PrecalColors[0] , PrecalColors[1] , PrecalColors[2] );
							
							Color ^= ColorXor;
							Color |= ColorOr;
							if ((Color >> 24)> (pst_CurrentPond->AlphhaT + 10))
							{
								float Z;
								/* Compuite position */
								MATH_ScaleVector_ALIGNED(&Place , pst_Point + p_Triangle ->auw_Index[0] , pst_CurrentPond->FakeXYZ.x);
								MATH_AddScaleVector_ALIGNED(&Place , &Place  , pst_Point + p_Triangle ->auw_Index[1], pst_CurrentPond->FakeXYZ.y);
								MATH_AddScaleVector_ALIGNED(&Place , &Place  , pst_Point + p_Triangle ->auw_Index[2], pst_CurrentPond->FakeXYZ.z);
#ifndef JADEFUSION
								Z = MATH_f_DotProduct_ALIGNED(&Place , &st_CameraDir) - fCameraNear;
#endif
								if (1)
								{
#ifndef JADEFUSION
									Z = ZF0 / Z;
									Z -= ZF1;
#endif
									if (1)//Z > (float)pst_CurrentPond->AlphhaT)
									{
										float Noise;
										ULONG VectorU , VectorV;

/* Compute position **********************************************************************************************************************************/

										/* Compute noise */
										Noise = _pst_SPG2->f_Noise  * (0.003921568627450980392156862745098f /*1.0f / 255.0f*/) * (float)(pst_CurrentPond->AlphhaT ^255);
										Noise += 1.0f - _pst_SPG2->f_Noise ;
										Noise *= (SizeOr | (Color >> 24)) * (0.003921568627450980392156862745098f /*1.0f / 255.0f*/);

										/* Compuite Normale */
#ifdef PSX2_TARGET
										{
											MATH_tdst_Vector stNormal0 ONLY_PSX2_ALIGNED(16);
											MATH_tdst_Vector stNormal1 ONLY_PSX2_ALIGNED(16);
											MATH_tdst_Vector stNormal2 ONLY_PSX2_ALIGNED(16);
											
											SPG2_ExpandNormale(&pst_CompressedPointNormales[p_Triangle ->auw_Index[0]],&stNormal0 );
											SPG2_ExpandNormale(&pst_CompressedPointNormales[p_Triangle ->auw_Index[1]],&stNormal1 );
											SPG2_ExpandNormale(&pst_CompressedPointNormales[p_Triangle ->auw_Index[2]],&stNormal2 );
											MATH_ScaleVector_ALIGNED(&PlaceN , &stNormal0 , pst_CurrentPond->FakeXYZ.x) ;
											MATH_AddScaleVector_ALIGNED(&PlaceN , &PlaceN  , &stNormal1, pst_CurrentPond->FakeXYZ.y);
											MATH_AddScaleVector_ALIGNED(&PlaceN , &PlaceN  , &stNormal2, pst_CurrentPond->FakeXYZ.z);
										}
#else
										MATH_ScaleVector(&PlaceN , pst_PointNormales + p_Triangle ->auw_Index[0] , pst_CurrentPond->FakeXYZ.x);
										MATH_AddScaleVector(&PlaceN , &PlaceN  , pst_PointNormales + p_Triangle ->auw_Index[1], pst_CurrentPond->FakeXYZ.y);
										MATH_AddScaleVector(&PlaceN , &PlaceN  , pst_PointNormales + p_Triangle ->auw_Index[2], pst_CurrentPond->FakeXYZ.z);
#endif

										if ((_pst_SPG2->ulFlags & SPG2_OnlyPositiveZ) && (PlaceN.z < 0.0f)) continue;


/* ***************************************************************************************************************************************************/
/* DRAW **********************************************************************************************************************************************/
/* ***************************************************************************************************************************************************/
										_pst_SPG2->ulNumberofgeneratedSprites ++; 
										/* SKIP IF CACHED B ************************************************************************/
										if (ulStartBase)
										{
											ulStartBase--;
										}  else
										/* SKIP IF CACHED E ************************************************************************/

										{
											MATH_tdst_Vector	XA ONLY_PSX2_ALIGNED(16);
											MATH_tdst_Vector	YA ONLY_PSX2_ALIGNED(16);
											MATH_tdst_Vector	ZA ONLY_PSX2_ALIGNED(16);
											float 	LocalSize ;

											/* Extraction */
											MATH_AddScaleVector_ALIGNED(&Place ,&Place , &PlaceN  , _pst_SPG2->fExtraction);
											/* Min Max Box */
											MATH_VectorMinMax(&Place,&_pst_SPG2->MinBox,&_pst_SPG2->MaxBox);
											LocalSize = Noise * _pst_SPG2 ->f_GlobalSize ;


											/* "Random" rotation ***********************/
											{
#ifdef PSX2_TARGET
												/* Decompress binormales begin */
												VectorU = SPG2_InterpolColorFull(&pst_CurrentPond->FakeXYZ, _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[0] * 2], _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[1] * 2] , _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[2] * 2]);
												VectorV = SPG2_InterpolColorFull(&pst_CurrentPond->FakeXYZ, _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[0] * 2 + 1], _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[1] * 2 + 1] , _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[2] * 2 + 1]);
												XA.x = ((VectorU) & 0xff) / 128.0f - 1.0f;
												XA.y = ((VectorU>>8) & 0xff) / 128.0f - 1.0f;
												XA.z = ((VectorU>>16) & 0xff) / 128.0f - 1.0f;
												YA.x = ((VectorV) & 0xff) / 128.0f - 1.0f;
												YA.y = ((VectorV>>8) & 0xff) / 128.0f - 1.0f;
												YA.z = ((VectorV>>16) & 0xff) / 128.0f - 1.0f;//*/
												//((u16 *)&XA)[LOW_PART] = p_Triangle ->auw_Index[0];
												MATH_AddScaleVector_ALIGNED(&ZA,&PlaceN,&YA,_pst_SPG2->VShift);
												*(pCurrentColor++) = Color | 0xff000000;
												*(u_long128*)(pCurrentPoint++) = *(u_long128*)&Place;
												*(u_long128*)(pCurrentPoint++) = *(u_long128*)&XA;
												*(u_long128*)(pCurrentPoint)   = *(u_long128*)&YA;
												(pCurrentPoint++)->w = LocalSize;
												*(u_long128*)(pCurrentPoint)   = *(u_long128	*)&ZA;
												(pCurrentPoint++)->c = (WindSelector ++) & (SPG2_WindNumbers - 1);
#else
												/* Decompress binormales begin */
												VectorU = SPG2_InterpolColorFull(&pst_CurrentPond->FakeXYZ, _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[0] * 2], _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[1] * 2] , _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[2] * 2]);
												VectorV = SPG2_InterpolColorFull(&pst_CurrentPond->FakeXYZ, _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[0] * 2 + 1], _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[1] * 2 + 1] , _pst_Obj->pBiNormales[ p_Triangle ->auw_Index[2] * 2 + 1]);
												XA.x = ((VectorU) & 0xff) / 128.0f - 1.0f;
												XA.y = ((VectorU>>8) & 0xff) / 128.0f - 1.0f;
												XA.z = ((VectorU>>16) & 0xff) / 128.0f - 1.0f;
												YA.x = ((VectorV) & 0xff) / 128.0f - 1.0f;
												YA.y = ((VectorV>>8) & 0xff) / 128.0f - 1.0f;
												YA.z = ((VectorV>>16) & 0xff) / 128.0f - 1.0f;
												//((u16 *)&XA)[LOW_PART] = p_Triangle ->auw_Index[0];												
												MATH_AddScaleVector_ALIGNED(&ZA,&PlaceN,&YA,_pst_SPG2->VShift);
												*(pCurrentColor++) = Color | 0xff000000;
												*(pCurrentPoint++) = *(SOFT_tdst_AVertex*)&Place;
												*(pCurrentPoint++) = *(SOFT_tdst_AVertex	*)&XA;
												*(pCurrentPoint)   = *(SOFT_tdst_AVertex	*)&YA;
												(pCurrentPoint++)->w = LocalSize;
												*(pCurrentPoint)      = *(SOFT_tdst_AVertex	*)&ZA;
												(pCurrentPoint++)->c = (WindSelector ++) & (SPG2_WindNumbers - 1);
#endif									
												p_CachedPrimitiv->a_PtrLA2+=4;
#ifndef _XENON_RENDER
												if (p_CachedPrimitiv->a_PtrLA2 & (SPG2_PACKET_SIZE<<2))
												{
													/* DRAW AND ADD IN CACHE IF POSSIBLE B */
													p_CachedPrimitiv->ulFlags = 3; 
													DrawSPG2(p_CachedPrimitiv,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
													if (_pst_SPG2->ulFlags & SPG2_DontUseCache)
													{
														p_CachedPrimitiv = &SPG2_TmpPrim;
													} else
													{
														p_CachedPrimitiv ->p_NextCacheLine = SPG2_GetAFreeLine();
														if (p_CachedPrimitiv ->p_NextCacheLine)
														/* POSSIBLE */
															p_CachedPrimitiv = p_CachedPrimitiv ->p_NextCacheLine ;
														else
														/* NOT POSSIBLE */
															p_CachedPrimitiv = &SPG2_TmpPrim;
													}
													p_CachedPrimitiv ->a_PtrLA2 = 0;
													pCurrentColor = p_CachedPrimitiv->a_ColorLA2;
													pCurrentPoint = p_CachedPrimitiv->a_PointLA2;
													/* DRAW AND ADD IN CACHE IF POSSIBLE E */

												}//*/
#else
                                                if(p_CachedPrimitiv->a_PtrLA2>=(ULONG)(SPG2_PACKET_SIZE<<2))
                                                {
                                                    // invalid primitive setup for spg2.. warn and remove unwanted spg2
#ifdef ACTIVE_EDITORS
                                                    char msg[1024];
                                                    sprintf(msg, "Too many spg2 generated for this mesh [%s] <%d>. cannot fit in cache\n",pst_GO->sz_Name, p_CachedPrimitiv->a_PtrLA2);
                                                    ERR_X_Warning(0, msg,"");
#endif
                                                    p_CachedPrimitiv->a_PtrLA2 = 4;
                                                    _pst_SPG2->ulNumberofgeneratedSprites = 1; 
                                                    goto END_OF_GENERATION;
                                                }
#endif // #ifndef _XENON_RENDER
											}
										}
									}
								}
							}
						}
					}
#ifdef PSX2_TARGET // Fast porting
					if (pindex)
					{
						p_Triangle->auw_Index[0] = p_Triangle->auw_Index[1];
						p_Triangle->auw_Index[1] = p_Triangle->auw_Index[2];
						p_Triangle->auw_Index[2] = *(pindex++) & 0x3fff;
						p_TriangleL --;
					}
					else
#endif	
						p_Triangle ++;
				}
			}
			p_stInd3++;
		}
#ifdef _GAMECUBE // Fast porting
		GEO_I_Need_The_Triangles_End(_pst_Obj,0);
#endif
	}

	/*******************************************************************************/
	/*************************** per point generation ******************************/
	/*******************************************************************************/

	if (_pst_SPG2->ulFlags & SPG2_OnePerPoint)
	{
		MATH_tdst_Vector *p_Normale;
#ifdef PSX2_TARGET
	    u_int			*pst_CompressedNormale;
#endif		
		GEO_Vertex *p_Point,*p_PointLast;
		MATH_tdst_Vector Place ONLY_PSX2_ALIGNED(16);   
		MATH_tdst_Vector PlaceN ONLY_PSX2_ALIGNED(16);
		ULONG			*p_Colors,*pBiNormales;
		ULONG ColorOr,ColorXor,SizeOr;
		float ZF0,ZF1;
		ULONG RandomCounter;
		RandomCounter = 0;

		p_Point = GDI_gpst_CurDD->p_Current_Vertex_List;
		p_PointLast = p_Point + _pst_Obj->l_NbPoints;
		p_Colors = pColor ;
#ifdef PSX2_TARGET
		p_Normale = &PlaceN;
	    pst_CompressedNormale = _pst_Obj->p_CompressedNormals;
#else
		p_Normale = pst_PointNormales;
#endif		
		pBiNormales = _pst_Obj->pBiNormales;

		ZF0 = Coef /  _pst_SPG2->f_Near;
		ZF1 = Coef / _pst_SPG2->f_Far;
		ZF0 = 255.0f / (ZF0 - ZF1);
		ZF1 *= ZF0;
		ColorOr = 0xff000000;
		ColorXor = 0x00000000;
		SizeOr  = 0xff;
	
		p_Point += ulStartBase;

		ColorOr = 0;
		if (_pst_SPG2->ulFlags & SPG2_InversePrevious) ColorXor = 0xff000000;
		SizeOr = 0;
		while (p_Point < p_PointLast)
		{
			ULONG Color;
            pst_CurrentPond = &Fake[(RandomCounter ++) & (MAX_RND - 1) ] ;
			Color = *p_Colors;
			Color ^= ColorXor;
			Color |= ColorOr;
#ifdef JADEFUSION
			if ((Color >> 24)> (pst_CurrentPond->AlphhaT + 10))
#endif
			{
				float Z;
				/* Compuite position */
				Place = *(MATH_tdst_Vector *)p_Point;
				Z = MATH_f_DotProduct_ALIGNED(&Place , &st_CameraDir) - fCameraNear;
				if (1)//Z > -CullingS)
				{
					Z = ZF0 / Z;
					Z -= ZF1;
					if (1)//(Z > (float)pst_CurrentPond->AlphhaT)
					{
						float Noise;
						ULONG VectorU , VectorV;

/* ***************************************************************************************************************************************************/
/* Compute position **********************************************************************************************************************************/
/* ***************************************************************************************************************************************************/

						/* Compute noise */
						Noise = _pst_SPG2->f_Noise  * (0.003921568627450980392156862745098f /*1.0f / 255.0f*/) * (float)(pst_CurrentPond->AlphhaT ^255);
						Noise += 1.0f - _pst_SPG2->f_Noise ;
						Noise *= (SizeOr | (Color >> 24)) * (0.003921568627450980392156862745098f /*1.0f / 255.0f*/);

						/* Compuite Normale */
#ifdef PSX2_TARGET						
						SPG2_ExpandNormale(pst_CompressedNormale,&PlaceN );
#else
						PlaceN = *p_Normale;
#endif

						if ((!(_pst_SPG2->ulFlags & SPG2_OnlyPositiveZ)) || (PlaceN.z > 0.0f)) 
						{


/* ***************************************************************************************************************************************************/
/* DRAW **********************************************************************************************************************************************/
/* ***************************************************************************************************************************************************/
							_pst_SPG2->ulNumberofgeneratedSprites ++; 
							/* SKIP IF CACHED B ************************************************************************/
							if (ulStartBase)
							{
								ulStartBase--;
							}  else
							/* SKIP IF CACHED E ************************************************************************/
							{
								MATH_tdst_Vector XA ONLY_PSX2_ALIGNED(16);
								MATH_tdst_Vector YA ONLY_PSX2_ALIGNED(16);
								MATH_tdst_Vector ZA ONLY_PSX2_ALIGNED(16);
								float 	LocalSize ;

								/* Extraction */
								MATH_AddScaleVector(&Place ,&Place , &PlaceN  , _pst_SPG2->fExtraction);
								MATH_VectorMinMax(&Place,&_pst_SPG2->MinBox,&_pst_SPG2->MaxBox);
								LocalSize = Noise * _pst_SPG2 ->f_GlobalSize ;
								/* Min Max Box */


								/* "Random" rotation ***********************/
								{
#ifdef PSX2_TARGET
									/* Decompress binormales begin */
									VectorU = *pBiNormales;
									VectorV = *(pBiNormales + 1);
									XA.x = YA.y = 1.0f;
									XA.y = XA.z = YA.x = YA.z = 0.0f;
									XA.x = ((VectorU) & 0xff) / 128.0f - 1.0f;
									XA.y = ((VectorU>>8) & 0xff) / 128.0f - 1.0f;
									XA.z = ((VectorU>>16) & 0xff) / 128.0f - 1.0f;
									YA.x = ((VectorV) & 0xff) / 128.0f - 1.0f;
									YA.y = ((VectorV>>8) & 0xff) / 128.0f - 1.0f;
									YA.z = ((VectorV>>16) & 0xff) / 128.0f - 1.0f;//*/
									
	/*								XA.x = ((VectorU) & 0xff) / 128.0f - 1.0f;
									XA.y = ((VectorU>>8) & 0xff) / 128.0f - 1.0f;
									XA.z = ((VectorU>>16) & 0xff) / 128.0f - 1.0f;
									YA.x = ((VectorV) & 0xff) / 128.0f - 1.0f;
									YA.y = ((VectorV>>8) & 0xff) / 128.0f - 1.0f;
									YA.z = ((VectorV>>16) & 0xff) / 128.0f - 1.0f;*/
									MATH_AddScaleVector_ALIGNED(&ZA,&PlaceN,&YA,_pst_SPG2->VShift);
									p_CachedPrimitiv->a_ColorLA2[p_CachedPrimitiv->a_PtrLA2 >> 2] = Color | 0xff000000;
									*(u_long128*)&p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++] = *(u_long128*)&Place;
									*(u_long128*)&p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++] = *(u_long128*)&XA;
									*(u_long128*)&p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2] = *(u_long128*)&YA;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++].w = LocalSize;
									*(u_long128*)&p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2] = *(u_long128*)&ZA;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++].c = (WindSelector ++) & (SPG2_WindNumbers - 1);
#else
									/* Decompress binormales begin */
									VectorU = *pBiNormales;
									VectorV = *(pBiNormales + 1);
									XA.x = ((VectorU) & 0xff) / 128.0f - 1.0f;
									XA.y = ((VectorU>>8) & 0xff) / 128.0f - 1.0f;
									XA.z = ((VectorU>>16) & 0xff) / 128.0f - 1.0f;
									YA.x = ((VectorV) & 0xff) / 128.0f - 1.0f;
									YA.y = ((VectorV>>8) & 0xff) / 128.0f - 1.0f;
									YA.z = ((VectorV>>16) & 0xff) / 128.0f - 1.0f;
									MATH_AddScaleVector_ALIGNED(&ZA,&PlaceN,&YA,_pst_SPG2->VShift);
									p_CachedPrimitiv->a_ColorLA2[p_CachedPrimitiv->a_PtrLA2 >> 2] = Color | 0xff000000;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++] = *(SOFT_tdst_AVertex*)&Place;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++] = *(SOFT_tdst_AVertex	*)&XA;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2] = *(SOFT_tdst_AVertex	*)&YA;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++].w = LocalSize;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2] = *(SOFT_tdst_AVertex	*)&ZA;
									p_CachedPrimitiv->a_PointLA2[p_CachedPrimitiv->a_PtrLA2++].c = (WindSelector ++) & (SPG2_WindNumbers - 1);
#endif
#ifndef _XENON_RENDER
									if (p_CachedPrimitiv->a_PtrLA2 & (SPG2_PACKET_SIZE<<2))
									{
										/* DRAW AND ADD IN CACHE IF POSSIBLE B */
										p_CachedPrimitiv->ulFlags = 3; 
										DrawSPG2(p_CachedPrimitiv,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
										if (_pst_SPG2->ulFlags & SPG2_DontUseCache)
										{
											p_CachedPrimitiv = &SPG2_TmpPrim;
										} else
										{
											p_CachedPrimitiv ->p_NextCacheLine = SPG2_GetAFreeLine();
											if (p_CachedPrimitiv ->p_NextCacheLine)
											/* POSSIBLE */
												p_CachedPrimitiv = p_CachedPrimitiv ->p_NextCacheLine ;
											else
											/* NOT POSSIBLE */
												p_CachedPrimitiv = &SPG2_TmpPrim;
										}
										p_CachedPrimitiv ->a_PtrLA2 = 0;
										/* DRAW AND ADD IN CACHE IF POSSIBLE E */
									}//*/
#else
                                    if(p_CachedPrimitiv->a_PtrLA2>=(ULONG)(SPG2_PACKET_SIZE<<2))
                                    {
                                        // invalid primitive setup for spg2.. warn and remove unwanted spg2
#ifdef ACTIVE_EDITORS
                                        char msg[1024];
                                        sprintf(msg, "Too many spg2 generated for this mesh [%s] <%d>. cannot fit in cache\n",pst_GO->sz_Name, p_CachedPrimitiv->a_PtrLA2);
                                        ERR_X_Warning(0, msg,"");
#endif
                                        p_CachedPrimitiv->a_PtrLA2 = 4;
                                        goto END_OF_GENERATION;
                                    }
#endif // #ifndef _XENON_RENDER
								}
							}
						}
					}
				}

			}
			p_Point ++;
			p_Colors ++;
#ifdef PSX2_TARGET
	    	pst_CompressedNormale++;
#else
			p_Normale ++;
#endif			
			pBiNormales += 2;
		}
	}
END_OF_GENERATION:

	/* DRAW THE REST B */
	if (p_CachedPrimitiv->a_PtrLA2)
	{
		p_CachedPrimitiv ->ulFlags = SPG2_CachedPrimitivsInitFlag;
#ifdef _XENON_RENDER
        // fill instance information
        _pst_SPG2->stInstance.a_PtrLA2 = p_CachedPrimitiv->a_PtrLA2;

        if(!_pst_SPG2->stInstance.a_PointLA2)
            _pst_SPG2->stInstance.a_PointLA2 = (SOFT_tdst_AVertex*)MEM_p_Alloc(_pst_SPG2->stInstance.a_PtrLA2*sizeof(SOFT_tdst_AVertex));
        if(!_pst_SPG2->stInstance.a_ColorLA2)
            _pst_SPG2->stInstance.a_ColorLA2 = (ULONG*)MEM_p_Alloc(_pst_SPG2->stInstance.a_PtrLA2*sizeof(ULONG));
        L_memcpy(_pst_SPG2->stInstance.a_PointLA2, p_CachedPrimitiv->a_PointLA2, _pst_SPG2->stInstance.a_PtrLA2*sizeof(SOFT_tdst_AVertex));
        L_memcpy(_pst_SPG2->stInstance.a_ColorLA2, p_CachedPrimitiv->a_ColorLA2, _pst_SPG2->stInstance.a_PtrLA2*sizeof(ULONG));
#ifdef VIDEOCONSOLE_ENABLE
        if(!NoSPG2_Geom || g_bForceApply)
#endif
            DrawSPG2(&_pst_SPG2->stInstance,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
#else
		DrawSPG2(p_CachedPrimitiv,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
#endif
	}//*/
	/* DRAW THE REST E */
	_pst_SPG2->ulMustbeRecompute = 0;

	if (_pst_SPG2->ulNumberofgeneratedSprites == 0)
		_pst_SPG2->ulNumberofgeneratedSprites = -1;

GRID_GEN:
#ifdef Active_CloneListe
	/*******************************************************************************/
	/*************************** CLONE GENERATION ***********************************/
	/*******************************************************************************/
	if (CloneDetected)
	{
			OBJ_tdst_GameObject	*_pst_GOList;
#ifdef PSX2_TARGET
			GSP_SPG2_CloseCamra(_pst_SPG2);
#endif	
			_pst_GOList =pst_GO->p_CloneNextGao;
			while (_pst_GOList)
			{
				if ((_pst_GOList->ul_StatusAndControlFlags & OBJ_C_StatusFlag_Culled) == 0)
				{
					SPG2_CachedPrimitivs	*p_CachedPrimitivSource;
					f_LOD = 1.0f;
					SOFT_l_MatrixStack_Pop(&GDI_gpst_CurDD->st_MatrixStack);
					SOFT_l_MatrixStack_Push(&GDI_gpst_CurDD->st_MatrixStack, OBJ_pst_GetAbsoluteMatrix(_pst_GOList));
				
					if (_pst_SPG2->ulFlags1 & SPG2_UseLOD)
					{
						float fDistance;
						fDistance = f_LOD = MATH_f_Distance(&_pst_GOList->pst_GlobalMatrix->T,&GDI_gpst_CurDD->st_Camera.st_Matrix.T);
						f_LOD -= _pst_SPG2->f_Near;
						f_LOD /= _pst_SPG2->f_Far - _pst_SPG2->f_Near;
						f_LOD = 1.0f - fMin(fMax(f_LOD,0.0f),1.0f);
						if (_pst_SPG2->ulFlags1 & SPG2_UseLOD2)
						{
							float f_LOD2;
							f_LOD2 = fDistance;
							f_LOD2 -= _pst_SPG2->f_Near2;
							f_LOD2 /= _pst_SPG2->f_Far2 - _pst_SPG2->f_Near2;
							f_LOD2 = 1.0f - fMin(fMax(f_LOD2,0.0f),1.0f);
							f_LOD *= f_LOD2;
						}
					}
					if (f_LOD != 0.0f)
					{
						stII.GlobalSCale = f_LOD;
						MATH_InvertMatrix(&stCurrentInverted, GDI_gpst_CurDD->st_MatrixStack.pst_CurrentMatrix);
						MATH_InitVector(&stLocal , 0.0f,0.0f,0.0f);
						MATH_TransformVertex(&st_CameraPos,&stCurrentInverted,&stLocal );
						MATH_InitVector(&stLocal , _pst_SPG2 ->f_SpriteSize,0.0f,0.0f);
						MATH_TransformVector(&st_CameraX_BLOD,&stCurrentInverted,&stLocal );
						MATH_InitVector(&stLocal , 0.0f,_pst_SPG2 ->f_SpriteSize,0.0f);
						MATH_TransformVector(&st_CameraY_BLOD,&stCurrentInverted,&stLocal );
						MATH_InitVector(&stLocal , 0.0f,0.0f,1.0f);
						MATH_TransformVector(&st_CameraDir,&stCurrentInverted,&stLocal );
						MATH_ScaleVector(&st_CameraX,&st_CameraX_BLOD,f_LOD);
						MATH_ScaleVector(&st_CameraY,&st_CameraY_BLOD,f_LOD);
#ifdef PSX2_TARGET
						GSP_SPG2_PrepareCamra(_pst_SPG2,Wind,f_LOD);
#else	
						GDI_SetViewMatrix((*GDI_gpst_CurDD) , GDI_gpst_CurDD->st_MatrixStack.pst_CurrentMatrix);
#endif
#ifndef _XENON_RENDER
						p_CachedPrimitivSource = &_pst_SPG2->SPG2_FirstCachedPrimitivs;
						while (p_CachedPrimitivSource)
						{
							DrawSPG2(p_CachedPrimitivSource,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
							p_CachedPrimitivSource = p_CachedPrimitivSource->p_NextCacheLine;
						}
#endif
					}
				}
				_pst_GOList = _pst_GOList->p_CloneNextGao;
				if (_pst_GOList == pst_GO) _pst_GOList = NULL;
			}

			SOFT_l_MatrixStack_Pop(&GDI_gpst_CurDD->st_MatrixStack);
			SOFT_l_MatrixStack_Push(&GDI_gpst_CurDD->st_MatrixStack, OBJ_pst_GetAbsoluteMatrix(_pst_Mod->pst_GO));
#ifdef PSX2_TARGET
			GSP_SPG2_PrepareCamra(_pst_SPG2,Wind,f_LOD);
#else 
			GDI_SetViewMatrix((*GDI_gpst_CurDD) , GDI_gpst_CurDD->st_MatrixStack.pst_CurrentMatrix);
#endif

			
	}
#endif	
 
	/*******************************************************************************/
	/*************************** GRID GENERATION ***********************************/
	/*******************************************************************************/
	if (_pst_SPG2->ulFlags & SPG2_GridGeneration)
	{
#ifdef _XENON_RENDER
        if (_pst_SPG2->ulFlags & SPG2_BurnedMode) _pst_SPG2->GridFilter |= 0x20; // Burned
        if (_pst_SPG2->ulFlags & SPG2_ModeAdd)  _pst_SPG2->GridFilter = 0x10; // Burning
        if (MATH_b_TestScaleType(_pst_Mod->pst_GO->pst_GlobalMatrix))
            MATH_ClearScale(_pst_Mod->pst_GO->pst_GlobalMatrix,1);
        if (!(_pst_SPG2->ulFlags & SPG2_ModeAdd) && !(_pst_SPG2->ulFlags1 & SPG2_DontGenerate))
        {
            if ((!st_CurrentGridMapper.IsComputed) || (!(st_CurrentGridMapper.SPG2_GRID_MAKS & (1 << _pst_SPG2->GridFilter))))
            {
                st_CurrentGridMapper.SPG2_GRID_MAKS |= 1 << (_pst_SPG2->GridFilter & 0xf);
                st_CurrentGridMapper.GRID_NOISES[_pst_SPG2->GridFilter & 0xf] = _pst_SPG2->GridNoise;
                if (_pst_SPG2->ulFlags & SPG2_BurnedMode) 
                    st_CurrentGridMapper.SPG2_GRID_MAKS |= 0x10000 << (_pst_SPG2->GridFilter & 0xf);
                SPG2_ComputeSpecialGrid(_pst_SPG2, WOR_World_GetWorldOfObject(_pst_Mod->pst_GO), pst_GO);
            }
        }
#else
		ULONG RandomCounter,BaseAnimLocal;
		FakeStr							*pst_CurrentPond;
		MATH_tdst_Vector	st_GMin, st_GMax;
		RandomCounter = 0;
		BaseAnimLocal = stII.BaseAnimUv ;


		if (_pst_SPG2->ulFlags & SPG2_BurnedMode) _pst_SPG2->GridFilter |= 0x20; // Burned
		if (_pst_SPG2->ulFlags & SPG2_ModeAdd)  _pst_SPG2->GridFilter = 0x10; // Burning
		
		if (MATH_b_TestScaleType(_pst_Mod->pst_GO->pst_GlobalMatrix))
			MATH_ClearScale(_pst_Mod->pst_GO->pst_GlobalMatrix,1);


		if (!(_pst_SPG2->ulFlags & SPG2_ModeAdd) && !(_pst_SPG2->ulFlags1 & SPG2_DontGenerate))
		{
			if ((!st_CurrentGridMapper.IsComputed) || (!(st_CurrentGridMapper.SPG2_GRID_MAKS & (1 << (_pst_SPG2->GridFilter & 0xf)))))
			{
				st_CurrentGridMapper.SPG2_GRID_MAKS |= 1 << (_pst_SPG2->GridFilter & 0xf);
				st_CurrentGridMapper.GRID_NOISES[_pst_SPG2->GridFilter & 0xf] = _pst_SPG2->GridNoise;
				if (_pst_SPG2->ulFlags & SPG2_BurnedMode) 
					st_CurrentGridMapper.SPG2_GRID_MAKS |= 0x10000 << (_pst_SPG2->GridFilter & 0xf);
				SPG2_ComputeSpecialGrid(_pst_SPG2, WOR_World_GetWorldOfObject(_pst_Mod->pst_GO), pst_GO);
			}
		}
		
        //..........................
        // !!! IF THIS CODE CHANGES, WARN DANY JOANNETTE because this code is replicated in the XBOX360 pipeline !!!
        //                    ......................................................................................
		
		/* Per point gen + Parse the Grid */
		if (st_CurrentGridMapper.ulNumbeOfNode)
		{
			float SphereRadius , CosAlpha,OoSinAlpha,SaveSize;
			MATH_tdst_Vector    st_SphereCenter ;
			SPG2_GridMazpperNode *p_stFirstGMNode,*p_stLastGMNode;
			st_CurrentGridMapper.GRID_NOISES[_pst_SPG2->GridFilter & 0xf] = _pst_SPG2->GridNoise;


			MATH_BlendVector(&st_SphereCenter , &_pst_SPG2->MinBox , &_pst_SPG2->MaxBox , 0.5f);
			SphereRadius = _pst_SPG2->f_GlobalSize  + MATH_f_Distance(&st_SphereCenter , &_pst_SPG2->MinBox );
			CosAlpha   = (float)  fCos(GDI_gpst_CurDD->st_Camera.f_FieldOfVision * 0.5f);
			OoSinAlpha = 1.0f / (float) fSin(GDI_gpst_CurDD->st_Camera.f_FieldOfVision * 0.5f);
			if (_pst_SPG2 ->SphereCollideRadius == 0.0f ) _pst_SPG2 ->SphereCollideRadius = 0.5f;

			p_stFirstGMNode = st_CurrentGridMapper. p_AllNodes;
			p_stLastGMNode = p_stFirstGMNode + st_CurrentGridMapper. ulNumbeOfNode;

			if(_pst_SPG2->ulFlags1 & SPG2_GenInBV)
			{
				MATH_CopyVector(&st_GMin, OBJ_pst_BV_GetGMin(_pst_Mod->pst_GO->pst_BV));
				MATH_CopyVector(&st_GMax, OBJ_pst_BV_GetGMax(_pst_Mod->pst_GO->pst_BV));
				MATH_AddEqualVector(&st_GMin, &_pst_Mod->pst_GO->pst_GlobalMatrix->T);
				MATH_AddEqualVector(&st_GMax, &_pst_Mod->pst_GO->pst_GlobalMatrix->T);
			}

			if(!(_pst_SPG2->ulFlags1 & SPG2_DontDisplay))
			{
				SPG2_CachedPrimitivs	*p_CachedPrimitivSource;

				while (p_stFirstGMNode < p_stLastGMNode)
				{
					RandomCounter++;

					if(_pst_SPG2->ulFlags1 & SPG2_GenInBV)
					{
						if(!SPG2_InBV(p_stFirstGMNode->stPos.x, p_stFirstGMNode->stPos.y, &st_GMin, &st_GMax)) 
						{
							p_stFirstGMNode++;
							continue;
						}
					}
					if(_pst_SPG2->ulFlags1 & SPG2_Damier2)
						if (*(u32 *)&p_stFirstGMNode->stPos.x & 1) 
						{
							p_stFirstGMNode++;
							continue;
						}
					if ((_pst_SPG2->ulFlags & SPG2_ModeAdd) && (p_stFirstGMNode ->GridFire == 0))
					{
						p_stFirstGMNode++;
						continue;
					}
						

					if (((p_stFirstGMNode->GridValue & ~0x30) == _pst_SPG2->GridFilter) || (p_stFirstGMNode ->GridFire && (_pst_SPG2->GridFilter & 0x10 /* Burning */)))
					{
	//					stII.GlobalPos = p_stFirstGMNode->stPos;
						MATH_TransformVertex(&stII.GlobalPos ,&stCurrentInverted , &p_stFirstGMNode->stPos);
	//					MATH_SubVector(&stII.GlobalPos ,&stII.GlobalPos , &_pst_Mod->pst_GO->pst_GlobalMatrix->T);
						p_CachedPrimitivSource = &_pst_SPG2->SPG2_FirstCachedPrimitivs;
						while (p_CachedPrimitivSource)
						{
#ifdef JADEFUSION
							stII.HeatShimmerIntensity = 0.0f;
#endif
							MATH_tdst_Vector    st_SphereCenterLocal; 
							float LODSizeCoef;
							MATH_AddVector(&st_SphereCenterLocal , &st_SphereCenter , &stII.GlobalPos );
							/* 1: Compute Culling Info */
							//Culling = MATH_ComputeCulling(CamPos,);
							stII.Culling = MATH_ComputeCulling(&st_CameraPos, &st_CameraDir, CosAlpha,OoSinAlpha,&st_SphereCenterLocal, SphereRadius);
							p_CachedPrimitivSource->ulFlags &= 2;
							p_CachedPrimitivSource->ulFlags |= SPG2_CachedPrimitivsFlagGRID;
							pst_CurrentPond = &Fake[(RandomCounter) & (MAX_RND - 1) ] ;
							stII.BaseWind = RandomCounter & (SPG2_WindNumbers - 1);
							stII.GlobalZADD.x = stII.GlobalZADD.y = stII.GlobalZADD.z = 0.0f;
							LODSizeCoef = stII.Culling * 4.0f - pst_CurrentPond->FakeXYZ.x;
							if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
							{
								stII.BaseAnimUv = (u32)(BaseAnimLocal + ((RandomCounter & 0xff) << 16)) & 0xffffff;
								stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileUPo2 << 24;
								stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileVPo2 << 28;
							}

							if (LODSizeCoef > 0.0f)
							{
								float Distance;
								if (LODSizeCoef > 1.0f) LODSizeCoef = 1.0f;
								stII.GlobalSCale = LODSizeCoef * (pst_CurrentPond ->FakeXYZ.z * 0.5f + 0.5f);
								SaveSize = _pst_SPG2->f_GlobalRatio;
								if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
								{
									u32 RG,RG2;
									stII.GlobalSCale *= (float)p_stFirstGMNode ->GridFire / 255.0f;
									_pst_SPG2->f_GlobalRatio *= (float)p_stFirstGMNode ->GridFire / 255.0f;
									stII.GlobalColor = 0;
									RG = (p_stFirstGMNode ->GridFire >> 1) + (p_stFirstGMNode ->GridFire >> 2);
									RG2 = RG + (RG>>2);
									RG2 = lMin(RG2 , 190);
									stII.GlobalColor = (((u32)RG) << 8) | (((u32)RG) << 16) | RG2;
									stII.GlobalColor &= 0xf8f8f8f8;
									stII.GlobalColor >>= 2;
									stII.GlobalColor += stII.GlobalColor >> 1;
									stII.GlobalColor |= 0x20000000;

								}
								else
								{
									/* Camera intrusion */
		/*							Distance =MATH_f_Distance(&st_CameraPos,&stII.GlobalPos);
									if (Distance < _pst_SPG2 ->SphereCollideRadius * SphereRadius)
									{
	      								MATH_SubVector(&stII.GlobalZADD , &stII.GlobalPos , &st_CameraPos);
										Distance = _pst_SPG2 ->SphereCollideRadius * SphereRadius / Distance;
										MATH_ScaleEqualVector(&stII.GlobalZADD , Distance - 1.0f);
										MATH_AddScaleVector(&stII.GlobalZADD , &stII.GlobalZADD , &st_CameraDir , -0.5f * MATH_f_DotProduct(&st_CameraDir,&stII.GlobalZADD));
									}*///*/
									/* Other sphere intrusions */
									if ((LODSizeCoef > 0.2f) && (SPG2_ulNumberOfSpheres))
									{
										ULONG SphereCounter;
										MATH_tdst_Vector	LocalPos;
										SphereCounter = SPG2_ulNumberOfSpheres;
										while (SphereCounter --)
										{
											float Opt;
	      									MATH_SubVector(&LocalPos, &SPG2_SphereCenters[SphereCounter] , &p_stFirstGMNode->stPos);
											LocalPos.z += _pst_SPG2 ->SphereCollideRadius;
											if (LocalPos.z < 0.1f) LocalPos.z = 0.1f;
											Distance = MATH_f_SqrNormVector(&LocalPos);
											Opt = SPG2_SphereRadius[SphereCounter] * _pst_SPG2 ->SphereCollideRadius;
											if (Distance < Opt * Opt)
											{
												Distance = fOptSqrt(Distance);
												Distance = SPG2_SphereRadius[SphereCounter] * _pst_SPG2 ->SphereCollideRadius / Distance;
												if (Distance > 4.0f) 
													Distance = 4.0f;
												MATH_AddScaleVector(&stII.GlobalZADD , &stII.GlobalZADD , &LocalPos ,  - Distance + 1.0f);
											}
										}
									}
#ifdef JADEFUSION									
							if (_pst_SPG2->ulFlags & SPG2_ModeAdd)
								{
									stII.GlobalColor = 0;
								}
								else if (p_stFirstGMNode->GridValue & 0x30)
#else		
									if (p_stFirstGMNode->GridValue & 0x30)
#endif
									{
										int Coef;
										if (p_stFirstGMNode->GridValue & 0x10) 
										{
											Coef = 255 - (p_stFirstGMNode ->GridFire>>1);
											stII.GlobalColor = ((p_stFirstGMNode->Color & 0xFCFCFC)>>1) | 0xff000000;;
										}
										else
										{
											Coef = (p_stFirstGMNode ->GridFire>>1);
											stII.GlobalColor = ((p_stFirstGMNode->Color & 0xFCFCFC)>>2) | 0xff000000;;
										}

										
										stII.GlobalSCale *= 0.5f + (float)Coef  / 512.0f;
									} else
										stII.GlobalColor = p_stFirstGMNode->Color | 0xff000000;
								
#ifdef JADEFUSION
                        if( (_pst_SPG2->ulFlags1 & SPG2_HeatShimmerEnable) != 0 )
                                {
                                    // Compute heat shimmer intensity
                                    stII.HeatShimmerIntensity = ((float)p_stFirstGMNode -> GridFire) / 255.0f;
                                }
		
#endif
								}
										
								DrawSPG2(p_CachedPrimitivSource,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
								_pst_SPG2->f_GlobalRatio = SaveSize ;
							}
							p_CachedPrimitivSource = p_CachedPrimitivSource->p_NextCacheLine;
						}
					}
					p_stFirstGMNode++;
				}
			}
		}
#endif // #ifndef _XENON_RENDER

	}

#ifdef PSX2_TARGET	
	GSP_SPG2_CloseCamra(_pst_SPG2);
#endif	
	
	/*******************************************************************************/
	/*************************** AI NODES GENERATION *******************************/
	/*******************************************************************************/
	{
		ULONG			RandomCounter,BaseAnimLocal;
		FakeStr			*pst_CurrentPond;
		RandomCounter = 0;
		BaseAnimLocal = stII.BaseAnimUv ;

		/* Per point gen + Parse the Grid */
		if ((st_SPG2_AI.ul_NbNodes_Cur) && (_pst_SPG2->ulFlags & SPG2_IAGenerator))
		{
			float					SphereRadius;
			float					CosAlpha;
			float					OoSinAlpha;
			float					SaveSize;
			float					SaveRatio;
			float					LODSizeCoef;
			MATH_tdst_Vector		st_SphereCenter ;
			MATH_tdst_Vector		st_SphereCenterLocal; 
			SPG2_AINode				*p_Node,*p_LastNode;
#ifndef _XENON_RENDER
			SPG2_CachedPrimitivs	*p_CachedPrimitivSource;
#endif
			MATH_BlendVector(&st_SphereCenter , &_pst_SPG2->MinBox , &_pst_SPG2->MaxBox , 0.5f);
			SphereRadius = _pst_SPG2->f_GlobalSize  + MATH_f_Distance(&st_SphereCenter , &_pst_SPG2->MinBox );
			CosAlpha   = (float)  fCos(GDI_gpst_CurDD->st_Camera.f_FieldOfVision * 0.5f);
			OoSinAlpha = 1.0f / (float) fSin(GDI_gpst_CurDD->st_Camera.f_FieldOfVision * 0.5f);
			if (_pst_SPG2 ->SphereCollideRadius == 0.0f ) _pst_SPG2 ->SphereCollideRadius = 0.5f;

			p_Node = st_SPG2_AI.pst_Node;
			p_LastNode = p_Node + st_SPG2_AI.ul_NbNodes_Cur;
			
			while ( p_Node < p_LastNode )
			{
				// update node data
				if ((p_Node->Flags & 1) == 0) // fire off
				{
					p_Node->f_Timer -= TIM_gf_dt;
					if ( p_Node->f_Timer < 0.0f ) 
					{
						p_Node->f_Timer = 0.0f;
						if (p_Node->Flags & 2)
						{
							p_LastNode--;
							st_SPG2_AI.ul_NbNodes_Cur--;
							if ( p_LastNode != p_Node )
								L_memcpy( p_Node, p_LastNode, sizeof( SPG2_AINode ) );
						}
						else
							p_Node++;
						continue;
					}
				}
				else
				{
					p_Node->f_Timer += TIM_gf_dt;
					if (p_Node->f_Timer > 1.0f)
						p_Node->f_Timer = 1.0f;
				}
				p_Node->Fire = (u8) (p_Node->f_Timer * p_Node->f_FireRatio * 255.0f);
				
				RandomCounter++;
				MATH_TransformVertex(&stII.GlobalPos ,&stCurrentInverted , &p_Node->stPos);
#ifndef _XENON_RENDER
				p_CachedPrimitivSource = &_pst_SPG2->SPG2_FirstCachedPrimitivs;
				while (p_CachedPrimitivSource)
#endif
				{
					MATH_AddVector(&st_SphereCenterLocal , &st_SphereCenter , &stII.GlobalPos );
					/* 1: Compute Culling Info */
					stII.Culling = MATH_ComputeCulling(&st_CameraPos, &st_CameraDir, CosAlpha,OoSinAlpha,&st_SphereCenterLocal, SphereRadius);
#ifndef _XENON_RENDER
					p_CachedPrimitivSource->ulFlags &= ~1;
#endif
					pst_CurrentPond = &Fake[(RandomCounter) & (MAX_RND - 1) ] ;
					stII.BaseWind = RandomCounter & (SPG2_WindNumbers - 1);
					stII.GlobalZADD.x = stII.GlobalZADD.y = stII.GlobalZADD.z = 0.0f;
					LODSizeCoef = stII.Culling * 4.0f - pst_CurrentPond->FakeXYZ.x;
						
					stII.BaseAnimUv = (u32)(BaseAnimLocal + ((RandomCounter & 0xff) << 16)) & 0xffffff;
					RandomCounter += 5;
					stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileUPo2 << 24;
					stII.BaseAnimUv |= _pst_SPG2->AnimTextureTileVPo2 << 28;

					if (LODSizeCoef > 0.0f)
					{
#ifndef _XENON_RENDER
						u32 SaveLA2;
#endif
						if (LODSizeCoef > 1.0f) 
							LODSizeCoef = 1.0f;
						
						stII.GlobalSCale = LODSizeCoef * (pst_CurrentPond ->FakeXYZ.z * 0.5f + 0.5f);
						SaveSize = _pst_SPG2->f_GlobalSize;
						SaveRatio = _pst_SPG2->f_GlobalRatio;

						stII.GlobalColor = 0;
						stII.GlobalSCale *= (float) p_Node->Fire / 255.0f;
						_pst_SPG2->f_GlobalSize *= (float) p_Node->Fire / 255.0f;
						_pst_SPG2->f_GlobalRatio *= p_Node->f_SizeRatio;
						stII.GlobalSCale *= p_Node->f_SizeRatio;
						stII.GlobalZADD = p_Node->f_Zadd;
#ifndef _XENON_RENDER // no supported

						SaveLA2 = p_CachedPrimitivSource->a_PtrLA2;

/*						if (p_Node->Flags & 16)
						{
							
						}
*/						
#ifdef PSX2_TARGET
			GSP_SPG2_PrepareCamra(_pst_SPG2,Wind,f_LOD);
#endif	
						p_CachedPrimitivSource->a_PtrLA2 = 4;
						p_CachedPrimitivSource->a_PointLA2[0].x = p_CachedPrimitivSource->a_PointLA2[0].y = p_CachedPrimitivSource->a_PointLA2[0].z = 0.0f;
						p_CachedPrimitivSource->a_PointLA2[2].w = 8.0f;
#endif

#ifdef VIDEOCONSOLE_ENABLE
                        if(!NoSPG2_AI)
#endif
                        {
#ifdef _XENON_RENDER
                            DrawSPG2(&_pst_SPG2->stInstance,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
#else
						DrawSPG2(p_CachedPrimitivSource,TexturesID,&st_CameraX,&st_CameraY,_pst_SPG2,Wind,&stII);
#endif
						}
#ifdef PSX2_TARGET	
			GSP_SPG2_CloseCamra(_pst_SPG2);
#endif	
						_pst_SPG2->f_GlobalSize = SaveSize;
						_pst_SPG2->f_GlobalRatio = SaveRatio;
#ifndef _XENON_RENDER // not supported
						p_CachedPrimitivSource->a_PtrLA2 = SaveLA2;
#endif
					}
#ifndef _XENON_RENDER
					p_CachedPrimitivSource = p_CachedPrimitivSource->p_NextCacheLine;
#endif
				}
				p_Node++;
			}
		}
	}
#ifdef JADEFUSION
	// Update heat shimmer scroll
    if( (_pst_SPG2->ulFlags1 & SPG2_HeatShimmerEnable) != 0 )
    {
        _pst_SPG2->f_HeatShimmerScroll += _pst_SPG2->f_HeatShimmerScrollSpeed * TIM_gf_realdt / _pst_SPG2->f_HeatShimmerNoisePixelSize;
    }
#endif

#ifdef _GAMECUBE
	GX_GXSetCurrentMtx(GX_PNMTX0);
#endif //_GAMECUBE

	_GSP_EndRaster(55);

//	MEM_vCheckMem(&MEM_gst_MemoryInfo);
}


#ifdef ACTIVE_EDITORS
#define SPG2_SAV_LOAD_Buffer(ValueA , TypeC)	ulSize += 4; if (Flags & 1) SAV_Buffer(&ValueA , 4); if (Flags & 2) ValueA = LOA_Read##TypeC(_pc_ReadBuffer);
#else
#define SPG2_SAV_LOAD_Buffer(ValueA , TypeC)	ulSize += 4; if (Flags & 2) ValueA = LOA_Read##TypeC(_pc_ReadBuffer);
#endif

#if defined(XML_CONV_TOOL)
ULONG gSPG2Version;
ULONG gGaoSpg2SizeHack[100];
ULONG gGaoSpg2SizeHackRPos;
ULONG gGaoSpg2SizeHackWPos;
#endif

ULONG SPG2_Modifier_SaveLoad_Parrams(SPG2_tdst_Modifier *_pst_SPG2 , ULONG Flags, char **_pc_ReadBuffer)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	ULONG							ulSize,ulVersion;
	ULONG							Dummy;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	Dummy = 0;
	ulSize = 0;
#ifdef JADEFUSION
	if (!Flags || (Flags & 1)) // Save or Query size
	{
		//ulVersion = 0x0113; // Increment Last version Here // should be 13 but to make sure we see a change if montpellier change it
		ulVersion = 0x0113;
	}
#else
	if (Flags & 1) // Save
	{
		ulVersion = 13; // Increment Last version Here
	}
#endif
	if (Flags & 2) // Read
	{
		SPG2_InitModifier(_pst_SPG2);
	}
#ifdef JADEFUSION
// Beginning of minor HACK
// -----------------------
// This hack was created to compensate for the missing version field in the SPG2 struct
// For the XML_CONV_TOOL to work correctly, we must be able to keep the version at the same
// value.. so we save it in the XML along with the other params
// We are using a global (just for the xml tool) to keep that version and save it later on
// That is why the next few lines may seem weird...
	if (Flags & 2) // Read
	{
	/* SaveLoad Version */
	SPG2_SAV_LOAD_Buffer(ulVersion, Long);
	}

#if defined(XML_CONV_TOOL)
	if (!Flags || (Flags & 1))		// Save or Query size
		ulVersion = gSPG2Version;	// Get the version from the global (which was loaded from the xml)
	else							// Read
		gSPG2Version = ulVersion;	// Set the global to the objects version (to save it in the xml)
#endif

	if (!Flags || (Flags & 1)) // Save or Query size
	{
	/* SaveLoad Version */
	SPG2_SAV_LOAD_Buffer(ulVersion, Long);
	}
// -----------------
// End of minor HACK

	/* SaveLoad ulFlags */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulFlags, Long);
#if !defined(XML_CONV_TOOL)
	if ((_pst_SPG2->ulFlags & (SPG2_DrawHat|SPG2_DrawX|SPG2_DrawY|SPG2_DrawSprites)) == 0) 
		_pst_SPG2->ulFlags |= (SPG2_DrawHat|SPG2_DrawX|SPG2_DrawY);
#endif
#else
	/* SaveLoad Version */
	SPG2_SAV_LOAD_Buffer(ulVersion, Long);

	/* SaveLoad ulFlags */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulFlags, Long);
	if ((_pst_SPG2->ulFlags & (SPG2_DrawHat|SPG2_DrawX|SPG2_DrawY|SPG2_DrawSprites)) == 0) _pst_SPG2->ulFlags |= (SPG2_DrawHat|SPG2_DrawX|SPG2_DrawY);

#endif
	/* SaveLoad fSize */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_GlobalSize, Float);
	/* SaveLoad ratio */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_GlobalRatio, Float);
	/* SaveLoad Extraction */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_Density, Float);
	/* SaveLoad SMM */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulSubMaterialMask, Long);
	/* SaveLoad Noise */
	SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_Noise, Float);
	if (ulVersion >= 1)
	{
		/* SaveLoad Near */
		SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_Near, Float);
		/* SaveLoad Far */
		SPG2_SAV_LOAD_Buffer(_pst_SPG2->f_Far, Float);

		if (ulVersion >= 2)
		{
			/* SaveLoad Near */
			SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulSubMaterial_LOOKAT, Long);
			/* SaveLoad Far */
			SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulSubMaterial_SPRITE, Long);
			if (ulVersion >= 3)
			{
				/* SaveLoad extraction */
				SPG2_SAV_LOAD_Buffer(_pst_SPG2->fExtraction, Float);
				/* SaveLoad Submat */
				SPG2_SAV_LOAD_Buffer(_pst_SPG2->ulSubMaterialNum, Long);
				if (ulVersion >= 4)
				{
					/* SaveLoad extraction */
					SPG2_SAV_LOAD_Buffer(_pst_SPG2->fExtractionOfHorizontalPlane, Float);
					if (ulVersion >= 5)
					{
						/* SaveLoad GoDistanceSwitch */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->SwitchDistance, Float);
						/* SaveLoad Go BigKey */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->GameObjectKey, Long);
						/* SaveLoad Thresh */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->AlphaThreshold, Long);
#if !defined(XML_CONV_TOOL)
						if (_pst_SPG2->AlphaThreshold == 0) _pst_SPG2->AlphaThreshold = 75;
#endif
						/* SaveLoad Numberofsegments  */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->NumberOfSegments, Long);
#ifdef JADEFUSION
#if !defined(XML_CONV_TOOL)
						if (_pst_SPG2->NumberOfSegments >= 20) _pst_SPG2->NumberOfSegments = 10;
#endif
#else
						if (_pst_SPG2->NumberOfSegments > 20) _pst_SPG2->NumberOfSegments = 20;
#endif
						/* SaveLoad Grvity */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->Gravity, Float);
						/* Inertia parrameters */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->SringStrenght, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->SpeedAbsorbtion, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->Freedom, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->WindSensibility, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2->NumberOfSprites, Long);
						/* DUMMY's */
						SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->f_SpriteSize, Float);
#if !defined(XML_CONV_TOOL)
						if (_pst_SPG2 ->f_SpriteSize == 0.0f)
							_pst_SPG2 ->f_SpriteSize = 1.0f;
#endif
						SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->f_SpriteGeneratorRadius, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->ulAlphaFromPondSelector, Long);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->VShift, Float);
						SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->fTrapeze, Float);

						if (ulVersion >= 6)
						{
							SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->TileNumber, Long);
#if !defined(XML_CONV_TOOL)
							if (_pst_SPG2 ->TileNumber == 0) _pst_SPG2 ->TileNumber = 1;
#endif
							if (ulVersion >= 7)
							{
								SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->GridFilter, Long);
								if (ulVersion >= 8)
								{
									SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->SphereCollideRadius, Float);
									SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->Preset, Long);
									if (ulVersion >= 9)
									{
										SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->AnimTextureSpeed, Float);
										SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->AnimTextureTileUPo2, Long);
										SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->AnimTextureTileVPo2, Long);
										if (ulVersion >= 10)
										{
											SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->GridNoise, Float);
#if !defined(XML_CONV_TOOL)
#ifndef ACTIVE_EDITORS
#ifdef JADEFUSION
											if (_pst_SPG2 -> GridNoise > 0.5f)
#endif
											_pst_SPG2 ->GridNoise = 0.5f; // Seb request.
#endif
#endif
											if (ulVersion >= 11)
											{
												SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->ulFlags1, Long);
												if (ulVersion >= 12)
												{
													SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->UniqID, Long);
													SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->BaseNoise , Long);
													if (ulVersion >= 13)
													{
														SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->f_Near2, Float);
														SPG2_SAV_LOAD_Buffer(_pst_SPG2 ->f_Far2, Float);
													} 
												} else
												{
													_pst_SPG2 ->UniqID = 0;
													_pst_SPG2 ->BaseNoise = 0;
												}
#ifdef JADEFUSION //POPOWARNING
												if( ulVersion >= 14 && ulVersion != 0x0111)//popoverif//>=12
                                                {
                                                    SPG2_SAV_LOAD_Buffer(_pst_SPG2 -> f_HeatShimmerNoisePixelSize, Float);
                                                    SPG2_SAV_LOAD_Buffer(_pst_SPG2 -> f_HeatShimmerScrollSpeed, Float);
                                                    SPG2_SAV_LOAD_Buffer(_pst_SPG2 -> f_HeatShimmerRange, Float );
                                                    SPG2_SAV_LOAD_Buffer(_pst_SPG2 -> f_HeatShimmerHeight, Float );
                                                }
                                                if ( ulVersion >= 15 && ulVersion != 0x0111)//>= 13
                                                {
                                                    SPG2_SAV_LOAD_Buffer(_pst_SPG2 -> f_HeatShimmerOpacity, Float );
                                                }
#endif										
											}
										} else
											_pst_SPG2 ->GridNoise = 1.0f;
									}
								}
							}
						}

#if !defined(XML_CONV_TOOL)
						if ((_pst_SPG2->ulFlags & (SPG2_OnePerPoint|SPG2_FillSurface)) == 0)
							_pst_SPG2->ulFlags |= SPG2_FillSurface;
#endif
					}

				}           

			}

		}
	}

#ifdef JADEFUSION
    if (ulVersion >= 0x0111)
    {
        ULONG ulKey;

        if (Flags & 2) // Load
        {
            SPG2_SAV_LOAD_Buffer(ulKey, Long);

            if (ulKey && ulKey != BIG_C_InvalidKey)
            {
                LOA_MakeFileRef(ulKey, (ULONG *) &_pst_SPG2->pSPG2Holder, OBJ_ul_GameObjectCallback, LOA_C_MustExists);
            }
            else
            {
                _pst_SPG2->pSPG2Holder = NULL;
            }
        }

#ifdef ACTIVE_EDITORS
        if (Flags & 1) // Save
        {
            if (_pst_SPG2->pSPG2Holder)
                ulKey = LOA_ul_SearchKeyWithAddress((ULONG) _pst_SPG2->pSPG2Holder);
            else
                ulKey = 0;

            SPG2_SAV_LOAD_Buffer(ulKey, Long);
        }
#endif

        if(!Flags)
            ulSize += 4;
    }
#endif //JADEFUSION
#if !defined(XML_CONV_TOOL)
	if ((_pst_SPG2->ulFlags & SPG2_GridGeneration) && (_pst_SPG2->GridFilter == 0))
	{
		_pst_SPG2->ulFlags &= ~SPG2_GridGeneration;
	}
#endif	

#ifdef ACTIVE_EDITORS
	_pst_SPG2->ulCodeKey = 0xC0DE2002;
#endif
	_pst_SPG2->ulMustbeRecompute = 1;
	return ulSize;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
#ifdef ACTIVE_EDITORS
void SPG2_Modifier_Save(MDF_tdst_Modifier *_pst_Mod)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_tdst_Modifier				*_pst_SPG2;
	ULONG								ulSize;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	_pst_SPG2 = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;
	/* Save Size */
	ulSize = SPG2_Modifier_SaveLoad_Parrams(_pst_SPG2 , 0 , NULL);
#if defined(XML_CONV_TOOL)
	SAV_Buffer(&gGaoSpg2SizeHack[gGaoSpg2SizeHackRPos++], 4);
#else
	SAV_Buffer(&ulSize, 4);
#endif
	SPG2_Modifier_SaveLoad_Parrams(_pst_SPG2 , 1 , NULL);

	SPG2_DestroySpecialGrid();
}
#endif

/*
 =======================================================================================================================
 =======================================================================================================================
 */
#ifdef ACTIVE_EDITORS
int SPG2_Modifier_Copy(MDF_tdst_Modifier *_pst_Dst, MDF_tdst_Modifier *_pst_Src )
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_tdst_Modifier	*Src, *Dst , *p_NextSPG2;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	Src = (SPG2_tdst_Modifier *) _pst_Src->p_Data;
	Dst = (SPG2_tdst_Modifier *) _pst_Dst->p_Data;
	
	/* copy */
	p_NextSPG2 = Dst ->p_NextSPG2;
	memcpy(Dst , Src , sizeof(SPG2_tdst_Modifier));
#ifdef _XENON_RENDER
    memset(&Dst -> stInstance , 0 , sizeof (SPG2_Instance));
#else
	memset(&Dst ->SPG2_FirstCachedPrimitivs , 0 , sizeof (SPG2_CachedPrimitivs));
#endif
	Dst ->p_NextSPG2 = p_NextSPG2;
	Dst ->ulMustbeRecompute = 1;
	return 1;
}
#endif

/*
 =======================================================================================================================
 =======================================================================================================================
 */

ULONG SPG2_ul_Modifier_Load(MDF_tdst_Modifier *_pst_Mod, char *_pc_Buffer)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_tdst_Modifier				*_pst_SPG2 ;
	unsigned char					*pc_Cur;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	SPG2_InitCachedData();


	pc_Cur = (unsigned char* )_pc_Buffer;
	_pst_SPG2  = (SPG2_tdst_Modifier *) _pst_Mod->p_Data;
	/* Skip size */
#if defined(XML_CONV_TOOL)
	gGaoSpg2SizeHack[gGaoSpg2SizeHackWPos++] = LOA_ReadLong((CHAR**)&pc_Cur);
#else
	LOA_ReadLong((char **)&pc_Cur);
#endif
	SPG2_Modifier_SaveLoad_Parrams(_pst_SPG2 , 2, (char **)&pc_Cur);

	st_CurrentGridMapper.SPG2_GRID_MAKS |= 1 << (_pst_SPG2->GridFilter & 0xf);
	st_CurrentGridMapper.GRID_NOISES[_pst_SPG2->GridFilter & 0xf] = _pst_SPG2->GridNoise;
	if (_pst_SPG2->ulFlags & SPG2_BurnedMode) 
		st_CurrentGridMapper.SPG2_GRID_MAKS |= 0x10000 << (_pst_SPG2->GridFilter & 0xf);
	
	LoadingHasBeenDetected = 10;


	if (_pst_Mod->pst_GO->ul_MyKey == 0x1E000B05)
	{
		/* Fire on lance detected. */
		_pst_SPG2->f_Density = fMin(1200.0f,_pst_SPG2->f_Density * 2.0f);
	}
	
#ifdef JADEFUSION
    // if no holder, use current gameobject as holder
    /*if(!_pst_SPG2->pSPG2Holder)
        _pst_SPG2->pSPG2Holder = _pst_Mod->pst_GO;
    */
    _pst_SPG2->pParentModifier = _pst_Mod;

#endif

	//return pc_Cur - _pc_Buffer ;
	return (ULONG)(pc_Cur - (unsigned char*)_pc_Buffer);
}

/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	FONCTION SPG2_IA
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */
 
/*
 =======================================================================================================================
 =======================================================================================================================
 */
ULONG SPG2_AI_AddOne( MATH_tdst_Vector *_pst_Pos, int _i_State )
{
	if ( !st_SPG2_AI.pst_Node )
	{
		st_SPG2_AI.ul_NbNodes_Max = 16;
		st_SPG2_AI.ul_NbNodes_Cur = 0;
		st_SPG2_AI.pst_Node = (SPG2_AINode *) MEM_p_Alloc(sizeof(SPG2_AINode) * 16);
	}
	else if (st_SPG2_AI.ul_NbNodes_Cur == st_SPG2_AI.ul_NbNodes_Max)
	{
		st_SPG2_AI.ul_NbNodes_Max += 16;
		st_SPG2_AI.pst_Node = (SPG2_AINode *) MEM_p_Realloc(st_SPG2_AI.pst_Node, sizeof(SPG2_AINode) * st_SPG2_AI.ul_NbNodes_Max);
	}
	
	MATH_CopyVector( &st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].stPos, _pst_Pos);
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].ul_Id = ul_SPG2_AI_ID++;
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].Flags = _i_State ? 1 : 0;
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_Timer = _i_State ? 1.0f : 0.0f;
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_SizeRatio = 1.0f;
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_FireRatio = 1.0f;
	st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_Zadd.x = st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_Zadd.y = st_SPG2_AI.pst_Node[ st_SPG2_AI.ul_NbNodes_Cur ].f_Zadd.z = 0.0f;
	pst_SPG2_AI_CurNode = st_SPG2_AI.pst_Node + st_SPG2_AI.ul_NbNodes_Cur;
	st_SPG2_AI.ul_NbNodes_Cur++;
	return ( ul_SPG2_AI_ID - 1 );
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_AI_SetCurrentNode( ULONG _ul_Id )
{
	SPG2_AINode *p_Last;
	if (pst_SPG2_AI_CurNode && ( pst_SPG2_AI_CurNode->ul_Id == _ul_Id ) )
		return;
	pst_SPG2_AI_CurNode = st_SPG2_AI.pst_Node;
	p_Last = pst_SPG2_AI_CurNode + st_SPG2_AI.ul_NbNodes_Cur;
	while (pst_SPG2_AI_CurNode < p_Last )
	{
		if ( pst_SPG2_AI_CurNode->ul_Id == _ul_Id )
			return;
		pst_SPG2_AI_CurNode++;
	}
	pst_SPG2_AI_CurNode = NULL;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_AI_SetState( ULONG _ul_Id, int c_State )
{
	SPG2_AI_SetCurrentNode( _ul_Id );
	if( !pst_SPG2_AI_CurNode ) return;
	pst_SPG2_AI_CurNode->Flags = c_State & 0xFF;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_AI_SetPos( ULONG _ul_Id, MATH_tdst_Vector *_pst_Pos )
{
	SPG2_AI_SetCurrentNode( _ul_Id );
	if( !pst_SPG2_AI_CurNode ) return;
	MATH_SubVector(&pst_SPG2_AI_CurNode->f_Zadd, &pst_SPG2_AI_CurNode->stPos, _pst_Pos );
MATH_ScaleEqualVector(&pst_SPG2_AI_CurNode->f_Zadd , 1.5f);
	MATH_CopyVector( &pst_SPG2_AI_CurNode->stPos, _pst_Pos );
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_AI_SetFloat( ULONG _ul_Id, int _i_Float, float _f_Value )
{
	SPG2_AI_SetCurrentNode( _ul_Id );
	if( !pst_SPG2_AI_CurNode ) return;
	switch( _i_Float )
	{
	case 0: pst_SPG2_AI_CurNode->f_SizeRatio = _f_Value; break;
	case 1: pst_SPG2_AI_CurNode->f_FireRatio = _f_Value; break;
		case 2: pst_SPG2_AI_CurNode->f_Zadd.z = _f_Value; break;
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
void SPG2_SetValue_C( OBJ_tdst_GameObject *_pst_GO,ULONG _ul_UnicId, ULONG _ul_NumToSet, float _f_Value )
{
	MDF_tdst_Modifier		*pst_Modifier;

	pst_Modifier = NULL; 

	if ( _pst_GO->pst_Extended && _pst_GO->pst_Extended->pst_Modifiers )
		pst_Modifier = _pst_GO->pst_Extended->pst_Modifiers;

	while (pst_Modifier)
	{	
		SPG2_tdst_Modifier *pstModifier;
		if ( pst_Modifier->i->ul_Type == MDF_C_Modifier_SpriteMapper2)
		{
			pstModifier = (SPG2_tdst_Modifier *) pst_Modifier->p_Data;
			if (_ul_UnicId == pstModifier->UniqID)
			{
				switch( _ul_NumToSet )
				{
					case 0: pstModifier->SringStrenght = _f_Value;		break;
					case 1: pstModifier->SpeedAbsorbtion = _f_Value;	break;
					case 2: pstModifier->Freedom = _f_Value;			break;
					case 3: pstModifier->WindSensibility = _f_Value;	break;
					case 4: pstModifier->SphereCollideRadius = _f_Value;break;
				}
			}

		}
		pst_Modifier = pst_Modifier->pst_Next;
	}
	
}


BOOL SPG2_bIsSameSPG2Modifier(struct	SPG2_tdst_Modifier_ *pstModifier1,struct SPG2_tdst_Modifier_ *pstModifier2)
{
    // Do the modifiers have the same parameters ?
    if (!(pstModifier1->ulFlags == pstModifier2->ulFlags))
        return FALSE;

    if (!(pstModifier1->ulFlags1 == pstModifier2->ulFlags1))
        return FALSE;

    if (!(pstModifier1->f_GlobalSize == pstModifier2->f_GlobalSize))
        return FALSE;

    if (!(pstModifier1->f_SpriteSize == pstModifier2->f_SpriteSize))
        return FALSE;
 
    if (!(pstModifier1->f_SpriteGeneratorRadius == pstModifier2->f_SpriteGeneratorRadius))
        return FALSE;

    if (!(pstModifier1->f_GlobalRatio == pstModifier2->f_GlobalRatio))
        return FALSE;

    if (!(pstModifier1->f_Density == pstModifier2->f_Density))
        return FALSE;

    if (!(pstModifier1->f_Near == pstModifier2->f_Near))
        return FALSE;

    if (!(pstModifier1->f_Far == pstModifier2->f_Far))
        return FALSE;

    if (!(pstModifier1->ulSubMaterialMask == pstModifier2->ulSubMaterialMask))
        return FALSE;

    if (!(pstModifier1->AlphaThreshold == pstModifier2->AlphaThreshold))
        return FALSE;

    if (!(pstModifier1->VShift == pstModifier2->VShift))
        return FALSE;

    if (!(pstModifier1->fTrapeze == pstModifier2->fTrapeze))
        return FALSE;

    if (!(pstModifier1->TileNumber == pstModifier2->TileNumber))
        return FALSE;

    if (!(pstModifier1->GridFilter == pstModifier2->GridFilter))
        return FALSE;

    if (!(pstModifier1->fExtraction == pstModifier2->fExtraction))
        return FALSE;

    if (!(pstModifier1->ulSubMaterialNum == pstModifier2->ulSubMaterialNum))
        return FALSE;

    if (!(pstModifier1->fExtractionOfHorizontalPlane == pstModifier2->fExtractionOfHorizontalPlane))
        return FALSE;

//    if (!(pstModifier1->ulSubMaterial_LOOKAT == pstModifier2->ulSubMaterial_LOOKAT))
//        return FALSE;

//    if (!(pstModifier1->ulSubMaterial_SPRITE == pstModifier2->ulSubMaterial_SPRITE))
//        return FALSE;

    if (!(pstModifier1->AnimTextureTileUPo2 == pstModifier2->AnimTextureTileUPo2))
        return FALSE;

    if (!(pstModifier1->AnimTextureTileVPo2 == pstModifier2->AnimTextureTileVPo2))
        return FALSE;

    if (!(pstModifier1->AnimTextureSpeed == pstModifier2->AnimTextureSpeed))
        return FALSE;

    if (!(pstModifier1->SwitchDistance == pstModifier2->SwitchDistance))
        return FALSE;

    if (!(pstModifier1->Gravity == pstModifier2->Gravity))
        return FALSE;

    if (!(pstModifier1->NumberOfSegments == pstModifier2->NumberOfSegments))
        return FALSE;

    if (!(pstModifier1->NumberOfSprites == pstModifier2->NumberOfSprites))
        return FALSE;

    if (!(pstModifier1->SringStrenght == pstModifier2->SringStrenght))
        return FALSE;

    if (!(pstModifier1->SpeedAbsorbtion == pstModifier2->SpeedAbsorbtion))
        return FALSE;

    if (!(pstModifier1->Freedom == pstModifier2->Freedom))
        return FALSE;

    if (!(pstModifier1->WindSensibility == pstModifier2->WindSensibility))
        return FALSE;

    if (!(pstModifier1->Preset == pstModifier2->Preset))
        return FALSE;

    if (!(pstModifier1->SphereCollideRadius == pstModifier2->SphereCollideRadius))
        return FALSE;

    if (!(pstModifier1->GridNoise == pstModifier2->GridNoise))
        return FALSE;

    return TRUE;
/*    return ((pstModifier1->ulFlags == pstModifier2->ulFlags) &&
        (pstModifier1->ulFlags1 == pstModifier2->ulFlags1) &&
        (pstModifier1->f_GlobalSize == pstModifier2->f_GlobalSize) &&
        (pstModifier1->f_SpriteSize == pstModifier2->ulFlags1) &&
        (pstModifier1->f_SpriteGeneratorRadius == pstModifier2->f_SpriteGeneratorRadius) &&
        (pstModifier1->f_GlobalRatio == pstModifier2->f_GlobalRatio) &&
        (pstModifier1->f_Density == pstModifier2->f_Density) &&
        (pstModifier1->f_Noise == pstModifier2->f_Noise) &&
        (pstModifier1->f_Near == pstModifier2->f_Near) &&
        (pstModifier1->f_Far == pstModifier2->f_Far) &&
        (pstModifier1->ulSubMaterialMask == pstModifier2->ulSubMaterialMask) &&
        (pstModifier1->AlphaThreshold == pstModifier2->AlphaThreshold) &&
        (pstModifier1->VShift == pstModifier2->VShift) &&
        (pstModifier1->fTrapeze == pstModifier2->fTrapeze) &&
        (pstModifier1->TileNumber == pstModifier2->TileNumber) &&
        (pstModifier1->GridFilter == pstModifier2->GridFilter) &&
        (pstModifier1->fExtraction == pstModifier2->fExtraction) &&
        (pstModifier1->ulSubMaterialNum == pstModifier2->ulSubMaterialNum) &&
        (pstModifier1->fExtractionOfHorizontalPlane == pstModifier2->fExtractionOfHorizontalPlane) &&
        (pstModifier1->ulSubMaterial_LOOKAT == pstModifier2->ulSubMaterial_LOOKAT) &&
        (pstModifier1->ulSubMaterial_SPRITE == pstModifier2->ulSubMaterial_SPRITE) &&
        (pstModifier1->AnimTextureTileUPo2 == pstModifier2->AnimTextureTileUPo2) &&
        (pstModifier1->AnimTextureTileVPo2 == pstModifier2->AnimTextureTileVPo2) &&
        (pstModifier1->AnimTextureSpeed == pstModifier2->AnimTextureSpeed) &&
        (pstModifier1->SwitchDistance == pstModifier2->SwitchDistance) &&
        (pstModifier1->Gravity == pstModifier2->Gravity) &&
        (pstModifier1->NumberOfSegments == pstModifier2->NumberOfSegments) &&
        (pstModifier1->NumberOfSprites == pstModifier2->NumberOfSprites) &&
        (pstModifier1->SringStrenght == pstModifier2->SringStrenght) &&
        (pstModifier1->SpeedAbsorbtion == pstModifier2->SpeedAbsorbtion) &&
        (pstModifier1->Freedom == pstModifier2->Freedom) &&
        (pstModifier1->WindSensibility == pstModifier2->WindSensibility) &&
        (pstModifier1->Preset == pstModifier2->Preset) &&
        (pstModifier1->SphereCollideRadius == pstModifier2->SphereCollideRadius) &&
        (pstModifier1->GridNoise == pstModifier2->GridNoise));*/
}

#if defined(PSX2_TARGET) && defined(__cplusplus)
}
#endif
